// Generated by Futhark 0.22.0
// git: ed22762 (Sat Jan 15 01:09:59 2022 +0100)

// We need to define _GNU_SOURCE before
// _any_ headers files are imported to get
// the usage statistics of a thread (i.e. have RUSAGE_THREAD) on GNU/Linux
// https://manpages.courier-mta.org/htmlman2/getrusage.2.html
#ifndef _GNU_SOURCE // Avoid possible double-definition warning.
#define _GNU_SOURCE
#endif

#ifdef __clang__
#pragma clang diagnostic ignored "-Wunused-function"
#pragma clang diagnostic ignored "-Wunused-variable"
#pragma clang diagnostic ignored "-Wparentheses"
#pragma clang diagnostic ignored "-Wunused-label"
#elif __GNUC__
#pragma GCC diagnostic ignored "-Wunused-function"
#pragma GCC diagnostic ignored "-Wunused-variable"
#pragma GCC diagnostic ignored "-Wparentheses"
#pragma GCC diagnostic ignored "-Wunused-label"
#pragma GCC diagnostic ignored "-Wunused-but-set-variable"
#endif

// Headers\n")
#include <stdint.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdio.h>
#include <float.h>

#ifdef __cplusplus
extern "C" {
#endif

// Initialisation
struct futhark_context_config;
struct futhark_context_config *futhark_context_config_new(void);
void futhark_context_config_free(struct futhark_context_config *cfg);
void futhark_context_config_set_debugging(struct futhark_context_config *cfg,
                                          int flag);
void futhark_context_config_set_profiling(struct futhark_context_config *cfg,
                                          int flag);
void futhark_context_config_set_logging(struct futhark_context_config *cfg,
                                        int flag);
struct futhark_context;
struct futhark_context *futhark_context_new(struct futhark_context_config *cfg);
void futhark_context_free(struct futhark_context *ctx);
int futhark_context_config_set_tuning_param(struct futhark_context_config *cfg,
                                            const char *param_name,
                                            size_t param_value);
int futhark_get_tuning_param_count(void);
const char *futhark_get_tuning_param_name(int);
const char *futhark_get_tuning_param_class(int);

// Arrays
struct futhark_f64_2d;
struct futhark_f64_2d *futhark_new_f64_2d(struct futhark_context *ctx, const
                                          double *data, int64_t dim0,
                                          int64_t dim1);
struct futhark_f64_2d *futhark_new_raw_f64_2d(struct futhark_context *ctx, const
                                              unsigned char *data,
                                              int64_t offset, int64_t dim0,
                                              int64_t dim1);
int futhark_free_f64_2d(struct futhark_context *ctx,
                        struct futhark_f64_2d *arr);
int futhark_values_f64_2d(struct futhark_context *ctx,
                          struct futhark_f64_2d *arr, double *data);
unsigned char *futhark_values_raw_f64_2d(struct futhark_context *ctx,
                                         struct futhark_f64_2d *arr);
const int64_t *futhark_shape_f64_2d(struct futhark_context *ctx,
                                    struct futhark_f64_2d *arr);

// Opaque values


// Entry points
int futhark_entry_main(struct futhark_context *ctx,
                       struct futhark_f64_2d **out0,
                       struct futhark_f64_2d **out1,
                       struct futhark_f64_2d **out2, const
                       struct futhark_f64_2d *in0, const int64_t in1, const
                       int64_t in2, const int64_t in3, const int64_t in4, const
                       int64_t in5, const int64_t in6, const int64_t in7, const
                       int64_t in8, const int64_t in9, const int64_t in10, const
                       int64_t in11, const int64_t in12, const int64_t in13,
                       const int64_t in14);

// Miscellaneous
int futhark_context_sync(struct futhark_context *ctx);
char *futhark_context_report(struct futhark_context *ctx);
char *futhark_context_get_error(struct futhark_context *ctx);
void futhark_context_set_logging_file(struct futhark_context *ctx, FILE *f);
void futhark_context_pause_profiling(struct futhark_context *ctx);
void futhark_context_unpause_profiling(struct futhark_context *ctx);
int futhark_context_clear_caches(struct futhark_context *ctx);
#define FUTHARK_BACKEND_c

#ifdef __cplusplus
}
#endif

#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <math.h>
#include <stdint.h>
// If NDEBUG is set, the assert() macro will do nothing. Since Futhark
// (unfortunately) makes use of assert() for error detection (and even some
// side effects), we want to avoid that.
#undef NDEBUG
#include <assert.h>
#include <stdarg.h>
// Start of util.h.
//
// Various helper functions that are useful in all generated C code.

#include <errno.h>
#include <string.h>

static const char *fut_progname = "(embedded Futhark)";

static void futhark_panic(int eval, const char *fmt, ...) __attribute__((noreturn));
static char* msgprintf(const char *s, ...);
static void* slurp_file(const char *filename, size_t *size);
static int dump_file(const char *file, const void *buf, size_t n);
struct str_builder;
static void str_builder_init(struct str_builder *b);
static void str_builder(struct str_builder *b, const char *s, ...);

static void futhark_panic(int eval, const char *fmt, ...) {
  va_list ap;
  va_start(ap, fmt);
  fprintf(stderr, "%s: ", fut_progname);
  vfprintf(stderr, fmt, ap);
  va_end(ap);
  exit(eval);
}

// For generating arbitrary-sized error messages.  It is the callers
// responsibility to free the buffer at some point.
static char* msgprintf(const char *s, ...) {
  va_list vl;
  va_start(vl, s);
  size_t needed = 1 + (size_t)vsnprintf(NULL, 0, s, vl);
  char *buffer = (char*) malloc(needed);
  va_start(vl, s); // Must re-init.
  vsnprintf(buffer, needed, s, vl);
  return buffer;
}

static inline void check_err(int errval, int sets_errno, const char *fun, int line,
                            const char *msg, ...) {
  if (errval) {
    char errnum[10];

    va_list vl;
    va_start(vl, msg);

    fprintf(stderr, "ERROR: ");
    vfprintf(stderr, msg, vl);
    fprintf(stderr, " in %s() at line %d with error code %s\n",
            fun, line,
            sets_errno ? strerror(errno) : errnum);
    exit(errval);
  }
}

#define CHECK_ERR(err, ...) check_err(err, 0, __func__, __LINE__, __VA_ARGS__)
#define CHECK_ERRNO(err, ...) check_err(err, 1, __func__, __LINE__, __VA_ARGS__)

// Read the rest of an open file into a NUL-terminated string; returns
// NULL on error.
static void* fslurp_file(FILE *f, size_t *size) {
  long start = ftell(f);
  fseek(f, 0, SEEK_END);
  long src_size = ftell(f)-start;
  fseek(f, start, SEEK_SET);
  unsigned char *s = (unsigned char*) malloc((size_t)src_size + 1);
  if (fread(s, 1, (size_t)src_size, f) != (size_t)src_size) {
    free(s);
    s = NULL;
  } else {
    s[src_size] = '\0';
  }

  if (size) {
    *size = (size_t)src_size;
  }

  return s;
}

// Read a file into a NUL-terminated string; returns NULL on error.
static void* slurp_file(const char *filename, size_t *size) {
  FILE *f = fopen(filename, "rb"); // To avoid Windows messing with linebreaks.
  if (f == NULL) return NULL;
  unsigned char *s = fslurp_file(f, size);
  fclose(f);
  return s;
}

// Dump 'n' bytes from 'buf' into the file at the designated location.
// Returns 0 on success.
static int dump_file(const char *file, const void *buf, size_t n) {
  FILE *f = fopen(file, "w");

  if (f == NULL) {
    return 1;
  }

  if (fwrite(buf, sizeof(char), n, f) != n) {
    return 1;
  }

  if (fclose(f) != 0) {
    return 1;
  }

  return 0;
}

struct str_builder {
  char *str;
  size_t capacity; // Size of buffer.
  size_t used; // Bytes used, *not* including final zero.
};

static void str_builder_init(struct str_builder *b) {
  b->capacity = 10;
  b->used = 0;
  b->str = malloc(b->capacity);
  b->str[0] = 0;
}

static void str_builder(struct str_builder *b, const char *s, ...) {
  va_list vl;
  va_start(vl, s);
  size_t needed = (size_t)vsnprintf(NULL, 0, s, vl);

  while (b->capacity < b->used + needed + 1) {
    b->capacity *= 2;
    b->str = realloc(b->str, b->capacity);
  }

  va_start(vl, s); // Must re-init.
  vsnprintf(b->str+b->used, b->capacity-b->used, s, vl);
  b->used += needed;
}

// End of util.h.
// Start of half.h.

// Conversion functions are from http://half.sourceforge.net/, but
// translated to C.
//
// Copyright (c) 2012-2021 Christian Rau
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

#ifndef __OPENCL_VERSION__
#define __constant
#endif

__constant static const uint16_t base_table[512] = {
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0001, 0x0002, 0x0004, 0x0008, 0x0010, 0x0020, 0x0040, 0x0080, 0x0100,
  0x0200, 0x0400, 0x0800, 0x0C00, 0x1000, 0x1400, 0x1800, 0x1C00, 0x2000, 0x2400, 0x2800, 0x2C00, 0x3000, 0x3400, 0x3800, 0x3C00,
  0x4000, 0x4400, 0x4800, 0x4C00, 0x5000, 0x5400, 0x5800, 0x5C00, 0x6000, 0x6400, 0x6800, 0x6C00, 0x7000, 0x7400, 0x7800, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8001, 0x8002, 0x8004, 0x8008, 0x8010, 0x8020, 0x8040, 0x8080, 0x8100,
  0x8200, 0x8400, 0x8800, 0x8C00, 0x9000, 0x9400, 0x9800, 0x9C00, 0xA000, 0xA400, 0xA800, 0xAC00, 0xB000, 0xB400, 0xB800, 0xBC00,
  0xC000, 0xC400, 0xC800, 0xCC00, 0xD000, 0xD400, 0xD800, 0xDC00, 0xE000, 0xE400, 0xE800, 0xEC00, 0xF000, 0xF400, 0xF800, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00 };

__constant static const unsigned char shift_table[512] = {
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 23, 22, 21, 20, 19, 18, 17, 16, 15, 14, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,
  13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 13,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 23, 22, 21, 20, 19, 18, 17, 16, 15, 14, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,
  13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 13 };

__constant static const uint32_t mantissa_table[2048] = {
  0x00000000, 0x33800000, 0x34000000, 0x34400000, 0x34800000, 0x34A00000, 0x34C00000, 0x34E00000, 0x35000000, 0x35100000, 0x35200000, 0x35300000, 0x35400000, 0x35500000, 0x35600000, 0x35700000,
  0x35800000, 0x35880000, 0x35900000, 0x35980000, 0x35A00000, 0x35A80000, 0x35B00000, 0x35B80000, 0x35C00000, 0x35C80000, 0x35D00000, 0x35D80000, 0x35E00000, 0x35E80000, 0x35F00000, 0x35F80000,
  0x36000000, 0x36040000, 0x36080000, 0x360C0000, 0x36100000, 0x36140000, 0x36180000, 0x361C0000, 0x36200000, 0x36240000, 0x36280000, 0x362C0000, 0x36300000, 0x36340000, 0x36380000, 0x363C0000,
  0x36400000, 0x36440000, 0x36480000, 0x364C0000, 0x36500000, 0x36540000, 0x36580000, 0x365C0000, 0x36600000, 0x36640000, 0x36680000, 0x366C0000, 0x36700000, 0x36740000, 0x36780000, 0x367C0000,
  0x36800000, 0x36820000, 0x36840000, 0x36860000, 0x36880000, 0x368A0000, 0x368C0000, 0x368E0000, 0x36900000, 0x36920000, 0x36940000, 0x36960000, 0x36980000, 0x369A0000, 0x369C0000, 0x369E0000,
  0x36A00000, 0x36A20000, 0x36A40000, 0x36A60000, 0x36A80000, 0x36AA0000, 0x36AC0000, 0x36AE0000, 0x36B00000, 0x36B20000, 0x36B40000, 0x36B60000, 0x36B80000, 0x36BA0000, 0x36BC0000, 0x36BE0000,
  0x36C00000, 0x36C20000, 0x36C40000, 0x36C60000, 0x36C80000, 0x36CA0000, 0x36CC0000, 0x36CE0000, 0x36D00000, 0x36D20000, 0x36D40000, 0x36D60000, 0x36D80000, 0x36DA0000, 0x36DC0000, 0x36DE0000,
  0x36E00000, 0x36E20000, 0x36E40000, 0x36E60000, 0x36E80000, 0x36EA0000, 0x36EC0000, 0x36EE0000, 0x36F00000, 0x36F20000, 0x36F40000, 0x36F60000, 0x36F80000, 0x36FA0000, 0x36FC0000, 0x36FE0000,
  0x37000000, 0x37010000, 0x37020000, 0x37030000, 0x37040000, 0x37050000, 0x37060000, 0x37070000, 0x37080000, 0x37090000, 0x370A0000, 0x370B0000, 0x370C0000, 0x370D0000, 0x370E0000, 0x370F0000,
  0x37100000, 0x37110000, 0x37120000, 0x37130000, 0x37140000, 0x37150000, 0x37160000, 0x37170000, 0x37180000, 0x37190000, 0x371A0000, 0x371B0000, 0x371C0000, 0x371D0000, 0x371E0000, 0x371F0000,
  0x37200000, 0x37210000, 0x37220000, 0x37230000, 0x37240000, 0x37250000, 0x37260000, 0x37270000, 0x37280000, 0x37290000, 0x372A0000, 0x372B0000, 0x372C0000, 0x372D0000, 0x372E0000, 0x372F0000,
  0x37300000, 0x37310000, 0x37320000, 0x37330000, 0x37340000, 0x37350000, 0x37360000, 0x37370000, 0x37380000, 0x37390000, 0x373A0000, 0x373B0000, 0x373C0000, 0x373D0000, 0x373E0000, 0x373F0000,
  0x37400000, 0x37410000, 0x37420000, 0x37430000, 0x37440000, 0x37450000, 0x37460000, 0x37470000, 0x37480000, 0x37490000, 0x374A0000, 0x374B0000, 0x374C0000, 0x374D0000, 0x374E0000, 0x374F0000,
  0x37500000, 0x37510000, 0x37520000, 0x37530000, 0x37540000, 0x37550000, 0x37560000, 0x37570000, 0x37580000, 0x37590000, 0x375A0000, 0x375B0000, 0x375C0000, 0x375D0000, 0x375E0000, 0x375F0000,
  0x37600000, 0x37610000, 0x37620000, 0x37630000, 0x37640000, 0x37650000, 0x37660000, 0x37670000, 0x37680000, 0x37690000, 0x376A0000, 0x376B0000, 0x376C0000, 0x376D0000, 0x376E0000, 0x376F0000,
  0x37700000, 0x37710000, 0x37720000, 0x37730000, 0x37740000, 0x37750000, 0x37760000, 0x37770000, 0x37780000, 0x37790000, 0x377A0000, 0x377B0000, 0x377C0000, 0x377D0000, 0x377E0000, 0x377F0000,
  0x37800000, 0x37808000, 0x37810000, 0x37818000, 0x37820000, 0x37828000, 0x37830000, 0x37838000, 0x37840000, 0x37848000, 0x37850000, 0x37858000, 0x37860000, 0x37868000, 0x37870000, 0x37878000,
  0x37880000, 0x37888000, 0x37890000, 0x37898000, 0x378A0000, 0x378A8000, 0x378B0000, 0x378B8000, 0x378C0000, 0x378C8000, 0x378D0000, 0x378D8000, 0x378E0000, 0x378E8000, 0x378F0000, 0x378F8000,
  0x37900000, 0x37908000, 0x37910000, 0x37918000, 0x37920000, 0x37928000, 0x37930000, 0x37938000, 0x37940000, 0x37948000, 0x37950000, 0x37958000, 0x37960000, 0x37968000, 0x37970000, 0x37978000,
  0x37980000, 0x37988000, 0x37990000, 0x37998000, 0x379A0000, 0x379A8000, 0x379B0000, 0x379B8000, 0x379C0000, 0x379C8000, 0x379D0000, 0x379D8000, 0x379E0000, 0x379E8000, 0x379F0000, 0x379F8000,
  0x37A00000, 0x37A08000, 0x37A10000, 0x37A18000, 0x37A20000, 0x37A28000, 0x37A30000, 0x37A38000, 0x37A40000, 0x37A48000, 0x37A50000, 0x37A58000, 0x37A60000, 0x37A68000, 0x37A70000, 0x37A78000,
  0x37A80000, 0x37A88000, 0x37A90000, 0x37A98000, 0x37AA0000, 0x37AA8000, 0x37AB0000, 0x37AB8000, 0x37AC0000, 0x37AC8000, 0x37AD0000, 0x37AD8000, 0x37AE0000, 0x37AE8000, 0x37AF0000, 0x37AF8000,
  0x37B00000, 0x37B08000, 0x37B10000, 0x37B18000, 0x37B20000, 0x37B28000, 0x37B30000, 0x37B38000, 0x37B40000, 0x37B48000, 0x37B50000, 0x37B58000, 0x37B60000, 0x37B68000, 0x37B70000, 0x37B78000,
  0x37B80000, 0x37B88000, 0x37B90000, 0x37B98000, 0x37BA0000, 0x37BA8000, 0x37BB0000, 0x37BB8000, 0x37BC0000, 0x37BC8000, 0x37BD0000, 0x37BD8000, 0x37BE0000, 0x37BE8000, 0x37BF0000, 0x37BF8000,
  0x37C00000, 0x37C08000, 0x37C10000, 0x37C18000, 0x37C20000, 0x37C28000, 0x37C30000, 0x37C38000, 0x37C40000, 0x37C48000, 0x37C50000, 0x37C58000, 0x37C60000, 0x37C68000, 0x37C70000, 0x37C78000,
  0x37C80000, 0x37C88000, 0x37C90000, 0x37C98000, 0x37CA0000, 0x37CA8000, 0x37CB0000, 0x37CB8000, 0x37CC0000, 0x37CC8000, 0x37CD0000, 0x37CD8000, 0x37CE0000, 0x37CE8000, 0x37CF0000, 0x37CF8000,
  0x37D00000, 0x37D08000, 0x37D10000, 0x37D18000, 0x37D20000, 0x37D28000, 0x37D30000, 0x37D38000, 0x37D40000, 0x37D48000, 0x37D50000, 0x37D58000, 0x37D60000, 0x37D68000, 0x37D70000, 0x37D78000,
  0x37D80000, 0x37D88000, 0x37D90000, 0x37D98000, 0x37DA0000, 0x37DA8000, 0x37DB0000, 0x37DB8000, 0x37DC0000, 0x37DC8000, 0x37DD0000, 0x37DD8000, 0x37DE0000, 0x37DE8000, 0x37DF0000, 0x37DF8000,
  0x37E00000, 0x37E08000, 0x37E10000, 0x37E18000, 0x37E20000, 0x37E28000, 0x37E30000, 0x37E38000, 0x37E40000, 0x37E48000, 0x37E50000, 0x37E58000, 0x37E60000, 0x37E68000, 0x37E70000, 0x37E78000,
  0x37E80000, 0x37E88000, 0x37E90000, 0x37E98000, 0x37EA0000, 0x37EA8000, 0x37EB0000, 0x37EB8000, 0x37EC0000, 0x37EC8000, 0x37ED0000, 0x37ED8000, 0x37EE0000, 0x37EE8000, 0x37EF0000, 0x37EF8000,
  0x37F00000, 0x37F08000, 0x37F10000, 0x37F18000, 0x37F20000, 0x37F28000, 0x37F30000, 0x37F38000, 0x37F40000, 0x37F48000, 0x37F50000, 0x37F58000, 0x37F60000, 0x37F68000, 0x37F70000, 0x37F78000,
  0x37F80000, 0x37F88000, 0x37F90000, 0x37F98000, 0x37FA0000, 0x37FA8000, 0x37FB0000, 0x37FB8000, 0x37FC0000, 0x37FC8000, 0x37FD0000, 0x37FD8000, 0x37FE0000, 0x37FE8000, 0x37FF0000, 0x37FF8000,
  0x38000000, 0x38004000, 0x38008000, 0x3800C000, 0x38010000, 0x38014000, 0x38018000, 0x3801C000, 0x38020000, 0x38024000, 0x38028000, 0x3802C000, 0x38030000, 0x38034000, 0x38038000, 0x3803C000,
  0x38040000, 0x38044000, 0x38048000, 0x3804C000, 0x38050000, 0x38054000, 0x38058000, 0x3805C000, 0x38060000, 0x38064000, 0x38068000, 0x3806C000, 0x38070000, 0x38074000, 0x38078000, 0x3807C000,
  0x38080000, 0x38084000, 0x38088000, 0x3808C000, 0x38090000, 0x38094000, 0x38098000, 0x3809C000, 0x380A0000, 0x380A4000, 0x380A8000, 0x380AC000, 0x380B0000, 0x380B4000, 0x380B8000, 0x380BC000,
  0x380C0000, 0x380C4000, 0x380C8000, 0x380CC000, 0x380D0000, 0x380D4000, 0x380D8000, 0x380DC000, 0x380E0000, 0x380E4000, 0x380E8000, 0x380EC000, 0x380F0000, 0x380F4000, 0x380F8000, 0x380FC000,
  0x38100000, 0x38104000, 0x38108000, 0x3810C000, 0x38110000, 0x38114000, 0x38118000, 0x3811C000, 0x38120000, 0x38124000, 0x38128000, 0x3812C000, 0x38130000, 0x38134000, 0x38138000, 0x3813C000,
  0x38140000, 0x38144000, 0x38148000, 0x3814C000, 0x38150000, 0x38154000, 0x38158000, 0x3815C000, 0x38160000, 0x38164000, 0x38168000, 0x3816C000, 0x38170000, 0x38174000, 0x38178000, 0x3817C000,
  0x38180000, 0x38184000, 0x38188000, 0x3818C000, 0x38190000, 0x38194000, 0x38198000, 0x3819C000, 0x381A0000, 0x381A4000, 0x381A8000, 0x381AC000, 0x381B0000, 0x381B4000, 0x381B8000, 0x381BC000,
  0x381C0000, 0x381C4000, 0x381C8000, 0x381CC000, 0x381D0000, 0x381D4000, 0x381D8000, 0x381DC000, 0x381E0000, 0x381E4000, 0x381E8000, 0x381EC000, 0x381F0000, 0x381F4000, 0x381F8000, 0x381FC000,
  0x38200000, 0x38204000, 0x38208000, 0x3820C000, 0x38210000, 0x38214000, 0x38218000, 0x3821C000, 0x38220000, 0x38224000, 0x38228000, 0x3822C000, 0x38230000, 0x38234000, 0x38238000, 0x3823C000,
  0x38240000, 0x38244000, 0x38248000, 0x3824C000, 0x38250000, 0x38254000, 0x38258000, 0x3825C000, 0x38260000, 0x38264000, 0x38268000, 0x3826C000, 0x38270000, 0x38274000, 0x38278000, 0x3827C000,
  0x38280000, 0x38284000, 0x38288000, 0x3828C000, 0x38290000, 0x38294000, 0x38298000, 0x3829C000, 0x382A0000, 0x382A4000, 0x382A8000, 0x382AC000, 0x382B0000, 0x382B4000, 0x382B8000, 0x382BC000,
  0x382C0000, 0x382C4000, 0x382C8000, 0x382CC000, 0x382D0000, 0x382D4000, 0x382D8000, 0x382DC000, 0x382E0000, 0x382E4000, 0x382E8000, 0x382EC000, 0x382F0000, 0x382F4000, 0x382F8000, 0x382FC000,
  0x38300000, 0x38304000, 0x38308000, 0x3830C000, 0x38310000, 0x38314000, 0x38318000, 0x3831C000, 0x38320000, 0x38324000, 0x38328000, 0x3832C000, 0x38330000, 0x38334000, 0x38338000, 0x3833C000,
  0x38340000, 0x38344000, 0x38348000, 0x3834C000, 0x38350000, 0x38354000, 0x38358000, 0x3835C000, 0x38360000, 0x38364000, 0x38368000, 0x3836C000, 0x38370000, 0x38374000, 0x38378000, 0x3837C000,
  0x38380000, 0x38384000, 0x38388000, 0x3838C000, 0x38390000, 0x38394000, 0x38398000, 0x3839C000, 0x383A0000, 0x383A4000, 0x383A8000, 0x383AC000, 0x383B0000, 0x383B4000, 0x383B8000, 0x383BC000,
  0x383C0000, 0x383C4000, 0x383C8000, 0x383CC000, 0x383D0000, 0x383D4000, 0x383D8000, 0x383DC000, 0x383E0000, 0x383E4000, 0x383E8000, 0x383EC000, 0x383F0000, 0x383F4000, 0x383F8000, 0x383FC000,
  0x38400000, 0x38404000, 0x38408000, 0x3840C000, 0x38410000, 0x38414000, 0x38418000, 0x3841C000, 0x38420000, 0x38424000, 0x38428000, 0x3842C000, 0x38430000, 0x38434000, 0x38438000, 0x3843C000,
  0x38440000, 0x38444000, 0x38448000, 0x3844C000, 0x38450000, 0x38454000, 0x38458000, 0x3845C000, 0x38460000, 0x38464000, 0x38468000, 0x3846C000, 0x38470000, 0x38474000, 0x38478000, 0x3847C000,
  0x38480000, 0x38484000, 0x38488000, 0x3848C000, 0x38490000, 0x38494000, 0x38498000, 0x3849C000, 0x384A0000, 0x384A4000, 0x384A8000, 0x384AC000, 0x384B0000, 0x384B4000, 0x384B8000, 0x384BC000,
  0x384C0000, 0x384C4000, 0x384C8000, 0x384CC000, 0x384D0000, 0x384D4000, 0x384D8000, 0x384DC000, 0x384E0000, 0x384E4000, 0x384E8000, 0x384EC000, 0x384F0000, 0x384F4000, 0x384F8000, 0x384FC000,
  0x38500000, 0x38504000, 0x38508000, 0x3850C000, 0x38510000, 0x38514000, 0x38518000, 0x3851C000, 0x38520000, 0x38524000, 0x38528000, 0x3852C000, 0x38530000, 0x38534000, 0x38538000, 0x3853C000,
  0x38540000, 0x38544000, 0x38548000, 0x3854C000, 0x38550000, 0x38554000, 0x38558000, 0x3855C000, 0x38560000, 0x38564000, 0x38568000, 0x3856C000, 0x38570000, 0x38574000, 0x38578000, 0x3857C000,
  0x38580000, 0x38584000, 0x38588000, 0x3858C000, 0x38590000, 0x38594000, 0x38598000, 0x3859C000, 0x385A0000, 0x385A4000, 0x385A8000, 0x385AC000, 0x385B0000, 0x385B4000, 0x385B8000, 0x385BC000,
  0x385C0000, 0x385C4000, 0x385C8000, 0x385CC000, 0x385D0000, 0x385D4000, 0x385D8000, 0x385DC000, 0x385E0000, 0x385E4000, 0x385E8000, 0x385EC000, 0x385F0000, 0x385F4000, 0x385F8000, 0x385FC000,
  0x38600000, 0x38604000, 0x38608000, 0x3860C000, 0x38610000, 0x38614000, 0x38618000, 0x3861C000, 0x38620000, 0x38624000, 0x38628000, 0x3862C000, 0x38630000, 0x38634000, 0x38638000, 0x3863C000,
  0x38640000, 0x38644000, 0x38648000, 0x3864C000, 0x38650000, 0x38654000, 0x38658000, 0x3865C000, 0x38660000, 0x38664000, 0x38668000, 0x3866C000, 0x38670000, 0x38674000, 0x38678000, 0x3867C000,
  0x38680000, 0x38684000, 0x38688000, 0x3868C000, 0x38690000, 0x38694000, 0x38698000, 0x3869C000, 0x386A0000, 0x386A4000, 0x386A8000, 0x386AC000, 0x386B0000, 0x386B4000, 0x386B8000, 0x386BC000,
  0x386C0000, 0x386C4000, 0x386C8000, 0x386CC000, 0x386D0000, 0x386D4000, 0x386D8000, 0x386DC000, 0x386E0000, 0x386E4000, 0x386E8000, 0x386EC000, 0x386F0000, 0x386F4000, 0x386F8000, 0x386FC000,
  0x38700000, 0x38704000, 0x38708000, 0x3870C000, 0x38710000, 0x38714000, 0x38718000, 0x3871C000, 0x38720000, 0x38724000, 0x38728000, 0x3872C000, 0x38730000, 0x38734000, 0x38738000, 0x3873C000,
  0x38740000, 0x38744000, 0x38748000, 0x3874C000, 0x38750000, 0x38754000, 0x38758000, 0x3875C000, 0x38760000, 0x38764000, 0x38768000, 0x3876C000, 0x38770000, 0x38774000, 0x38778000, 0x3877C000,
  0x38780000, 0x38784000, 0x38788000, 0x3878C000, 0x38790000, 0x38794000, 0x38798000, 0x3879C000, 0x387A0000, 0x387A4000, 0x387A8000, 0x387AC000, 0x387B0000, 0x387B4000, 0x387B8000, 0x387BC000,
  0x387C0000, 0x387C4000, 0x387C8000, 0x387CC000, 0x387D0000, 0x387D4000, 0x387D8000, 0x387DC000, 0x387E0000, 0x387E4000, 0x387E8000, 0x387EC000, 0x387F0000, 0x387F4000, 0x387F8000, 0x387FC000,
  0x38000000, 0x38002000, 0x38004000, 0x38006000, 0x38008000, 0x3800A000, 0x3800C000, 0x3800E000, 0x38010000, 0x38012000, 0x38014000, 0x38016000, 0x38018000, 0x3801A000, 0x3801C000, 0x3801E000,
  0x38020000, 0x38022000, 0x38024000, 0x38026000, 0x38028000, 0x3802A000, 0x3802C000, 0x3802E000, 0x38030000, 0x38032000, 0x38034000, 0x38036000, 0x38038000, 0x3803A000, 0x3803C000, 0x3803E000,
  0x38040000, 0x38042000, 0x38044000, 0x38046000, 0x38048000, 0x3804A000, 0x3804C000, 0x3804E000, 0x38050000, 0x38052000, 0x38054000, 0x38056000, 0x38058000, 0x3805A000, 0x3805C000, 0x3805E000,
  0x38060000, 0x38062000, 0x38064000, 0x38066000, 0x38068000, 0x3806A000, 0x3806C000, 0x3806E000, 0x38070000, 0x38072000, 0x38074000, 0x38076000, 0x38078000, 0x3807A000, 0x3807C000, 0x3807E000,
  0x38080000, 0x38082000, 0x38084000, 0x38086000, 0x38088000, 0x3808A000, 0x3808C000, 0x3808E000, 0x38090000, 0x38092000, 0x38094000, 0x38096000, 0x38098000, 0x3809A000, 0x3809C000, 0x3809E000,
  0x380A0000, 0x380A2000, 0x380A4000, 0x380A6000, 0x380A8000, 0x380AA000, 0x380AC000, 0x380AE000, 0x380B0000, 0x380B2000, 0x380B4000, 0x380B6000, 0x380B8000, 0x380BA000, 0x380BC000, 0x380BE000,
  0x380C0000, 0x380C2000, 0x380C4000, 0x380C6000, 0x380C8000, 0x380CA000, 0x380CC000, 0x380CE000, 0x380D0000, 0x380D2000, 0x380D4000, 0x380D6000, 0x380D8000, 0x380DA000, 0x380DC000, 0x380DE000,
  0x380E0000, 0x380E2000, 0x380E4000, 0x380E6000, 0x380E8000, 0x380EA000, 0x380EC000, 0x380EE000, 0x380F0000, 0x380F2000, 0x380F4000, 0x380F6000, 0x380F8000, 0x380FA000, 0x380FC000, 0x380FE000,
  0x38100000, 0x38102000, 0x38104000, 0x38106000, 0x38108000, 0x3810A000, 0x3810C000, 0x3810E000, 0x38110000, 0x38112000, 0x38114000, 0x38116000, 0x38118000, 0x3811A000, 0x3811C000, 0x3811E000,
  0x38120000, 0x38122000, 0x38124000, 0x38126000, 0x38128000, 0x3812A000, 0x3812C000, 0x3812E000, 0x38130000, 0x38132000, 0x38134000, 0x38136000, 0x38138000, 0x3813A000, 0x3813C000, 0x3813E000,
  0x38140000, 0x38142000, 0x38144000, 0x38146000, 0x38148000, 0x3814A000, 0x3814C000, 0x3814E000, 0x38150000, 0x38152000, 0x38154000, 0x38156000, 0x38158000, 0x3815A000, 0x3815C000, 0x3815E000,
  0x38160000, 0x38162000, 0x38164000, 0x38166000, 0x38168000, 0x3816A000, 0x3816C000, 0x3816E000, 0x38170000, 0x38172000, 0x38174000, 0x38176000, 0x38178000, 0x3817A000, 0x3817C000, 0x3817E000,
  0x38180000, 0x38182000, 0x38184000, 0x38186000, 0x38188000, 0x3818A000, 0x3818C000, 0x3818E000, 0x38190000, 0x38192000, 0x38194000, 0x38196000, 0x38198000, 0x3819A000, 0x3819C000, 0x3819E000,
  0x381A0000, 0x381A2000, 0x381A4000, 0x381A6000, 0x381A8000, 0x381AA000, 0x381AC000, 0x381AE000, 0x381B0000, 0x381B2000, 0x381B4000, 0x381B6000, 0x381B8000, 0x381BA000, 0x381BC000, 0x381BE000,
  0x381C0000, 0x381C2000, 0x381C4000, 0x381C6000, 0x381C8000, 0x381CA000, 0x381CC000, 0x381CE000, 0x381D0000, 0x381D2000, 0x381D4000, 0x381D6000, 0x381D8000, 0x381DA000, 0x381DC000, 0x381DE000,
  0x381E0000, 0x381E2000, 0x381E4000, 0x381E6000, 0x381E8000, 0x381EA000, 0x381EC000, 0x381EE000, 0x381F0000, 0x381F2000, 0x381F4000, 0x381F6000, 0x381F8000, 0x381FA000, 0x381FC000, 0x381FE000,
  0x38200000, 0x38202000, 0x38204000, 0x38206000, 0x38208000, 0x3820A000, 0x3820C000, 0x3820E000, 0x38210000, 0x38212000, 0x38214000, 0x38216000, 0x38218000, 0x3821A000, 0x3821C000, 0x3821E000,
  0x38220000, 0x38222000, 0x38224000, 0x38226000, 0x38228000, 0x3822A000, 0x3822C000, 0x3822E000, 0x38230000, 0x38232000, 0x38234000, 0x38236000, 0x38238000, 0x3823A000, 0x3823C000, 0x3823E000,
  0x38240000, 0x38242000, 0x38244000, 0x38246000, 0x38248000, 0x3824A000, 0x3824C000, 0x3824E000, 0x38250000, 0x38252000, 0x38254000, 0x38256000, 0x38258000, 0x3825A000, 0x3825C000, 0x3825E000,
  0x38260000, 0x38262000, 0x38264000, 0x38266000, 0x38268000, 0x3826A000, 0x3826C000, 0x3826E000, 0x38270000, 0x38272000, 0x38274000, 0x38276000, 0x38278000, 0x3827A000, 0x3827C000, 0x3827E000,
  0x38280000, 0x38282000, 0x38284000, 0x38286000, 0x38288000, 0x3828A000, 0x3828C000, 0x3828E000, 0x38290000, 0x38292000, 0x38294000, 0x38296000, 0x38298000, 0x3829A000, 0x3829C000, 0x3829E000,
  0x382A0000, 0x382A2000, 0x382A4000, 0x382A6000, 0x382A8000, 0x382AA000, 0x382AC000, 0x382AE000, 0x382B0000, 0x382B2000, 0x382B4000, 0x382B6000, 0x382B8000, 0x382BA000, 0x382BC000, 0x382BE000,
  0x382C0000, 0x382C2000, 0x382C4000, 0x382C6000, 0x382C8000, 0x382CA000, 0x382CC000, 0x382CE000, 0x382D0000, 0x382D2000, 0x382D4000, 0x382D6000, 0x382D8000, 0x382DA000, 0x382DC000, 0x382DE000,
  0x382E0000, 0x382E2000, 0x382E4000, 0x382E6000, 0x382E8000, 0x382EA000, 0x382EC000, 0x382EE000, 0x382F0000, 0x382F2000, 0x382F4000, 0x382F6000, 0x382F8000, 0x382FA000, 0x382FC000, 0x382FE000,
  0x38300000, 0x38302000, 0x38304000, 0x38306000, 0x38308000, 0x3830A000, 0x3830C000, 0x3830E000, 0x38310000, 0x38312000, 0x38314000, 0x38316000, 0x38318000, 0x3831A000, 0x3831C000, 0x3831E000,
  0x38320000, 0x38322000, 0x38324000, 0x38326000, 0x38328000, 0x3832A000, 0x3832C000, 0x3832E000, 0x38330000, 0x38332000, 0x38334000, 0x38336000, 0x38338000, 0x3833A000, 0x3833C000, 0x3833E000,
  0x38340000, 0x38342000, 0x38344000, 0x38346000, 0x38348000, 0x3834A000, 0x3834C000, 0x3834E000, 0x38350000, 0x38352000, 0x38354000, 0x38356000, 0x38358000, 0x3835A000, 0x3835C000, 0x3835E000,
  0x38360000, 0x38362000, 0x38364000, 0x38366000, 0x38368000, 0x3836A000, 0x3836C000, 0x3836E000, 0x38370000, 0x38372000, 0x38374000, 0x38376000, 0x38378000, 0x3837A000, 0x3837C000, 0x3837E000,
  0x38380000, 0x38382000, 0x38384000, 0x38386000, 0x38388000, 0x3838A000, 0x3838C000, 0x3838E000, 0x38390000, 0x38392000, 0x38394000, 0x38396000, 0x38398000, 0x3839A000, 0x3839C000, 0x3839E000,
  0x383A0000, 0x383A2000, 0x383A4000, 0x383A6000, 0x383A8000, 0x383AA000, 0x383AC000, 0x383AE000, 0x383B0000, 0x383B2000, 0x383B4000, 0x383B6000, 0x383B8000, 0x383BA000, 0x383BC000, 0x383BE000,
  0x383C0000, 0x383C2000, 0x383C4000, 0x383C6000, 0x383C8000, 0x383CA000, 0x383CC000, 0x383CE000, 0x383D0000, 0x383D2000, 0x383D4000, 0x383D6000, 0x383D8000, 0x383DA000, 0x383DC000, 0x383DE000,
  0x383E0000, 0x383E2000, 0x383E4000, 0x383E6000, 0x383E8000, 0x383EA000, 0x383EC000, 0x383EE000, 0x383F0000, 0x383F2000, 0x383F4000, 0x383F6000, 0x383F8000, 0x383FA000, 0x383FC000, 0x383FE000,
  0x38400000, 0x38402000, 0x38404000, 0x38406000, 0x38408000, 0x3840A000, 0x3840C000, 0x3840E000, 0x38410000, 0x38412000, 0x38414000, 0x38416000, 0x38418000, 0x3841A000, 0x3841C000, 0x3841E000,
  0x38420000, 0x38422000, 0x38424000, 0x38426000, 0x38428000, 0x3842A000, 0x3842C000, 0x3842E000, 0x38430000, 0x38432000, 0x38434000, 0x38436000, 0x38438000, 0x3843A000, 0x3843C000, 0x3843E000,
  0x38440000, 0x38442000, 0x38444000, 0x38446000, 0x38448000, 0x3844A000, 0x3844C000, 0x3844E000, 0x38450000, 0x38452000, 0x38454000, 0x38456000, 0x38458000, 0x3845A000, 0x3845C000, 0x3845E000,
  0x38460000, 0x38462000, 0x38464000, 0x38466000, 0x38468000, 0x3846A000, 0x3846C000, 0x3846E000, 0x38470000, 0x38472000, 0x38474000, 0x38476000, 0x38478000, 0x3847A000, 0x3847C000, 0x3847E000,
  0x38480000, 0x38482000, 0x38484000, 0x38486000, 0x38488000, 0x3848A000, 0x3848C000, 0x3848E000, 0x38490000, 0x38492000, 0x38494000, 0x38496000, 0x38498000, 0x3849A000, 0x3849C000, 0x3849E000,
  0x384A0000, 0x384A2000, 0x384A4000, 0x384A6000, 0x384A8000, 0x384AA000, 0x384AC000, 0x384AE000, 0x384B0000, 0x384B2000, 0x384B4000, 0x384B6000, 0x384B8000, 0x384BA000, 0x384BC000, 0x384BE000,
  0x384C0000, 0x384C2000, 0x384C4000, 0x384C6000, 0x384C8000, 0x384CA000, 0x384CC000, 0x384CE000, 0x384D0000, 0x384D2000, 0x384D4000, 0x384D6000, 0x384D8000, 0x384DA000, 0x384DC000, 0x384DE000,
  0x384E0000, 0x384E2000, 0x384E4000, 0x384E6000, 0x384E8000, 0x384EA000, 0x384EC000, 0x384EE000, 0x384F0000, 0x384F2000, 0x384F4000, 0x384F6000, 0x384F8000, 0x384FA000, 0x384FC000, 0x384FE000,
  0x38500000, 0x38502000, 0x38504000, 0x38506000, 0x38508000, 0x3850A000, 0x3850C000, 0x3850E000, 0x38510000, 0x38512000, 0x38514000, 0x38516000, 0x38518000, 0x3851A000, 0x3851C000, 0x3851E000,
  0x38520000, 0x38522000, 0x38524000, 0x38526000, 0x38528000, 0x3852A000, 0x3852C000, 0x3852E000, 0x38530000, 0x38532000, 0x38534000, 0x38536000, 0x38538000, 0x3853A000, 0x3853C000, 0x3853E000,
  0x38540000, 0x38542000, 0x38544000, 0x38546000, 0x38548000, 0x3854A000, 0x3854C000, 0x3854E000, 0x38550000, 0x38552000, 0x38554000, 0x38556000, 0x38558000, 0x3855A000, 0x3855C000, 0x3855E000,
  0x38560000, 0x38562000, 0x38564000, 0x38566000, 0x38568000, 0x3856A000, 0x3856C000, 0x3856E000, 0x38570000, 0x38572000, 0x38574000, 0x38576000, 0x38578000, 0x3857A000, 0x3857C000, 0x3857E000,
  0x38580000, 0x38582000, 0x38584000, 0x38586000, 0x38588000, 0x3858A000, 0x3858C000, 0x3858E000, 0x38590000, 0x38592000, 0x38594000, 0x38596000, 0x38598000, 0x3859A000, 0x3859C000, 0x3859E000,
  0x385A0000, 0x385A2000, 0x385A4000, 0x385A6000, 0x385A8000, 0x385AA000, 0x385AC000, 0x385AE000, 0x385B0000, 0x385B2000, 0x385B4000, 0x385B6000, 0x385B8000, 0x385BA000, 0x385BC000, 0x385BE000,
  0x385C0000, 0x385C2000, 0x385C4000, 0x385C6000, 0x385C8000, 0x385CA000, 0x385CC000, 0x385CE000, 0x385D0000, 0x385D2000, 0x385D4000, 0x385D6000, 0x385D8000, 0x385DA000, 0x385DC000, 0x385DE000,
  0x385E0000, 0x385E2000, 0x385E4000, 0x385E6000, 0x385E8000, 0x385EA000, 0x385EC000, 0x385EE000, 0x385F0000, 0x385F2000, 0x385F4000, 0x385F6000, 0x385F8000, 0x385FA000, 0x385FC000, 0x385FE000,
  0x38600000, 0x38602000, 0x38604000, 0x38606000, 0x38608000, 0x3860A000, 0x3860C000, 0x3860E000, 0x38610000, 0x38612000, 0x38614000, 0x38616000, 0x38618000, 0x3861A000, 0x3861C000, 0x3861E000,
  0x38620000, 0x38622000, 0x38624000, 0x38626000, 0x38628000, 0x3862A000, 0x3862C000, 0x3862E000, 0x38630000, 0x38632000, 0x38634000, 0x38636000, 0x38638000, 0x3863A000, 0x3863C000, 0x3863E000,
  0x38640000, 0x38642000, 0x38644000, 0x38646000, 0x38648000, 0x3864A000, 0x3864C000, 0x3864E000, 0x38650000, 0x38652000, 0x38654000, 0x38656000, 0x38658000, 0x3865A000, 0x3865C000, 0x3865E000,
  0x38660000, 0x38662000, 0x38664000, 0x38666000, 0x38668000, 0x3866A000, 0x3866C000, 0x3866E000, 0x38670000, 0x38672000, 0x38674000, 0x38676000, 0x38678000, 0x3867A000, 0x3867C000, 0x3867E000,
  0x38680000, 0x38682000, 0x38684000, 0x38686000, 0x38688000, 0x3868A000, 0x3868C000, 0x3868E000, 0x38690000, 0x38692000, 0x38694000, 0x38696000, 0x38698000, 0x3869A000, 0x3869C000, 0x3869E000,
  0x386A0000, 0x386A2000, 0x386A4000, 0x386A6000, 0x386A8000, 0x386AA000, 0x386AC000, 0x386AE000, 0x386B0000, 0x386B2000, 0x386B4000, 0x386B6000, 0x386B8000, 0x386BA000, 0x386BC000, 0x386BE000,
  0x386C0000, 0x386C2000, 0x386C4000, 0x386C6000, 0x386C8000, 0x386CA000, 0x386CC000, 0x386CE000, 0x386D0000, 0x386D2000, 0x386D4000, 0x386D6000, 0x386D8000, 0x386DA000, 0x386DC000, 0x386DE000,
  0x386E0000, 0x386E2000, 0x386E4000, 0x386E6000, 0x386E8000, 0x386EA000, 0x386EC000, 0x386EE000, 0x386F0000, 0x386F2000, 0x386F4000, 0x386F6000, 0x386F8000, 0x386FA000, 0x386FC000, 0x386FE000,
  0x38700000, 0x38702000, 0x38704000, 0x38706000, 0x38708000, 0x3870A000, 0x3870C000, 0x3870E000, 0x38710000, 0x38712000, 0x38714000, 0x38716000, 0x38718000, 0x3871A000, 0x3871C000, 0x3871E000,
  0x38720000, 0x38722000, 0x38724000, 0x38726000, 0x38728000, 0x3872A000, 0x3872C000, 0x3872E000, 0x38730000, 0x38732000, 0x38734000, 0x38736000, 0x38738000, 0x3873A000, 0x3873C000, 0x3873E000,
  0x38740000, 0x38742000, 0x38744000, 0x38746000, 0x38748000, 0x3874A000, 0x3874C000, 0x3874E000, 0x38750000, 0x38752000, 0x38754000, 0x38756000, 0x38758000, 0x3875A000, 0x3875C000, 0x3875E000,
  0x38760000, 0x38762000, 0x38764000, 0x38766000, 0x38768000, 0x3876A000, 0x3876C000, 0x3876E000, 0x38770000, 0x38772000, 0x38774000, 0x38776000, 0x38778000, 0x3877A000, 0x3877C000, 0x3877E000,
  0x38780000, 0x38782000, 0x38784000, 0x38786000, 0x38788000, 0x3878A000, 0x3878C000, 0x3878E000, 0x38790000, 0x38792000, 0x38794000, 0x38796000, 0x38798000, 0x3879A000, 0x3879C000, 0x3879E000,
  0x387A0000, 0x387A2000, 0x387A4000, 0x387A6000, 0x387A8000, 0x387AA000, 0x387AC000, 0x387AE000, 0x387B0000, 0x387B2000, 0x387B4000, 0x387B6000, 0x387B8000, 0x387BA000, 0x387BC000, 0x387BE000,
  0x387C0000, 0x387C2000, 0x387C4000, 0x387C6000, 0x387C8000, 0x387CA000, 0x387CC000, 0x387CE000, 0x387D0000, 0x387D2000, 0x387D4000, 0x387D6000, 0x387D8000, 0x387DA000, 0x387DC000, 0x387DE000,
  0x387E0000, 0x387E2000, 0x387E4000, 0x387E6000, 0x387E8000, 0x387EA000, 0x387EC000, 0x387EE000, 0x387F0000, 0x387F2000, 0x387F4000, 0x387F6000, 0x387F8000, 0x387FA000, 0x387FC000, 0x387FE000 };
__constant static const uint32_t exponent_table[64] = {
  0x00000000, 0x00800000, 0x01000000, 0x01800000, 0x02000000, 0x02800000, 0x03000000, 0x03800000, 0x04000000, 0x04800000, 0x05000000, 0x05800000, 0x06000000, 0x06800000, 0x07000000, 0x07800000,
  0x08000000, 0x08800000, 0x09000000, 0x09800000, 0x0A000000, 0x0A800000, 0x0B000000, 0x0B800000, 0x0C000000, 0x0C800000, 0x0D000000, 0x0D800000, 0x0E000000, 0x0E800000, 0x0F000000, 0x47800000,
  0x80000000, 0x80800000, 0x81000000, 0x81800000, 0x82000000, 0x82800000, 0x83000000, 0x83800000, 0x84000000, 0x84800000, 0x85000000, 0x85800000, 0x86000000, 0x86800000, 0x87000000, 0x87800000,
  0x88000000, 0x88800000, 0x89000000, 0x89800000, 0x8A000000, 0x8A800000, 0x8B000000, 0x8B800000, 0x8C000000, 0x8C800000, 0x8D000000, 0x8D800000, 0x8E000000, 0x8E800000, 0x8F000000, 0xC7800000 };
__constant static const unsigned short offset_table[64] = {
  0, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
  0, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024 };

static uint16_t float2halfbits(float value) {
  union { float x; uint32_t y; } u;
  u.x = value;
  uint32_t bits = u.y;

  uint16_t hbits = base_table[bits>>23] + (uint16_t)((bits&0x7FFFFF)>>shift_table[bits>>23]);;

  return hbits;
}

static float halfbits2float(uint16_t value) {
  uint32_t bits = mantissa_table[offset_table[value>>10]+(value&0x3FF)] + exponent_table[value>>10];

  union { uint32_t x; float y; } u;
  u.x = bits;
  return u.y;
}

// End of half.h.
// Start of timing.h.

// The function get_wall_time() returns the wall time in microseconds
// (with an unspecified offset).

#ifdef _WIN32

#include <windows.h>

static int64_t get_wall_time(void) {
  LARGE_INTEGER time,freq;
  assert(QueryPerformanceFrequency(&freq));
  assert(QueryPerformanceCounter(&time));
  return ((double)time.QuadPart / freq.QuadPart) * 1000000;
}

#else
// Assuming POSIX

#include <time.h>
#include <sys/time.h>

static int64_t get_wall_time(void) {
  struct timeval time;
  assert(gettimeofday(&time,NULL) == 0);
  return time.tv_sec * 1000000 + time.tv_usec;
}

static int64_t get_wall_time_ns(void) {
  struct timespec time;
  assert(clock_gettime(CLOCK_REALTIME, &time) == 0);
  return time.tv_sec * 1000000000 + time.tv_nsec;
}

#endif

// End of timing.h.

#ifdef _MSC_VER
#define inline __inline
#endif
#include <string.h>
#include <string.h>
#include <errno.h>
#include <assert.h>
#include <ctype.h>



// Start of lock.h.

// A very simple cross-platform implementation of locks.  Uses
// pthreads on Unix and some Windows thing there.  Futhark's
// host-level code is not multithreaded, but user code may be, so we
// need some mechanism for ensuring atomic access to API functions.
// This is that mechanism.  It is not exposed to user code at all, so
// we do not have to worry about name collisions.

#ifdef _WIN32

typedef HANDLE lock_t;

static void create_lock(lock_t *lock) {
  *lock = CreateMutex(NULL,  // Default security attributes.
                      FALSE, // Initially unlocked.
                      NULL); // Unnamed.
}

static void lock_lock(lock_t *lock) {
  assert(WaitForSingleObject(*lock, INFINITE) == WAIT_OBJECT_0);
}

static void lock_unlock(lock_t *lock) {
  assert(ReleaseMutex(*lock));
}

static void free_lock(lock_t *lock) {
  CloseHandle(*lock);
}

#else
// Assuming POSIX

#include <pthread.h>

typedef pthread_mutex_t lock_t;

static void create_lock(lock_t *lock) {
  int r = pthread_mutex_init(lock, NULL);
  assert(r == 0);
}

static void lock_lock(lock_t *lock) {
  int r = pthread_mutex_lock(lock);
  assert(r == 0);
}

static void lock_unlock(lock_t *lock) {
  int r = pthread_mutex_unlock(lock);
  assert(r == 0);
}

static void free_lock(lock_t *lock) {
  // Nothing to do for pthreads.
  (void)lock;
}

#endif

// End of lock.h.

#define FUTHARK_F64_ENABLED

// Start of scalar.h.

// Implementation of the primitive scalar operations.  Very
// repetitive.  This code is inserted directly into both CUDA and
// OpenCL programs, as well as the CPU code, so it has some #ifdefs to
// work everywhere.  Some operations are defined as macros because
// this allows us to use them as constant expressions in things like
// array sizes and static initialisers.

// Some of the #ifdefs are because OpenCL uses type-generic functions
// for some operations (e.g. sqrt), while C and CUDA sensibly use
// distinct functions for different precisions (e.g. sqrtf() and
// sqrt()).  This is quite annoying.  Due to C's unfortunate casting
// rules, it is also really easy to accidentally implement
// floating-point functions in the wrong precision, so be careful.

// Double-precision definitions are only included if the preprocessor
// macro FUTHARK_F64_ENABLED is set.

static inline uint8_t add8(uint8_t x, uint8_t y) {
  return x + y;
}

static inline uint16_t add16(uint16_t x, uint16_t y) {
  return x + y;
}

static inline uint32_t add32(uint32_t x, uint32_t y) {
  return x + y;
}

static inline uint64_t add64(uint64_t x, uint64_t y) {
  return x + y;
}

static inline uint8_t sub8(uint8_t x, uint8_t y) {
  return x - y;
}

static inline uint16_t sub16(uint16_t x, uint16_t y) {
  return x - y;
}

static inline uint32_t sub32(uint32_t x, uint32_t y) {
  return x - y;
}

static inline uint64_t sub64(uint64_t x, uint64_t y) {
  return x - y;
}

static inline uint8_t mul8(uint8_t x, uint8_t y) {
  return x * y;
}

static inline uint16_t mul16(uint16_t x, uint16_t y) {
  return x * y;
}

static inline uint32_t mul32(uint32_t x, uint32_t y) {
  return x * y;
}

static inline uint64_t mul64(uint64_t x, uint64_t y) {
  return x * y;
}

static inline uint8_t udiv8(uint8_t x, uint8_t y) {
  return x / y;
}

static inline uint16_t udiv16(uint16_t x, uint16_t y) {
  return x / y;
}

static inline uint32_t udiv32(uint32_t x, uint32_t y) {
  return x / y;
}

static inline uint64_t udiv64(uint64_t x, uint64_t y) {
  return x / y;
}

static inline uint8_t udiv_up8(uint8_t x, uint8_t y) {
  return (x + y - 1) / y;
}

static inline uint16_t udiv_up16(uint16_t x, uint16_t y) {
  return (x + y - 1) / y;
}

static inline uint32_t udiv_up32(uint32_t x, uint32_t y) {
  return (x + y - 1) / y;
}

static inline uint64_t udiv_up64(uint64_t x, uint64_t y) {
  return (x + y - 1) / y;
}

static inline uint8_t umod8(uint8_t x, uint8_t y) {
  return x % y;
}

static inline uint16_t umod16(uint16_t x, uint16_t y) {
  return x % y;
}

static inline uint32_t umod32(uint32_t x, uint32_t y) {
  return x % y;
}

static inline uint64_t umod64(uint64_t x, uint64_t y) {
  return x % y;
}

static inline uint8_t udiv_safe8(uint8_t x, uint8_t y) {
  return y == 0 ? 0 : x / y;
}

static inline uint16_t udiv_safe16(uint16_t x, uint16_t y) {
  return y == 0 ? 0 : x / y;
}

static inline uint32_t udiv_safe32(uint32_t x, uint32_t y) {
  return y == 0 ? 0 : x / y;
}

static inline uint64_t udiv_safe64(uint64_t x, uint64_t y) {
  return y == 0 ? 0 : x / y;
}

static inline uint8_t udiv_up_safe8(uint8_t x, uint8_t y) {
  return y == 0 ? 0 : (x + y - 1) / y;
}

static inline uint16_t udiv_up_safe16(uint16_t x, uint16_t y) {
  return y == 0 ? 0 : (x + y - 1) / y;
}

static inline uint32_t udiv_up_safe32(uint32_t x, uint32_t y) {
  return y == 0 ? 0 : (x + y - 1) / y;
}

static inline uint64_t udiv_up_safe64(uint64_t x, uint64_t y) {
  return y == 0 ? 0 : (x + y - 1) / y;
}

static inline uint8_t umod_safe8(uint8_t x, uint8_t y) {
  return y == 0 ? 0 : x % y;
}

static inline uint16_t umod_safe16(uint16_t x, uint16_t y) {
  return y == 0 ? 0 : x % y;
}

static inline uint32_t umod_safe32(uint32_t x, uint32_t y) {
  return y == 0 ? 0 : x % y;
}

static inline uint64_t umod_safe64(uint64_t x, uint64_t y) {
  return y == 0 ? 0 : x % y;
}

static inline int8_t sdiv8(int8_t x, int8_t y) {
  int8_t q = x / y;
  int8_t r = x % y;

  return q - ((r != 0 && r < 0 != y < 0) ? 1 : 0);
}

static inline int16_t sdiv16(int16_t x, int16_t y) {
  int16_t q = x / y;
  int16_t r = x % y;

  return q - ((r != 0 && r < 0 != y < 0) ? 1 : 0);
}

static inline int32_t sdiv32(int32_t x, int32_t y) {
  int32_t q = x / y;
  int32_t r = x % y;

  return q - ((r != 0 && r < 0 != y < 0) ? 1 : 0);
}

static inline int64_t sdiv64(int64_t x, int64_t y) {
  int64_t q = x / y;
  int64_t r = x % y;

  return q - ((r != 0 && r < 0 != y < 0) ? 1 : 0);
}

static inline int8_t sdiv_up8(int8_t x, int8_t y) {
  return sdiv8(x + y - 1, y);
}

static inline int16_t sdiv_up16(int16_t x, int16_t y) {
  return sdiv16(x + y - 1, y);
}

static inline int32_t sdiv_up32(int32_t x, int32_t y) {
  return sdiv32(x + y - 1, y);
}

static inline int64_t sdiv_up64(int64_t x, int64_t y) {
  return sdiv64(x + y - 1, y);
}

static inline int8_t smod8(int8_t x, int8_t y) {
  int8_t r = x % y;

  return r + (r == 0 || (x > 0 && y > 0) || (x < 0 && y < 0) ? 0 : y);
}

static inline int16_t smod16(int16_t x, int16_t y) {
  int16_t r = x % y;

  return r + (r == 0 || (x > 0 && y > 0) || (x < 0 && y < 0) ? 0 : y);
}

static inline int32_t smod32(int32_t x, int32_t y) {
  int32_t r = x % y;

  return r + (r == 0 || (x > 0 && y > 0) || (x < 0 && y < 0) ? 0 : y);
}

static inline int64_t smod64(int64_t x, int64_t y) {
  int64_t r = x % y;

  return r + (r == 0 || (x > 0 && y > 0) || (x < 0 && y < 0) ? 0 : y);
}

static inline int8_t sdiv_safe8(int8_t x, int8_t y) {
  return y == 0 ? 0 : sdiv8(x, y);
}

static inline int16_t sdiv_safe16(int16_t x, int16_t y) {
  return y == 0 ? 0 : sdiv16(x, y);
}

static inline int32_t sdiv_safe32(int32_t x, int32_t y) {
  return y == 0 ? 0 : sdiv32(x, y);
}

static inline int64_t sdiv_safe64(int64_t x, int64_t y) {
  return y == 0 ? 0 : sdiv64(x, y);
}

static inline int8_t sdiv_up_safe8(int8_t x, int8_t y) {
  return sdiv_safe8(x + y - 1, y);
}

static inline int16_t sdiv_up_safe16(int16_t x, int16_t y) {
  return sdiv_safe16(x + y - 1, y);
}

static inline int32_t sdiv_up_safe32(int32_t x, int32_t y) {
  return sdiv_safe32(x + y - 1, y);
}

static inline int64_t sdiv_up_safe64(int64_t x, int64_t y) {
  return sdiv_safe64(x + y - 1, y);
}

static inline int8_t smod_safe8(int8_t x, int8_t y) {
  return y == 0 ? 0 : smod8(x, y);
}

static inline int16_t smod_safe16(int16_t x, int16_t y) {
  return y == 0 ? 0 : smod16(x, y);
}

static inline int32_t smod_safe32(int32_t x, int32_t y) {
  return y == 0 ? 0 : smod32(x, y);
}

static inline int64_t smod_safe64(int64_t x, int64_t y) {
  return y == 0 ? 0 : smod64(x, y);
}

static inline int8_t squot8(int8_t x, int8_t y) {
  return x / y;
}

static inline int16_t squot16(int16_t x, int16_t y) {
  return x / y;
}

static inline int32_t squot32(int32_t x, int32_t y) {
  return x / y;
}

static inline int64_t squot64(int64_t x, int64_t y) {
  return x / y;
}

static inline int8_t srem8(int8_t x, int8_t y) {
  return x % y;
}

static inline int16_t srem16(int16_t x, int16_t y) {
  return x % y;
}

static inline int32_t srem32(int32_t x, int32_t y) {
  return x % y;
}

static inline int64_t srem64(int64_t x, int64_t y) {
  return x % y;
}

static inline int8_t squot_safe8(int8_t x, int8_t y) {
  return y == 0 ? 0 : x / y;
}

static inline int16_t squot_safe16(int16_t x, int16_t y) {
  return y == 0 ? 0 : x / y;
}

static inline int32_t squot_safe32(int32_t x, int32_t y) {
  return y == 0 ? 0 : x / y;
}

static inline int64_t squot_safe64(int64_t x, int64_t y) {
  return y == 0 ? 0 : x / y;
}

static inline int8_t srem_safe8(int8_t x, int8_t y) {
  return y == 0 ? 0 : x % y;
}

static inline int16_t srem_safe16(int16_t x, int16_t y) {
  return y == 0 ? 0 : x % y;
}

static inline int32_t srem_safe32(int32_t x, int32_t y) {
  return y == 0 ? 0 : x % y;
}

static inline int64_t srem_safe64(int64_t x, int64_t y) {
  return y == 0 ? 0 : x % y;
}

static inline int8_t smin8(int8_t x, int8_t y) {
  return x < y ? x : y;
}

static inline int16_t smin16(int16_t x, int16_t y) {
  return x < y ? x : y;
}

static inline int32_t smin32(int32_t x, int32_t y) {
  return x < y ? x : y;
}

static inline int64_t smin64(int64_t x, int64_t y) {
  return x < y ? x : y;
}

static inline uint8_t umin8(uint8_t x, uint8_t y) {
  return x < y ? x : y;
}

static inline uint16_t umin16(uint16_t x, uint16_t y) {
  return x < y ? x : y;
}

static inline uint32_t umin32(uint32_t x, uint32_t y) {
  return x < y ? x : y;
}

static inline uint64_t umin64(uint64_t x, uint64_t y) {
  return x < y ? x : y;
}

static inline int8_t smax8(int8_t x, int8_t y) {
  return x < y ? y : x;
}

static inline int16_t smax16(int16_t x, int16_t y) {
  return x < y ? y : x;
}

static inline int32_t smax32(int32_t x, int32_t y) {
  return x < y ? y : x;
}

static inline int64_t smax64(int64_t x, int64_t y) {
  return x < y ? y : x;
}

static inline uint8_t umax8(uint8_t x, uint8_t y) {
  return x < y ? y : x;
}

static inline uint16_t umax16(uint16_t x, uint16_t y) {
  return x < y ? y : x;
}

static inline uint32_t umax32(uint32_t x, uint32_t y) {
  return x < y ? y : x;
}

static inline uint64_t umax64(uint64_t x, uint64_t y) {
  return x < y ? y : x;
}

static inline uint8_t shl8(uint8_t x, uint8_t y) {
  return (uint8_t)(x << y);
}

static inline uint16_t shl16(uint16_t x, uint16_t y) {
  return (uint16_t)(x << y);
}

static inline uint32_t shl32(uint32_t x, uint32_t y) {
  return x << y;
}

static inline uint64_t shl64(uint64_t x, uint64_t y) {
  return x << y;
}

static inline uint8_t lshr8(uint8_t x, uint8_t y) {
  return x >> y;
}

static inline uint16_t lshr16(uint16_t x, uint16_t y) {
  return x >> y;
}

static inline uint32_t lshr32(uint32_t x, uint32_t y) {
  return x >> y;
}

static inline uint64_t lshr64(uint64_t x, uint64_t y) {
  return x >> y;
}

static inline int8_t ashr8(int8_t x, int8_t y) {
  return x >> y;
}

static inline int16_t ashr16(int16_t x, int16_t y) {
  return x >> y;
}

static inline int32_t ashr32(int32_t x, int32_t y) {
  return x >> y;
}

static inline int64_t ashr64(int64_t x, int64_t y) {
  return x >> y;
}

static inline uint8_t and8(uint8_t x, uint8_t y) {
  return x & y;
}

static inline uint16_t and16(uint16_t x, uint16_t y) {
  return x & y;
}

static inline uint32_t and32(uint32_t x, uint32_t y) {
  return x & y;
}

static inline uint64_t and64(uint64_t x, uint64_t y) {
  return x & y;
}

static inline uint8_t or8(uint8_t x, uint8_t y) {
  return x | y;
}

static inline uint16_t or16(uint16_t x, uint16_t y) {
  return x | y;
}

static inline uint32_t or32(uint32_t x, uint32_t y) {
  return x | y;
}

static inline uint64_t or64(uint64_t x, uint64_t y) {
  return x | y;
}

static inline uint8_t xor8(uint8_t x, uint8_t y) {
  return x ^ y;
}

static inline uint16_t xor16(uint16_t x, uint16_t y) {
  return x ^ y;
}

static inline uint32_t xor32(uint32_t x, uint32_t y) {
  return x ^ y;
}

static inline uint64_t xor64(uint64_t x, uint64_t y) {
  return x ^ y;
}

static inline bool ult8(uint8_t x, uint8_t y) {
  return x < y;
}

static inline bool ult16(uint16_t x, uint16_t y) {
  return x < y;
}

static inline bool ult32(uint32_t x, uint32_t y) {
  return x < y;
}

static inline bool ult64(uint64_t x, uint64_t y) {
  return x < y;
}

static inline bool ule8(uint8_t x, uint8_t y) {
  return x <= y;
}

static inline bool ule16(uint16_t x, uint16_t y) {
  return x <= y;
}

static inline bool ule32(uint32_t x, uint32_t y) {
  return x <= y;
}

static inline bool ule64(uint64_t x, uint64_t y) {
  return x <= y;
}

static inline bool slt8(int8_t x, int8_t y) {
  return x < y;
}

static inline bool slt16(int16_t x, int16_t y) {
  return x < y;
}

static inline bool slt32(int32_t x, int32_t y) {
  return x < y;
}

static inline bool slt64(int64_t x, int64_t y) {
  return x < y;
}

static inline bool sle8(int8_t x, int8_t y) {
  return x <= y;
}

static inline bool sle16(int16_t x, int16_t y) {
  return x <= y;
}

static inline bool sle32(int32_t x, int32_t y) {
  return x <= y;
}

static inline bool sle64(int64_t x, int64_t y) {
  return x <= y;
}

static inline uint8_t pow8(uint8_t x, uint8_t y) {
  uint8_t res = 1, rem = y;

  while (rem != 0) {
    if (rem & 1)
      res *= x;
    rem >>= 1;
    x *= x;
  }
  return res;
}

static inline uint16_t pow16(uint16_t x, uint16_t y) {
  uint16_t res = 1, rem = y;

  while (rem != 0) {
    if (rem & 1)
      res *= x;
    rem >>= 1;
    x *= x;
  }
  return res;
}

static inline uint32_t pow32(uint32_t x, uint32_t y) {
  uint32_t res = 1, rem = y;

  while (rem != 0) {
    if (rem & 1)
      res *= x;
    rem >>= 1;
    x *= x;
  }
  return res;
}

static inline uint64_t pow64(uint64_t x, uint64_t y) {
  uint64_t res = 1, rem = y;

  while (rem != 0) {
    if (rem & 1)
      res *= x;
    rem >>= 1;
    x *= x;
  }
  return res;
}

static inline bool itob_i8_bool(int8_t x) {
  return x;
}

static inline bool itob_i16_bool(int16_t x) {
  return x;
}

static inline bool itob_i32_bool(int32_t x) {
  return x;
}

static inline bool itob_i64_bool(int64_t x) {
  return x;
}

static inline int8_t btoi_bool_i8(bool x) {
  return x;
}

static inline int16_t btoi_bool_i16(bool x) {
  return x;
}

static inline int32_t btoi_bool_i32(bool x) {
  return x;
}

static inline int64_t btoi_bool_i64(bool x) {
  return x;
}

#define sext_i8_i8(x) ((int8_t) (int8_t) (x))
#define sext_i8_i16(x) ((int16_t) (int8_t) (x))
#define sext_i8_i32(x) ((int32_t) (int8_t) (x))
#define sext_i8_i64(x) ((int64_t) (int8_t) (x))
#define sext_i16_i8(x) ((int8_t) (int16_t) (x))
#define sext_i16_i16(x) ((int16_t) (int16_t) (x))
#define sext_i16_i32(x) ((int32_t) (int16_t) (x))
#define sext_i16_i64(x) ((int64_t) (int16_t) (x))
#define sext_i32_i8(x) ((int8_t) (int32_t) (x))
#define sext_i32_i16(x) ((int16_t) (int32_t) (x))
#define sext_i32_i32(x) ((int32_t) (int32_t) (x))
#define sext_i32_i64(x) ((int64_t) (int32_t) (x))
#define sext_i64_i8(x) ((int8_t) (int64_t) (x))
#define sext_i64_i16(x) ((int16_t) (int64_t) (x))
#define sext_i64_i32(x) ((int32_t) (int64_t) (x))
#define sext_i64_i64(x) ((int64_t) (int64_t) (x))
#define zext_i8_i8(x) ((int8_t) (uint8_t) (x))
#define zext_i8_i16(x) ((int16_t) (uint8_t) (x))
#define zext_i8_i32(x) ((int32_t) (uint8_t) (x))
#define zext_i8_i64(x) ((int64_t) (uint8_t) (x))
#define zext_i16_i8(x) ((int8_t) (uint16_t) (x))
#define zext_i16_i16(x) ((int16_t) (uint16_t) (x))
#define zext_i16_i32(x) ((int32_t) (uint16_t) (x))
#define zext_i16_i64(x) ((int64_t) (uint16_t) (x))
#define zext_i32_i8(x) ((int8_t) (uint32_t) (x))
#define zext_i32_i16(x) ((int16_t) (uint32_t) (x))
#define zext_i32_i32(x) ((int32_t) (uint32_t) (x))
#define zext_i32_i64(x) ((int64_t) (uint32_t) (x))
#define zext_i64_i8(x) ((int8_t) (uint64_t) (x))
#define zext_i64_i16(x) ((int16_t) (uint64_t) (x))
#define zext_i64_i32(x) ((int32_t) (uint64_t) (x))
#define zext_i64_i64(x) ((int64_t) (uint64_t) (x))

static int8_t abs8(int8_t x) {
  return (int8_t)abs(x);
}

static int16_t abs16(int16_t x) {
  return (int16_t)abs(x);
}

static int32_t abs32(int32_t x) {
  return abs(x);
}

static int64_t abs64(int64_t x) {
#if defined(__OPENCL_VERSION__)
  return abs(x);
#else
  return llabs(x);
#endif
}

#if defined(__OPENCL_VERSION__)
static int32_t futrts_popc8(int8_t x) {
  return popcount(x);
}

static int32_t futrts_popc16(int16_t x) {
  return popcount(x);
}

static int32_t futrts_popc32(int32_t x) {
  return popcount(x);
}

static int32_t futrts_popc64(int64_t x) {
  return popcount(x);
}
#elif defined(__CUDA_ARCH__)

static int32_t futrts_popc8(int8_t x) {
  return __popc(zext_i8_i32(x));
}

static int32_t futrts_popc16(int16_t x) {
  return __popc(zext_i16_i32(x));
}

static int32_t futrts_popc32(int32_t x) {
  return __popc(x);
}

static int32_t futrts_popc64(int64_t x) {
  return __popcll(x);
}

#else // Not OpenCL or CUDA, but plain C.

static int32_t futrts_popc8(uint8_t x) {
  int c = 0;
  for (; x; ++c) { x &= x - 1; }
  return c;
}

static int32_t futrts_popc16(uint16_t x) {
  int c = 0;
  for (; x; ++c) { x &= x - 1; }
  return c;
}

static int32_t futrts_popc32(uint32_t x) {
  int c = 0;
  for (; x; ++c) { x &= x - 1; }
  return c;
}

static int32_t futrts_popc64(uint64_t x) {
  int c = 0;
  for (; x; ++c) { x &= x - 1; }
  return c;
}
#endif

#if defined(__OPENCL_VERSION__)
static uint8_t futrts_mul_hi8(uint8_t a, uint8_t b) {
  return mul_hi(a, b);
}

static uint16_t futrts_mul_hi16(uint16_t a, uint16_t b) {
  return mul_hi(a, b);
}

static uint32_t futrts_mul_hi32(uint32_t a, uint32_t b) {
  return mul_hi(a, b);
}

static uint64_t futrts_mul_hi64(uint64_t a, uint64_t b) {
  return mul_hi(a, b);
}

#elif defined(__CUDA_ARCH__)

static uint8_t futrts_mul_hi8(uint8_t a, uint8_t b) {
  uint16_t aa = a;
  uint16_t bb = b;

  return aa * bb >> 8;
}

static uint16_t futrts_mul_hi16(uint16_t a, uint16_t b) {
  uint32_t aa = a;
  uint32_t bb = b;

  return aa * bb >> 16;
}

static uint32_t futrts_mul_hi32(uint32_t a, uint32_t b) {
  return mulhi(a, b);
}

static uint64_t futrts_mul_hi64(uint64_t a, uint64_t b) {
  return mul64hi(a, b);
}

#else // Not OpenCL or CUDA, but plain C.

static uint8_t futrts_mul_hi8(uint8_t a, uint8_t b) {
  uint16_t aa = a;
  uint16_t bb = b;

  return aa * bb >> 8;
}

static uint16_t futrts_mul_hi16(uint16_t a, uint16_t b) {
  uint32_t aa = a;
  uint32_t bb = b;

  return aa * bb >> 16;
}

static uint32_t futrts_mul_hi32(uint32_t a, uint32_t b) {
  uint64_t aa = a;
  uint64_t bb = b;

  return aa * bb >> 32;
}

static uint64_t futrts_mul_hi64(uint64_t a, uint64_t b) {
  __uint128_t aa = a;
  __uint128_t bb = b;

  return aa * bb >> 64;
}
#endif

#if defined(__OPENCL_VERSION__)
static uint8_t futrts_mad_hi8(uint8_t a, uint8_t b, uint8_t c) {
  return mad_hi(a, b, c);
}

static uint16_t futrts_mad_hi16(uint16_t a, uint16_t b, uint16_t c) {
  return mad_hi(a, b, c);
}

static uint32_t futrts_mad_hi32(uint32_t a, uint32_t b, uint32_t c) {
  return mad_hi(a, b, c);
}

static uint64_t futrts_mad_hi64(uint64_t a, uint64_t b, uint64_t c) {
  return mad_hi(a, b, c);
}

#else // Not OpenCL

static uint8_t futrts_mad_hi8(uint8_t a, uint8_t b, uint8_t c) {
  return futrts_mul_hi8(a, b) + c;
}

static uint16_t futrts_mad_hi16(uint16_t a, uint16_t b, uint16_t c) {
  return futrts_mul_hi16(a, b) + c;
}

static uint32_t futrts_mad_hi32(uint32_t a, uint32_t b, uint32_t c) {
  return futrts_mul_hi32(a, b) + c;
}

static uint64_t futrts_mad_hi64(uint64_t a, uint64_t b, uint64_t c) {
  return futrts_mul_hi64(a, b) + c;
}
#endif

#if defined(__OPENCL_VERSION__)
static int32_t futrts_clzz8(int8_t x) {
  return clz(x);
}

static int32_t futrts_clzz16(int16_t x) {
  return clz(x);
}

static int32_t futrts_clzz32(int32_t x) {
  return clz(x);
}

static int32_t futrts_clzz64(int64_t x) {
  return clz(x);
}

#elif defined(__CUDA_ARCH__)

static int32_t futrts_clzz8(int8_t x) {
  return __clz(zext_i8_i32(x)) - 24;
}

static int32_t futrts_clzz16(int16_t x) {
  return __clz(zext_i16_i32(x)) - 16;
}

static int32_t futrts_clzz32(int32_t x) {
  return __clz(x);
}

static int32_t futrts_clzz64(int64_t x) {
  return __clzll(x);
}

#else // Not OpenCL or CUDA, but plain C.

static int32_t futrts_clzz8(int8_t x) {
  return x == 0 ? 8 : __builtin_clz((uint32_t)zext_i8_i32(x)) - 24;
}

static int32_t futrts_clzz16(int16_t x) {
  return x == 0 ? 16 : __builtin_clz((uint32_t)zext_i16_i32(x)) - 16;
}

static int32_t futrts_clzz32(int32_t x) {
  return x == 0 ? 32 : __builtin_clz((uint32_t)x);
}

static int32_t futrts_clzz64(int64_t x) {
  return x == 0 ? 64 : __builtin_clzll((uint64_t)x);
}
#endif

#if defined(__OPENCL_VERSION__)
static int32_t futrts_ctzz8(int8_t x) {
  int i = 0;
  for (; i < 8 && (x & 1) == 0; i++, x >>= 1)
    ;
  return i;
}

static int32_t futrts_ctzz16(int16_t x) {
  int i = 0;
  for (; i < 16 && (x & 1) == 0; i++, x >>= 1)
    ;
  return i;
}

static int32_t futrts_ctzz32(int32_t x) {
  int i = 0;
  for (; i < 32 && (x & 1) == 0; i++, x >>= 1)
    ;
  return i;
}

static int32_t futrts_ctzz64(int64_t x) {
  int i = 0;
  for (; i < 64 && (x & 1) == 0; i++, x >>= 1)
    ;
  return i;
}

#elif defined(__CUDA_ARCH__)

static int32_t futrts_ctzz8(int8_t x) {
  int y = __ffs(x);
  return y == 0 ? 8 : y - 1;
}

static int32_t futrts_ctzz16(int16_t x) {
  int y = __ffs(x);
  return y == 0 ? 16 : y - 1;
}

static int32_t futrts_ctzz32(int32_t x) {
  int y = __ffs(x);
  return y == 0 ? 32 : y - 1;
}

static int32_t futrts_ctzz64(int64_t x) {
  int y = __ffsll(x);
  return y == 0 ? 64 : y - 1;
}

#else // Not OpenCL or CUDA, but plain C.

static int32_t futrts_ctzz8(int8_t x) {
  return x == 0 ? 8 : __builtin_ctz((uint32_t)x);
}

static int32_t futrts_ctzz16(int16_t x) {
  return x == 0 ? 16 : __builtin_ctz((uint32_t)x);
}

static int32_t futrts_ctzz32(int32_t x) {
  return x == 0 ? 32 : __builtin_ctz((uint32_t)x);
}

static int32_t futrts_ctzz64(int64_t x) {
  return x == 0 ? 64 : __builtin_ctzll((uint64_t)x);
}
#endif

static inline float fdiv32(float x, float y) {
  return x / y;
}

static inline float fadd32(float x, float y) {
  return x + y;
}

static inline float fsub32(float x, float y) {
  return x - y;
}

static inline float fmul32(float x, float y) {
  return x * y;
}

static inline bool cmplt32(float x, float y) {
  return x < y;
}

static inline bool cmple32(float x, float y) {
  return x <= y;
}

static inline float sitofp_i8_f32(int8_t x) {
  return (float) x;
}

static inline float sitofp_i16_f32(int16_t x) {
  return (float) x;
}

static inline float sitofp_i32_f32(int32_t x) {
  return (float) x;
}

static inline float sitofp_i64_f32(int64_t x) {
  return (float) x;
}

static inline float uitofp_i8_f32(uint8_t x) {
  return (float) x;
}

static inline float uitofp_i16_f32(uint16_t x) {
  return (float) x;
}

static inline float uitofp_i32_f32(uint32_t x) {
  return (float) x;
}

static inline float uitofp_i64_f32(uint64_t x) {
  return (float) x;
}

static inline int8_t fptosi_f32_i8(float x) {
  return (int8_t) x;
}

static inline int16_t fptosi_f32_i16(float x) {
  return (int16_t) x;
}

static inline int32_t fptosi_f32_i32(float x) {
  return (int32_t) x;
}

static inline int64_t fptosi_f32_i64(float x) {
  return (int64_t) x;
}

static inline uint8_t fptoui_f32_i8(float x) {
  return (uint8_t) x;
}

static inline uint16_t fptoui_f32_i16(float x) {
  return (uint16_t) x;
}

static inline uint32_t fptoui_f32_i32(float x) {
  return (uint32_t) x;
}

static inline uint64_t fptoui_f32_i64(float x) {
  return (uint64_t) x;
}

#ifdef __OPENCL_VERSION__
static inline float fabs32(float x) {
  return fabs(x);
}

static inline float fmax32(float x, float y) {
  return fmax(x, y);
}

static inline float fmin32(float x, float y) {
  return fmin(x, y);
}

static inline float fpow32(float x, float y) {
  return pow(x, y);
}

#else // Not OpenCL, but CUDA or plain C.

static inline float fabs32(float x) {
  return fabsf(x);
}

static inline float fmax32(float x, float y) {
  return fmaxf(x, y);
}

static inline float fmin32(float x, float y) {
  return fminf(x, y);
}

static inline float fpow32(float x, float y) {
  return powf(x, y);
}
#endif

static inline bool futrts_isnan32(float x) {
  return isnan(x);
}

static inline bool futrts_isinf32(float x) {
  return isinf(x);
}

#ifdef __OPENCL_VERSION__
static inline float futrts_log32(float x) {
  return log(x);
}

static inline float futrts_log2_32(float x) {
  return log2(x);
}

static inline float futrts_log10_32(float x) {
  return log10(x);
}

static inline float futrts_sqrt32(float x) {
  return sqrt(x);
}

static inline float futrts_exp32(float x) {
  return exp(x);
}

static inline float futrts_cos32(float x) {
  return cos(x);
}

static inline float futrts_sin32(float x) {
  return sin(x);
}

static inline float futrts_tan32(float x) {
  return tan(x);
}

static inline float futrts_acos32(float x) {
  return acos(x);
}

static inline float futrts_asin32(float x) {
  return asin(x);
}

static inline float futrts_atan32(float x) {
  return atan(x);
}

static inline float futrts_cosh32(float x) {
  return cosh(x);
}

static inline float futrts_sinh32(float x) {
  return sinh(x);
}

static inline float futrts_tanh32(float x) {
  return tanh(x);
}

static inline float futrts_acosh32(float x) {
  return acosh(x);
}

static inline float futrts_asinh32(float x) {
  return asinh(x);
}

static inline float futrts_atanh32(float x) {
  return atanh(x);
}

static inline float futrts_atan2_32(float x, float y) {
  return atan2(x, y);
}

static inline float futrts_hypot32(float x, float y) {
  return hypot(x, y);
}

static inline float futrts_gamma32(float x) {
  return tgamma(x);
}

static inline float futrts_lgamma32(float x) {
  return lgamma(x);
}

static inline float fmod32(float x, float y) {
  return fmod(x, y);
}

static inline float futrts_round32(float x) {
  return rint(x);
}

static inline float futrts_floor32(float x) {
  return floor(x);
}

static inline float futrts_ceil32(float x) {
  return ceil(x);
}

static inline float futrts_lerp32(float v0, float v1, float t) {
  return mix(v0, v1, t);
}

static inline float futrts_mad32(float a, float b, float c) {
  return mad(a, b, c);
}

static inline float futrts_fma32(float a, float b, float c) {
  return fma(a, b, c);
}

#else // Not OpenCL, but CUDA or plain C.

static inline float futrts_log32(float x) {
  return logf(x);
}

static inline float futrts_log2_32(float x) {
  return log2f(x);
}

static inline float futrts_log10_32(float x) {
  return log10f(x);
}

static inline float futrts_sqrt32(float x) {
  return sqrtf(x);
}

static inline float futrts_exp32(float x) {
  return expf(x);
}

static inline float futrts_cos32(float x) {
  return cosf(x);
}

static inline float futrts_sin32(float x) {
  return sinf(x);
}

static inline float futrts_tan32(float x) {
  return tanf(x);
}

static inline float futrts_acos32(float x) {
  return acosf(x);
}

static inline float futrts_asin32(float x) {
  return asinf(x);
}

static inline float futrts_atan32(float x) {
  return atanf(x);
}

static inline float futrts_cosh32(float x) {
  return coshf(x);
}

static inline float futrts_sinh32(float x) {
  return sinhf(x);
}

static inline float futrts_tanh32(float x) {
  return tanhf(x);
}

static inline float futrts_acosh32(float x) {
  return acoshf(x);
}

static inline float futrts_asinh32(float x) {
  return asinhf(x);
}

static inline float futrts_atanh32(float x) {
  return atanhf(x);
}

static inline float futrts_atan2_32(float x, float y) {
  return atan2f(x, y);
}

static inline float futrts_hypot32(float x, float y) {
  return hypotf(x, y);
}

static inline float futrts_gamma32(float x) {
  return tgammaf(x);
}

static inline float futrts_lgamma32(float x) {
  return lgammaf(x);
}

static inline float fmod32(float x, float y) {
  return fmodf(x, y);
}

static inline float futrts_round32(float x) {
  return rintf(x);
}

static inline float futrts_floor32(float x) {
  return floorf(x);
}

static inline float futrts_ceil32(float x) {
  return ceilf(x);
}

static inline float futrts_lerp32(float v0, float v1, float t) {
  return v0 + (v1 - v0) * t;
}

static inline float futrts_mad32(float a, float b, float c) {
  return a * b + c;
}

static inline float futrts_fma32(float a, float b, float c) {
  return fmaf(a, b, c);
}
#endif

static inline int32_t futrts_to_bits32(float x) {
  union {
    float f;
    int32_t t;
  } p;

  p.f = x;
  return p.t;
}

static inline float futrts_from_bits32(int32_t x) {
  union {
    int32_t f;
    float t;
  } p;

  p.f = x;
  return p.t;
}

static inline float fsignum32(float x) {
  return futrts_isnan32(x) ? x : (x > 0) - (x < 0);
}

#ifdef FUTHARK_F64_ENABLED

static inline double fdiv64(double x, double y) {
  return x / y;
}

static inline double fadd64(double x, double y) {
  return x + y;
}

static inline double fsub64(double x, double y) {
  return x - y;
}

static inline double fmul64(double x, double y) {
  return x * y;
}

static inline bool cmplt64(double x, double y) {
  return x < y;
}

static inline bool cmple64(double x, double y) {
  return x <= y;
}

static inline double sitofp_i8_f64(int8_t x) {
  return (double) x;
}

static inline double sitofp_i16_f64(int16_t x) {
  return (double) x;
}

static inline double sitofp_i32_f64(int32_t x) {
  return (double) x;
}

static inline double sitofp_i64_f64(int64_t x) {
  return (double) x;
}

static inline double uitofp_i8_f64(uint8_t x) {
  return (double) x;
}

static inline double uitofp_i16_f64(uint16_t x) {
  return (double) x;
}

static inline double uitofp_i32_f64(uint32_t x) {
  return (double) x;
}

static inline double uitofp_i64_f64(uint64_t x) {
  return (double) x;
}

static inline int8_t fptosi_f64_i8(double x) {
  return (int8_t) x;
}

static inline int16_t fptosi_f64_i16(double x) {
  return (int16_t) x;
}

static inline int32_t fptosi_f64_i32(double x) {
  return (int32_t) x;
}

static inline int64_t fptosi_f64_i64(double x) {
  return (int64_t) x;
}

static inline uint8_t fptoui_f64_i8(double x) {
  return (uint8_t) x;
}

static inline uint16_t fptoui_f64_i16(double x) {
  return (uint16_t) x;
}

static inline uint32_t fptoui_f64_i32(double x) {
  return (uint32_t) x;
}

static inline uint64_t fptoui_f64_i64(double x) {
  return (uint64_t) x;
}

static inline double fabs64(double x) {
  return fabs(x);
}

static inline double fmax64(double x, double y) {
  return fmax(x, y);
}

static inline double fmin64(double x, double y) {
  return fmin(x, y);
}

static inline double fpow64(double x, double y) {
  return pow(x, y);
}

static inline double futrts_log64(double x) {
  return log(x);
}

static inline double futrts_log2_64(double x) {
  return log2(x);
}

static inline double futrts_log10_64(double x) {
  return log10(x);
}

static inline double futrts_sqrt64(double x) {
  return sqrt(x);
}

static inline double futrts_exp64(double x) {
  return exp(x);
}

static inline double futrts_cos64(double x) {
  return cos(x);
}

static inline double futrts_sin64(double x) {
  return sin(x);
}

static inline double futrts_tan64(double x) {
  return tan(x);
}

static inline double futrts_acos64(double x) {
  return acos(x);
}

static inline double futrts_asin64(double x) {
  return asin(x);
}

static inline double futrts_atan64(double x) {
  return atan(x);
}

static inline double futrts_cosh64(double x) {
  return cosh(x);
}

static inline double futrts_sinh64(double x) {
  return sinh(x);
}

static inline double futrts_tanh64(double x) {
  return tanh(x);
}

static inline double futrts_acosh64(double x) {
  return acosh(x);
}

static inline double futrts_asinh64(double x) {
  return asinh(x);
}

static inline double futrts_atanh64(double x) {
  return atanh(x);
}

static inline double futrts_atan2_64(double x, double y) {
  return atan2(x, y);
}

static inline double futrts_hypot64(double x, double y) {
  return hypot(x, y);
}

static inline double futrts_gamma64(double x) {
  return tgamma(x);
}

static inline double futrts_lgamma64(double x) {
  return lgamma(x);
}

static inline double futrts_fma64(double a, double b, double c) {
  return fma(a, b, c);
}

static inline double futrts_round64(double x) {
  return rint(x);
}

static inline double futrts_ceil64(double x) {
  return ceil(x);
}

static inline double futrts_floor64(double x) {
  return floor(x);
}

static inline bool futrts_isnan64(double x) {
  return isnan(x);
}

static inline bool futrts_isinf64(double x) {
  return isinf(x);
}

static inline int64_t futrts_to_bits64(double x) {
  union {
    double f;
    int64_t t;
  } p;

  p.f = x;
  return p.t;
}

static inline double futrts_from_bits64(int64_t x) {
  union {
    int64_t f;
    double t;
  } p;

  p.f = x;
  return p.t;
}

static inline double fmod64(double x, double y) {
  return fmod(x, y);
}

static inline double fsignum64(double x) {
  return futrts_isnan64(x) ? x : (x > 0) - (x < 0);
}

static inline double futrts_lerp64(double v0, double v1, double t) {
#ifdef __OPENCL_VERSION__
  return mix(v0, v1, t);
#else
  return v0 + (v1 - v0) * t;
#endif
}

static inline double futrts_mad64(double a, double b, double c) {
#ifdef __OPENCL_VERSION__
  return mad(a, b, c);
#else
  return a * b + c;
#endif
}

static inline float fpconv_f32_f32(float x) {
  return (float) x;
}

static inline double fpconv_f32_f64(float x) {
  return (double) x;
}

static inline float fpconv_f64_f32(double x) {
  return (float) x;
}

static inline double fpconv_f64_f64(double x) {
  return (double) x;
}

#endif

// End of scalar.h.
// Start of scalar_f16.h.

// Half-precision is emulated if needed (e.g. in straight C) with the
// native type used if possible.  The emulation works by typedef'ing
// 'float' to 'f16', and then implementing all operations on single
// precision.  To cut down on duplication, we use the same code for
// those Futhark functions that require just operators or casts.  The
// in-memory representation for arrays will still be 16 bits even
// under emulation, so the compiler will have to be careful when
// generating reads or writes.

#if !defined(cl_khr_fp16) && !(defined(__CUDA_ARCH__) && __CUDA_ARCH__ >= 600)
#define EMULATE_F16
#endif

#if !defined(EMULATE_F16) && defined(__OPENCL_VERSION__)
#pragma OPENCL EXTENSION cl_khr_fp16 : enable
#endif

#ifdef EMULATE_F16

// Note that the half-precision storage format is still 16 bits - the
// compiler will have to be real careful!
typedef float f16;

#else

#ifdef __CUDA_ARCH__
#include <cuda_fp16.h>
#endif

typedef half f16;

#endif

// Some of these functions convert to single precision because half
// precision versions are not available.

static inline f16 fadd16(f16 x, f16 y) {
  return x + y;
}

static inline f16 fsub16(f16 x, f16 y) {
  return x - y;
}

static inline f16 fmul16(f16 x, f16 y) {
  return x * y;
}

static inline bool cmplt16(f16 x, f16 y) {
  return x < y;
}

static inline bool cmple16(f16 x, f16 y) {
  return x <= y;
}

static inline f16 sitofp_i8_f16(int8_t x) {
  return (f16) x;
}

static inline f16 sitofp_i16_f16(int16_t x) {
  return (f16) x;
}

static inline f16 sitofp_i32_f16(int32_t x) {
  return (f16) x;
}

static inline f16 sitofp_i64_f16(int64_t x) {
  return (f16) x;
}

static inline f16 uitofp_i8_f16(uint8_t x) {
  return (f16) x;
}

static inline f16 uitofp_i16_f16(uint16_t x) {
  return (f16) x;
}

static inline f16 uitofp_i32_f16(uint32_t x) {
  return (f16) x;
}

static inline f16 uitofp_i64_f16(uint64_t x) {
  return (f16) x;
}

static inline int8_t fptosi_f16_i8(f16 x) {
  return (int8_t) (float) x;
}

static inline int16_t fptosi_f16_i16(f16 x) {
  return (int16_t) x;
}

static inline int32_t fptosi_f16_i32(f16 x) {
  return (int32_t) x;
}

static inline int64_t fptosi_f16_i64(f16 x) {
  return (int64_t) x;
}

static inline uint8_t fptoui_f16_i8(f16 x) {
  return (uint8_t) (float) x;
}

static inline uint16_t fptoui_f16_i16(f16 x) {
  return (uint16_t) x;
}

static inline uint32_t fptoui_f16_i32(f16 x) {
  return (uint32_t) x;
}

static inline uint64_t fptoui_f16_i64(f16 x) {
  return (uint64_t) x;
}

#ifndef EMULATE_F16

#ifdef __OPENCL_VERSION__
static inline f16 fabs16(f16 x) {
  return fabs(x);
}

static inline f16 fmax16(f16 x, f16 y) {
  return fmax(x, y);
}

static inline f16 fmin16(f16 x, f16 y) {
  return fmin(x, y);
}

static inline f16 fpow16(f16 x, f16 y) {
  return pow(x, y);
}

#else // Assuming CUDA.

static inline f16 fabs16(f16 x) {
  return fabsf(x);
}

static inline f16 fmax16(f16 x, f16 y) {
  return fmaxf(x, y);
}

static inline f16 fmin16(f16 x, f16 y) {
  return fminf(x, y);
}

static inline f16 fpow16(f16 x, f16 y) {
  return powf(x, y);
}
#endif

static inline bool futrts_isnan16(f16 x) {
  return isnan((float)x);
}

static inline bool futrts_isinf16(f16 x) {
  return isinf((float)x);
}

#ifdef __OPENCL_VERSION__
static inline f16 futrts_log16(f16 x) {
  return log(x);
}

static inline f16 futrts_log2_16(f16 x) {
  return log2(x);
}

static inline f16 futrts_log10_16(f16 x) {
  return log10(x);
}

static inline f16 futrts_sqrt16(f16 x) {
  return sqrt(x);
}

static inline f16 futrts_exp16(f16 x) {
  return exp(x);
}

static inline f16 futrts_cos16(f16 x) {
  return cos(x);
}

static inline f16 futrts_sin16(f16 x) {
  return sin(x);
}

static inline f16 futrts_tan16(f16 x) {
  return tan(x);
}

static inline f16 futrts_acos16(f16 x) {
  return acos(x);
}

static inline f16 futrts_asin16(f16 x) {
  return asin(x);
}

static inline f16 futrts_atan16(f16 x) {
  return atan(x);
}

static inline f16 futrts_cosh16(f16 x) {
  return cosh(x);
}

static inline f16 futrts_sinh16(f16 x) {
  return sinh(x);
}

static inline f16 futrts_tanh16(f16 x) {
  return tanh(x);
}

static inline f16 futrts_acosh16(f16 x) {
  return acosh(x);
}

static inline f16 futrts_asinh16(f16 x) {
  return asinh(x);
}

static inline f16 futrts_atanh16(f16 x) {
  return atanh(x);
}

static inline f16 futrts_atan2_16(f16 x, f16 y) {
  return atan2(x, y);
}

static inline f16 futrts_hypot16(f16 x, f16 y) {
  return hypot(x, y);
}

static inline f16 futrts_gamma16(f16 x) {
  return tgamma(x);
}

static inline f16 futrts_lgamma16(f16 x) {
  return lgamma(x);
}

static inline f16 fmod16(f16 x, f16 y) {
  return fmod(x, y);
}

static inline f16 futrts_round16(f16 x) {
  return rint(x);
}

static inline f16 futrts_floor16(f16 x) {
  return floor(x);
}

static inline f16 futrts_ceil16(f16 x) {
  return ceil(x);
}

static inline f16 futrts_lerp16(f16 v0, f16 v1, f16 t) {
  return mix(v0, v1, t);
}

static inline f16 futrts_mad16(f16 a, f16 b, f16 c) {
  return mad(a, b, c);
}

static inline f16 futrts_fma16(f16 a, f16 b, f16 c) {
  return fma(a, b, c);
}

#else // Assume CUDA.

static inline f16 futrts_log16(f16 x) {
  return hlog(x);
}

static inline f16 futrts_log2_16(f16 x) {
  return hlog2(x);
}

static inline f16 futrts_log10_16(f16 x) {
  return hlog10(x);
}

static inline f16 futrts_sqrt16(f16 x) {
  return hsqrt(x);
}

static inline f16 futrts_exp16(f16 x) {
  return hexp(x);
}

static inline f16 futrts_cos16(f16 x) {
  return hcos(x);
}

static inline f16 futrts_sin16(f16 x) {
  return hsin(x);
}

static inline f16 futrts_tan16(f16 x) {
  return tanf(x);
}

static inline f16 futrts_acos16(f16 x) {
  return acosf(x);
}

static inline f16 futrts_asin16(f16 x) {
  return asinf(x);
}

static inline f16 futrts_atan16(f16 x) {
  return atanf(x);
}

static inline f16 futrts_cosh16(f16 x) {
  return coshf(x);
}

static inline f16 futrts_sinh16(f16 x) {
  return sinhf(x);
}

static inline f16 futrts_tanh16(f16 x) {
  return tanhf(x);
}

static inline f16 futrts_acosh16(f16 x) {
  return acoshf(x);
}

static inline f16 futrts_asinh16(f16 x) {
  return asinhf(x);
}

static inline f16 futrts_atanh16(f16 x) {
  return atanhf(x);
}

static inline f16 futrts_atan2_16(f16 x, f16 y) {
  return atan2f(x, y);
}

static inline f16 futrts_hypot16(f16 x, f16 y) {
  return hypotf(x, y);
}

static inline f16 futrts_gamma16(f16 x) {
  return tgammaf(x);
}

static inline f16 futrts_lgamma16(f16 x) {
  return lgammaf(x);
}

static inline f16 fmod16(f16 x, f16 y) {
  return fmodf(x, y);
}

static inline f16 futrts_round16(f16 x) {
  return rintf(x);
}

static inline f16 futrts_floor16(f16 x) {
  return hfloor(x);
}

static inline f16 futrts_ceil16(f16 x) {
  return hceil(x);
}

static inline f16 futrts_lerp16(f16 v0, f16 v1, f16 t) {
  return v0 + (v1 - v0) * t;
}

static inline f16 futrts_mad16(f16 a, f16 b, f16 c) {
  return a * b + c;
}

static inline f16 futrts_fma16(f16 a, f16 b, f16 c) {
  return fmaf(a, b, c);
}

#endif

// The CUDA __half type cannot be put in unions for some reason, so we
// use bespoke conversion functions instead.
#ifdef __CUDA_ARCH__
static inline int16_t futrts_to_bits16(f16 x) {
  return __half_as_ushort(x);
}
static inline f16 futrts_from_bits16(int16_t x) {
  return __ushort_as_half(x);
}
#else
static inline int16_t futrts_to_bits16(f16 x) {
  union {
    f16 f;
    int16_t t;
  } p;

  p.f = x;
  return p.t;
}

static inline f16 futrts_from_bits16(int16_t x) {
  union {
    int16_t f;
    f16 t;
  } p;

  p.f = x;
  return p.t;
}
#endif

#else // No native f16 - emulate.

static inline f16 fabs16(f16 x) {
  return fabs32(x);
}

static inline f16 fmax16(f16 x, f16 y) {
  return fmax32(x, y);
}

static inline f16 fmin16(f16 x, f16 y) {
  return fmin32(x, y);
}

static inline f16 fpow16(f16 x, f16 y) {
  return fpow32(x, y);
}

static inline bool futrts_isnan16(f16 x) {
  return futrts_isnan32(x);
}

static inline bool futrts_isinf16(f16 x) {
  return futrts_isinf32(x);
}

static inline f16 futrts_log16(f16 x) {
  return futrts_log32(x);
}

static inline f16 futrts_log2_16(f16 x) {
  return futrts_log2_32(x);
}

static inline f16 futrts_log10_16(f16 x) {
  return futrts_log10_32(x);
}

static inline f16 futrts_sqrt16(f16 x) {
  return futrts_sqrt32(x);
}

static inline f16 futrts_exp16(f16 x) {
  return futrts_exp32(x);
}

static inline f16 futrts_cos16(f16 x) {
  return futrts_cos32(x);
}

static inline f16 futrts_sin16(f16 x) {
  return futrts_sin32(x);
}

static inline f16 futrts_tan16(f16 x) {
  return futrts_tan32(x);
}

static inline f16 futrts_acos16(f16 x) {
  return futrts_acos32(x);
}

static inline f16 futrts_asin16(f16 x) {
  return futrts_asin32(x);
}

static inline f16 futrts_atan16(f16 x) {
  return futrts_atan32(x);
}

static inline f16 futrts_cosh16(f16 x) {
  return futrts_cosh32(x);
}

static inline f16 futrts_sinh16(f16 x) {
  return futrts_sinh32(x);
}

static inline f16 futrts_tanh16(f16 x) {
  return futrts_tanh32(x);
}

static inline f16 futrts_acosh16(f16 x) {
  return futrts_acosh32(x);
}

static inline f16 futrts_asinh16(f16 x) {
  return futrts_asinh32(x);
}

static inline f16 futrts_atanh16(f16 x) {
  return futrts_atanh32(x);
}

static inline f16 futrts_atan2_16(f16 x, f16 y) {
  return futrts_atan2_32(x, y);
}

static inline f16 futrts_hypot16(f16 x, f16 y) {
  return futrts_hypot32(x, y);
}

static inline f16 futrts_gamma16(f16 x) {
  return futrts_gamma32(x);
}

static inline f16 futrts_lgamma16(f16 x) {
  return futrts_lgamma32(x);
}

static inline f16 fmod16(f16 x, f16 y) {
  return fmod32(x, y);
}

static inline f16 futrts_round16(f16 x) {
  return futrts_round32(x);
}

static inline f16 futrts_floor16(f16 x) {
  return futrts_floor32(x);
}

static inline f16 futrts_ceil16(f16 x) {
  return futrts_ceil32(x);
}

static inline f16 futrts_lerp16(f16 v0, f16 v1, f16 t) {
  return futrts_lerp32(v0, v1, t);
}

static inline f16 futrts_mad16(f16 a, f16 b, f16 c) {
  return futrts_mad32(a, b, c);
}

static inline f16 futrts_fma16(f16 a, f16 b, f16 c) {
  return futrts_fma32(a, b, c);
}

// Even when we are using an OpenCL that does not support cl_khr_fp16,
// it must still support vload_half for actually creating a
// half-precision number, which can then be efficiently converted to a
// float.  Similarly for vstore_half.
#ifdef __OPENCL_VERSION__

static inline int16_t futrts_to_bits16(f16 x) {
  int16_t y;
  // Violating strict aliasing here.
  vstore_half((float)x, 0, (half*)&y);
  return y;
}

static inline f16 futrts_from_bits16(int16_t x) {
  return (f16)vload_half(0, (half*)&x);
}

#else

static inline int16_t futrts_to_bits16(f16 x) {
  return (int16_t)float2halfbits(x);
}

static inline f16 futrts_from_bits16(int16_t x) {
  return halfbits2float((uint16_t)x);
}

static inline f16 fsignum16(f16 x) {
  return futrts_isnan16(x) ? x : (x > 0) - (x < 0);
}

#endif

#endif

static inline float fpconv_f16_f16(f16 x) {
  return x;
}

static inline float fpconv_f16_f32(f16 x) {
  return x;
}

static inline f16 fpconv_f32_f16(float x) {
  return x;
}

#ifdef FUTHARK_F64_ENABLED

static inline double fpconv_f16_f64(f16 x) {
  return (double) x;
}

static inline f16 fpconv_f64_f16(double x) {
  return (f16) x;
}

#endif


// End of scalar_f16.h.

static int init_constants(struct futhark_context *);
static int free_constants(struct futhark_context *);
struct memblock {
    int *references;
    unsigned char *mem;
    int64_t size;
    const char *desc;
};
struct futhark_context_config {
    int debugging;
    int in_use;
};
struct futhark_context_config *futhark_context_config_new(void)
{
    struct futhark_context_config *cfg =
                                  (struct futhark_context_config *) malloc(sizeof(struct futhark_context_config));
    
    if (cfg == NULL)
        return NULL;
    cfg->in_use = 0;
    cfg->debugging = 0;
    return cfg;
}
void futhark_context_config_free(struct futhark_context_config *cfg)
{
    assert(!cfg->in_use);
    free(cfg);
}
void futhark_context_config_set_debugging(struct futhark_context_config *cfg,
                                          int detail)
{
    cfg->debugging = detail;
}
void futhark_context_config_set_profiling(struct futhark_context_config *cfg,
                                          int flag)
{
    (void) cfg;
    (void) flag;
}
void futhark_context_config_set_logging(struct futhark_context_config *cfg,
                                        int detail)
{
    // Does nothing for this backend.
    (void) cfg;
    (void) detail;
}
struct futhark_context {
    struct futhark_context_config *cfg;
    int detail_memory;
    int debugging;
    int profiling;
    int logging;
    lock_t lock;
    char *error;
    FILE *log;
    int profiling_paused;
    int64_t peak_mem_usage_default;
    int64_t cur_mem_usage_default;
    struct {
        int dummy;
    } constants;
};
struct futhark_context *futhark_context_new(struct futhark_context_config *cfg)
{
    assert(!cfg->in_use);
    
    struct futhark_context *ctx =
                           (struct futhark_context *) malloc(sizeof(struct futhark_context));
    
    if (ctx == NULL)
        return NULL;
    ctx->cfg = cfg;
    ctx->cfg->in_use = 1;
    ctx->detail_memory = cfg->debugging;
    ctx->debugging = cfg->debugging;
    ctx->profiling = cfg->debugging;
    ctx->logging = cfg->debugging;
    ctx->error = NULL;
    ctx->log = stderr;
    create_lock(&ctx->lock);
    ctx->peak_mem_usage_default = 0;
    ctx->cur_mem_usage_default = 0;
    init_constants(ctx);
    return ctx;
}
void futhark_context_free(struct futhark_context *ctx)
{
    free_constants(ctx);
    free_lock(&ctx->lock);
    ctx->cfg->in_use = 0;
    free(ctx);
}
int futhark_context_sync(struct futhark_context *ctx)
{
    (void) ctx;
    return 0;
}
static const char *tuning_param_names[0];
static const char *tuning_param_vars[0];
static const char *tuning_param_classes[0];
int futhark_context_config_set_tuning_param(struct futhark_context_config *cfg,
                                            const char *param_name,
                                            size_t param_value)
{
    (void) cfg;
    (void) param_name;
    (void) param_value;
    return 1;
}
static int memblock_unref(struct futhark_context *ctx, struct memblock *block,
                          const char *desc)
{
    if (block->references != NULL) {
        *block->references -= 1;
        if (ctx->detail_memory)
            fprintf(ctx->log,
                    "Unreferencing block %s (allocated as %s) in %s: %d references remaining.\n",
                    desc, block->desc, "default space", *block->references);
        if (*block->references == 0) {
            ctx->cur_mem_usage_default -= block->size;
            free(block->mem);
            free(block->references);
            if (ctx->detail_memory)
                fprintf(ctx->log,
                        "%lld bytes freed (now allocated: %lld bytes)\n",
                        (long long) block->size,
                        (long long) ctx->cur_mem_usage_default);
        }
        block->references = NULL;
    }
    return 0;
}
static int memblock_alloc(struct futhark_context *ctx, struct memblock *block,
                          int64_t size, const char *desc)
{
    if (size < 0)
        futhark_panic(1,
                      "Negative allocation of %lld bytes attempted for %s in %s.\n",
                      (long long) size, desc, "default space",
                      ctx->cur_mem_usage_default);
    
    int ret = memblock_unref(ctx, block, desc);
    
    ctx->cur_mem_usage_default += size;
    if (ctx->detail_memory)
        fprintf(ctx->log,
                "Allocating %lld bytes for %s in %s (then allocated: %lld bytes)",
                (long long) size, desc, "default space",
                (long long) ctx->cur_mem_usage_default);
    if (ctx->cur_mem_usage_default > ctx->peak_mem_usage_default) {
        ctx->peak_mem_usage_default = ctx->cur_mem_usage_default;
        if (ctx->detail_memory)
            fprintf(ctx->log, " (new peak).\n");
    } else if (ctx->detail_memory)
        fprintf(ctx->log, ".\n");
    block->mem = (unsigned char *) malloc((size_t) size);
    block->references = (int *) malloc(sizeof(int));
    *block->references = 1;
    block->size = size;
    block->desc = desc;
    return ret;
}
static int memblock_set(struct futhark_context *ctx, struct memblock *lhs,
                        struct memblock *rhs, const char *lhs_desc)
{
    int ret = memblock_unref(ctx, lhs, lhs_desc);
    
    if (rhs->references != NULL)
        (*rhs->references)++;
    *lhs = *rhs;
    return ret;
}
int futhark_get_tuning_param_count(void)
{
    return sizeof(tuning_param_names) / sizeof(tuning_param_names[0]);
}
const char *futhark_get_tuning_param_name(int i)
{
    return tuning_param_names[i];
}
const char *futhark_get_tuning_param_class(int i)
{
    return tuning_param_classes[i];
}
char *futhark_context_report(struct futhark_context *ctx)
{
    if (futhark_context_sync(ctx) != 0)
        return NULL;
    
    struct str_builder builder;
    
    str_builder_init(&builder);
    if (ctx->detail_memory || ctx->profiling || ctx->logging) {
        { }
    }
    if (ctx->profiling) { }
    return builder.str;
}
char *futhark_context_get_error(struct futhark_context *ctx)
{
    char *error = ctx->error;
    
    ctx->error = NULL;
    return error;
}
void futhark_context_set_logging_file(struct futhark_context *ctx, FILE *f)
{
    ctx->log = f;
}
void futhark_context_pause_profiling(struct futhark_context *ctx)
{
    ctx->profiling_paused = 1;
}
void futhark_context_unpause_profiling(struct futhark_context *ctx)
{
    ctx->profiling_paused = 0;
}
int futhark_context_clear_caches(struct futhark_context *ctx)
{
    lock_lock(&ctx->lock);
    ctx->peak_mem_usage_default = 0;
    lock_unlock(&ctx->lock);
    return ctx->error != NULL;
}

static int futrts_entry_main(struct futhark_context *ctx,
                             struct memblock *mem_out_p_213725,
                             struct memblock *mem_out_p_213726,
                             struct memblock *mem_out_p_213727,
                             struct memblock Y_mem_208318, int64_t m_203489,
                             int64_t n_203490, int64_t n_p_203492,
                             int64_t q_s_203493, int64_t q_t_203494,
                             int64_t q_l_203495, int64_t d_s_203496,
                             int64_t d_t_203497, int64_t d_l_203498,
                             int64_t jump_s_203499, int64_t jump_t_203500,
                             int64_t jump_l_203501, int64_t n_inner_203502,
                             int64_t n_outer_203503,
                             int64_t jump_threshold_203504,
                             int64_t q_threshold_203505);

static int init_constants(struct futhark_context *ctx)
{
    (void) ctx;
    
    int err = 0;
    
    
  cleanup:
    return err;
}
static int free_constants(struct futhark_context *ctx)
{
    (void) ctx;
    return 0;
}
struct futhark_f64_2d {
    struct memblock mem;
    int64_t shape[2];
};
struct futhark_f64_2d *futhark_new_f64_2d(struct futhark_context *ctx, const
                                          double *data, int64_t dim0,
                                          int64_t dim1)
{
    struct futhark_f64_2d *bad = NULL;
    struct futhark_f64_2d *arr =
                          (struct futhark_f64_2d *) malloc(sizeof(struct futhark_f64_2d));
    
    if (arr == NULL)
        return bad;
    lock_lock(&ctx->lock);
    arr->mem.references = NULL;
    if (memblock_alloc(ctx, &arr->mem, dim0 * dim1 * 8, "arr->mem"))
        return NULL;
    arr->shape[0] = dim0;
    arr->shape[1] = dim1;
    if ((size_t) (dim0 * dim1) * 8 > 0)
        memmove(arr->mem.mem + 0, data + 0, (size_t) (dim0 * dim1) * 8);
    lock_unlock(&ctx->lock);
    return arr;
}
struct futhark_f64_2d *futhark_new_raw_f64_2d(struct futhark_context *ctx, const
                                              unsigned char *data,
                                              int64_t offset, int64_t dim0,
                                              int64_t dim1)
{
    struct futhark_f64_2d *bad = NULL;
    struct futhark_f64_2d *arr =
                          (struct futhark_f64_2d *) malloc(sizeof(struct futhark_f64_2d));
    
    if (arr == NULL)
        return bad;
    lock_lock(&ctx->lock);
    arr->mem.references = NULL;
    if (memblock_alloc(ctx, &arr->mem, dim0 * dim1 * 8, "arr->mem"))
        return NULL;
    arr->shape[0] = dim0;
    arr->shape[1] = dim1;
    if ((size_t) (dim0 * dim1) * 8 > 0)
        memmove(arr->mem.mem + 0, data + offset, (size_t) (dim0 * dim1) * 8);
    lock_unlock(&ctx->lock);
    return arr;
}
int futhark_free_f64_2d(struct futhark_context *ctx, struct futhark_f64_2d *arr)
{
    lock_lock(&ctx->lock);
    if (memblock_unref(ctx, &arr->mem, "arr->mem") != 0)
        return 1;
    lock_unlock(&ctx->lock);
    free(arr);
    return 0;
}
int futhark_values_f64_2d(struct futhark_context *ctx,
                          struct futhark_f64_2d *arr, double *data)
{
    lock_lock(&ctx->lock);
    if ((size_t) (arr->shape[0] * arr->shape[1]) * 8 > 0)
        memmove(data + 0, arr->mem.mem + 0, (size_t) (arr->shape[0] *
                                                      arr->shape[1]) * 8);
    lock_unlock(&ctx->lock);
    return 0;
}
unsigned char *futhark_values_raw_f64_2d(struct futhark_context *ctx,
                                         struct futhark_f64_2d *arr)
{
    (void) ctx;
    return arr->mem.mem;
}
const int64_t *futhark_shape_f64_2d(struct futhark_context *ctx,
                                    struct futhark_f64_2d *arr)
{
    (void) ctx;
    return arr->shape;
}

static int futrts_entry_main(struct futhark_context *ctx,
                             struct memblock *mem_out_p_213725,
                             struct memblock *mem_out_p_213726,
                             struct memblock *mem_out_p_213727,
                             struct memblock Y_mem_208318, int64_t m_203489,
                             int64_t n_203490, int64_t n_p_203492,
                             int64_t q_s_203493, int64_t q_t_203494,
                             int64_t q_l_203495, int64_t d_s_203496,
                             int64_t d_t_203497, int64_t d_l_203498,
                             int64_t jump_s_203499, int64_t jump_t_203500,
                             int64_t jump_l_203501, int64_t n_inner_203502,
                             int64_t n_outer_203503,
                             int64_t jump_threshold_203504,
                             int64_t q_threshold_203505)
{
    (void) ctx;
    
    int err = 0;
    size_t mem_208321_cached_sizze_213728 = 0;
    unsigned char *mem_208321 = NULL;
    size_t mem_208324_cached_sizze_213729 = 0;
    unsigned char *mem_208324 = NULL;
    size_t mem_208352_cached_sizze_213730 = 0;
    unsigned char *mem_208352 = NULL;
    size_t mem_208355_cached_sizze_213731 = 0;
    unsigned char *mem_208355 = NULL;
    size_t mem_208375_cached_sizze_213732 = 0;
    unsigned char *mem_208375 = NULL;
    size_t mem_208392_cached_sizze_213733 = 0;
    unsigned char *mem_208392 = NULL;
    size_t mem_208395_cached_sizze_213734 = 0;
    unsigned char *mem_208395 = NULL;
    size_t mem_208415_cached_sizze_213735 = 0;
    unsigned char *mem_208415 = NULL;
    size_t mem_208430_cached_sizze_213736 = 0;
    unsigned char *mem_208430 = NULL;
    size_t mem_208467_cached_sizze_213737 = 0;
    unsigned char *mem_208467 = NULL;
    size_t mem_208559_cached_sizze_213738 = 0;
    unsigned char *mem_208559 = NULL;
    size_t mem_208563_cached_sizze_213739 = 0;
    unsigned char *mem_208563 = NULL;
    size_t mem_208616_cached_sizze_213740 = 0;
    unsigned char *mem_208616 = NULL;
    size_t mem_208631_cached_sizze_213741 = 0;
    unsigned char *mem_208631 = NULL;
    size_t mem_208710_cached_sizze_213742 = 0;
    unsigned char *mem_208710 = NULL;
    size_t mem_208715_cached_sizze_213743 = 0;
    unsigned char *mem_208715 = NULL;
    size_t mem_208776_cached_sizze_213744 = 0;
    unsigned char *mem_208776 = NULL;
    size_t mem_208908_cached_sizze_213745 = 0;
    unsigned char *mem_208908 = NULL;
    size_t mem_208912_cached_sizze_213746 = 0;
    unsigned char *mem_208912 = NULL;
    size_t mem_208935_cached_sizze_213747 = 0;
    unsigned char *mem_208935 = NULL;
    size_t mem_209011_cached_sizze_213748 = 0;
    unsigned char *mem_209011 = NULL;
    size_t mem_209015_cached_sizze_213749 = 0;
    unsigned char *mem_209015 = NULL;
    size_t mem_209038_cached_sizze_213750 = 0;
    unsigned char *mem_209038 = NULL;
    size_t mem_209168_cached_sizze_213751 = 0;
    unsigned char *mem_209168 = NULL;
    size_t mem_209213_cached_sizze_213752 = 0;
    unsigned char *mem_209213 = NULL;
    size_t mem_209218_cached_sizze_213753 = 0;
    unsigned char *mem_209218 = NULL;
    size_t mem_209962_cached_sizze_213754 = 0;
    unsigned char *mem_209962 = NULL;
    size_t mem_210121_cached_sizze_213755 = 0;
    unsigned char *mem_210121 = NULL;
    size_t mem_210124_cached_sizze_213756 = 0;
    unsigned char *mem_210124 = NULL;
    size_t mem_210335_cached_sizze_213757 = 0;
    unsigned char *mem_210335 = NULL;
    size_t mem_210338_cached_sizze_213758 = 0;
    unsigned char *mem_210338 = NULL;
    size_t mem_210365_cached_sizze_213759 = 0;
    unsigned char *mem_210365 = NULL;
    size_t mem_210368_cached_sizze_213760 = 0;
    unsigned char *mem_210368 = NULL;
    size_t mem_210643_cached_sizze_213761 = 0;
    unsigned char *mem_210643 = NULL;
    size_t mem_210686_cached_sizze_213762 = 0;
    unsigned char *mem_210686 = NULL;
    size_t mem_210702_cached_sizze_213763 = 0;
    unsigned char *mem_210702 = NULL;
    size_t mem_210715_cached_sizze_213764 = 0;
    unsigned char *mem_210715 = NULL;
    size_t mem_210738_cached_sizze_213765 = 0;
    unsigned char *mem_210738 = NULL;
    size_t mem_210754_cached_sizze_213766 = 0;
    unsigned char *mem_210754 = NULL;
    size_t mem_210767_cached_sizze_213767 = 0;
    unsigned char *mem_210767 = NULL;
    size_t mem_210790_cached_sizze_213768 = 0;
    unsigned char *mem_210790 = NULL;
    size_t mem_210806_cached_sizze_213769 = 0;
    unsigned char *mem_210806 = NULL;
    size_t mem_210819_cached_sizze_213770 = 0;
    unsigned char *mem_210819 = NULL;
    size_t mem_211127_cached_sizze_213771 = 0;
    unsigned char *mem_211127 = NULL;
    size_t mem_211211_cached_sizze_213772 = 0;
    unsigned char *mem_211211 = NULL;
    size_t mem_211214_cached_sizze_213773 = 0;
    unsigned char *mem_211214 = NULL;
    size_t mem_211329_cached_sizze_213774 = 0;
    unsigned char *mem_211329 = NULL;
    size_t mem_211332_cached_sizze_213775 = 0;
    unsigned char *mem_211332 = NULL;
    size_t mem_211359_cached_sizze_213776 = 0;
    unsigned char *mem_211359 = NULL;
    size_t mem_211362_cached_sizze_213777 = 0;
    unsigned char *mem_211362 = NULL;
    size_t mem_211589_cached_sizze_213778 = 0;
    unsigned char *mem_211589 = NULL;
    size_t mem_211604_cached_sizze_213779 = 0;
    unsigned char *mem_211604 = NULL;
    size_t mem_211607_cached_sizze_213780 = 0;
    unsigned char *mem_211607 = NULL;
    size_t mem_211692_cached_sizze_213781 = 0;
    unsigned char *mem_211692 = NULL;
    size_t mem_211707_cached_sizze_213782 = 0;
    unsigned char *mem_211707 = NULL;
    size_t mem_211710_cached_sizze_213783 = 0;
    unsigned char *mem_211710 = NULL;
    size_t mem_211825_cached_sizze_213784 = 0;
    unsigned char *mem_211825 = NULL;
    size_t mem_211840_cached_sizze_213785 = 0;
    unsigned char *mem_211840 = NULL;
    size_t mem_211843_cached_sizze_213786 = 0;
    unsigned char *mem_211843 = NULL;
    size_t mem_211980_cached_sizze_213787 = 0;
    unsigned char *mem_211980 = NULL;
    size_t mem_211995_cached_sizze_213788 = 0;
    unsigned char *mem_211995 = NULL;
    size_t mem_211998_cached_sizze_213789 = 0;
    unsigned char *mem_211998 = NULL;
    size_t mem_212036_cached_sizze_213790 = 0;
    unsigned char *mem_212036 = NULL;
    size_t mem_212098_cached_sizze_213791 = 0;
    unsigned char *mem_212098 = NULL;
    size_t mem_212113_cached_sizze_213792 = 0;
    unsigned char *mem_212113 = NULL;
    size_t mem_212116_cached_sizze_213793 = 0;
    unsigned char *mem_212116 = NULL;
    size_t mem_212165_cached_sizze_213794 = 0;
    unsigned char *mem_212165 = NULL;
    size_t mem_212168_cached_sizze_213795 = 0;
    unsigned char *mem_212168 = NULL;
    size_t mem_212261_cached_sizze_213796 = 0;
    unsigned char *mem_212261 = NULL;
    size_t mem_212276_cached_sizze_213797 = 0;
    unsigned char *mem_212276 = NULL;
    size_t mem_212279_cached_sizze_213798 = 0;
    unsigned char *mem_212279 = NULL;
    size_t mem_212328_cached_sizze_213799 = 0;
    unsigned char *mem_212328 = NULL;
    size_t mem_212331_cached_sizze_213800 = 0;
    unsigned char *mem_212331 = NULL;
    size_t mem_212358_cached_sizze_213801 = 0;
    unsigned char *mem_212358 = NULL;
    size_t mem_212361_cached_sizze_213802 = 0;
    unsigned char *mem_212361 = NULL;
    size_t mem_212543_cached_sizze_213803 = 0;
    unsigned char *mem_212543 = NULL;
    size_t mem_212547_cached_sizze_213804 = 0;
    unsigned char *mem_212547 = NULL;
    size_t mem_212631_cached_sizze_213805 = 0;
    unsigned char *mem_212631 = NULL;
    size_t mem_212652_cached_sizze_213806 = 0;
    unsigned char *mem_212652 = NULL;
    size_t mem_212655_cached_sizze_213807 = 0;
    unsigned char *mem_212655 = NULL;
    size_t mem_212658_cached_sizze_213808 = 0;
    unsigned char *mem_212658 = NULL;
    size_t mem_212661_cached_sizze_213809 = 0;
    unsigned char *mem_212661 = NULL;
    size_t mem_212664_cached_sizze_213810 = 0;
    unsigned char *mem_212664 = NULL;
    size_t mem_212727_cached_sizze_213811 = 0;
    unsigned char *mem_212727 = NULL;
    size_t mem_212758_cached_sizze_213812 = 0;
    unsigned char *mem_212758 = NULL;
    size_t mem_212761_cached_sizze_213813 = 0;
    unsigned char *mem_212761 = NULL;
    size_t mem_212764_cached_sizze_213814 = 0;
    unsigned char *mem_212764 = NULL;
    size_t mem_212880_cached_sizze_213815 = 0;
    unsigned char *mem_212880 = NULL;
    size_t mem_212884_cached_sizze_213816 = 0;
    unsigned char *mem_212884 = NULL;
    size_t mem_212888_cached_sizze_213817 = 0;
    unsigned char *mem_212888 = NULL;
    size_t mem_212921_cached_sizze_213818 = 0;
    unsigned char *mem_212921 = NULL;
    size_t mem_212924_cached_sizze_213819 = 0;
    unsigned char *mem_212924 = NULL;
    size_t mem_212927_cached_sizze_213820 = 0;
    unsigned char *mem_212927 = NULL;
    struct memblock mem_out_213362;
    
    mem_out_213362.references = NULL;
    
    struct memblock mem_out_213363;
    
    mem_out_213363.references = NULL;
    
    struct memblock mem_out_213364;
    
    mem_out_213364.references = NULL;
    
    double i64_res_203506 = sitofp_i64_f64(n_203490);
    double i64_res_203507 = sitofp_i64_f64(n_p_203492);
    double ceil_arg_203508 = i64_res_203506 / i64_res_203507;
    double ceil_res_203509;
    
    ceil_res_203509 = futrts_ceil64(ceil_arg_203508);
    
    int64_t defunc_0_f_res_203510 = fptosi_f64_i64(ceil_res_203509);
    bool bounds_invalid_upwards_203511 = slt64(n_p_203492, (int64_t) 0);
    bool valid_203512 = !bounds_invalid_upwards_203511;
    bool range_valid_c_203513;
    
    if (!valid_203512) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) n_p_203492, " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  stl.fut:403:29-408:37\n   #4  stl.fut:402:22-409:28\n   #5  stl.fut:455:3-469:34\n   #6  stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_out_213364, "mem_out_213364") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213363, "mem_out_213363") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213362, "mem_out_213362") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool bounds_invalid_upwards_203515 = slt64(defunc_0_f_res_203510,
                                               (int64_t) 0);
    bool valid_203516 = !bounds_invalid_upwards_203515;
    bool range_valid_c_203517;
    
    if (!valid_203516) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) defunc_0_f_res_203510,
                               " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  stl.fut:404:36-407:52\n   #4  /prelude/soacs.fut:59:3-10\n   #5  /prelude/array.fut:195:3-17\n   #6  utils.fut:6:3-16\n   #7  stl.fut:403:29-408:37\n   #8  stl.fut:402:22-409:28\n   #9  stl.fut:455:3-469:34\n   #10 stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_out_213364, "mem_out_213364") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213363, "mem_out_213363") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213362, "mem_out_213362") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    int64_t binop_y_208319 = (int64_t) 8 * m_203489;
    int64_t bytes_208320 = smax64((int64_t) 0, binop_y_208319);
    
    if (mem_208321_cached_sizze_213728 < (size_t) bytes_208320) {
        mem_208321 = realloc(mem_208321, bytes_208320);
        mem_208321_cached_sizze_213728 = bytes_208320;
    }
    if (mem_208324_cached_sizze_213729 < (size_t) bytes_208320) {
        mem_208324 = realloc(mem_208324, bytes_208320);
        mem_208324_cached_sizze_213729 = bytes_208320;
    }
    
    int64_t discard_206875;
    int64_t scanacc_206867 = (int64_t) 0;
    
    for (int64_t i_206871 = 0; i_206871 < m_203489; i_206871++) {
        bool defunc_2_reduce_res_203548;
        bool redout_206862 = 0;
        
        for (int64_t i_206863 = 0; i_206863 < n_p_203492; i_206863++) {
            bool defunc_2_reduce_res_203553;
            bool redout_206860 = 1;
            
            for (int64_t i_206861 = 0; i_206861 < defunc_0_f_res_203510;
                 i_206861++) {
                int64_t x_203558 = mul64(n_p_203492, i_206861);
                int64_t idx_203559 = add64(x_203558, i_206863);
                bool cond_203560 = slt64(idx_203559, n_203490);
                bool defunc_0_f_res_203561;
                
                if (cond_203560) {
                    bool x_203562 = sle64((int64_t) 0, idx_203559);
                    bool bounds_check_203563 = cond_203560 && x_203562;
                    bool index_certs_203564;
                    
                    if (!bounds_check_203563) {
                        ctx->error =
                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                      "Index [", (long long) idx_203559,
                                      "] out of bounds for array of shape [",
                                      (long long) n_203490, "].",
                                      "-> #0  stl.fut:406:65-70\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:404:36-407:52\n   #5  /prelude/soacs.fut:59:3-10\n   #6  /prelude/array.fut:195:3-17\n   #7  utils.fut:6:3-16\n   #8  stl.fut:403:29-408:37\n   #9  stl.fut:402:22-409:28\n   #10 stl.fut:455:3-469:34\n   #11 stl.fut:439:1-469:34\n");
                        if (memblock_unref(ctx, &mem_out_213364,
                                           "mem_out_213364") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_213363,
                                           "mem_out_213363") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_213362,
                                           "mem_out_213362") != 0)
                            return 1;
                        err = 1;
                        goto cleanup;
                    }
                    
                    double isnan_arg_203565;
                    
                    isnan_arg_203565 = ((double *) Y_mem_208318.mem)[i_206871 *
                                                                     n_203490 +
                                                                     idx_203559];
                    
                    bool isnan_res_203566;
                    
                    isnan_res_203566 = futrts_isnan64(isnan_arg_203565);
                    defunc_0_f_res_203561 = isnan_res_203566;
                } else {
                    defunc_0_f_res_203561 = 0;
                }
                
                bool x_203556 = defunc_0_f_res_203561 && redout_206860;
                bool redout_tmp_213369 = x_203556;
                
                redout_206860 = redout_tmp_213369;
            }
            defunc_2_reduce_res_203553 = redout_206860;
            
            bool defunc_1_op_res_203551 = defunc_2_reduce_res_203553 ||
                 redout_206862;
            bool redout_tmp_213368 = defunc_1_op_res_203551;
            
            redout_206862 = redout_tmp_213368;
        }
        defunc_2_reduce_res_203548 = redout_206862;
        
        int64_t defunc_2_lifted_lambda_res_203567 =
                btoi_bool_i64(defunc_2_reduce_res_203548);
        bool is_i_203568 = defunc_2_lifted_lambda_res_203567 == (int64_t) 0;
        bool cond_neg_203569 = !is_i_203568;
        int64_t part_res_203570 = btoi_bool_i64(cond_neg_203569);
        int64_t part_res_203571 = btoi_bool_i64(is_i_203568);
        int64_t zz_203546 = part_res_203571 + scanacc_206867;
        
        ((int64_t *) mem_208321)[i_206871] = zz_203546;
        ((int64_t *) mem_208324)[i_206871] = part_res_203570;
        
        int64_t scanacc_tmp_213365 = zz_203546;
        
        scanacc_206867 = scanacc_tmp_213365;
    }
    discard_206875 = scanacc_206867;
    
    int64_t last_index_203575 = m_203489 - (int64_t) 1;
    bool is_empty_203576 = m_203489 == (int64_t) 0;
    int64_t partition_sizze_203577;
    
    if (is_empty_203576) {
        partition_sizze_203577 = (int64_t) 0;
    } else {
        int64_t last_offset_203578;
        
        last_offset_203578 = ((int64_t *) mem_208321)[last_index_203575];
        partition_sizze_203577 = last_offset_203578;
    }
    
    int64_t binop_x_208349 = m_203489 * n_203490;
    int64_t binop_y_208350 = (int64_t) 8 * binop_x_208349;
    int64_t bytes_208351 = smax64((int64_t) 0, binop_y_208350);
    
    if (mem_208352_cached_sizze_213730 < (size_t) bytes_208351) {
        mem_208352 = realloc(mem_208352, bytes_208351);
        mem_208352_cached_sizze_213730 = bytes_208351;
    }
    if (mem_208355_cached_sizze_213731 < (size_t) bytes_208320) {
        mem_208355 = realloc(mem_208355, bytes_208320);
        mem_208355_cached_sizze_213731 = bytes_208320;
    }
    
    int64_t binop_y_208373 = (int64_t) 8 * n_203490;
    int64_t bytes_208374 = smax64((int64_t) 0, binop_y_208373);
    
    if (mem_208375_cached_sizze_213732 < (size_t) bytes_208374) {
        mem_208375 = realloc(mem_208375, bytes_208374);
        mem_208375_cached_sizze_213732 = bytes_208374;
    }
    for (int64_t write_iter_206876 = 0; write_iter_206876 < m_203489;
         write_iter_206876++) {
        int64_t write_iv_206879;
        
        write_iv_206879 = ((int64_t *) mem_208324)[write_iter_206876];
        
        int64_t write_iv_206880;
        
        write_iv_206880 = ((int64_t *) mem_208321)[write_iter_206876];
        if (n_203490 * (int64_t) 8 > 0)
            memmove(mem_208375 + (int64_t) 0, Y_mem_208318.mem +
                    write_iter_206876 * n_203490 * (int64_t) 8, n_203490 *
                    (int64_t) 8);
        
        bool is_this_one_203588 = write_iv_206879 == (int64_t) 0;
        int64_t this_offset_203589 = (int64_t) -1 + write_iv_206880;
        int64_t total_res_203590;
        
        if (is_this_one_203588) {
            total_res_203590 = this_offset_203589;
        } else {
            total_res_203590 = (int64_t) -1;
        }
        if ((sle64((int64_t) 0, total_res_203590) && slt64(total_res_203590,
                                                           m_203489)) &&
            (sle64((int64_t) 0, (int64_t) 0) && slt64(n_203490 - (int64_t) 1,
                                                      n_203490))) {
            if (n_203490 * (int64_t) 8 > 0)
                memmove(mem_208352 + total_res_203590 * n_203490 * (int64_t) 8,
                        mem_208375 + (int64_t) 0, n_203490 * (int64_t) 8);
        }
        if (sle64((int64_t) 0, total_res_203590) && slt64(total_res_203590,
                                                          m_203489)) {
            ((int64_t *) mem_208355)[total_res_203590] = write_iter_206876;
        }
    }
    
    bool empty_slice_203591 = partition_sizze_203577 == (int64_t) 0;
    int64_t m_203592 = sub64(partition_sizze_203577, (int64_t) 1);
    bool zzero_leq_i_p_m_t_s_203593 = sle64((int64_t) 0, m_203592);
    bool i_p_m_t_s_leq_w_203594 = slt64(m_203592, m_203489);
    bool i_lte_j_203595 = sle64((int64_t) 0, partition_sizze_203577);
    bool y_203596 = zzero_leq_i_p_m_t_s_203593 && i_p_m_t_s_leq_w_203594;
    bool y_203597 = i_lte_j_203595 && y_203596;
    bool ok_or_empty_203598 = empty_slice_203591 || y_203597;
    bool index_certs_203599;
    
    if (!ok_or_empty_203598) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Index [:", (long long) partition_sizze_203577,
                               "] out of bounds for array of shape [",
                               (long long) m_203489, "].",
                               "-> #0  /prelude/soacs.fut:163:6-16\n   #1  stl.fut:412:7-66\n   #2  stl.fut:455:3-469:34\n   #3  stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_out_213364, "mem_out_213364") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213363, "mem_out_213363") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213362, "mem_out_213362") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool assert_cond_203602 = sle64((int64_t) 4, n_p_203492);
    bool assert_c_203603;
    
    if (!assert_cond_203602) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (n_p >= 4)",
                               "-> #0  stl.fut:69:13-33\n   #1  stl.fut:415:61-429:75\n   #2  stl.fut:455:3-469:34\n   #3  stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_out_213364, "mem_out_213364") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213363, "mem_out_213363") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213362, "mem_out_213362") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    int64_t x_203604 = smod64(q_t_203494, (int64_t) 2);
    bool assert_cond_203605 = x_203604 == (int64_t) 1;
    bool assert_c_203606;
    
    if (!assert_cond_203605) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x % 2 == 1)",
                               "-> #0  utils.fut:20:3-23\n   #1  /prelude/functional.fut:39:62-64\n   #2  stl.fut:71:13-25\n   #3  stl.fut:415:61-429:75\n   #4  stl.fut:455:3-469:34\n   #5  stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_out_213364, "mem_out_213364") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213363, "mem_out_213363") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213362, "mem_out_213362") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool assert_cond_203607 = slt64((int64_t) 0, q_t_203494);
    bool assert_c_203608;
    
    if (!assert_cond_203607) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x > 0)",
                               "-> #0  utils.fut:17:3-18\n   #1  /prelude/functional.fut:39:59-65\n   #2  stl.fut:71:13-25\n   #3  stl.fut:415:61-429:75\n   #4  stl.fut:455:3-469:34\n   #5  stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_out_213364, "mem_out_213364") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213363, "mem_out_213363") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213362, "mem_out_213362") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    int64_t x_203609 = smod64(q_l_203495, (int64_t) 2);
    bool assert_cond_203610 = x_203609 == (int64_t) 1;
    bool assert_c_203611;
    
    if (!assert_cond_203610) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x % 2 == 1)",
                               "-> #0  utils.fut:20:3-23\n   #1  /prelude/functional.fut:39:62-64\n   #2  stl.fut:72:13-25\n   #3  stl.fut:415:61-429:75\n   #4  stl.fut:455:3-469:34\n   #5  stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_out_213364, "mem_out_213364") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213363, "mem_out_213363") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213362, "mem_out_213362") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool assert_cond_203612 = slt64((int64_t) 0, q_l_203495);
    bool assert_c_203613;
    
    if (!assert_cond_203612) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x > 0)",
                               "-> #0  utils.fut:17:3-18\n   #1  /prelude/functional.fut:39:59-65\n   #2  stl.fut:72:13-25\n   #3  stl.fut:415:61-429:75\n   #4  stl.fut:455:3-469:34\n   #5  stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_out_213364, "mem_out_213364") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213363, "mem_out_213363") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213362, "mem_out_213362") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool assert_cond_203622 = slt64((int64_t) 0, jump_t_203500);
    bool assert_c_203623;
    
    if (!assert_cond_203622) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x > 0)",
                               "-> #0  utils.fut:17:3-18\n   #1  stl.fut:77:16-31\n   #2  stl.fut:415:61-429:75\n   #3  stl.fut:455:3-469:34\n   #4  stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_out_213364, "mem_out_213364") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213363, "mem_out_213363") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213362, "mem_out_213362") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool assert_cond_203624 = slt64((int64_t) 0, jump_l_203501);
    bool assert_c_203625;
    
    if (!assert_cond_203624) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x > 0)",
                               "-> #0  utils.fut:17:3-18\n   #1  stl.fut:78:16-31\n   #2  stl.fut:415:61-429:75\n   #3  stl.fut:455:3-469:34\n   #4  stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_out_213364, "mem_out_213364") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213363, "mem_out_213363") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213362, "mem_out_213362") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool assert_cond_203626 = slt64((int64_t) 0, n_inner_203502);
    bool assert_c_203627;
    
    if (!assert_cond_203626) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x > 0)",
                               "-> #0  utils.fut:17:3-18\n   #1  stl.fut:80:17-33\n   #2  stl.fut:415:61-429:75\n   #3  stl.fut:455:3-469:34\n   #4  stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_out_213364, "mem_out_213364") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213363, "mem_out_213363") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213362, "mem_out_213362") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool assert_cond_203628 = slt64((int64_t) 0, n_outer_203503);
    bool assert_c_203629;
    
    if (!assert_cond_203628) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x > 0)",
                               "-> #0  utils.fut:17:3-18\n   #1  stl.fut:81:17-33\n   #2  stl.fut:415:61-429:75\n   #3  stl.fut:455:3-469:34\n   #4  stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_out_213364, "mem_out_213364") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213363, "mem_out_213363") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213362, "mem_out_213362") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    double ceil_res_203630;
    
    ceil_res_203630 = futrts_ceil64(ceil_arg_203508);
    
    int64_t defunc_0_f_res_203631 = fptosi_f64_i64(ceil_res_203630);
    int64_t pad_css_len_203632 = add64((int64_t) 2, defunc_0_f_res_203631);
    int64_t y_203633 = mul64((int64_t) 2, n_p_203492);
    int64_t C_len_203634 = add64(n_203490, y_203633);
    bool cond_203635 = jump_s_203499 == (int64_t) 1;
    int64_t s_n_m_203636;
    
    if (cond_203635) {
        s_n_m_203636 = pad_css_len_203632;
    } else {
        bool zzero_203637 = jump_s_203499 == (int64_t) 0;
        bool nonzzero_203638 = !zzero_203637;
        bool nonzzero_cert_203639;
        
        if (!nonzzero_203638) {
            ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                                   "division by zero",
                                   "-> #0  stl.fut:88:52-71\n   #1  stl.fut:415:61-429:75\n   #2  stl.fut:455:3-469:34\n   #3  stl.fut:439:1-469:34\n");
            if (memblock_unref(ctx, &mem_out_213364, "mem_out_213364") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_out_213363, "mem_out_213363") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_out_213362, "mem_out_213362") != 0)
                return 1;
            err = 1;
            goto cleanup;
        }
        
        int64_t x_203640 = sdiv64(defunc_0_f_res_203631, jump_s_203499);
        int64_t s_n_m_f_res_203641 = add64((int64_t) 3, x_203640);
        
        s_n_m_203636 = s_n_m_f_res_203641;
    }
    
    bool cond_203642 = jump_l_203501 == (int64_t) 1;
    int64_t l_n_m_203643;
    
    if (cond_203642) {
        l_n_m_203643 = n_203490;
    } else {
        bool zzero_203644 = jump_l_203501 == (int64_t) 0;
        bool nonzzero_203645 = !zzero_203644;
        bool nonzzero_cert_203646;
        
        if (!nonzzero_203645) {
            ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                                   "division by zero",
                                   "-> #0  stl.fut:94:42-51\n   #1  stl.fut:415:61-429:75\n   #2  stl.fut:455:3-469:34\n   #3  stl.fut:439:1-469:34\n");
            if (memblock_unref(ctx, &mem_out_213364, "mem_out_213364") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_out_213363, "mem_out_213363") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_out_213362, "mem_out_213362") != 0)
                return 1;
            err = 1;
            goto cleanup;
        }
        
        int64_t x_203647 = sdiv64(n_203490, jump_l_203501);
        int64_t l_n_m_f_res_203648 = add64((int64_t) 1, x_203647);
        
        l_n_m_203643 = l_n_m_f_res_203648;
    }
    
    bool cond_203649 = jump_t_203500 == (int64_t) 1;
    int64_t t_n_m_203650;
    
    if (cond_203649) {
        t_n_m_203650 = n_203490;
    } else {
        bool zzero_203651 = jump_t_203500 == (int64_t) 0;
        bool nonzzero_203652 = !zzero_203651;
        bool nonzzero_cert_203653;
        
        if (!nonzzero_203652) {
            ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                                   "division by zero",
                                   "-> #0  stl.fut:98:42-51\n   #1  stl.fut:415:61-429:75\n   #2  stl.fut:455:3-469:34\n   #3  stl.fut:439:1-469:34\n");
            if (memblock_unref(ctx, &mem_out_213364, "mem_out_213364") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_out_213363, "mem_out_213363") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_out_213362, "mem_out_213362") != 0)
                return 1;
            err = 1;
            goto cleanup;
        }
        
        int64_t x_203654 = sdiv64(n_203490, jump_t_203500);
        int64_t t_n_m_f_res_203655 = add64((int64_t) 1, x_203654);
        
        t_n_m_203650 = t_n_m_f_res_203655;
    }
    
    double x_203656 = i64_res_203506 / 2.0;
    double floor_arg_203657 = 1.0 + x_203656;
    double floor_res_203658;
    
    floor_res_203658 = futrts_floor64(floor_arg_203657);
    
    int64_t defunc_0_f_res_203659 = fptosi_f64_i64(floor_res_203658);
    int64_t x_203660 = sub64(n_203490, defunc_0_f_res_203659);
    int64_t mid2_203661 = add64((int64_t) 1, x_203660);
    bool cond_203662 = defunc_0_f_res_203659 == mid2_203661;
    int64_t stl_res_t_res_203663 = sub64(defunc_0_f_res_203659, (int64_t) 1);
    int64_t stl_res_203664;
    int64_t stl_res_203665;
    
    if (cond_203662) {
        stl_res_203664 = stl_res_t_res_203663;
        stl_res_203665 = defunc_0_f_res_203659;
    } else {
        int64_t min_res_203666 = smin64(defunc_0_f_res_203659, mid2_203661);
        int64_t stl_res_f_res_203667 = sub64(min_res_203666, (int64_t) 1);
        int64_t max_res_203668 = smax64(defunc_0_f_res_203659, mid2_203661);
        
        stl_res_203664 = stl_res_f_res_203667;
        stl_res_203665 = max_res_203668;
    }
    
    int64_t i_203670 = sub64(n_203490, (int64_t) 1);
    bool x_203671 = sle64((int64_t) 0, i_203670);
    bool y_203672 = slt64(i_203670, n_203490);
    bool bounds_check_203673 = x_203671 && y_203672;
    bool index_certs_203674;
    
    if (!bounds_check_203673) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Index [", (long long) i_203670,
                               "] out of bounds for array of shape [",
                               (long long) n_203490, "].",
                               "-> #0  /prelude/array.fut:26:29-34\n   #1  utils.fut:45:13-20\n   #2  stl.fut:112:31-49\n   #3  stl.fut:415:61-429:75\n   #4  stl.fut:455:3-469:34\n   #5  stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_out_213364, "mem_out_213364") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213363, "mem_out_213363") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213362, "mem_out_213362") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    int64_t binop_x_208389 = n_203490 * partition_sizze_203577;
    int64_t binop_y_208390 = (int64_t) 8 * binop_x_208389;
    int64_t bytes_208391 = smax64((int64_t) 0, binop_y_208390);
    
    if (mem_208392_cached_sizze_213733 < (size_t) bytes_208391) {
        mem_208392 = realloc(mem_208392, bytes_208391);
        mem_208392_cached_sizze_213733 = bytes_208391;
    }
    
    int64_t binop_y_208393 = (int64_t) 8 * partition_sizze_203577;
    int64_t bytes_208394 = smax64((int64_t) 0, binop_y_208393);
    
    if (mem_208395_cached_sizze_213734 < (size_t) bytes_208394) {
        mem_208395 = realloc(mem_208395, bytes_208394);
        mem_208395_cached_sizze_213734 = bytes_208394;
    }
    
    int64_t binop_y_208413 = (int64_t) 8 * n_203490;
    int64_t bytes_208414 = smax64((int64_t) 0, binop_y_208413);
    
    if (mem_208415_cached_sizze_213735 < (size_t) bytes_208414) {
        mem_208415 = realloc(mem_208415, bytes_208414);
        mem_208415_cached_sizze_213735 = bytes_208414;
    }
    if (mem_208430_cached_sizze_213736 < (size_t) bytes_208414) {
        mem_208430 = realloc(mem_208430, bytes_208414);
        mem_208430_cached_sizze_213736 = bytes_208414;
    }
    for (int64_t i_213372 = 0; i_213372 < n_203490; i_213372++) {
        ((int64_t *) mem_208430)[i_213372] = (int64_t) -1;
    }
    for (int64_t i_206902 = 0; i_206902 < partition_sizze_203577; i_206902++) {
        int64_t discard_206891;
        int64_t scanacc_206887 = (int64_t) 0;
        
        for (int64_t i_206889 = 0; i_206889 < n_203490; i_206889++) {
            double x_203682;
            
            x_203682 = ((double *) mem_208352)[i_206902 * n_203490 + i_206889];
            
            bool isnan_res_203683;
            
            isnan_res_203683 = futrts_isnan64(x_203682);
            
            bool defunc_0_p_res_203684 = !isnan_res_203683;
            int64_t defunc_0_f_res_203685 =
                    btoi_bool_i64(defunc_0_p_res_203684);
            int64_t defunc_1_op_res_203681 = add64(defunc_0_f_res_203685,
                                                   scanacc_206887);
            
            ((int64_t *) mem_208415)[i_206889] = defunc_1_op_res_203681;
            
            int64_t scanacc_tmp_213375 = defunc_1_op_res_203681;
            
            scanacc_206887 = scanacc_tmp_213375;
        }
        discard_206891 = scanacc_206887;
        if (n_203490 * (int64_t) 8 > 0)
            memmove(mem_208392 + i_206902 * n_203490 * (int64_t) 8, mem_208430 +
                    (int64_t) 0, n_203490 * (int64_t) 8);
        for (int64_t write_iter_206892 = 0; write_iter_206892 < n_203490;
             write_iter_206892++) {
            double write_iv_206894;
            
            write_iv_206894 = ((double *) mem_208352)[i_206902 * n_203490 +
                                                      write_iter_206892];
            
            int64_t write_iv_206895;
            
            write_iv_206895 = ((int64_t *) mem_208415)[write_iter_206892];
            
            bool isnan_res_203692;
            
            isnan_res_203692 = futrts_isnan64(write_iv_206894);
            
            bool defunc_0_p_res_203693 = !isnan_res_203692;
            int64_t defunc_1_f_res_203694;
            
            if (defunc_0_p_res_203693) {
                int64_t defunc_1_f_res_t_res_203695 = sub64(write_iv_206895,
                                                            (int64_t) 1);
                
                defunc_1_f_res_203694 = defunc_1_f_res_t_res_203695;
            } else {
                defunc_1_f_res_203694 = (int64_t) -1;
            }
            if ((sle64((int64_t) 0, i_206902) && slt64(i_206902,
                                                       partition_sizze_203577)) &&
                (sle64((int64_t) 0, defunc_1_f_res_203694) &&
                 slt64(defunc_1_f_res_203694, n_203490))) {
                ((int64_t *) mem_208392)[i_206902 * n_203490 +
                                         defunc_1_f_res_203694] =
                    write_iter_206892;
            }
        }
        if ((int64_t) 8 > 0)
            memmove(mem_208395 + i_206902 * (int64_t) 8, mem_208415 +
                    ((int64_t) 0 + (int64_t) 1 * i_203670) * (int64_t) 8,
                    (int64_t) 8);
    }
    
    bool bounds_invalid_upwards_203698 = slt64(defunc_0_f_res_203631,
                                               (int64_t) 0);
    bool valid_203699 = !bounds_invalid_upwards_203698;
    bool range_valid_c_203700;
    
    if (!valid_203699) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) defunc_0_f_res_203631,
                               " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  stl.fut:119:20-125:36\n   #4  /prelude/soacs.fut:59:3-10\n   #5  /prelude/array.fut:195:3-17\n   #6  utils.fut:6:3-16\n   #7  stl.fut:117:12-126:20\n   #8  stl.fut:116:5-127:11\n   #9  stl.fut:415:61-429:75\n   #10 stl.fut:455:3-469:34\n   #11 stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_out_213364, "mem_out_213364") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213363, "mem_out_213363") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213362, "mem_out_213362") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    int64_t binop_x_208463 = n_p_203492 * partition_sizze_203577;
    int64_t binop_x_208464 = defunc_0_f_res_203631 * binop_x_208463;
    int64_t binop_y_208465 = (int64_t) 8 * binop_x_208464;
    int64_t bytes_208466 = smax64((int64_t) 0, binop_y_208465);
    
    if (mem_208467_cached_sizze_213737 < (size_t) bytes_208466) {
        mem_208467 = realloc(mem_208467, bytes_208466);
        mem_208467_cached_sizze_213737 = bytes_208466;
    }
    
    int64_t ctx_val_208480 = n_p_203492 * defunc_0_f_res_203631;
    
    for (int64_t i_206915 = 0; i_206915 < partition_sizze_203577; i_206915++) {
        for (int64_t i_206911 = 0; i_206911 < n_p_203492; i_206911++) {
            for (int64_t i_206907 = 0; i_206907 < defunc_0_f_res_203631;
                 i_206907++) {
                int64_t y_203708 = mul64(n_p_203492, i_206907);
                int64_t new_i_203709 = add64(y_203708, i_206911);
                bool cond_203710 = slt64(i_203670, new_i_203709);
                double defunc_0_f_res_203711;
                
                if (cond_203710) {
                    defunc_0_f_res_203711 = NAN;
                } else {
                    bool x_203712 = sle64((int64_t) 0, new_i_203709);
                    bool y_203713 = slt64(new_i_203709, n_203490);
                    bool bounds_check_203714 = x_203712 && y_203713;
                    bool index_certs_203715;
                    
                    if (!bounds_check_203714) {
                        ctx->error =
                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                      "Index [", (long long) new_i_203709,
                                      "] out of bounds for array of shape [",
                                      (long long) n_203490, "].",
                                      "-> #0  stl.fut:124:33-40\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:119:20-125:36\n   #5  /prelude/soacs.fut:59:3-10\n   #6  /prelude/array.fut:195:3-17\n   #7  utils.fut:6:3-16\n   #8  stl.fut:117:12-126:20\n   #9  stl.fut:116:5-127:11\n   #10 stl.fut:415:61-429:75\n   #11 stl.fut:455:3-469:34\n   #12 stl.fut:439:1-469:34\n");
                        if (memblock_unref(ctx, &mem_out_213364,
                                           "mem_out_213364") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_213363,
                                           "mem_out_213363") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_213362,
                                           "mem_out_213362") != 0)
                            return 1;
                        err = 1;
                        goto cleanup;
                    }
                    
                    double defunc_0_f_res_f_res_203716;
                    
                    defunc_0_f_res_f_res_203716 =
                        ((double *) mem_208352)[i_206915 * n_203490 +
                                                new_i_203709];
                    defunc_0_f_res_203711 = defunc_0_f_res_f_res_203716;
                }
                ((double *) mem_208467)[i_206915 * ctx_val_208480 + i_206911 *
                                        defunc_0_f_res_203631 + i_206907] =
                    defunc_0_f_res_203711;
            }
        }
    }
    
    int64_t i_203718 = sub64(defunc_0_f_res_203631, (int64_t) 1);
    bool x_203719 = sle64((int64_t) 0, i_203718);
    bool y_203720 = slt64(i_203718, defunc_0_f_res_203631);
    bool bounds_check_203721 = x_203719 && y_203720;
    bool index_certs_203722;
    
    if (!bounds_check_203721) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Index [", (long long) i_203718,
                               "] out of bounds for array of shape [",
                               (long long) defunc_0_f_res_203631, "].",
                               "-> #0  /prelude/array.fut:26:29-34\n   #1  utils.fut:45:13-20\n   #2  stl.fut:133:51-67\n   #3  stl.fut:132:12-135:21\n   #4  stl.fut:131:5-136:16\n   #5  stl.fut:415:61-429:75\n   #6  stl.fut:455:3-469:34\n   #7  stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_out_213364, "mem_out_213364") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213363, "mem_out_213363") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213362, "mem_out_213362") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    if (mem_208559_cached_sizze_213738 < (size_t) bytes_208466) {
        mem_208559 = realloc(mem_208559, bytes_208466);
        mem_208559_cached_sizze_213738 = bytes_208466;
    }
    
    int64_t binop_y_208561 = (int64_t) 8 * binop_x_208463;
    int64_t bytes_208562 = smax64((int64_t) 0, binop_y_208561);
    
    if (mem_208563_cached_sizze_213739 < (size_t) bytes_208562) {
        mem_208563 = realloc(mem_208563, bytes_208562);
        mem_208563_cached_sizze_213739 = bytes_208562;
    }
    
    int64_t binop_y_208614 = (int64_t) 8 * defunc_0_f_res_203631;
    int64_t bytes_208615 = smax64((int64_t) 0, binop_y_208614);
    
    if (mem_208616_cached_sizze_213740 < (size_t) bytes_208615) {
        mem_208616 = realloc(mem_208616, bytes_208615);
        mem_208616_cached_sizze_213740 = bytes_208615;
    }
    if (mem_208631_cached_sizze_213741 < (size_t) bytes_208615) {
        mem_208631 = realloc(mem_208631, bytes_208615);
        mem_208631_cached_sizze_213741 = bytes_208615;
    }
    for (int64_t i_213381 = 0; i_213381 < defunc_0_f_res_203631; i_213381++) {
        ((int64_t *) mem_208631)[i_213381] = (int64_t) -1;
    }
    for (int64_t i_206940 = 0; i_206940 < partition_sizze_203577; i_206940++) {
        for (int64_t i_206933 = 0; i_206933 < n_p_203492; i_206933++) {
            int64_t discard_206922;
            int64_t scanacc_206918 = (int64_t) 0;
            
            for (int64_t i_206920 = 0; i_206920 < defunc_0_f_res_203631;
                 i_206920++) {
                double x_203733;
                
                x_203733 = ((double *) mem_208467)[i_206940 * ctx_val_208480 +
                                                   i_206933 *
                                                   defunc_0_f_res_203631 +
                                                   i_206920];
                
                bool isnan_res_203734;
                
                isnan_res_203734 = futrts_isnan64(x_203733);
                
                bool defunc_0_p_res_203735 = !isnan_res_203734;
                int64_t defunc_0_f_res_203736 =
                        btoi_bool_i64(defunc_0_p_res_203735);
                int64_t defunc_1_op_res_203732 = add64(defunc_0_f_res_203736,
                                                       scanacc_206918);
                
                ((int64_t *) mem_208616)[i_206920] = defunc_1_op_res_203732;
                
                int64_t scanacc_tmp_213386 = defunc_1_op_res_203732;
                
                scanacc_206918 = scanacc_tmp_213386;
            }
            discard_206922 = scanacc_206918;
            if (defunc_0_f_res_203631 * (int64_t) 8 > 0)
                memmove(mem_208559 + (i_206940 * ctx_val_208480 + i_206933 *
                                      defunc_0_f_res_203631) * (int64_t) 8,
                        mem_208631 + (int64_t) 0, defunc_0_f_res_203631 *
                        (int64_t) 8);
            for (int64_t write_iter_206923 = 0; write_iter_206923 <
                 defunc_0_f_res_203631; write_iter_206923++) {
                double write_iv_206925;
                
                write_iv_206925 = ((double *) mem_208467)[i_206940 *
                                                          ctx_val_208480 +
                                                          i_206933 *
                                                          defunc_0_f_res_203631 +
                                                          write_iter_206923];
                
                int64_t write_iv_206926;
                
                write_iv_206926 = ((int64_t *) mem_208616)[write_iter_206923];
                
                bool isnan_res_203743;
                
                isnan_res_203743 = futrts_isnan64(write_iv_206925);
                
                bool defunc_0_p_res_203744 = !isnan_res_203743;
                int64_t defunc_1_f_res_203745;
                
                if (defunc_0_p_res_203744) {
                    int64_t defunc_1_f_res_t_res_203746 = sub64(write_iv_206926,
                                                                (int64_t) 1);
                    
                    defunc_1_f_res_203745 = defunc_1_f_res_t_res_203746;
                } else {
                    defunc_1_f_res_203745 = (int64_t) -1;
                }
                if (((sle64((int64_t) 0, i_206940) && slt64(i_206940,
                                                            partition_sizze_203577)) &&
                     (sle64((int64_t) 0, i_206933) && slt64(i_206933,
                                                            n_p_203492))) &&
                    (sle64((int64_t) 0, defunc_1_f_res_203745) &&
                     slt64(defunc_1_f_res_203745, defunc_0_f_res_203631))) {
                    ((int64_t *) mem_208559)[i_206940 * ctx_val_208480 +
                                             i_206933 * defunc_0_f_res_203631 +
                                             defunc_1_f_res_203745] =
                        write_iter_206923;
                }
            }
            if ((int64_t) 8 > 0)
                memmove(mem_208563 + (i_206940 * n_p_203492 + i_206933) *
                        (int64_t) 8, mem_208616 + ((int64_t) 0 + (int64_t) 1 *
                                                   i_203718) * (int64_t) 8,
                        (int64_t) 8);
        }
    }
    
    int64_t min_res_203749 = smin64(q_s_203493, defunc_0_f_res_203631);
    bool bounds_invalid_upwards_203750 = slt64(s_n_m_203636, (int64_t) 0);
    bool valid_203751 = !bounds_invalid_upwards_203750;
    bool range_valid_c_203752;
    
    if (!valid_203751) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) s_n_m_203636, " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  loess.fut:443:3-470:10\n   #4  loess.fut:517:15-50\n   #5  stl.fut:142:20-80\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:141:12-143:40\n   #9  /prelude/soacs.fut:67:19-23\n   #10 /prelude/soacs.fut:67:3-37\n   #11 stl.fut:140:5-144:36\n   #12 stl.fut:415:61-429:75\n   #13 stl.fut:455:3-469:34\n   #14 stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_out_213364, "mem_out_213364") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213363, "mem_out_213363") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213362, "mem_out_213362") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool loop_cond_203754 = slt64((int64_t) 1, min_res_203749);
    double i64_res_203755 = sitofp_i64_f64(q_s_203493);
    int64_t binop_x_208707 = s_n_m_203636 * binop_x_208463;
    int64_t binop_y_208708 = (int64_t) 8 * binop_x_208707;
    int64_t bytes_208709 = smax64((int64_t) 0, binop_y_208708);
    
    if (mem_208710_cached_sizze_213742 < (size_t) bytes_208709) {
        mem_208710 = realloc(mem_208710, bytes_208709);
        mem_208710_cached_sizze_213742 = bytes_208709;
    }
    if (mem_208715_cached_sizze_213743 < (size_t) bytes_208709) {
        mem_208715 = realloc(mem_208715, bytes_208709);
        mem_208715_cached_sizze_213743 = bytes_208709;
    }
    
    int64_t ctx_val_208739 = n_p_203492 * s_n_m_203636;
    int64_t binop_y_208774 = (int64_t) 8 * defunc_0_f_res_203631;
    int64_t bytes_208775 = smax64((int64_t) 0, binop_y_208774);
    
    if (mem_208776_cached_sizze_213744 < (size_t) bytes_208775) {
        mem_208776 = realloc(mem_208776, bytes_208775);
        mem_208776_cached_sizze_213744 = bytes_208775;
    }
    for (int64_t i_206965 = 0; i_206965 < partition_sizze_203577; i_206965++) {
        for (int64_t i_206958 = 0; i_206958 < n_p_203492; i_206958++) {
            int64_t x_203763;
            
            x_203763 = ((int64_t *) mem_208563)[i_206965 * n_p_203492 +
                                                i_206958];
            for (int64_t i_206945 = 0; i_206945 < defunc_0_f_res_203631;
                 i_206945++) {
                int64_t x_203765;
                
                x_203765 = ((int64_t *) mem_208559)[i_206965 * ctx_val_208480 +
                                                    i_206958 *
                                                    defunc_0_f_res_203631 +
                                                    i_206945];
                
                int64_t defunc_0_f_res_203766 = add64((int64_t) 1, x_203765);
                
                ((int64_t *) mem_208776)[i_206945] = defunc_0_f_res_203766;
            }
            
            int64_t min_arg_203767 = sub64(x_203763, (int64_t) 1);
            int64_t min_arg_203768 = sub64(x_203763, min_res_203749);
            int64_t min_res_203769 = smin64(q_s_203493, x_203763);
            double i64_res_203770 = sitofp_i64_f64(x_203763);
            double x_203771 = i64_res_203755 - i64_res_203770;
            double max_arg_203772 = x_203771 / 2.0;
            double max_res_203773 = fmax64(0.0, max_arg_203772);
            
            for (int64_t i_206951 = 0; i_206951 < s_n_m_203636; i_206951++) {
                bool cond_203777 = i_206951 == (int64_t) 0;
                int64_t defunc_0_m_fun_res_203778;
                
                if (cond_203777) {
                    defunc_0_m_fun_res_203778 = (int64_t) 0;
                } else {
                    int64_t y_203779 = sub64(s_n_m_203636, (int64_t) 1);
                    bool cond_203780 = i_206951 == y_203779;
                    int64_t defunc_0_m_fun_res_f_res_203781;
                    
                    if (cond_203780) {
                        int64_t defunc_0_m_fun_res_f_res_t_res_203782 =
                                sub64(pad_css_len_203632, (int64_t) 1);
                        
                        defunc_0_m_fun_res_f_res_203781 =
                            defunc_0_m_fun_res_f_res_t_res_203782;
                    } else {
                        int64_t x_203783 = sub64(i_206951, (int64_t) 1);
                        int64_t x_203784 = mul64(jump_s_203499, x_203783);
                        int64_t min_arg_203785 = add64((int64_t) 1, x_203784);
                        int64_t min_res_203786 = smin64(defunc_0_f_res_203631,
                                                        min_arg_203785);
                        
                        defunc_0_m_fun_res_f_res_203781 = min_res_203786;
                    }
                    defunc_0_m_fun_res_203778 = defunc_0_m_fun_res_f_res_203781;
                }
                
                bool init_idx_203787;
                int64_t init_idx_203788;
                int64_t init_idx_203789;
                bool loop_while_203790;
                int64_t low_203791;
                int64_t high_203792;
                
                loop_while_203790 = x_203719;
                low_203791 = (int64_t) 0;
                high_203792 = i_203718;
                while (loop_while_203790) {
                    int64_t x_203793 = add64(low_203791, high_203792);
                    int64_t mid_203794 = sdiv64(x_203793, (int64_t) 2);
                    bool x_203795 = sle64((int64_t) 0, mid_203794);
                    bool y_203796 = slt64(mid_203794, defunc_0_f_res_203631);
                    bool bounds_check_203797 = x_203795 && y_203796;
                    bool index_certs_203798;
                    
                    if (!bounds_check_203797) {
                        ctx->error =
                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                      "Index [", (long long) mid_203794,
                                      "] out of bounds for array of shape [",
                                      (long long) defunc_0_f_res_203631, "].",
                                      "-> #0  loess.fut:450:26-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:443:3-470:10\n   #5  loess.fut:517:15-50\n   #6  stl.fut:142:20-80\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:141:12-143:40\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:140:5-144:36\n   #13 stl.fut:415:61-429:75\n   #14 stl.fut:455:3-469:34\n   #15 stl.fut:439:1-469:34\n");
                        if (memblock_unref(ctx, &mem_out_213364,
                                           "mem_out_213364") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_213363,
                                           "mem_out_213363") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_213362,
                                           "mem_out_213362") != 0)
                            return 1;
                        err = 1;
                        goto cleanup;
                    }
                    
                    int64_t mid_id_203799;
                    
                    mid_id_203799 = ((int64_t *) mem_208776)[mid_203794];
                    
                    bool cond_203800 = slt64(mid_id_203799, (int64_t) 0);
                    int64_t mid_idx_203801;
                    
                    if (cond_203800) {
                        mid_idx_203801 = (int64_t) 9223372036854775807;
                    } else {
                        mid_idx_203801 = mid_id_203799;
                    }
                    
                    bool cond_203802 = sle64(defunc_0_m_fun_res_203778,
                                             mid_idx_203801);
                    int64_t loopres_203803;
                    int64_t loopres_203804;
                    
                    if (cond_203802) {
                        int64_t loopres_t_res_203805 = sub64(mid_203794,
                                                             (int64_t) 1);
                        
                        loopres_203803 = low_203791;
                        loopres_203804 = loopres_t_res_203805;
                    } else {
                        int64_t loopres_f_res_203806 = add64((int64_t) 1,
                                                             mid_203794);
                        
                        loopres_203803 = loopres_f_res_203806;
                        loopres_203804 = high_203792;
                    }
                    
                    bool loop_cond_203807 = sle64(loopres_203803,
                                                  loopres_203804);
                    bool loop_while_tmp_213396 = loop_cond_203807;
                    int64_t low_tmp_213397 = loopres_203803;
                    int64_t high_tmp_213398 = loopres_203804;
                    
                    loop_while_203790 = loop_while_tmp_213396;
                    low_203791 = low_tmp_213397;
                    high_203792 = high_tmp_213398;
                }
                init_idx_203787 = loop_while_203790;
                init_idx_203788 = low_203791;
                init_idx_203789 = high_203792;
                
                bool idx_203808;
                int64_t idx_203809;
                int64_t idx_203810;
                int64_t idx_203811;
                bool loop_while_203812;
                int64_t l_idx_203813;
                int64_t r_idx_203814;
                int64_t span_203815;
                
                loop_while_203812 = loop_cond_203754;
                l_idx_203813 = init_idx_203788;
                r_idx_203814 = init_idx_203788;
                span_203815 = (int64_t) 1;
                while (loop_while_203812) {
                    int64_t max_arg_203816 = sub64(l_idx_203813, (int64_t) 1);
                    int64_t max_res_203817 = smax64((int64_t) 0,
                                                    max_arg_203816);
                    int64_t min_arg_203818 = add64((int64_t) 1, r_idx_203814);
                    int64_t min_res_203819 = smin64(min_arg_203767,
                                                    min_arg_203818);
                    bool x_203820 = sle64((int64_t) 0, max_res_203817);
                    bool y_203821 = slt64(max_res_203817,
                                          defunc_0_f_res_203631);
                    bool bounds_check_203822 = x_203820 && y_203821;
                    bool index_certs_203823;
                    
                    if (!bounds_check_203822) {
                        ctx->error =
                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                      "Index [", (long long) max_res_203817,
                                      "] out of bounds for array of shape [",
                                      (long long) defunc_0_f_res_203631, "].",
                                      "-> #0  loess.fut:460:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:443:3-470:10\n   #5  loess.fut:517:15-50\n   #6  stl.fut:142:20-80\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:141:12-143:40\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:140:5-144:36\n   #13 stl.fut:415:61-429:75\n   #14 stl.fut:455:3-469:34\n   #15 stl.fut:439:1-469:34\n");
                        if (memblock_unref(ctx, &mem_out_213364,
                                           "mem_out_213364") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_213363,
                                           "mem_out_213363") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_213362,
                                           "mem_out_213362") != 0)
                            return 1;
                        err = 1;
                        goto cleanup;
                    }
                    
                    int64_t x_203824;
                    
                    x_203824 = ((int64_t *) mem_208776)[max_res_203817];
                    
                    int64_t abs_arg_203825 = sub64(x_203824,
                                                   defunc_0_m_fun_res_203778);
                    int64_t abs_res_203826 = abs64(abs_arg_203825);
                    bool x_203827 = sle64((int64_t) 0, min_res_203819);
                    bool y_203828 = slt64(min_res_203819,
                                          defunc_0_f_res_203631);
                    bool bounds_check_203829 = x_203827 && y_203828;
                    bool index_certs_203830;
                    
                    if (!bounds_check_203829) {
                        ctx->error =
                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                      "Index [", (long long) min_res_203819,
                                      "] out of bounds for array of shape [",
                                      (long long) defunc_0_f_res_203631, "].",
                                      "-> #0  loess.fut:461:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:443:3-470:10\n   #5  loess.fut:517:15-50\n   #6  stl.fut:142:20-80\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:141:12-143:40\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:140:5-144:36\n   #13 stl.fut:415:61-429:75\n   #14 stl.fut:455:3-469:34\n   #15 stl.fut:439:1-469:34\n");
                        if (memblock_unref(ctx, &mem_out_213364,
                                           "mem_out_213364") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_213363,
                                           "mem_out_213363") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_213362,
                                           "mem_out_213362") != 0)
                            return 1;
                        err = 1;
                        goto cleanup;
                    }
                    
                    int64_t x_203831;
                    
                    x_203831 = ((int64_t *) mem_208776)[min_res_203819];
                    
                    int64_t abs_arg_203832 = sub64(x_203831,
                                                   defunc_0_m_fun_res_203778);
                    int64_t abs_res_203833 = abs64(abs_arg_203832);
                    bool cond_203834 = max_res_203817 == l_idx_203813;
                    int64_t loopres_203835;
                    int64_t loopres_203836;
                    int64_t loopres_203837;
                    
                    if (cond_203834) {
                        loopres_203835 = l_idx_203813;
                        loopres_203836 = r_idx_203814;
                        loopres_203837 = min_res_203749;
                    } else {
                        bool cond_203838 = slt64(abs_res_203826,
                                                 abs_res_203833);
                        bool cond_f_res_203839 = min_res_203819 == r_idx_203814;
                        bool x_203840 = !cond_203838;
                        bool y_203841 = cond_f_res_203839 && x_203840;
                        bool cond_203842 = cond_203838 || y_203841;
                        int64_t loopres_f_res_203843;
                        
                        if (cond_203842) {
                            loopres_f_res_203843 = max_res_203817;
                        } else {
                            loopres_f_res_203843 = l_idx_203813;
                        }
                        
                        int64_t loopres_f_res_203844;
                        
                        if (cond_203842) {
                            loopres_f_res_203844 = r_idx_203814;
                        } else {
                            loopres_f_res_203844 = min_res_203819;
                        }
                        
                        int64_t loopres_f_res_203845;
                        
                        if (cond_203842) {
                            int64_t loopres_f_res_t_res_203846 =
                                    add64((int64_t) 1, span_203815);
                            
                            loopres_f_res_203845 = loopres_f_res_t_res_203846;
                        } else {
                            int64_t loopres_f_res_f_res_203847 =
                                    add64((int64_t) 1, span_203815);
                            
                            loopres_f_res_203845 = loopres_f_res_f_res_203847;
                        }
                        loopres_203835 = loopres_f_res_203843;
                        loopres_203836 = loopres_f_res_203844;
                        loopres_203837 = loopres_f_res_203845;
                    }
                    
                    bool loop_cond_203848 = slt64(loopres_203837,
                                                  min_res_203749);
                    bool loop_while_tmp_213399 = loop_cond_203848;
                    int64_t l_idx_tmp_213400 = loopres_203835;
                    int64_t r_idx_tmp_213401 = loopres_203836;
                    int64_t span_tmp_213402 = loopres_203837;
                    
                    loop_while_203812 = loop_while_tmp_213399;
                    l_idx_203813 = l_idx_tmp_213400;
                    r_idx_203814 = r_idx_tmp_213401;
                    span_203815 = span_tmp_213402;
                }
                idx_203808 = loop_while_203812;
                idx_203809 = l_idx_203813;
                idx_203810 = r_idx_203814;
                idx_203811 = span_203815;
                
                int64_t min_res_203849 = smin64(min_arg_203768, idx_203809);
                int64_t max_res_203850 = smax64((int64_t) 0, min_res_203849);
                int64_t defunc_0_m_fun_res_203851;
                
                if (cond_203777) {
                    defunc_0_m_fun_res_203851 = (int64_t) 0;
                } else {
                    int64_t y_203852 = sub64(s_n_m_203636, (int64_t) 1);
                    bool cond_203853 = i_206951 == y_203852;
                    int64_t defunc_0_m_fun_res_f_res_203854;
                    
                    if (cond_203853) {
                        int64_t defunc_0_m_fun_res_f_res_t_res_203855 =
                                sub64(pad_css_len_203632, (int64_t) 1);
                        
                        defunc_0_m_fun_res_f_res_203854 =
                            defunc_0_m_fun_res_f_res_t_res_203855;
                    } else {
                        int64_t x_203856 = sub64(i_206951, (int64_t) 1);
                        int64_t x_203857 = mul64(jump_s_203499, x_203856);
                        int64_t min_arg_203858 = add64((int64_t) 1, x_203857);
                        int64_t min_res_203859 = smin64(defunc_0_f_res_203631,
                                                        min_arg_203858);
                        
                        defunc_0_m_fun_res_f_res_203854 = min_res_203859;
                    }
                    defunc_0_m_fun_res_203851 = defunc_0_m_fun_res_f_res_203854;
                }
                
                int64_t x_203860 = add64(min_res_203769, max_res_203850);
                int64_t r_203861 = sub64(x_203860, (int64_t) 1);
                bool x_203862 = sle64((int64_t) 0, r_203861);
                bool y_203863 = slt64(r_203861, defunc_0_f_res_203631);
                bool bounds_check_203864 = x_203862 && y_203863;
                bool index_certs_203865;
                
                if (!bounds_check_203864) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) r_203861,
                                  "] out of bounds for array of shape [",
                                  (long long) defunc_0_f_res_203631, "].",
                                  "-> #0  loess.fut:485:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:480:3-488:25\n   #4  loess.fut:518:16-54\n   #5  stl.fut:142:20-80\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:141:12-143:40\n   #9  /prelude/soacs.fut:67:19-23\n   #10 /prelude/soacs.fut:67:3-37\n   #11 stl.fut:140:5-144:36\n   #12 stl.fut:415:61-429:75\n   #13 stl.fut:455:3-469:34\n   #14 stl.fut:439:1-469:34\n");
                    if (memblock_unref(ctx, &mem_out_213364,
                                       "mem_out_213364") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213363,
                                       "mem_out_213363") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213362,
                                       "mem_out_213362") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                int64_t x_203866;
                
                x_203866 = ((int64_t *) mem_208776)[r_203861];
                
                int64_t abs_arg_203867 = sub64(x_203866,
                                               defunc_0_m_fun_res_203851);
                int64_t abs_res_203868 = abs64(abs_arg_203867);
                bool x_203869 = sle64((int64_t) 0, max_res_203850);
                bool y_203870 = slt64(max_res_203850, defunc_0_f_res_203631);
                bool bounds_check_203871 = x_203869 && y_203870;
                bool index_certs_203872;
                
                if (!bounds_check_203871) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) max_res_203850,
                                  "] out of bounds for array of shape [",
                                  (long long) defunc_0_f_res_203631, "].",
                                  "-> #0  loess.fut:484:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:480:3-488:25\n   #4  loess.fut:518:16-54\n   #5  stl.fut:142:20-80\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:141:12-143:40\n   #9  /prelude/soacs.fut:67:19-23\n   #10 /prelude/soacs.fut:67:3-37\n   #11 stl.fut:140:5-144:36\n   #12 stl.fut:415:61-429:75\n   #13 stl.fut:455:3-469:34\n   #14 stl.fut:439:1-469:34\n");
                    if (memblock_unref(ctx, &mem_out_213364,
                                       "mem_out_213364") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213363,
                                       "mem_out_213363") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213362,
                                       "mem_out_213362") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                int64_t x_203873;
                
                x_203873 = ((int64_t *) mem_208776)[max_res_203850];
                
                int64_t abs_arg_203874 = sub64(x_203873,
                                               defunc_0_m_fun_res_203851);
                int64_t abs_res_203875 = abs64(abs_arg_203874);
                int64_t max_res_203876 = smax64(abs_res_203868, abs_res_203875);
                double defunc_0_f_res_203877 = sitofp_i64_f64(max_res_203876);
                double defunc_1_f_res_203878 = max_res_203773 +
                       defunc_0_f_res_203877;
                
                ((double *) mem_208715)[i_206965 * ctx_val_208739 + i_206958 *
                                        s_n_m_203636 + i_206951] =
                    defunc_1_f_res_203878;
                ((int64_t *) mem_208710)[i_206965 * ctx_val_208739 + i_206958 *
                                         s_n_m_203636 + i_206951] =
                    max_res_203850;
            }
        }
    }
    
    int64_t min_res_203881 = smin64(n_203490, q_l_203495);
    bool bounds_invalid_upwards_203882 = slt64(l_n_m_203643, (int64_t) 0);
    bool valid_203883 = !bounds_invalid_upwards_203882;
    bool range_valid_c_203884;
    
    if (!valid_203883) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) l_n_m_203643, " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  loess.fut:443:3-470:10\n   #4  loess.fut:503:15-61\n   #5  stl.fut:150:13-60\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:148:5-151:26\n   #9  stl.fut:415:61-429:75\n   #10 stl.fut:455:3-469:34\n   #11 stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_out_213364, "mem_out_213364") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213363, "mem_out_213363") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213362, "mem_out_213362") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool loop_cond_203886 = slt64((int64_t) 1, min_res_203881);
    double i64_res_203887 = sitofp_i64_f64(q_l_203495);
    int64_t binop_x_208905 = partition_sizze_203577 * l_n_m_203643;
    int64_t binop_y_208906 = (int64_t) 8 * binop_x_208905;
    int64_t bytes_208907 = smax64((int64_t) 0, binop_y_208906);
    
    if (mem_208908_cached_sizze_213745 < (size_t) bytes_208907) {
        mem_208908 = realloc(mem_208908, bytes_208907);
        mem_208908_cached_sizze_213745 = bytes_208907;
    }
    if (mem_208912_cached_sizze_213746 < (size_t) bytes_208907) {
        mem_208912 = realloc(mem_208912, bytes_208907);
        mem_208912_cached_sizze_213746 = bytes_208907;
    }
    
    int64_t binop_y_208933 = (int64_t) 8 * n_203490;
    int64_t bytes_208934 = smax64((int64_t) 0, binop_y_208933);
    
    if (mem_208935_cached_sizze_213747 < (size_t) bytes_208934) {
        mem_208935 = realloc(mem_208935, bytes_208934);
        mem_208935_cached_sizze_213747 = bytes_208934;
    }
    for (int64_t i_206983 = 0; i_206983 < partition_sizze_203577; i_206983++) {
        int64_t x_203891;
        
        x_203891 = ((int64_t *) mem_208395)[i_206983];
        for (int64_t i_206970 = 0; i_206970 < n_203490; i_206970++) {
            int64_t x_203893;
            
            x_203893 = ((int64_t *) mem_208392)[i_206983 * n_203490 + i_206970];
            
            int64_t defunc_0_f_res_203894 = add64((int64_t) 1, x_203893);
            
            ((int64_t *) mem_208935)[i_206970] = defunc_0_f_res_203894;
        }
        
        int64_t min_arg_203895 = sub64(x_203891, (int64_t) 1);
        int64_t min_arg_203896 = sub64(x_203891, min_res_203881);
        int64_t min_res_203897 = smin64(q_l_203495, x_203891);
        double i64_res_203898 = sitofp_i64_f64(x_203891);
        double x_203899 = i64_res_203887 - i64_res_203898;
        double max_arg_203900 = x_203899 / 2.0;
        double max_res_203901 = fmax64(0.0, max_arg_203900);
        
        for (int64_t i_206976 = 0; i_206976 < l_n_m_203643; i_206976++) {
            int64_t min_arg_203905 = mul64(jump_l_203501, i_206976);
            int64_t min_res_203906 = smin64(i_203670, min_arg_203905);
            int64_t defunc_0_g_res_203907 = add64((int64_t) 1, min_res_203906);
            bool init_idx_203908;
            int64_t init_idx_203909;
            int64_t init_idx_203910;
            bool loop_while_203911;
            int64_t low_203912;
            int64_t high_203913;
            
            loop_while_203911 = x_203671;
            low_203912 = (int64_t) 0;
            high_203913 = i_203670;
            while (loop_while_203911) {
                int64_t x_203914 = add64(low_203912, high_203913);
                int64_t mid_203915 = sdiv64(x_203914, (int64_t) 2);
                bool x_203916 = sle64((int64_t) 0, mid_203915);
                bool y_203917 = slt64(mid_203915, n_203490);
                bool bounds_check_203918 = x_203916 && y_203917;
                bool index_certs_203919;
                
                if (!bounds_check_203918) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) mid_203915,
                                  "] out of bounds for array of shape [",
                                  (long long) n_203490, "].",
                                  "-> #0  loess.fut:450:26-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:443:3-470:10\n   #5  loess.fut:503:15-61\n   #6  stl.fut:150:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:148:5-151:26\n   #10 stl.fut:415:61-429:75\n   #11 stl.fut:455:3-469:34\n   #12 stl.fut:439:1-469:34\n");
                    if (memblock_unref(ctx, &mem_out_213364,
                                       "mem_out_213364") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213363,
                                       "mem_out_213363") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213362,
                                       "mem_out_213362") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                int64_t mid_id_203920;
                
                mid_id_203920 = ((int64_t *) mem_208935)[mid_203915];
                
                bool cond_203921 = slt64(mid_id_203920, (int64_t) 0);
                int64_t mid_idx_203922;
                
                if (cond_203921) {
                    mid_idx_203922 = (int64_t) 9223372036854775807;
                } else {
                    mid_idx_203922 = mid_id_203920;
                }
                
                bool cond_203923 = sle64(defunc_0_g_res_203907, mid_idx_203922);
                int64_t loopres_203924;
                int64_t loopres_203925;
                
                if (cond_203923) {
                    int64_t loopres_t_res_203926 = sub64(mid_203915,
                                                         (int64_t) 1);
                    
                    loopres_203924 = low_203912;
                    loopres_203925 = loopres_t_res_203926;
                } else {
                    int64_t loopres_f_res_203927 = add64((int64_t) 1,
                                                         mid_203915);
                    
                    loopres_203924 = loopres_f_res_203927;
                    loopres_203925 = high_203913;
                }
                
                bool loop_cond_203928 = sle64(loopres_203924, loopres_203925);
                bool loop_while_tmp_213408 = loop_cond_203928;
                int64_t low_tmp_213409 = loopres_203924;
                int64_t high_tmp_213410 = loopres_203925;
                
                loop_while_203911 = loop_while_tmp_213408;
                low_203912 = low_tmp_213409;
                high_203913 = high_tmp_213410;
            }
            init_idx_203908 = loop_while_203911;
            init_idx_203909 = low_203912;
            init_idx_203910 = high_203913;
            
            bool idx_203929;
            int64_t idx_203930;
            int64_t idx_203931;
            int64_t idx_203932;
            bool loop_while_203933;
            int64_t l_idx_203934;
            int64_t r_idx_203935;
            int64_t span_203936;
            
            loop_while_203933 = loop_cond_203886;
            l_idx_203934 = init_idx_203909;
            r_idx_203935 = init_idx_203909;
            span_203936 = (int64_t) 1;
            while (loop_while_203933) {
                int64_t max_arg_203937 = sub64(l_idx_203934, (int64_t) 1);
                int64_t max_res_203938 = smax64((int64_t) 0, max_arg_203937);
                int64_t min_arg_203939 = add64((int64_t) 1, r_idx_203935);
                int64_t min_res_203940 = smin64(min_arg_203895, min_arg_203939);
                bool x_203941 = sle64((int64_t) 0, max_res_203938);
                bool y_203942 = slt64(max_res_203938, n_203490);
                bool bounds_check_203943 = x_203941 && y_203942;
                bool index_certs_203944;
                
                if (!bounds_check_203943) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) max_res_203938,
                                  "] out of bounds for array of shape [",
                                  (long long) n_203490, "].",
                                  "-> #0  loess.fut:460:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:443:3-470:10\n   #5  loess.fut:503:15-61\n   #6  stl.fut:150:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:148:5-151:26\n   #10 stl.fut:415:61-429:75\n   #11 stl.fut:455:3-469:34\n   #12 stl.fut:439:1-469:34\n");
                    if (memblock_unref(ctx, &mem_out_213364,
                                       "mem_out_213364") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213363,
                                       "mem_out_213363") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213362,
                                       "mem_out_213362") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                int64_t x_203945;
                
                x_203945 = ((int64_t *) mem_208935)[max_res_203938];
                
                int64_t abs_arg_203946 = sub64(x_203945, defunc_0_g_res_203907);
                int64_t abs_res_203947 = abs64(abs_arg_203946);
                bool x_203948 = sle64((int64_t) 0, min_res_203940);
                bool y_203949 = slt64(min_res_203940, n_203490);
                bool bounds_check_203950 = x_203948 && y_203949;
                bool index_certs_203951;
                
                if (!bounds_check_203950) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) min_res_203940,
                                  "] out of bounds for array of shape [",
                                  (long long) n_203490, "].",
                                  "-> #0  loess.fut:461:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:443:3-470:10\n   #5  loess.fut:503:15-61\n   #6  stl.fut:150:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:148:5-151:26\n   #10 stl.fut:415:61-429:75\n   #11 stl.fut:455:3-469:34\n   #12 stl.fut:439:1-469:34\n");
                    if (memblock_unref(ctx, &mem_out_213364,
                                       "mem_out_213364") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213363,
                                       "mem_out_213363") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213362,
                                       "mem_out_213362") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                int64_t x_203952;
                
                x_203952 = ((int64_t *) mem_208935)[min_res_203940];
                
                int64_t abs_arg_203953 = sub64(x_203952, defunc_0_g_res_203907);
                int64_t abs_res_203954 = abs64(abs_arg_203953);
                bool cond_203955 = max_res_203938 == l_idx_203934;
                int64_t loopres_203956;
                int64_t loopres_203957;
                int64_t loopres_203958;
                
                if (cond_203955) {
                    loopres_203956 = l_idx_203934;
                    loopres_203957 = r_idx_203935;
                    loopres_203958 = min_res_203881;
                } else {
                    bool cond_203959 = slt64(abs_res_203947, abs_res_203954);
                    bool cond_f_res_203960 = min_res_203940 == r_idx_203935;
                    bool x_203961 = !cond_203959;
                    bool y_203962 = cond_f_res_203960 && x_203961;
                    bool cond_203963 = cond_203959 || y_203962;
                    int64_t loopres_f_res_203964;
                    
                    if (cond_203963) {
                        loopres_f_res_203964 = max_res_203938;
                    } else {
                        loopres_f_res_203964 = l_idx_203934;
                    }
                    
                    int64_t loopres_f_res_203965;
                    
                    if (cond_203963) {
                        loopres_f_res_203965 = r_idx_203935;
                    } else {
                        loopres_f_res_203965 = min_res_203940;
                    }
                    
                    int64_t loopres_f_res_203966;
                    
                    if (cond_203963) {
                        int64_t loopres_f_res_t_res_203967 = add64((int64_t) 1,
                                                                   span_203936);
                        
                        loopres_f_res_203966 = loopres_f_res_t_res_203967;
                    } else {
                        int64_t loopres_f_res_f_res_203968 = add64((int64_t) 1,
                                                                   span_203936);
                        
                        loopres_f_res_203966 = loopres_f_res_f_res_203968;
                    }
                    loopres_203956 = loopres_f_res_203964;
                    loopres_203957 = loopres_f_res_203965;
                    loopres_203958 = loopres_f_res_203966;
                }
                
                bool loop_cond_203969 = slt64(loopres_203958, min_res_203881);
                bool loop_while_tmp_213411 = loop_cond_203969;
                int64_t l_idx_tmp_213412 = loopres_203956;
                int64_t r_idx_tmp_213413 = loopres_203957;
                int64_t span_tmp_213414 = loopres_203958;
                
                loop_while_203933 = loop_while_tmp_213411;
                l_idx_203934 = l_idx_tmp_213412;
                r_idx_203935 = r_idx_tmp_213413;
                span_203936 = span_tmp_213414;
            }
            idx_203929 = loop_while_203933;
            idx_203930 = l_idx_203934;
            idx_203931 = r_idx_203935;
            idx_203932 = span_203936;
            
            int64_t min_res_203970 = smin64(min_arg_203896, idx_203930);
            int64_t max_res_203971 = smax64((int64_t) 0, min_res_203970);
            int64_t x_203972 = add64(min_res_203897, max_res_203971);
            int64_t r_203973 = sub64(x_203972, (int64_t) 1);
            bool x_203974 = sle64((int64_t) 0, r_203973);
            bool y_203975 = slt64(r_203973, n_203490);
            bool bounds_check_203976 = x_203974 && y_203975;
            bool index_certs_203977;
            
            if (!bounds_check_203976) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) r_203973,
                              "] out of bounds for array of shape [",
                              (long long) n_203490, "].",
                              "-> #0  loess.fut:485:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:480:3-488:25\n   #4  loess.fut:504:16-51\n   #5  stl.fut:150:13-60\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:148:5-151:26\n   #9  stl.fut:415:61-429:75\n   #10 stl.fut:455:3-469:34\n   #11 stl.fut:439:1-469:34\n");
                if (memblock_unref(ctx, &mem_out_213364, "mem_out_213364") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_213363, "mem_out_213363") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_213362, "mem_out_213362") != 0)
                    return 1;
                err = 1;
                goto cleanup;
            }
            
            int64_t x_203978;
            
            x_203978 = ((int64_t *) mem_208392)[i_206983 * n_203490 + r_203973];
            
            int64_t abs_arg_203979 = sub64(x_203978, min_res_203906);
            int64_t abs_res_203980 = abs64(abs_arg_203979);
            bool x_203981 = sle64((int64_t) 0, max_res_203971);
            bool y_203982 = slt64(max_res_203971, n_203490);
            bool bounds_check_203983 = x_203981 && y_203982;
            bool index_certs_203984;
            
            if (!bounds_check_203983) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) max_res_203971,
                              "] out of bounds for array of shape [",
                              (long long) n_203490, "].",
                              "-> #0  loess.fut:484:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:480:3-488:25\n   #4  loess.fut:504:16-51\n   #5  stl.fut:150:13-60\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:148:5-151:26\n   #9  stl.fut:415:61-429:75\n   #10 stl.fut:455:3-469:34\n   #11 stl.fut:439:1-469:34\n");
                if (memblock_unref(ctx, &mem_out_213364, "mem_out_213364") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_213363, "mem_out_213363") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_213362, "mem_out_213362") != 0)
                    return 1;
                err = 1;
                goto cleanup;
            }
            
            int64_t x_203985;
            
            x_203985 = ((int64_t *) mem_208392)[i_206983 * n_203490 +
                                                max_res_203971];
            
            int64_t abs_arg_203986 = sub64(x_203985, min_res_203906);
            int64_t abs_res_203987 = abs64(abs_arg_203986);
            int64_t max_res_203988 = smax64(abs_res_203980, abs_res_203987);
            double defunc_0_f_res_203989 = sitofp_i64_f64(max_res_203988);
            double defunc_1_f_res_203990 = max_res_203901 +
                   defunc_0_f_res_203989;
            
            ((double *) mem_208912)[i_206983 * l_n_m_203643 + i_206976] =
                defunc_1_f_res_203990;
            ((int64_t *) mem_208908)[i_206983 * l_n_m_203643 + i_206976] =
                max_res_203971;
        }
    }
    
    int64_t min_res_203993 = smin64(n_203490, q_t_203494);
    bool bounds_invalid_upwards_203994 = slt64(t_n_m_203650, (int64_t) 0);
    bool valid_203995 = !bounds_invalid_upwards_203994;
    bool range_valid_c_203996;
    
    if (!valid_203995) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) t_n_m_203650, " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  loess.fut:443:3-470:10\n   #4  loess.fut:503:15-61\n   #5  stl.fut:157:13-60\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:155:5-158:26\n   #9  stl.fut:415:61-429:75\n   #10 stl.fut:455:3-469:34\n   #11 stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_out_213364, "mem_out_213364") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213363, "mem_out_213363") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213362, "mem_out_213362") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool loop_cond_203998 = slt64((int64_t) 1, min_res_203993);
    double i64_res_203999 = sitofp_i64_f64(q_t_203494);
    int64_t binop_x_209008 = partition_sizze_203577 * t_n_m_203650;
    int64_t binop_y_209009 = (int64_t) 8 * binop_x_209008;
    int64_t bytes_209010 = smax64((int64_t) 0, binop_y_209009);
    
    if (mem_209011_cached_sizze_213748 < (size_t) bytes_209010) {
        mem_209011 = realloc(mem_209011, bytes_209010);
        mem_209011_cached_sizze_213748 = bytes_209010;
    }
    if (mem_209015_cached_sizze_213749 < (size_t) bytes_209010) {
        mem_209015 = realloc(mem_209015, bytes_209010);
        mem_209015_cached_sizze_213749 = bytes_209010;
    }
    
    int64_t binop_y_209036 = (int64_t) 8 * n_203490;
    int64_t bytes_209037 = smax64((int64_t) 0, binop_y_209036);
    
    if (mem_209038_cached_sizze_213750 < (size_t) bytes_209037) {
        mem_209038 = realloc(mem_209038, bytes_209037);
        mem_209038_cached_sizze_213750 = bytes_209037;
    }
    for (int64_t i_207001 = 0; i_207001 < partition_sizze_203577; i_207001++) {
        int64_t x_204003;
        
        x_204003 = ((int64_t *) mem_208395)[i_207001];
        for (int64_t i_206988 = 0; i_206988 < n_203490; i_206988++) {
            int64_t x_204005;
            
            x_204005 = ((int64_t *) mem_208392)[i_207001 * n_203490 + i_206988];
            
            int64_t defunc_0_f_res_204006 = add64((int64_t) 1, x_204005);
            
            ((int64_t *) mem_209038)[i_206988] = defunc_0_f_res_204006;
        }
        
        int64_t min_arg_204007 = sub64(x_204003, (int64_t) 1);
        int64_t min_arg_204008 = sub64(x_204003, min_res_203993);
        int64_t min_res_204009 = smin64(q_t_203494, x_204003);
        double i64_res_204010 = sitofp_i64_f64(x_204003);
        double x_204011 = i64_res_203999 - i64_res_204010;
        double max_arg_204012 = x_204011 / 2.0;
        double max_res_204013 = fmax64(0.0, max_arg_204012);
        
        for (int64_t i_206994 = 0; i_206994 < t_n_m_203650; i_206994++) {
            int64_t min_arg_204017 = mul64(jump_t_203500, i_206994);
            int64_t min_res_204018 = smin64(i_203670, min_arg_204017);
            int64_t defunc_0_g_res_204019 = add64((int64_t) 1, min_res_204018);
            bool init_idx_204020;
            int64_t init_idx_204021;
            int64_t init_idx_204022;
            bool loop_while_204023;
            int64_t low_204024;
            int64_t high_204025;
            
            loop_while_204023 = x_203671;
            low_204024 = (int64_t) 0;
            high_204025 = i_203670;
            while (loop_while_204023) {
                int64_t x_204026 = add64(low_204024, high_204025);
                int64_t mid_204027 = sdiv64(x_204026, (int64_t) 2);
                bool x_204028 = sle64((int64_t) 0, mid_204027);
                bool y_204029 = slt64(mid_204027, n_203490);
                bool bounds_check_204030 = x_204028 && y_204029;
                bool index_certs_204031;
                
                if (!bounds_check_204030) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) mid_204027,
                                  "] out of bounds for array of shape [",
                                  (long long) n_203490, "].",
                                  "-> #0  loess.fut:450:26-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:443:3-470:10\n   #5  loess.fut:503:15-61\n   #6  stl.fut:157:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:155:5-158:26\n   #10 stl.fut:415:61-429:75\n   #11 stl.fut:455:3-469:34\n   #12 stl.fut:439:1-469:34\n");
                    if (memblock_unref(ctx, &mem_out_213364,
                                       "mem_out_213364") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213363,
                                       "mem_out_213363") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213362,
                                       "mem_out_213362") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                int64_t mid_id_204032;
                
                mid_id_204032 = ((int64_t *) mem_209038)[mid_204027];
                
                bool cond_204033 = slt64(mid_id_204032, (int64_t) 0);
                int64_t mid_idx_204034;
                
                if (cond_204033) {
                    mid_idx_204034 = (int64_t) 9223372036854775807;
                } else {
                    mid_idx_204034 = mid_id_204032;
                }
                
                bool cond_204035 = sle64(defunc_0_g_res_204019, mid_idx_204034);
                int64_t loopres_204036;
                int64_t loopres_204037;
                
                if (cond_204035) {
                    int64_t loopres_t_res_204038 = sub64(mid_204027,
                                                         (int64_t) 1);
                    
                    loopres_204036 = low_204024;
                    loopres_204037 = loopres_t_res_204038;
                } else {
                    int64_t loopres_f_res_204039 = add64((int64_t) 1,
                                                         mid_204027);
                    
                    loopres_204036 = loopres_f_res_204039;
                    loopres_204037 = high_204025;
                }
                
                bool loop_cond_204040 = sle64(loopres_204036, loopres_204037);
                bool loop_while_tmp_213420 = loop_cond_204040;
                int64_t low_tmp_213421 = loopres_204036;
                int64_t high_tmp_213422 = loopres_204037;
                
                loop_while_204023 = loop_while_tmp_213420;
                low_204024 = low_tmp_213421;
                high_204025 = high_tmp_213422;
            }
            init_idx_204020 = loop_while_204023;
            init_idx_204021 = low_204024;
            init_idx_204022 = high_204025;
            
            bool idx_204041;
            int64_t idx_204042;
            int64_t idx_204043;
            int64_t idx_204044;
            bool loop_while_204045;
            int64_t l_idx_204046;
            int64_t r_idx_204047;
            int64_t span_204048;
            
            loop_while_204045 = loop_cond_203998;
            l_idx_204046 = init_idx_204021;
            r_idx_204047 = init_idx_204021;
            span_204048 = (int64_t) 1;
            while (loop_while_204045) {
                int64_t max_arg_204049 = sub64(l_idx_204046, (int64_t) 1);
                int64_t max_res_204050 = smax64((int64_t) 0, max_arg_204049);
                int64_t min_arg_204051 = add64((int64_t) 1, r_idx_204047);
                int64_t min_res_204052 = smin64(min_arg_204007, min_arg_204051);
                bool x_204053 = sle64((int64_t) 0, max_res_204050);
                bool y_204054 = slt64(max_res_204050, n_203490);
                bool bounds_check_204055 = x_204053 && y_204054;
                bool index_certs_204056;
                
                if (!bounds_check_204055) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) max_res_204050,
                                  "] out of bounds for array of shape [",
                                  (long long) n_203490, "].",
                                  "-> #0  loess.fut:460:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:443:3-470:10\n   #5  loess.fut:503:15-61\n   #6  stl.fut:157:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:155:5-158:26\n   #10 stl.fut:415:61-429:75\n   #11 stl.fut:455:3-469:34\n   #12 stl.fut:439:1-469:34\n");
                    if (memblock_unref(ctx, &mem_out_213364,
                                       "mem_out_213364") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213363,
                                       "mem_out_213363") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213362,
                                       "mem_out_213362") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                int64_t x_204057;
                
                x_204057 = ((int64_t *) mem_209038)[max_res_204050];
                
                int64_t abs_arg_204058 = sub64(x_204057, defunc_0_g_res_204019);
                int64_t abs_res_204059 = abs64(abs_arg_204058);
                bool x_204060 = sle64((int64_t) 0, min_res_204052);
                bool y_204061 = slt64(min_res_204052, n_203490);
                bool bounds_check_204062 = x_204060 && y_204061;
                bool index_certs_204063;
                
                if (!bounds_check_204062) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) min_res_204052,
                                  "] out of bounds for array of shape [",
                                  (long long) n_203490, "].",
                                  "-> #0  loess.fut:461:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:443:3-470:10\n   #5  loess.fut:503:15-61\n   #6  stl.fut:157:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:155:5-158:26\n   #10 stl.fut:415:61-429:75\n   #11 stl.fut:455:3-469:34\n   #12 stl.fut:439:1-469:34\n");
                    if (memblock_unref(ctx, &mem_out_213364,
                                       "mem_out_213364") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213363,
                                       "mem_out_213363") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213362,
                                       "mem_out_213362") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                int64_t x_204064;
                
                x_204064 = ((int64_t *) mem_209038)[min_res_204052];
                
                int64_t abs_arg_204065 = sub64(x_204064, defunc_0_g_res_204019);
                int64_t abs_res_204066 = abs64(abs_arg_204065);
                bool cond_204067 = max_res_204050 == l_idx_204046;
                int64_t loopres_204068;
                int64_t loopres_204069;
                int64_t loopres_204070;
                
                if (cond_204067) {
                    loopres_204068 = l_idx_204046;
                    loopres_204069 = r_idx_204047;
                    loopres_204070 = min_res_203993;
                } else {
                    bool cond_204071 = slt64(abs_res_204059, abs_res_204066);
                    bool cond_f_res_204072 = min_res_204052 == r_idx_204047;
                    bool x_204073 = !cond_204071;
                    bool y_204074 = cond_f_res_204072 && x_204073;
                    bool cond_204075 = cond_204071 || y_204074;
                    int64_t loopres_f_res_204076;
                    
                    if (cond_204075) {
                        loopres_f_res_204076 = max_res_204050;
                    } else {
                        loopres_f_res_204076 = l_idx_204046;
                    }
                    
                    int64_t loopres_f_res_204077;
                    
                    if (cond_204075) {
                        loopres_f_res_204077 = r_idx_204047;
                    } else {
                        loopres_f_res_204077 = min_res_204052;
                    }
                    
                    int64_t loopres_f_res_204078;
                    
                    if (cond_204075) {
                        int64_t loopres_f_res_t_res_204079 = add64((int64_t) 1,
                                                                   span_204048);
                        
                        loopres_f_res_204078 = loopres_f_res_t_res_204079;
                    } else {
                        int64_t loopres_f_res_f_res_204080 = add64((int64_t) 1,
                                                                   span_204048);
                        
                        loopres_f_res_204078 = loopres_f_res_f_res_204080;
                    }
                    loopres_204068 = loopres_f_res_204076;
                    loopres_204069 = loopres_f_res_204077;
                    loopres_204070 = loopres_f_res_204078;
                }
                
                bool loop_cond_204081 = slt64(loopres_204070, min_res_203993);
                bool loop_while_tmp_213423 = loop_cond_204081;
                int64_t l_idx_tmp_213424 = loopres_204068;
                int64_t r_idx_tmp_213425 = loopres_204069;
                int64_t span_tmp_213426 = loopres_204070;
                
                loop_while_204045 = loop_while_tmp_213423;
                l_idx_204046 = l_idx_tmp_213424;
                r_idx_204047 = r_idx_tmp_213425;
                span_204048 = span_tmp_213426;
            }
            idx_204041 = loop_while_204045;
            idx_204042 = l_idx_204046;
            idx_204043 = r_idx_204047;
            idx_204044 = span_204048;
            
            int64_t min_res_204082 = smin64(min_arg_204008, idx_204042);
            int64_t max_res_204083 = smax64((int64_t) 0, min_res_204082);
            int64_t x_204084 = add64(min_res_204009, max_res_204083);
            int64_t r_204085 = sub64(x_204084, (int64_t) 1);
            bool x_204086 = sle64((int64_t) 0, r_204085);
            bool y_204087 = slt64(r_204085, n_203490);
            bool bounds_check_204088 = x_204086 && y_204087;
            bool index_certs_204089;
            
            if (!bounds_check_204088) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) r_204085,
                              "] out of bounds for array of shape [",
                              (long long) n_203490, "].",
                              "-> #0  loess.fut:485:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:480:3-488:25\n   #4  loess.fut:504:16-51\n   #5  stl.fut:157:13-60\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:155:5-158:26\n   #9  stl.fut:415:61-429:75\n   #10 stl.fut:455:3-469:34\n   #11 stl.fut:439:1-469:34\n");
                if (memblock_unref(ctx, &mem_out_213364, "mem_out_213364") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_213363, "mem_out_213363") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_213362, "mem_out_213362") != 0)
                    return 1;
                err = 1;
                goto cleanup;
            }
            
            int64_t x_204090;
            
            x_204090 = ((int64_t *) mem_208392)[i_207001 * n_203490 + r_204085];
            
            int64_t abs_arg_204091 = sub64(x_204090, min_res_204018);
            int64_t abs_res_204092 = abs64(abs_arg_204091);
            bool x_204093 = sle64((int64_t) 0, max_res_204083);
            bool y_204094 = slt64(max_res_204083, n_203490);
            bool bounds_check_204095 = x_204093 && y_204094;
            bool index_certs_204096;
            
            if (!bounds_check_204095) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) max_res_204083,
                              "] out of bounds for array of shape [",
                              (long long) n_203490, "].",
                              "-> #0  loess.fut:484:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:480:3-488:25\n   #4  loess.fut:504:16-51\n   #5  stl.fut:157:13-60\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:155:5-158:26\n   #9  stl.fut:415:61-429:75\n   #10 stl.fut:455:3-469:34\n   #11 stl.fut:439:1-469:34\n");
                if (memblock_unref(ctx, &mem_out_213364, "mem_out_213364") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_213363, "mem_out_213363") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_213362, "mem_out_213362") != 0)
                    return 1;
                err = 1;
                goto cleanup;
            }
            
            int64_t x_204097;
            
            x_204097 = ((int64_t *) mem_208392)[i_207001 * n_203490 +
                                                max_res_204083];
            
            int64_t abs_arg_204098 = sub64(x_204097, min_res_204018);
            int64_t abs_res_204099 = abs64(abs_arg_204098);
            int64_t max_res_204100 = smax64(abs_res_204092, abs_res_204099);
            double defunc_0_f_res_204101 = sitofp_i64_f64(max_res_204100);
            double defunc_1_f_res_204102 = max_res_204013 +
                   defunc_0_f_res_204101;
            
            ((double *) mem_209015)[i_207001 * t_n_m_203650 + i_206994] =
                defunc_1_f_res_204102;
            ((int64_t *) mem_209011)[i_207001 * t_n_m_203650 + i_206994] =
                max_res_204083;
        }
    }
    
    struct memblock mem_209114;
    
    mem_209114.references = NULL;
    if (memblock_alloc(ctx, &mem_209114, bytes_208391, "mem_209114")) {
        err = 1;
        goto cleanup;
    }
    for (int64_t i_213427 = 0; i_213427 < partition_sizze_203577; i_213427++) {
        for (int64_t i_213428 = 0; i_213428 < n_203490; i_213428++) {
            ((double *) mem_209114.mem)[i_213427 * n_203490 + i_213428] = 0.0;
        }
    }
    
    struct memblock mem_209118;
    
    mem_209118.references = NULL;
    if (memblock_alloc(ctx, &mem_209118, bytes_208391, "mem_209118")) {
        err = 1;
        goto cleanup;
    }
    for (int64_t i_213429 = 0; i_213429 < partition_sizze_203577; i_213429++) {
        for (int64_t i_213430 = 0; i_213430 < n_203490; i_213430++) {
            ((double *) mem_209118.mem)[i_213429 * n_203490 + i_213430] = 1.0;
        }
    }
    
    bool cond_204107 = slt64((int64_t) 1, jump_l_203501);
    bool cond_204108 = slt64((int64_t) 1, jump_t_203500);
    int64_t y_204109 = sub64(n_outer_203503, (int64_t) 1);
    int64_t css_results_l_204110;
    
    if (cond_203635) {
        css_results_l_204110 = s_n_m_203636;
    } else {
        css_results_l_204110 = pad_css_len_203632;
    }
    
    bool zzero_204111 = n_p_203492 == (int64_t) 0;
    bool nonzzero_204112 = !zzero_204111;
    bool loop_not_taken_204113 = !assert_cond_203626;
    bool protect_assert_disj_204114 = nonzzero_204112 || loop_not_taken_204113;
    bool loop_not_taken_204115 = !assert_cond_203628;
    bool protect_assert_disj_204116 = protect_assert_disj_204114 ||
         loop_not_taken_204115;
    bool nonzzero_cert_204117;
    
    if (!protect_assert_disj_204116) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "division by zero",
                               "-> #0  stl.fut:226:51-57\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:226:28-74\n   #5  stl.fut:225:21-227:39\n   #6  stl.fut:415:61-429:75\n   #7  stl.fut:455:3-469:34\n   #8  stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_209118, "mem_209118") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_209114, "mem_209114") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213364, "mem_out_213364") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213363, "mem_out_213363") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213362, "mem_out_213362") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    int64_t j_204118 = add64(n_203490, n_p_203492);
    bool empty_slice_204119 = n_203490 == (int64_t) 0;
    int64_t i_p_m_t_s_204120 = add64(n_p_203492, i_203670);
    bool zzero_leq_i_p_m_t_s_204121 = sle64((int64_t) 0, i_p_m_t_s_204120);
    bool i_p_m_t_s_leq_w_204122 = slt64(i_p_m_t_s_204120, C_len_203634);
    bool zzero_lte_i_204123 = sle64((int64_t) 0, n_p_203492);
    bool i_lte_j_204124 = sle64(n_p_203492, j_204118);
    bool y_204125 = i_p_m_t_s_leq_w_204122 && zzero_lte_i_204123;
    bool y_204126 = zzero_leq_i_p_m_t_s_204121 && y_204125;
    bool y_204127 = i_lte_j_204124 && y_204126;
    bool forwards_ok_204128 = zzero_lte_i_204123 && y_204127;
    bool ok_or_empty_204129 = empty_slice_204119 || forwards_ok_204128;
    bool protect_assert_disj_204130 = loop_not_taken_204113 ||
         ok_or_empty_204129;
    bool protect_assert_disj_204131 = loop_not_taken_204115 ||
         protect_assert_disj_204130;
    bool index_certs_204132;
    
    if (!protect_assert_disj_204131) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Index [", (long long) n_p_203492, ":",
                               (long long) j_204118,
                               "] out of bounds for array of shape [",
                               (long long) C_len_203634, "].",
                               "-> #0  stl.fut:262:35-50\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  stl.fut:260:13-265:26\n   #4  stl.fut:415:61-429:75\n   #5  stl.fut:455:3-469:34\n   #6  stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_209118, "mem_209118") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_209114, "mem_209114") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213364, "mem_out_213364") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213363, "mem_out_213363") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213362, "mem_out_213362") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    int64_t j_m_i_204133 = sub64(stl_res_203665, stl_res_203664);
    int64_t lifted_single_ma_l_arg_204134 = add64((int64_t) 1, j_204118);
    int64_t m_204135 = sub64(n_p_203492, (int64_t) 1);
    bool zzero_leq_i_p_m_t_s_204136 = sle64((int64_t) 0, m_204135);
    bool i_p_m_t_s_leq_w_204137 = slt64(m_204135, C_len_203634);
    bool y_204138 = zzero_leq_i_p_m_t_s_204136 && i_p_m_t_s_leq_w_204137;
    bool y_204139 = zzero_lte_i_204123 && y_204138;
    bool ok_or_empty_204140 = zzero_204111 || y_204139;
    bool protect_assert_disj_204141 = loop_not_taken_204113 ||
         ok_or_empty_204140;
    bool protect_assert_disj_204142 = loop_not_taken_204115 ||
         protect_assert_disj_204141;
    bool index_certs_204143;
    
    if (!protect_assert_disj_204142) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Index [:", (long long) n_p_203492,
                               "] out of bounds for array of shape [",
                               (long long) C_len_203634, "].",
                               "-> #0  stl.fut:24:37-43\n   #1  stl.fut:24:20-48\n   #2  stl.fut:38:3-36\n   #3  stl.fut:231:23-47\n   #4  stl.fut:415:61-429:75\n   #5  stl.fut:455:3-469:34\n   #6  stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_209118, "mem_209118") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_209114, "mem_209114") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213364, "mem_out_213364") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213363, "mem_out_213363") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213362, "mem_out_213362") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    int64_t dyn_lifted_single_ma_l_arg_204144 = add64((int64_t) 2, n_203490);
    bool i_p_m_t_s_leq_w_204145 = slt64(m_204135,
                                        lifted_single_ma_l_arg_204134);
    bool y_204146 = zzero_leq_i_p_m_t_s_204136 && i_p_m_t_s_leq_w_204145;
    bool y_204147 = zzero_lte_i_204123 && y_204146;
    bool ok_or_empty_204148 = zzero_204111 || y_204147;
    bool protect_assert_disj_204149 = loop_not_taken_204113 ||
         ok_or_empty_204148;
    bool protect_assert_disj_204150 = loop_not_taken_204115 ||
         protect_assert_disj_204149;
    bool index_certs_204151;
    
    if (!protect_assert_disj_204150) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Index [:", (long long) n_p_203492,
                               "] out of bounds for array of shape [",
                               (long long) lifted_single_ma_l_arg_204134, "].",
                               "-> #0  stl.fut:24:37-43\n   #1  stl.fut:24:20-48\n   #2  /prelude/functional.fut:9:42-44\n   #3  stl.fut:38:3-64\n   #4  stl.fut:231:23-47\n   #5  stl.fut:415:61-429:75\n   #6  stl.fut:455:3-469:34\n   #7  stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_209118, "mem_209118") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_209114, "mem_209114") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213364, "mem_out_213364") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213363, "mem_out_213363") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213362, "mem_out_213362") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool i_p_m_t_s_leq_w_204152 = slt64((int64_t) 2,
                                        dyn_lifted_single_ma_l_arg_204144);
    bool protect_assert_disj_204153 = loop_not_taken_204113 ||
         i_p_m_t_s_leq_w_204152;
    bool protect_assert_disj_204154 = loop_not_taken_204115 ||
         protect_assert_disj_204153;
    bool index_certs_204155;
    
    if (!protect_assert_disj_204154) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Index [:", (long long) (int64_t) 3,
                               "] out of bounds for array of shape [",
                               (long long) dyn_lifted_single_ma_l_arg_204144,
                               "].",
                               "-> #0  stl.fut:24:37-43\n   #1  stl.fut:24:20-48\n   #2  /prelude/functional.fut:9:42-44\n   #3  stl.fut:38:3-84\n   #4  stl.fut:231:23-47\n   #5  stl.fut:415:61-429:75\n   #6  stl.fut:455:3-469:34\n   #7  stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_209118, "mem_209118") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_209114, "mem_209114") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213364, "mem_out_213364") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213363, "mem_out_213363") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213362, "mem_out_213362") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool cond_204156 = slt64(jump_l_203501, jump_threshold_203504);
    bool cond_f_res_204157 = slt64(q_threshold_203505, q_l_203495);
    bool x_204158 = !cond_204156;
    bool y_204159 = cond_f_res_204157 && x_204158;
    bool cond_204160 = cond_204156 || y_204159;
    bool cond_204161 = slt64(jump_t_203500, jump_threshold_203504);
    bool cond_f_res_204162 = slt64(q_threshold_203505, q_t_203494);
    bool x_204163 = !cond_204161;
    bool y_204164 = cond_f_res_204162 && x_204163;
    bool cond_204165 = cond_204161 || y_204164;
    bool cond_204166 = slt64(jump_s_203499, jump_threshold_203504);
    bool cond_f_res_204167 = slt64(q_threshold_203505, q_s_203493);
    bool x_204168 = !cond_204166;
    bool y_204169 = cond_f_res_204167 && x_204168;
    bool cond_204170 = cond_204166 || y_204169;
    bool bounds_invalid_upwards_204171 = slt64(C_len_203634, (int64_t) 0);
    bool valid_204172 = !bounds_invalid_upwards_204171;
    bool protect_assert_disj_204173 = loop_not_taken_204113 || valid_204172;
    bool protect_assert_disj_204174 = loop_not_taken_204115 ||
         protect_assert_disj_204173;
    bool range_valid_c_204175;
    
    if (!protect_assert_disj_204174) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) C_len_203634, " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  stl.fut:226:28-74\n   #4  stl.fut:225:21-227:39\n   #5  stl.fut:415:61-429:75\n   #6  stl.fut:455:3-469:34\n   #7  stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_209118, "mem_209118") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_209114, "mem_209114") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213364, "mem_out_213364") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213363, "mem_out_213363") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213362, "mem_out_213362") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool bounds_invalid_upwards_204177 = slt64(lifted_single_ma_l_arg_204134,
                                               (int64_t) 0);
    bool valid_204178 = !bounds_invalid_upwards_204177;
    bool protect_assert_disj_204179 = loop_not_taken_204113 || valid_204178;
    bool protect_assert_disj_204180 = loop_not_taken_204115 ||
         protect_assert_disj_204179;
    bool range_valid_c_204181;
    
    if (!protect_assert_disj_204180) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) lifted_single_ma_l_arg_204134,
                               " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  stl.fut:27:13-33:19\n   #4  /prelude/soacs.fut:67:19-23\n   #5  /prelude/soacs.fut:67:3-37\n   #6  stl.fut:26:5-34:23\n   #7  stl.fut:38:3-36\n   #8  stl.fut:231:23-47\n   #9  stl.fut:415:61-429:75\n   #10 stl.fut:455:3-469:34\n   #11 stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_209118, "mem_209118") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_209114, "mem_209114") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213364, "mem_out_213364") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213363, "mem_out_213363") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213362, "mem_out_213362") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool bounds_invalid_upwards_204183 =
         slt64(dyn_lifted_single_ma_l_arg_204144, (int64_t) 0);
    bool valid_204184 = !bounds_invalid_upwards_204183;
    bool protect_assert_disj_204185 = loop_not_taken_204113 || valid_204184;
    bool protect_assert_disj_204186 = loop_not_taken_204115 ||
         protect_assert_disj_204185;
    bool range_valid_c_204187;
    
    if (!protect_assert_disj_204186) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) dyn_lifted_single_ma_l_arg_204144,
                               " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  stl.fut:27:13-33:19\n   #4  /prelude/soacs.fut:67:19-23\n   #5  /prelude/soacs.fut:67:3-37\n   #6  stl.fut:26:5-34:23\n   #7  /prelude/functional.fut:9:42-44\n   #8  stl.fut:38:3-64\n   #9  stl.fut:231:23-47\n   #10 stl.fut:415:61-429:75\n   #11 stl.fut:455:3-469:34\n   #12 stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_209118, "mem_209118") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_209114, "mem_209114") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213364, "mem_out_213364") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213363, "mem_out_213363") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213362, "mem_out_213362") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    if (mem_209168_cached_sizze_213751 < (size_t) bytes_208391) {
        mem_209168 = realloc(mem_209168, bytes_208391);
        mem_209168_cached_sizze_213751 = bytes_208391;
    }
    if (mem_209213_cached_sizze_213752 < (size_t) bytes_208466) {
        mem_209213 = realloc(mem_209213, bytes_208466);
        mem_209213_cached_sizze_213752 = bytes_208466;
    }
    if (mem_209218_cached_sizze_213753 < (size_t) bytes_208466) {
        mem_209218 = realloc(mem_209218, bytes_208466);
        mem_209218_cached_sizze_213753 = bytes_208466;
    }
    
    int64_t binop_x_210541 = pad_css_len_203632 * binop_x_208463;
    int64_t binop_y_210542 = (int64_t) 8 * binop_x_210541;
    int64_t bytes_210543 = smax64((int64_t) 0, binop_y_210542);
    int64_t binop_x_210640 = partition_sizze_203577 * C_len_203634;
    int64_t binop_y_210641 = (int64_t) 8 * binop_x_210640;
    int64_t bytes_210642 = smax64((int64_t) 0, binop_y_210641);
    
    if (mem_210643_cached_sizze_213761 < (size_t) bytes_210642) {
        mem_210643 = realloc(mem_210643, bytes_210642);
        mem_210643_cached_sizze_213761 = bytes_210642;
    }
    if (mem_210686_cached_sizze_213762 < (size_t) bytes_208394) {
        mem_210686 = realloc(mem_210686, bytes_208394);
        mem_210686_cached_sizze_213762 = bytes_208394;
    }
    
    int64_t binop_x_210699 = partition_sizze_203577 *
            lifted_single_ma_l_arg_204134;
    int64_t binop_y_210700 = (int64_t) 8 * binop_x_210699;
    int64_t bytes_210701 = smax64((int64_t) 0, binop_y_210700);
    
    if (mem_210702_cached_sizze_213763 < (size_t) bytes_210701) {
        mem_210702 = realloc(mem_210702, bytes_210701);
        mem_210702_cached_sizze_213763 = bytes_210701;
    }
    
    int64_t binop_y_210713 = (int64_t) 8 * lifted_single_ma_l_arg_204134;
    int64_t bytes_210714 = smax64((int64_t) 0, binop_y_210713);
    
    if (mem_210715_cached_sizze_213764 < (size_t) bytes_210714) {
        mem_210715 = realloc(mem_210715, bytes_210714);
        mem_210715_cached_sizze_213764 = bytes_210714;
    }
    if (mem_210738_cached_sizze_213765 < (size_t) bytes_208394) {
        mem_210738 = realloc(mem_210738, bytes_208394);
        mem_210738_cached_sizze_213765 = bytes_208394;
    }
    
    int64_t binop_x_210751 = partition_sizze_203577 *
            dyn_lifted_single_ma_l_arg_204144;
    int64_t binop_y_210752 = (int64_t) 8 * binop_x_210751;
    int64_t bytes_210753 = smax64((int64_t) 0, binop_y_210752);
    
    if (mem_210754_cached_sizze_213766 < (size_t) bytes_210753) {
        mem_210754 = realloc(mem_210754, bytes_210753);
        mem_210754_cached_sizze_213766 = bytes_210753;
    }
    
    int64_t binop_y_210765 = (int64_t) 8 * dyn_lifted_single_ma_l_arg_204144;
    int64_t bytes_210766 = smax64((int64_t) 0, binop_y_210765);
    
    if (mem_210767_cached_sizze_213767 < (size_t) bytes_210766) {
        mem_210767 = realloc(mem_210767, bytes_210766);
        mem_210767_cached_sizze_213767 = bytes_210766;
    }
    if (mem_210790_cached_sizze_213768 < (size_t) bytes_208394) {
        mem_210790 = realloc(mem_210790, bytes_208394);
        mem_210790_cached_sizze_213768 = bytes_208394;
    }
    if (mem_210806_cached_sizze_213769 < (size_t) bytes_208391) {
        mem_210806 = realloc(mem_210806, bytes_208391);
        mem_210806_cached_sizze_213769 = bytes_208391;
    }
    
    int64_t binop_y_210817 = (int64_t) 8 * n_203490;
    int64_t bytes_210818 = smax64((int64_t) 0, binop_y_210817);
    
    if (mem_210819_cached_sizze_213770 < (size_t) bytes_210818) {
        mem_210819 = realloc(mem_210819, bytes_210818);
        mem_210819_cached_sizze_213770 = bytes_210818;
    }
    
    int32_t iters_206665;
    
    if (empty_slice_204119) {
        iters_206665 = 0;
    } else {
        iters_206665 = 32;
    }
    
    int64_t binop_y_212650 = (int64_t) 8 * n_203490;
    int64_t bytes_212651 = smax64((int64_t) 0, binop_y_212650);
    int64_t binop_y_212662 = (int64_t) 4 * n_203490;
    int64_t bytes_212663 = smax64((int64_t) 0, binop_y_212662);
    int64_t ext_211521;
    
    if (cond_204107) {
        ext_211521 = n_203490;
    } else {
        ext_211521 = l_n_m_203643;
    }
    
    int64_t ext_211520;
    
    if (cond_204107) {
        ext_211520 = n_203490;
    } else {
        ext_211520 = l_n_m_203643;
    }
    
    int64_t ext_212520;
    
    if (cond_204108) {
        ext_212520 = n_203490;
    } else {
        ext_212520 = t_n_m_203650;
    }
    
    int64_t ext_212519;
    
    if (cond_204108) {
        ext_212519 = n_203490;
    } else {
        ext_212519 = t_n_m_203650;
    }
    
    int64_t ext_210637;
    
    if (cond_203635) {
        ext_210637 = s_n_m_203636;
    } else {
        ext_210637 = pad_css_len_203632;
    }
    
    int64_t ext_210635;
    
    if (cond_203635) {
        ext_210635 = s_n_m_203636;
    } else {
        ext_210635 = pad_css_len_203632;
    }
    
    int64_t ext_212868;
    int64_t ext_212866;
    int64_t ext_212862;
    int64_t ext_212861;
    int64_t ext_212860;
    int64_t ext_212859;
    int64_t ext_212858;
    int64_t ext_212857;
    int64_t ext_212856;
    struct memblock ext_mem_212855;
    
    ext_mem_212855.references = NULL;
    
    struct memblock ext_mem_212854;
    
    ext_mem_212854.references = NULL;
    
    struct memblock ext_mem_212853;
    
    ext_mem_212853.references = NULL;
    
    struct memblock mem_param_209126;
    
    mem_param_209126.references = NULL;
    
    int64_t ctx_param_ext_209128;
    int64_t ctx_param_ext_209130;
    struct memblock mem_param_209134;
    
    mem_param_209134.references = NULL;
    
    int64_t ctx_param_ext_209135;
    int64_t ctx_param_ext_209136;
    int64_t ctx_param_ext_209137;
    int64_t ctx_param_ext_209138;
    int64_t ctx_param_ext_209139;
    int64_t ctx_param_ext_209140;
    int64_t ctx_param_ext_209141;
    struct memblock mem_param_209142;
    
    mem_param_209142.references = NULL;
    ctx_param_ext_209128 = n_203490;
    ctx_param_ext_209130 = n_203490;
    ctx_param_ext_209135 = partition_sizze_203577;
    ctx_param_ext_209136 = n_203490;
    ctx_param_ext_209137 = (int64_t) 0;
    ctx_param_ext_209138 = n_203490;
    ctx_param_ext_209139 = partition_sizze_203577;
    ctx_param_ext_209140 = (int64_t) 1;
    ctx_param_ext_209141 = n_203490;
    if (memblock_set(ctx, &mem_param_209126, &mem_209114, "mem_209114") != 0)
        return 1;
    if (memblock_set(ctx, &mem_param_209134, &mem_209114, "mem_209114") != 0)
        return 1;
    if (memblock_set(ctx, &mem_param_209142, &mem_209118, "mem_209118") != 0)
        return 1;
    for (int64_t i_outer_204192 = 0; i_outer_204192 < n_outer_203503;
         i_outer_204192++) {
        int64_t ext_212531;
        int64_t ext_212529;
        struct memblock ext_mem_212525;
        
        ext_mem_212525.references = NULL;
        
        struct memblock ext_mem_212524;
        
        ext_mem_212524.references = NULL;
        
        struct memblock mem_param_209156;
        
        mem_param_209156.references = NULL;
        
        int64_t ctx_param_ext_209158;
        int64_t ctx_param_ext_209160;
        struct memblock mem_param_209164;
        
        mem_param_209164.references = NULL;
        ctx_param_ext_209158 = ctx_param_ext_209128;
        ctx_param_ext_209160 = ctx_param_ext_209130;
        if (memblock_set(ctx, &mem_param_209156, &mem_param_209126,
                         "mem_param_209126") != 0)
            return 1;
        if (memblock_set(ctx, &mem_param_209164, &mem_param_209134,
                         "mem_param_209134") != 0)
            return 1;
        for (int64_t _i_inner_204198 = 0; _i_inner_204198 < n_inner_203502;
             _i_inner_204198++) {
            for (int64_t i_207010 = 0; i_207010 < partition_sizze_203577;
                 i_207010++) {
                for (int64_t i_207006 = 0; i_207006 < n_203490; i_207006++) {
                    double x_204205;
                    
                    x_204205 = ((double *) mem_208352)[i_207010 * n_203490 +
                                                       i_207006];
                    
                    double x_204206;
                    
                    x_204206 = ((double *) mem_param_209164.mem)[i_207010 *
                                                                 ctx_param_ext_209160 +
                                                                 i_207006];
                    
                    double defunc_1_f_res_204207 = x_204205 - x_204206;
                    
                    ((double *) mem_209168)[i_207010 * n_203490 + i_207006] =
                        defunc_1_f_res_204207;
                }
            }
            for (int64_t i_207030 = 0; i_207030 < partition_sizze_203577;
                 i_207030++) {
                for (int64_t i_207023 = 0; i_207023 < n_p_203492; i_207023++) {
                    for (int64_t i_207016 = 0; i_207016 < defunc_0_f_res_203631;
                         i_207016++) {
                        int64_t x_204220;
                        
                        x_204220 = ((int64_t *) mem_208559)[i_207030 *
                                                            ctx_val_208480 +
                                                            i_207023 *
                                                            defunc_0_f_res_203631 +
                                                            i_207016];
                        
                        int64_t x_204221 = mul64(n_p_203492, x_204220);
                        int64_t idx_204222 = add64(x_204221, i_207023);
                        bool cond_204223 = slt64(i_203670, idx_204222);
                        bool cond_f_res_204224 = slt64(x_204220, (int64_t) 0);
                        bool x_204225 = !cond_204223;
                        bool y_204226 = cond_f_res_204224 && x_204225;
                        bool cond_204227 = cond_204223 || y_204226;
                        double defunc_0_f_res_204228;
                        double defunc_0_f_res_204229;
                        
                        if (cond_204227) {
                            defunc_0_f_res_204228 = 0.0;
                            defunc_0_f_res_204229 = 0.0;
                        } else {
                            bool x_204230 = sle64((int64_t) 0, idx_204222);
                            bool y_204231 = slt64(idx_204222, n_203490);
                            bool bounds_check_204232 = x_204230 && y_204231;
                            bool index_certs_204233;
                            
                            if (!bounds_check_204232) {
                                ctx->error =
                                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                              "Index [", (long long) idx_204222,
                                              "] out of bounds for array of shape [",
                                              (long long) n_203490, "].",
                                              "-> #0  stl.fut:193:42-57\n   #1  stl.fut:188:28-194:44\n   #2  /prelude/soacs.fut:67:19-23\n   #3  /prelude/soacs.fut:67:3-37\n   #4  stl.fut:186:21-195:50\n   #5  /prelude/soacs.fut:75:22-28\n   #6  /prelude/soacs.fut:75:3-45\n   #7  stl.fut:184:13-196:57\n   #8  stl.fut:415:61-429:75\n   #9  stl.fut:455:3-469:34\n   #10 stl.fut:439:1-469:34\n");
                                if (memblock_unref(ctx, &mem_param_209164,
                                                   "mem_param_209164") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_209156,
                                                   "mem_param_209156") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_212524,
                                                   "ext_mem_212524") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_212525,
                                                   "ext_mem_212525") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_209142,
                                                   "mem_param_209142") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_209134,
                                                   "mem_param_209134") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_209126,
                                                   "mem_param_209126") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_212853,
                                                   "ext_mem_212853") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_212854,
                                                   "ext_mem_212854") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_212855,
                                                   "ext_mem_212855") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_209118,
                                                   "mem_209118") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_209114,
                                                   "mem_209114") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_213364,
                                                   "mem_out_213364") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_213363,
                                                   "mem_out_213363") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_213362,
                                                   "mem_out_213362") != 0)
                                    return 1;
                                err = 1;
                                goto cleanup;
                            }
                            
                            double defunc_0_f_res_f_res_204234;
                            
                            defunc_0_f_res_f_res_204234 =
                                ((double *) mem_209168)[i_207030 * n_203490 +
                                                        idx_204222];
                            
                            double defunc_0_f_res_f_res_204235;
                            
                            defunc_0_f_res_f_res_204235 =
                                ((double *) mem_param_209142.mem)[ctx_param_ext_209137 +
                                                                  (i_207030 *
                                                                   ctx_param_ext_209138 +
                                                                   idx_204222 *
                                                                   ctx_param_ext_209140)];
                            defunc_0_f_res_204228 = defunc_0_f_res_f_res_204234;
                            defunc_0_f_res_204229 = defunc_0_f_res_f_res_204235;
                        }
                        ((double *) mem_209213)[i_207030 * ctx_val_208480 +
                                                i_207023 *
                                                defunc_0_f_res_203631 +
                                                i_207016] =
                            defunc_0_f_res_204228;
                        ((double *) mem_209218)[i_207030 * ctx_val_208480 +
                                                i_207023 *
                                                defunc_0_f_res_203631 +
                                                i_207016] =
                            defunc_0_f_res_204229;
                    }
                }
            }
            
            struct memblock ext_mem_210529;
            
            ext_mem_210529.references = NULL;
            
            struct memblock ext_mem_210518;
            
            ext_mem_210518.references = NULL;
            if (cond_204170) {
                bool match_lit_204240 = (int64_t) 0 == d_s_203496;
                struct memblock ext_mem_209892;
                
                ext_mem_209892.references = NULL;
                
                struct memblock ext_mem_209881;
                
                ext_mem_209881.references = NULL;
                if (match_lit_204240) {
                    struct memblock mem_209397;
                    
                    mem_209397.references = NULL;
                    if (memblock_alloc(ctx, &mem_209397, bytes_208709,
                                       "mem_209397")) {
                        err = 1;
                        goto cleanup;
                    }
                    for (int64_t i_213460 = 0; i_213460 <
                         partition_sizze_203577; i_213460++) {
                        for (int64_t i_213461 = 0; i_213461 < n_p_203492;
                             i_213461++) {
                            for (int64_t i_213462 = 0; i_213462 < s_n_m_203636;
                                 i_213462++) {
                                ((double *) mem_209397.mem)[i_213460 *
                                                            (s_n_m_203636 *
                                                             n_p_203492) +
                                                            i_213461 *
                                                            s_n_m_203636 +
                                                            i_213462] = 0.0;
                            }
                        }
                    }
                    
                    struct memblock mem_209402;
                    
                    mem_209402.references = NULL;
                    if (memblock_alloc(ctx, &mem_209402, bytes_208709,
                                       "mem_209402")) {
                        err = 1;
                        goto cleanup;
                    }
                    for (int64_t i_207047 = 0; i_207047 <
                         partition_sizze_203577; i_207047++) {
                        for (int64_t i_207043 = 0; i_207043 < n_p_203492;
                             i_207043++) {
                            int64_t x_204256;
                            
                            x_204256 = ((int64_t *) mem_208563)[i_207047 *
                                                                n_p_203492 +
                                                                i_207043];
                            for (int64_t i_207039 = 0; i_207039 < s_n_m_203636;
                                 i_207039++) {
                                int64_t x_204261;
                                
                                x_204261 = ((int64_t *) mem_208710)[i_207047 *
                                                                    ctx_val_208739 +
                                                                    i_207043 *
                                                                    s_n_m_203636 +
                                                                    i_207039];
                                
                                double x_204262;
                                
                                x_204262 = ((double *) mem_208715)[i_207047 *
                                                                   ctx_val_208739 +
                                                                   i_207043 *
                                                                   s_n_m_203636 +
                                                                   i_207039];
                                
                                bool cond_204263 = i_207039 == (int64_t) 0;
                                int64_t defunc_0_m_fun_res_204264;
                                
                                if (cond_204263) {
                                    defunc_0_m_fun_res_204264 = (int64_t) 0;
                                } else {
                                    int64_t y_204265 = sub64(s_n_m_203636,
                                                             (int64_t) 1);
                                    bool cond_204266 = i_207039 == y_204265;
                                    int64_t defunc_0_m_fun_res_f_res_204267;
                                    
                                    if (cond_204266) {
                                        int64_t
                                        defunc_0_m_fun_res_f_res_t_res_204268 =
                                        sub64(pad_css_len_203632, (int64_t) 1);
                                        
                                        defunc_0_m_fun_res_f_res_204267 =
                                            defunc_0_m_fun_res_f_res_t_res_204268;
                                    } else {
                                        int64_t x_204269 = sub64(i_207039,
                                                                 (int64_t) 1);
                                        int64_t x_204270 = mul64(jump_s_203499,
                                                                 x_204269);
                                        int64_t min_arg_204271 =
                                                add64((int64_t) 1, x_204270);
                                        int64_t min_res_204272 =
                                                smin64(defunc_0_f_res_203631,
                                                       min_arg_204271);
                                        
                                        defunc_0_m_fun_res_f_res_204267 =
                                            min_res_204272;
                                    }
                                    defunc_0_m_fun_res_204264 =
                                        defunc_0_m_fun_res_f_res_204267;
                                }
                                
                                double defunc_2_reduce_res_204273;
                                double redout_207033 = 0.0;
                                
                                for (int64_t i_207034 = 0; i_207034 <
                                     q_s_203493; i_207034++) {
                                    bool cond_204278 = sle64(x_204256,
                                                             i_207034);
                                    int64_t defunc_0_f_res_204279;
                                    
                                    if (cond_204278) {
                                        defunc_0_f_res_204279 = (int64_t) 0;
                                    } else {
                                        int64_t i_204280 = add64(x_204261,
                                                                 i_207034);
                                        int64_t defunc_0_add_arg_204281;
                                        
                                        defunc_0_add_arg_204281 =
                                            ((int64_t *) mem_208559)[i_207047 *
                                                                     ctx_val_208480 +
                                                                     i_207043 *
                                                                     defunc_0_f_res_203631 +
                                                                     i_204280];
                                        
                                        int64_t defunc_1_add_res_204282 =
                                                add64((int64_t) 1,
                                                      defunc_0_add_arg_204281);
                                        
                                        defunc_0_f_res_204279 =
                                            defunc_1_add_res_204282;
                                    }
                                    
                                    double defunc_0_f_res_204283;
                                    
                                    if (cond_204278) {
                                        defunc_0_f_res_204283 = 0.0;
                                    } else {
                                        int64_t i_204284 = add64(x_204261,
                                                                 i_207034);
                                        double defunc_0_add_arg_204285;
                                        
                                        defunc_0_add_arg_204285 =
                                            ((double *) mem_209218)[i_207047 *
                                                                    ctx_val_208480 +
                                                                    i_207043 *
                                                                    defunc_0_f_res_203631 +
                                                                    i_204284];
                                        defunc_0_f_res_204283 =
                                            defunc_0_add_arg_204285;
                                    }
                                    
                                    int64_t binop_p_204286 =
                                            sub64(defunc_0_f_res_204279,
                                                  defunc_0_m_fun_res_204264);
                                    double defunc_0_f_res_204287 =
                                           sitofp_i64_f64(binop_p_204286);
                                    double abs_res_204288 =
                                           fabs(defunc_0_f_res_204287);
                                    double tmp1_204289 = abs_res_204288 /
                                           x_204262;
                                    double x_204290 = tmp1_204289 * tmp1_204289;
                                    double y_204291 = tmp1_204289 * x_204290;
                                    double tmp2_204292 = 1.0 - y_204291;
                                    double x_204293 = tmp2_204292 * tmp2_204292;
                                    double tmp3_204294 = tmp2_204292 * x_204293;
                                    double w_j_204295 = defunc_0_f_res_204283 *
                                           tmp3_204294;
                                    double defunc_1_op_res_204276 = w_j_204295 +
                                           redout_207033;
                                    double redout_tmp_213466 =
                                           defunc_1_op_res_204276;
                                    
                                    redout_207033 = redout_tmp_213466;
                                }
                                defunc_2_reduce_res_204273 = redout_207033;
                                
                                double a0_204296 = 1.0 /
                                       defunc_2_reduce_res_204273;
                                int64_t defunc_0_m_fun_res_204297;
                                
                                if (cond_204263) {
                                    defunc_0_m_fun_res_204297 = (int64_t) 0;
                                } else {
                                    int64_t y_204298 = sub64(s_n_m_203636,
                                                             (int64_t) 1);
                                    bool cond_204299 = i_207039 == y_204298;
                                    int64_t defunc_0_m_fun_res_f_res_204300;
                                    
                                    if (cond_204299) {
                                        int64_t
                                        defunc_0_m_fun_res_f_res_t_res_204301 =
                                        sub64(pad_css_len_203632, (int64_t) 1);
                                        
                                        defunc_0_m_fun_res_f_res_204300 =
                                            defunc_0_m_fun_res_f_res_t_res_204301;
                                    } else {
                                        int64_t x_204302 = sub64(i_207039,
                                                                 (int64_t) 1);
                                        int64_t x_204303 = mul64(jump_s_203499,
                                                                 x_204302);
                                        int64_t min_arg_204304 =
                                                add64((int64_t) 1, x_204303);
                                        int64_t min_res_204305 =
                                                smin64(defunc_0_f_res_203631,
                                                       min_arg_204304);
                                        
                                        defunc_0_m_fun_res_f_res_204300 =
                                            min_res_204305;
                                    }
                                    defunc_0_m_fun_res_204297 =
                                        defunc_0_m_fun_res_f_res_204300;
                                }
                                
                                double defunc_2_reduce_res_204306;
                                double redout_207035 = 0.0;
                                
                                for (int64_t i_207036 = 0; i_207036 <
                                     q_s_203493; i_207036++) {
                                    bool cond_204311 = sle64(x_204256,
                                                             i_207036);
                                    int64_t defunc_0_f_res_204312;
                                    
                                    if (cond_204311) {
                                        defunc_0_f_res_204312 = (int64_t) 0;
                                    } else {
                                        int64_t i_204313 = add64(x_204261,
                                                                 i_207036);
                                        int64_t defunc_0_add_arg_204314;
                                        
                                        defunc_0_add_arg_204314 =
                                            ((int64_t *) mem_208559)[i_207047 *
                                                                     ctx_val_208480 +
                                                                     i_207043 *
                                                                     defunc_0_f_res_203631 +
                                                                     i_204313];
                                        
                                        int64_t defunc_1_add_res_204315 =
                                                add64((int64_t) 1,
                                                      defunc_0_add_arg_204314);
                                        
                                        defunc_0_f_res_204312 =
                                            defunc_1_add_res_204315;
                                    }
                                    
                                    double defunc_0_f_res_204316;
                                    
                                    if (cond_204311) {
                                        defunc_0_f_res_204316 = 0.0;
                                    } else {
                                        int64_t i_204317 = add64(x_204261,
                                                                 i_207036);
                                        double defunc_0_add_arg_204318;
                                        
                                        defunc_0_add_arg_204318 =
                                            ((double *) mem_209218)[i_207047 *
                                                                    ctx_val_208480 +
                                                                    i_207043 *
                                                                    defunc_0_f_res_203631 +
                                                                    i_204317];
                                        defunc_0_f_res_204316 =
                                            defunc_0_add_arg_204318;
                                    }
                                    
                                    int64_t binop_p_204319 =
                                            sub64(defunc_0_f_res_204312,
                                                  defunc_0_m_fun_res_204297);
                                    double defunc_0_f_res_204320 =
                                           sitofp_i64_f64(binop_p_204319);
                                    double abs_res_204321 =
                                           fabs(defunc_0_f_res_204320);
                                    double tmp1_204322 = abs_res_204321 /
                                           x_204262;
                                    double x_204323 = tmp1_204322 * tmp1_204322;
                                    double y_204324 = tmp1_204322 * x_204323;
                                    double tmp2_204325 = 1.0 - y_204324;
                                    double x_204326 = tmp2_204325 * tmp2_204325;
                                    double tmp3_204327 = tmp2_204325 * x_204326;
                                    double tmp4_204328 = defunc_0_f_res_204316 *
                                           tmp3_204327;
                                    double defunc_0_f_res_204329;
                                    
                                    if (cond_204311) {
                                        defunc_0_f_res_204329 = 0.0;
                                    } else {
                                        int64_t i_204330 = add64(x_204261,
                                                                 i_207036);
                                        double defunc_0_add_arg_204331;
                                        
                                        defunc_0_add_arg_204331 =
                                            ((double *) mem_209213)[i_207047 *
                                                                    ctx_val_208480 +
                                                                    i_207043 *
                                                                    defunc_0_f_res_203631 +
                                                                    i_204330];
                                        defunc_0_f_res_204329 =
                                            defunc_0_add_arg_204331;
                                    }
                                    
                                    double x_204332 = a0_204296 * tmp4_204328;
                                    double defunc_9_fit_fun_res_204333 =
                                           defunc_0_f_res_204329 * x_204332;
                                    double defunc_1_op_res_204309 =
                                           defunc_9_fit_fun_res_204333 +
                                           redout_207035;
                                    double redout_tmp_213467 =
                                           defunc_1_op_res_204309;
                                    
                                    redout_207035 = redout_tmp_213467;
                                }
                                defunc_2_reduce_res_204306 = redout_207035;
                                ((double *) mem_209402.mem)[i_207047 *
                                                            ctx_val_208739 +
                                                            i_207043 *
                                                            s_n_m_203636 +
                                                            i_207039] =
                                    defunc_2_reduce_res_204306;
                            }
                        }
                    }
                    if (memblock_set(ctx, &ext_mem_209892, &mem_209402,
                                     "mem_209402") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_209881, &mem_209397,
                                     "mem_209397") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_209402, "mem_209402") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_209397, "mem_209397") != 0)
                        return 1;
                } else {
                    bool match_lit_204336 = (int64_t) 1 == d_s_203496;
                    struct memblock ext_mem_209869;
                    
                    ext_mem_209869.references = NULL;
                    
                    struct memblock ext_mem_209858;
                    
                    ext_mem_209858.references = NULL;
                    if (match_lit_204336) {
                        struct memblock mem_209494;
                        
                        mem_209494.references = NULL;
                        if (memblock_alloc(ctx, &mem_209494, bytes_208709,
                                           "mem_209494")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_209499;
                        
                        mem_209499.references = NULL;
                        if (memblock_alloc(ctx, &mem_209499, bytes_208709,
                                           "mem_209499")) {
                            err = 1;
                            goto cleanup;
                        }
                        for (int64_t i_207074 = 0; i_207074 <
                             partition_sizze_203577; i_207074++) {
                            for (int64_t i_207067 = 0; i_207067 < n_p_203492;
                                 i_207067++) {
                                int64_t x_204353;
                                
                                x_204353 = ((int64_t *) mem_208563)[i_207074 *
                                                                    n_p_203492 +
                                                                    i_207067];
                                for (int64_t i_207060 = 0; i_207060 <
                                     s_n_m_203636; i_207060++) {
                                    int64_t x_204359;
                                    
                                    x_204359 =
                                        ((int64_t *) mem_208710)[i_207074 *
                                                                 ctx_val_208739 +
                                                                 i_207067 *
                                                                 s_n_m_203636 +
                                                                 i_207060];
                                    
                                    double x_204360;
                                    
                                    x_204360 =
                                        ((double *) mem_208715)[i_207074 *
                                                                ctx_val_208739 +
                                                                i_207067 *
                                                                s_n_m_203636 +
                                                                i_207060];
                                    
                                    bool cond_204361 = i_207060 == (int64_t) 0;
                                    int64_t defunc_0_m_fun_res_204362;
                                    
                                    if (cond_204361) {
                                        defunc_0_m_fun_res_204362 = (int64_t) 0;
                                    } else {
                                        int64_t y_204363 = sub64(s_n_m_203636,
                                                                 (int64_t) 1);
                                        bool cond_204364 = i_207060 == y_204363;
                                        int64_t defunc_0_m_fun_res_f_res_204365;
                                        
                                        if (cond_204364) {
                                            int64_t
                                            defunc_0_m_fun_res_f_res_t_res_204366
                                            = sub64(pad_css_len_203632,
                                                    (int64_t) 1);
                                            
                                            defunc_0_m_fun_res_f_res_204365 =
                                                defunc_0_m_fun_res_f_res_t_res_204366;
                                        } else {
                                            int64_t x_204367 = sub64(i_207060,
                                                                     (int64_t) 1);
                                            int64_t x_204368 =
                                                    mul64(jump_s_203499,
                                                          x_204367);
                                            int64_t min_arg_204369 =
                                                    add64((int64_t) 1,
                                                          x_204368);
                                            int64_t min_res_204370 =
                                                    smin64(defunc_0_f_res_203631,
                                                           min_arg_204369);
                                            
                                            defunc_0_m_fun_res_f_res_204365 =
                                                min_res_204370;
                                        }
                                        defunc_0_m_fun_res_204362 =
                                            defunc_0_m_fun_res_f_res_204365;
                                    }
                                    
                                    double defunc_2_reduce_res_204371;
                                    double defunc_2_reduce_res_204372;
                                    double defunc_2_reduce_res_204373;
                                    double redout_207049;
                                    double redout_207050;
                                    double redout_207051;
                                    
                                    redout_207049 = 0.0;
                                    redout_207050 = 0.0;
                                    redout_207051 = 0.0;
                                    for (int64_t i_207052 = 0; i_207052 <
                                         q_s_203493; i_207052++) {
                                        bool cond_204384 = sle64(x_204353,
                                                                 i_207052);
                                        int64_t defunc_0_f_res_204385;
                                        
                                        if (cond_204384) {
                                            defunc_0_f_res_204385 = (int64_t) 0;
                                        } else {
                                            int64_t i_204386 = add64(x_204359,
                                                                     i_207052);
                                            int64_t defunc_0_add_arg_204387;
                                            
                                            defunc_0_add_arg_204387 =
                                                ((int64_t *) mem_208559)[i_207074 *
                                                                         ctx_val_208480 +
                                                                         i_207067 *
                                                                         defunc_0_f_res_203631 +
                                                                         i_204386];
                                            
                                            int64_t defunc_1_add_res_204388 =
                                                    add64((int64_t) 1,
                                                          defunc_0_add_arg_204387);
                                            
                                            defunc_0_f_res_204385 =
                                                defunc_1_add_res_204388;
                                        }
                                        
                                        double defunc_0_f_res_204389;
                                        
                                        if (cond_204384) {
                                            defunc_0_f_res_204389 = 0.0;
                                        } else {
                                            int64_t i_204390 = add64(x_204359,
                                                                     i_207052);
                                            double defunc_0_add_arg_204391;
                                            
                                            defunc_0_add_arg_204391 =
                                                ((double *) mem_209218)[i_207074 *
                                                                        ctx_val_208480 +
                                                                        i_207067 *
                                                                        defunc_0_f_res_203631 +
                                                                        i_204390];
                                            defunc_0_f_res_204389 =
                                                defunc_0_add_arg_204391;
                                        }
                                        
                                        int64_t binop_p_204392 =
                                                sub64(defunc_0_f_res_204385,
                                                      defunc_0_m_fun_res_204362);
                                        double defunc_0_f_res_204393 =
                                               sitofp_i64_f64(binop_p_204392);
                                        double abs_res_204394 =
                                               fabs(defunc_0_f_res_204393);
                                        double tmp1_204395 = abs_res_204394 /
                                               x_204360;
                                        double x_204396 = tmp1_204395 *
                                               tmp1_204395;
                                        double y_204397 = tmp1_204395 *
                                               x_204396;
                                        double tmp2_204398 = 1.0 - y_204397;
                                        double x_204399 = tmp2_204398 *
                                               tmp2_204398;
                                        double tmp3_204400 = tmp2_204398 *
                                               x_204399;
                                        double w_j_204401 =
                                               defunc_0_f_res_204389 *
                                               tmp3_204400;
                                        double xw_j_204402 =
                                               defunc_0_f_res_204393 *
                                               w_j_204401;
                                        double x2w_j_204403 =
                                               defunc_0_f_res_204393 *
                                               xw_j_204402;
                                        double defunc_1_op_res_204376 =
                                               w_j_204401 + redout_207049;
                                        double defunc_1_op_res_204379 =
                                               xw_j_204402 + redout_207050;
                                        double defunc_1_op_res_204382 =
                                               x2w_j_204403 + redout_207051;
                                        double redout_tmp_213474 =
                                               defunc_1_op_res_204376;
                                        double redout_tmp_213475 =
                                               defunc_1_op_res_204379;
                                        double redout_tmp_213476 =
                                               defunc_1_op_res_204382;
                                        
                                        redout_207049 = redout_tmp_213474;
                                        redout_207050 = redout_tmp_213475;
                                        redout_207051 = redout_tmp_213476;
                                    }
                                    defunc_2_reduce_res_204371 = redout_207049;
                                    defunc_2_reduce_res_204372 = redout_207050;
                                    defunc_2_reduce_res_204373 = redout_207051;
                                    
                                    double x_204404 =
                                           defunc_2_reduce_res_204371 *
                                           defunc_2_reduce_res_204373;
                                    double y_204405 =
                                           defunc_2_reduce_res_204372 *
                                           defunc_2_reduce_res_204372;
                                    double y_204406 = x_204404 - y_204405;
                                    double det1_204407 = 1.0 / y_204406;
                                    double a11_204408 =
                                           defunc_2_reduce_res_204373 *
                                           det1_204407;
                                    double x_204409 = 0.0 -
                                           defunc_2_reduce_res_204372;
                                    double b11_204410 = det1_204407 * x_204409;
                                    double c11_204411 =
                                           defunc_2_reduce_res_204371 *
                                           det1_204407;
                                    int64_t defunc_0_m_fun_res_204412;
                                    
                                    if (cond_204361) {
                                        defunc_0_m_fun_res_204412 = (int64_t) 0;
                                    } else {
                                        int64_t y_204413 = sub64(s_n_m_203636,
                                                                 (int64_t) 1);
                                        bool cond_204414 = i_207060 == y_204413;
                                        int64_t defunc_0_m_fun_res_f_res_204415;
                                        
                                        if (cond_204414) {
                                            int64_t
                                            defunc_0_m_fun_res_f_res_t_res_204416
                                            = sub64(pad_css_len_203632,
                                                    (int64_t) 1);
                                            
                                            defunc_0_m_fun_res_f_res_204415 =
                                                defunc_0_m_fun_res_f_res_t_res_204416;
                                        } else {
                                            int64_t x_204417 = sub64(i_207060,
                                                                     (int64_t) 1);
                                            int64_t x_204418 =
                                                    mul64(jump_s_203499,
                                                          x_204417);
                                            int64_t min_arg_204419 =
                                                    add64((int64_t) 1,
                                                          x_204418);
                                            int64_t min_res_204420 =
                                                    smin64(defunc_0_f_res_203631,
                                                           min_arg_204419);
                                            
                                            defunc_0_m_fun_res_f_res_204415 =
                                                min_res_204420;
                                        }
                                        defunc_0_m_fun_res_204412 =
                                            defunc_0_m_fun_res_f_res_204415;
                                    }
                                    
                                    double defunc_2_reduce_res_204421;
                                    double defunc_2_reduce_res_204422;
                                    double redout_207053;
                                    double redout_207054;
                                    
                                    redout_207053 = 0.0;
                                    redout_207054 = 0.0;
                                    for (int64_t i_207055 = 0; i_207055 <
                                         q_s_203493; i_207055++) {
                                        bool cond_204430 = sle64(x_204353,
                                                                 i_207055);
                                        int64_t defunc_0_f_res_204431;
                                        
                                        if (cond_204430) {
                                            defunc_0_f_res_204431 = (int64_t) 0;
                                        } else {
                                            int64_t i_204432 = add64(x_204359,
                                                                     i_207055);
                                            int64_t defunc_0_add_arg_204433;
                                            
                                            defunc_0_add_arg_204433 =
                                                ((int64_t *) mem_208559)[i_207074 *
                                                                         ctx_val_208480 +
                                                                         i_207067 *
                                                                         defunc_0_f_res_203631 +
                                                                         i_204432];
                                            
                                            int64_t defunc_1_add_res_204434 =
                                                    add64((int64_t) 1,
                                                          defunc_0_add_arg_204433);
                                            
                                            defunc_0_f_res_204431 =
                                                defunc_1_add_res_204434;
                                        }
                                        
                                        double defunc_0_f_res_204435;
                                        
                                        if (cond_204430) {
                                            defunc_0_f_res_204435 = 0.0;
                                        } else {
                                            int64_t i_204436 = add64(x_204359,
                                                                     i_207055);
                                            double defunc_0_add_arg_204437;
                                            
                                            defunc_0_add_arg_204437 =
                                                ((double *) mem_209218)[i_207074 *
                                                                        ctx_val_208480 +
                                                                        i_207067 *
                                                                        defunc_0_f_res_203631 +
                                                                        i_204436];
                                            defunc_0_f_res_204435 =
                                                defunc_0_add_arg_204437;
                                        }
                                        
                                        int64_t binop_p_204438 =
                                                sub64(defunc_0_f_res_204431,
                                                      defunc_0_m_fun_res_204412);
                                        double defunc_0_f_res_204439 =
                                               sitofp_i64_f64(binop_p_204438);
                                        double abs_res_204440 =
                                               fabs(defunc_0_f_res_204439);
                                        double tmp1_204441 = abs_res_204440 /
                                               x_204360;
                                        double x_204442 = tmp1_204441 *
                                               tmp1_204441;
                                        double y_204443 = tmp1_204441 *
                                               x_204442;
                                        double tmp2_204444 = 1.0 - y_204443;
                                        double x_204445 = tmp2_204444 *
                                               tmp2_204444;
                                        double tmp3_204446 = tmp2_204444 *
                                               x_204445;
                                        double tmp4_204447 =
                                               defunc_0_f_res_204435 *
                                               tmp3_204446;
                                        double defunc_1_f_res_204448 =
                                               defunc_0_f_res_204439 *
                                               tmp4_204447;
                                        double defunc_0_f_res_204449;
                                        
                                        if (cond_204430) {
                                            defunc_0_f_res_204449 = 0.0;
                                        } else {
                                            int64_t i_204450 = add64(x_204359,
                                                                     i_207055);
                                            double defunc_0_add_arg_204451;
                                            
                                            defunc_0_add_arg_204451 =
                                                ((double *) mem_209213)[i_207074 *
                                                                        ctx_val_208480 +
                                                                        i_207067 *
                                                                        defunc_0_f_res_203631 +
                                                                        i_204450];
                                            defunc_0_f_res_204449 =
                                                defunc_0_add_arg_204451;
                                        }
                                        
                                        double x_204452 = a11_204408 *
                                               tmp4_204447;
                                        double y_204453 = b11_204410 *
                                               defunc_1_f_res_204448;
                                        double x_204454 = x_204452 + y_204453;
                                        double defunc_9_fit_fun_res_204455 =
                                               defunc_0_f_res_204449 * x_204454;
                                        double x_204456 = b11_204410 *
                                               tmp4_204447;
                                        double y_204457 = c11_204411 *
                                               defunc_1_f_res_204448;
                                        double x_204458 = x_204456 + y_204457;
                                        double defunc_9_slope_fun_res_204459 =
                                               defunc_0_f_res_204449 * x_204458;
                                        double defunc_1_op_res_204425 =
                                               defunc_9_fit_fun_res_204455 +
                                               redout_207053;
                                        double defunc_1_op_res_204428 =
                                               defunc_9_slope_fun_res_204459 +
                                               redout_207054;
                                        double redout_tmp_213477 =
                                               defunc_1_op_res_204425;
                                        double redout_tmp_213478 =
                                               defunc_1_op_res_204428;
                                        
                                        redout_207053 = redout_tmp_213477;
                                        redout_207054 = redout_tmp_213478;
                                    }
                                    defunc_2_reduce_res_204421 = redout_207053;
                                    defunc_2_reduce_res_204422 = redout_207054;
                                    ((double *) mem_209494.mem)[i_207074 *
                                                                ctx_val_208739 +
                                                                i_207067 *
                                                                s_n_m_203636 +
                                                                i_207060] =
                                        defunc_2_reduce_res_204421;
                                    ((double *) mem_209499.mem)[i_207074 *
                                                                ctx_val_208739 +
                                                                i_207067 *
                                                                s_n_m_203636 +
                                                                i_207060] =
                                        defunc_2_reduce_res_204422;
                                }
                            }
                        }
                        if (memblock_set(ctx, &ext_mem_209869, &mem_209494,
                                         "mem_209494") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_209858, &mem_209499,
                                         "mem_209499") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_209499, "mem_209499") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_209494, "mem_209494") != 0)
                            return 1;
                    } else {
                        struct memblock mem_209678;
                        
                        mem_209678.references = NULL;
                        if (memblock_alloc(ctx, &mem_209678, bytes_208709,
                                           "mem_209678")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_209683;
                        
                        mem_209683.references = NULL;
                        if (memblock_alloc(ctx, &mem_209683, bytes_208709,
                                           "mem_209683")) {
                            err = 1;
                            goto cleanup;
                        }
                        for (int64_t i_207104 = 0; i_207104 <
                             partition_sizze_203577; i_207104++) {
                            for (int64_t i_207097 = 0; i_207097 < n_p_203492;
                                 i_207097++) {
                                int64_t x_204476;
                                
                                x_204476 = ((int64_t *) mem_208563)[i_207104 *
                                                                    n_p_203492 +
                                                                    i_207097];
                                for (int64_t i_207090 = 0; i_207090 <
                                     s_n_m_203636; i_207090++) {
                                    int64_t x_204482;
                                    
                                    x_204482 =
                                        ((int64_t *) mem_208710)[i_207104 *
                                                                 ctx_val_208739 +
                                                                 i_207097 *
                                                                 s_n_m_203636 +
                                                                 i_207090];
                                    
                                    double x_204483;
                                    
                                    x_204483 =
                                        ((double *) mem_208715)[i_207104 *
                                                                ctx_val_208739 +
                                                                i_207097 *
                                                                s_n_m_203636 +
                                                                i_207090];
                                    
                                    bool cond_204484 = i_207090 == (int64_t) 0;
                                    int64_t defunc_0_m_fun_res_204485;
                                    
                                    if (cond_204484) {
                                        defunc_0_m_fun_res_204485 = (int64_t) 0;
                                    } else {
                                        int64_t y_204486 = sub64(s_n_m_203636,
                                                                 (int64_t) 1);
                                        bool cond_204487 = i_207090 == y_204486;
                                        int64_t defunc_0_m_fun_res_f_res_204488;
                                        
                                        if (cond_204487) {
                                            int64_t
                                            defunc_0_m_fun_res_f_res_t_res_204489
                                            = sub64(pad_css_len_203632,
                                                    (int64_t) 1);
                                            
                                            defunc_0_m_fun_res_f_res_204488 =
                                                defunc_0_m_fun_res_f_res_t_res_204489;
                                        } else {
                                            int64_t x_204490 = sub64(i_207090,
                                                                     (int64_t) 1);
                                            int64_t x_204491 =
                                                    mul64(jump_s_203499,
                                                          x_204490);
                                            int64_t min_arg_204492 =
                                                    add64((int64_t) 1,
                                                          x_204491);
                                            int64_t min_res_204493 =
                                                    smin64(defunc_0_f_res_203631,
                                                           min_arg_204492);
                                            
                                            defunc_0_m_fun_res_f_res_204488 =
                                                min_res_204493;
                                        }
                                        defunc_0_m_fun_res_204485 =
                                            defunc_0_m_fun_res_f_res_204488;
                                    }
                                    
                                    double defunc_2_reduce_res_204494;
                                    double defunc_2_reduce_res_204495;
                                    double defunc_2_reduce_res_204496;
                                    double defunc_2_reduce_res_204497;
                                    double defunc_2_reduce_res_204498;
                                    double redout_207077;
                                    double redout_207078;
                                    double redout_207079;
                                    double redout_207080;
                                    double redout_207081;
                                    
                                    redout_207077 = 0.0;
                                    redout_207078 = 0.0;
                                    redout_207079 = 0.0;
                                    redout_207080 = 0.0;
                                    redout_207081 = 0.0;
                                    for (int64_t i_207082 = 0; i_207082 <
                                         q_s_203493; i_207082++) {
                                        bool cond_204515 = sle64(x_204476,
                                                                 i_207082);
                                        int64_t defunc_0_f_res_204516;
                                        
                                        if (cond_204515) {
                                            defunc_0_f_res_204516 = (int64_t) 0;
                                        } else {
                                            int64_t i_204517 = add64(x_204482,
                                                                     i_207082);
                                            int64_t defunc_0_add_arg_204518;
                                            
                                            defunc_0_add_arg_204518 =
                                                ((int64_t *) mem_208559)[i_207104 *
                                                                         ctx_val_208480 +
                                                                         i_207097 *
                                                                         defunc_0_f_res_203631 +
                                                                         i_204517];
                                            
                                            int64_t defunc_1_add_res_204519 =
                                                    add64((int64_t) 1,
                                                          defunc_0_add_arg_204518);
                                            
                                            defunc_0_f_res_204516 =
                                                defunc_1_add_res_204519;
                                        }
                                        
                                        double defunc_0_f_res_204520;
                                        
                                        if (cond_204515) {
                                            defunc_0_f_res_204520 = 0.0;
                                        } else {
                                            int64_t i_204521 = add64(x_204482,
                                                                     i_207082);
                                            double defunc_0_add_arg_204522;
                                            
                                            defunc_0_add_arg_204522 =
                                                ((double *) mem_209218)[i_207104 *
                                                                        ctx_val_208480 +
                                                                        i_207097 *
                                                                        defunc_0_f_res_203631 +
                                                                        i_204521];
                                            defunc_0_f_res_204520 =
                                                defunc_0_add_arg_204522;
                                        }
                                        
                                        int64_t binop_p_204523 =
                                                sub64(defunc_0_f_res_204516,
                                                      defunc_0_m_fun_res_204485);
                                        double defunc_0_f_res_204524 =
                                               sitofp_i64_f64(binop_p_204523);
                                        double abs_res_204525 =
                                               fabs(defunc_0_f_res_204524);
                                        double tmp1_204526 = abs_res_204525 /
                                               x_204483;
                                        double x_204527 = tmp1_204526 *
                                               tmp1_204526;
                                        double y_204528 = tmp1_204526 *
                                               x_204527;
                                        double tmp2_204529 = 1.0 - y_204528;
                                        double x_204530 = tmp2_204529 *
                                               tmp2_204529;
                                        double tmp3_204531 = tmp2_204529 *
                                               x_204530;
                                        double w_j_204532 =
                                               defunc_0_f_res_204520 *
                                               tmp3_204531;
                                        double xw_j_204533 =
                                               defunc_0_f_res_204524 *
                                               w_j_204532;
                                        double x2w_j_204534 =
                                               defunc_0_f_res_204524 *
                                               xw_j_204533;
                                        double x3w_j_204535 =
                                               defunc_0_f_res_204524 *
                                               x2w_j_204534;
                                        double x4w_j_204536 =
                                               defunc_0_f_res_204524 *
                                               x3w_j_204535;
                                        double defunc_1_op_res_204501 =
                                               w_j_204532 + redout_207077;
                                        double defunc_1_op_res_204504 =
                                               xw_j_204533 + redout_207078;
                                        double defunc_1_op_res_204507 =
                                               x2w_j_204534 + redout_207079;
                                        double defunc_1_op_res_204510 =
                                               x3w_j_204535 + redout_207080;
                                        double defunc_1_op_res_204513 =
                                               x4w_j_204536 + redout_207081;
                                        double redout_tmp_213485 =
                                               defunc_1_op_res_204501;
                                        double redout_tmp_213486 =
                                               defunc_1_op_res_204504;
                                        double redout_tmp_213487 =
                                               defunc_1_op_res_204507;
                                        double redout_tmp_213488 =
                                               defunc_1_op_res_204510;
                                        double redout_tmp_213489 =
                                               defunc_1_op_res_204513;
                                        
                                        redout_207077 = redout_tmp_213485;
                                        redout_207078 = redout_tmp_213486;
                                        redout_207079 = redout_tmp_213487;
                                        redout_207080 = redout_tmp_213488;
                                        redout_207081 = redout_tmp_213489;
                                    }
                                    defunc_2_reduce_res_204494 = redout_207077;
                                    defunc_2_reduce_res_204495 = redout_207078;
                                    defunc_2_reduce_res_204496 = redout_207079;
                                    defunc_2_reduce_res_204497 = redout_207080;
                                    defunc_2_reduce_res_204498 = redout_207081;
                                    
                                    double x_204537 =
                                           defunc_2_reduce_res_204496 *
                                           defunc_2_reduce_res_204498;
                                    double y_204538 =
                                           defunc_2_reduce_res_204497 *
                                           defunc_2_reduce_res_204497;
                                    double a12_204539 = x_204537 - y_204538;
                                    double x_204540 =
                                           defunc_2_reduce_res_204496 *
                                           defunc_2_reduce_res_204497;
                                    double y_204541 =
                                           defunc_2_reduce_res_204495 *
                                           defunc_2_reduce_res_204498;
                                    double b12_204542 = x_204540 - y_204541;
                                    double x_204543 =
                                           defunc_2_reduce_res_204495 *
                                           defunc_2_reduce_res_204497;
                                    double y_204544 =
                                           defunc_2_reduce_res_204496 *
                                           defunc_2_reduce_res_204496;
                                    double c12_204545 = x_204543 - y_204544;
                                    double x_204546 =
                                           defunc_2_reduce_res_204494 *
                                           defunc_2_reduce_res_204498;
                                    double b2_204547 = x_204546 - y_204544;
                                    double x_204548 =
                                           defunc_2_reduce_res_204495 *
                                           defunc_2_reduce_res_204496;
                                    double y_204549 =
                                           defunc_2_reduce_res_204494 *
                                           defunc_2_reduce_res_204497;
                                    double c2_204550 = x_204548 - y_204549;
                                    double x_204551 =
                                           defunc_2_reduce_res_204494 *
                                           a12_204539;
                                    double y_204552 =
                                           defunc_2_reduce_res_204495 *
                                           b12_204542;
                                    double x_204553 = x_204551 + y_204552;
                                    double y_204554 =
                                           defunc_2_reduce_res_204496 *
                                           c12_204545;
                                    double y_204555 = x_204553 + y_204554;
                                    double det_204556 = 1.0 / y_204555;
                                    double a12_204557 = a12_204539 * det_204556;
                                    double b12_204558 = b12_204542 * det_204556;
                                    double c12_204559 = c12_204545 * det_204556;
                                    double b2_204560 = b2_204547 * det_204556;
                                    double c2_204561 = c2_204550 * det_204556;
                                    int64_t defunc_0_m_fun_res_204562;
                                    
                                    if (cond_204484) {
                                        defunc_0_m_fun_res_204562 = (int64_t) 0;
                                    } else {
                                        int64_t y_204563 = sub64(s_n_m_203636,
                                                                 (int64_t) 1);
                                        bool cond_204564 = i_207090 == y_204563;
                                        int64_t defunc_0_m_fun_res_f_res_204565;
                                        
                                        if (cond_204564) {
                                            int64_t
                                            defunc_0_m_fun_res_f_res_t_res_204566
                                            = sub64(pad_css_len_203632,
                                                    (int64_t) 1);
                                            
                                            defunc_0_m_fun_res_f_res_204565 =
                                                defunc_0_m_fun_res_f_res_t_res_204566;
                                        } else {
                                            int64_t x_204567 = sub64(i_207090,
                                                                     (int64_t) 1);
                                            int64_t x_204568 =
                                                    mul64(jump_s_203499,
                                                          x_204567);
                                            int64_t min_arg_204569 =
                                                    add64((int64_t) 1,
                                                          x_204568);
                                            int64_t min_res_204570 =
                                                    smin64(defunc_0_f_res_203631,
                                                           min_arg_204569);
                                            
                                            defunc_0_m_fun_res_f_res_204565 =
                                                min_res_204570;
                                        }
                                        defunc_0_m_fun_res_204562 =
                                            defunc_0_m_fun_res_f_res_204565;
                                    }
                                    
                                    double defunc_2_reduce_res_204571;
                                    double defunc_2_reduce_res_204572;
                                    double redout_207083;
                                    double redout_207084;
                                    
                                    redout_207083 = 0.0;
                                    redout_207084 = 0.0;
                                    for (int64_t i_207085 = 0; i_207085 <
                                         q_s_203493; i_207085++) {
                                        bool cond_204580 = sle64(x_204476,
                                                                 i_207085);
                                        int64_t defunc_0_f_res_204581;
                                        
                                        if (cond_204580) {
                                            defunc_0_f_res_204581 = (int64_t) 0;
                                        } else {
                                            int64_t i_204582 = add64(x_204482,
                                                                     i_207085);
                                            int64_t defunc_0_add_arg_204583;
                                            
                                            defunc_0_add_arg_204583 =
                                                ((int64_t *) mem_208559)[i_207104 *
                                                                         ctx_val_208480 +
                                                                         i_207097 *
                                                                         defunc_0_f_res_203631 +
                                                                         i_204582];
                                            
                                            int64_t defunc_1_add_res_204584 =
                                                    add64((int64_t) 1,
                                                          defunc_0_add_arg_204583);
                                            
                                            defunc_0_f_res_204581 =
                                                defunc_1_add_res_204584;
                                        }
                                        
                                        double defunc_0_f_res_204585;
                                        
                                        if (cond_204580) {
                                            defunc_0_f_res_204585 = 0.0;
                                        } else {
                                            int64_t i_204586 = add64(x_204482,
                                                                     i_207085);
                                            double defunc_0_add_arg_204587;
                                            
                                            defunc_0_add_arg_204587 =
                                                ((double *) mem_209218)[i_207104 *
                                                                        ctx_val_208480 +
                                                                        i_207097 *
                                                                        defunc_0_f_res_203631 +
                                                                        i_204586];
                                            defunc_0_f_res_204585 =
                                                defunc_0_add_arg_204587;
                                        }
                                        
                                        int64_t binop_p_204588 =
                                                sub64(defunc_0_f_res_204581,
                                                      defunc_0_m_fun_res_204562);
                                        double defunc_0_f_res_204589 =
                                               sitofp_i64_f64(binop_p_204588);
                                        double abs_res_204590 =
                                               fabs(defunc_0_f_res_204589);
                                        double tmp1_204591 = abs_res_204590 /
                                               x_204483;
                                        double x_204592 = tmp1_204591 *
                                               tmp1_204591;
                                        double y_204593 = tmp1_204591 *
                                               x_204592;
                                        double tmp2_204594 = 1.0 - y_204593;
                                        double x_204595 = tmp2_204594 *
                                               tmp2_204594;
                                        double tmp3_204596 = tmp2_204594 *
                                               x_204595;
                                        double tmp4_204597 =
                                               defunc_0_f_res_204585 *
                                               tmp3_204596;
                                        double defunc_1_f_res_204598 =
                                               defunc_0_f_res_204589 *
                                               tmp4_204597;
                                        double defunc_1_f_res_204599 =
                                               defunc_0_f_res_204589 *
                                               defunc_1_f_res_204598;
                                        double defunc_0_f_res_204600;
                                        
                                        if (cond_204580) {
                                            defunc_0_f_res_204600 = 0.0;
                                        } else {
                                            int64_t i_204601 = add64(x_204482,
                                                                     i_207085);
                                            double defunc_0_add_arg_204602;
                                            
                                            defunc_0_add_arg_204602 =
                                                ((double *) mem_209213)[i_207104 *
                                                                        ctx_val_208480 +
                                                                        i_207097 *
                                                                        defunc_0_f_res_203631 +
                                                                        i_204601];
                                            defunc_0_f_res_204600 =
                                                defunc_0_add_arg_204602;
                                        }
                                        
                                        double x_204603 = a12_204557 *
                                               tmp4_204597;
                                        double y_204604 = b12_204558 *
                                               defunc_1_f_res_204598;
                                        double x_204605 = x_204603 + y_204604;
                                        double y_204606 = c12_204559 *
                                               defunc_1_f_res_204599;
                                        double x_204607 = x_204605 + y_204606;
                                        double defunc_9_fit_fun_res_204608 =
                                               defunc_0_f_res_204600 * x_204607;
                                        double x_204609 = b12_204558 *
                                               tmp4_204597;
                                        double y_204610 = b2_204560 *
                                               defunc_1_f_res_204598;
                                        double x_204611 = x_204609 + y_204610;
                                        double y_204612 = c2_204561 *
                                               defunc_1_f_res_204599;
                                        double x_204613 = x_204611 + y_204612;
                                        double defunc_9_slope_fun_res_204614 =
                                               defunc_0_f_res_204600 * x_204613;
                                        double defunc_1_op_res_204575 =
                                               defunc_9_fit_fun_res_204608 +
                                               redout_207083;
                                        double defunc_1_op_res_204578 =
                                               defunc_9_slope_fun_res_204614 +
                                               redout_207084;
                                        double redout_tmp_213490 =
                                               defunc_1_op_res_204575;
                                        double redout_tmp_213491 =
                                               defunc_1_op_res_204578;
                                        
                                        redout_207083 = redout_tmp_213490;
                                        redout_207084 = redout_tmp_213491;
                                    }
                                    defunc_2_reduce_res_204571 = redout_207083;
                                    defunc_2_reduce_res_204572 = redout_207084;
                                    ((double *) mem_209678.mem)[i_207104 *
                                                                ctx_val_208739 +
                                                                i_207097 *
                                                                s_n_m_203636 +
                                                                i_207090] =
                                        defunc_2_reduce_res_204571;
                                    ((double *) mem_209683.mem)[i_207104 *
                                                                ctx_val_208739 +
                                                                i_207097 *
                                                                s_n_m_203636 +
                                                                i_207090] =
                                        defunc_2_reduce_res_204572;
                                }
                            }
                        }
                        if (memblock_set(ctx, &ext_mem_209869, &mem_209678,
                                         "mem_209678") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_209858, &mem_209683,
                                         "mem_209683") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_209683, "mem_209683") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_209678, "mem_209678") != 0)
                            return 1;
                    }
                    if (memblock_set(ctx, &ext_mem_209892, &ext_mem_209869,
                                     "ext_mem_209869") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_209881, &ext_mem_209858,
                                     "ext_mem_209858") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_209858,
                                       "ext_mem_209858") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_209869,
                                       "ext_mem_209869") != 0)
                        return 1;
                }
                if (memblock_set(ctx, &ext_mem_210529, &ext_mem_209892,
                                 "ext_mem_209892") != 0)
                    return 1;
                if (memblock_set(ctx, &ext_mem_210518, &ext_mem_209881,
                                 "ext_mem_209881") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_209881, "ext_mem_209881") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_209892, "ext_mem_209892") != 0)
                    return 1;
            } else {
                bool match_lit_204617 = (int64_t) 0 == d_s_203496;
                int64_t binop_y_209960 = (int64_t) 8 * q_s_203493;
                int64_t bytes_209961 = smax64((int64_t) 0, binop_y_209960);
                struct memblock ext_mem_210507;
                
                ext_mem_210507.references = NULL;
                
                struct memblock ext_mem_210496;
                
                ext_mem_210496.references = NULL;
                if (match_lit_204617) {
                    struct memblock mem_209907;
                    
                    mem_209907.references = NULL;
                    if (memblock_alloc(ctx, &mem_209907, bytes_208709,
                                       "mem_209907")) {
                        err = 1;
                        goto cleanup;
                    }
                    for (int64_t i_213492 = 0; i_213492 <
                         partition_sizze_203577; i_213492++) {
                        for (int64_t i_213493 = 0; i_213493 < n_p_203492;
                             i_213493++) {
                            for (int64_t i_213494 = 0; i_213494 < s_n_m_203636;
                                 i_213494++) {
                                ((double *) mem_209907.mem)[i_213492 *
                                                            (s_n_m_203636 *
                                                             n_p_203492) +
                                                            i_213493 *
                                                            s_n_m_203636 +
                                                            i_213494] = 0.0;
                            }
                        }
                    }
                    
                    struct memblock mem_209912;
                    
                    mem_209912.references = NULL;
                    if (memblock_alloc(ctx, &mem_209912, bytes_208709,
                                       "mem_209912")) {
                        err = 1;
                        goto cleanup;
                    }
                    if (mem_209962_cached_sizze_213754 <
                        (size_t) bytes_209961) {
                        mem_209962 = realloc(mem_209962, bytes_209961);
                        mem_209962_cached_sizze_213754 = bytes_209961;
                    }
                    for (int64_t i_207124 = 0; i_207124 <
                         partition_sizze_203577; i_207124++) {
                        for (int64_t i_207120 = 0; i_207120 < n_p_203492;
                             i_207120++) {
                            int64_t x_204633;
                            
                            x_204633 = ((int64_t *) mem_208563)[i_207124 *
                                                                n_p_203492 +
                                                                i_207120];
                            for (int64_t i_207116 = 0; i_207116 < s_n_m_203636;
                                 i_207116++) {
                                int64_t x_204638;
                                
                                x_204638 = ((int64_t *) mem_208710)[i_207124 *
                                                                    ctx_val_208739 +
                                                                    i_207120 *
                                                                    s_n_m_203636 +
                                                                    i_207116];
                                
                                double x_204639;
                                
                                x_204639 = ((double *) mem_208715)[i_207124 *
                                                                   ctx_val_208739 +
                                                                   i_207120 *
                                                                   s_n_m_203636 +
                                                                   i_207116];
                                
                                bool cond_204640 = i_207116 == (int64_t) 0;
                                int64_t defunc_0_m_fun_res_204641;
                                
                                if (cond_204640) {
                                    defunc_0_m_fun_res_204641 = (int64_t) 0;
                                } else {
                                    int64_t y_204642 = sub64(s_n_m_203636,
                                                             (int64_t) 1);
                                    bool cond_204643 = i_207116 == y_204642;
                                    int64_t defunc_0_m_fun_res_f_res_204644;
                                    
                                    if (cond_204643) {
                                        int64_t
                                        defunc_0_m_fun_res_f_res_t_res_204645 =
                                        sub64(pad_css_len_203632, (int64_t) 1);
                                        
                                        defunc_0_m_fun_res_f_res_204644 =
                                            defunc_0_m_fun_res_f_res_t_res_204645;
                                    } else {
                                        int64_t x_204646 = sub64(i_207116,
                                                                 (int64_t) 1);
                                        int64_t x_204647 = mul64(jump_s_203499,
                                                                 x_204646);
                                        int64_t min_arg_204648 =
                                                add64((int64_t) 1, x_204647);
                                        int64_t min_res_204649 =
                                                smin64(defunc_0_f_res_203631,
                                                       min_arg_204648);
                                        
                                        defunc_0_m_fun_res_f_res_204644 =
                                            min_res_204649;
                                    }
                                    defunc_0_m_fun_res_204641 =
                                        defunc_0_m_fun_res_f_res_204644;
                                }
                                
                                double defunc_2_reduce_res_204650;
                                double redout_207108 = 0.0;
                                
                                for (int64_t i_207110 = 0; i_207110 <
                                     q_s_203493; i_207110++) {
                                    bool cond_204656 = sle64(x_204633,
                                                             i_207110);
                                    int64_t defunc_0_f_res_204657;
                                    
                                    if (cond_204656) {
                                        defunc_0_f_res_204657 = (int64_t) 0;
                                    } else {
                                        int64_t i_204658 = add64(x_204638,
                                                                 i_207110);
                                        int64_t defunc_0_add_arg_204659;
                                        
                                        defunc_0_add_arg_204659 =
                                            ((int64_t *) mem_208559)[i_207124 *
                                                                     ctx_val_208480 +
                                                                     i_207120 *
                                                                     defunc_0_f_res_203631 +
                                                                     i_204658];
                                        
                                        int64_t defunc_1_add_res_204660 =
                                                add64((int64_t) 1,
                                                      defunc_0_add_arg_204659);
                                        
                                        defunc_0_f_res_204657 =
                                            defunc_1_add_res_204660;
                                    }
                                    
                                    double defunc_0_f_res_204661;
                                    
                                    if (cond_204656) {
                                        defunc_0_f_res_204661 = 0.0;
                                    } else {
                                        int64_t i_204662 = add64(x_204638,
                                                                 i_207110);
                                        double defunc_0_add_arg_204663;
                                        
                                        defunc_0_add_arg_204663 =
                                            ((double *) mem_209218)[i_207124 *
                                                                    ctx_val_208480 +
                                                                    i_207120 *
                                                                    defunc_0_f_res_203631 +
                                                                    i_204662];
                                        defunc_0_f_res_204661 =
                                            defunc_0_add_arg_204663;
                                    }
                                    
                                    int64_t binop_p_204664 =
                                            sub64(defunc_0_f_res_204657,
                                                  defunc_0_m_fun_res_204641);
                                    double defunc_0_f_res_204665 =
                                           sitofp_i64_f64(binop_p_204664);
                                    double abs_res_204666 =
                                           fabs(defunc_0_f_res_204665);
                                    double tmp1_204667 = abs_res_204666 /
                                           x_204639;
                                    double x_204668 = tmp1_204667 * tmp1_204667;
                                    double y_204669 = tmp1_204667 * x_204668;
                                    double tmp2_204670 = 1.0 - y_204669;
                                    double x_204671 = tmp2_204670 * tmp2_204670;
                                    double tmp3_204672 = tmp2_204670 * x_204671;
                                    double tmp4_204673 = defunc_0_f_res_204661 *
                                           tmp3_204672;
                                    double defunc_1_op_res_204654 =
                                           tmp4_204673 + redout_207108;
                                    
                                    ((double *) mem_209962)[i_207110] =
                                        tmp4_204673;
                                    
                                    double redout_tmp_213498 =
                                           defunc_1_op_res_204654;
                                    
                                    redout_207108 = redout_tmp_213498;
                                }
                                defunc_2_reduce_res_204650 = redout_207108;
                                
                                double a0_204674 = 1.0 /
                                       defunc_2_reduce_res_204650;
                                double defunc_2_reduce_res_204675;
                                double redout_207112 = 0.0;
                                
                                for (int64_t i_207113 = 0; i_207113 <
                                     q_s_203493; i_207113++) {
                                    double x_204680;
                                    
                                    x_204680 =
                                        ((double *) mem_209962)[i_207113];
                                    
                                    bool cond_204681 = sle64(x_204633,
                                                             i_207113);
                                    double defunc_0_f_res_204682;
                                    
                                    if (cond_204681) {
                                        defunc_0_f_res_204682 = 0.0;
                                    } else {
                                        int64_t i_204683 = add64(x_204638,
                                                                 i_207113);
                                        double defunc_0_add_arg_204684;
                                        
                                        defunc_0_add_arg_204684 =
                                            ((double *) mem_209213)[i_207124 *
                                                                    ctx_val_208480 +
                                                                    i_207120 *
                                                                    defunc_0_f_res_203631 +
                                                                    i_204683];
                                        defunc_0_f_res_204682 =
                                            defunc_0_add_arg_204684;
                                    }
                                    
                                    double x_204685 = a0_204674 * x_204680;
                                    double defunc_9_fit_fun_res_204686 =
                                           defunc_0_f_res_204682 * x_204685;
                                    double defunc_1_op_res_204678 =
                                           defunc_9_fit_fun_res_204686 +
                                           redout_207112;
                                    double redout_tmp_213500 =
                                           defunc_1_op_res_204678;
                                    
                                    redout_207112 = redout_tmp_213500;
                                }
                                defunc_2_reduce_res_204675 = redout_207112;
                                ((double *) mem_209912.mem)[i_207124 *
                                                            ctx_val_208739 +
                                                            i_207120 *
                                                            s_n_m_203636 +
                                                            i_207116] =
                                    defunc_2_reduce_res_204675;
                            }
                        }
                    }
                    if (memblock_set(ctx, &ext_mem_210507, &mem_209912,
                                     "mem_209912") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_210496, &mem_209907,
                                     "mem_209907") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_209912, "mem_209912") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_209907, "mem_209907") != 0)
                        return 1;
                } else {
                    bool match_lit_204689 = (int64_t) 1 == d_s_203496;
                    int64_t binop_y_210119 = (int64_t) 8 * q_s_203493;
                    int64_t bytes_210120 = smax64((int64_t) 0, binop_y_210119);
                    int64_t binop_y_210333 = (int64_t) 8 * q_s_203493;
                    int64_t bytes_210334 = smax64((int64_t) 0, binop_y_210333);
                    struct memblock ext_mem_210484;
                    
                    ext_mem_210484.references = NULL;
                    
                    struct memblock ext_mem_210473;
                    
                    ext_mem_210473.references = NULL;
                    if (match_lit_204689) {
                        struct memblock mem_210019;
                        
                        mem_210019.references = NULL;
                        if (memblock_alloc(ctx, &mem_210019, bytes_208709,
                                           "mem_210019")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_210024;
                        
                        mem_210024.references = NULL;
                        if (memblock_alloc(ctx, &mem_210024, bytes_208709,
                                           "mem_210024")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (mem_210121_cached_sizze_213755 <
                            (size_t) bytes_210120) {
                            mem_210121 = realloc(mem_210121, bytes_210120);
                            mem_210121_cached_sizze_213755 = bytes_210120;
                        }
                        if (mem_210124_cached_sizze_213756 <
                            (size_t) bytes_210120) {
                            mem_210124 = realloc(mem_210124, bytes_210120);
                            mem_210124_cached_sizze_213756 = bytes_210120;
                        }
                        for (int64_t i_207157 = 0; i_207157 <
                             partition_sizze_203577; i_207157++) {
                            for (int64_t i_207150 = 0; i_207150 < n_p_203492;
                                 i_207150++) {
                                int64_t x_204706;
                                
                                x_204706 = ((int64_t *) mem_208563)[i_207157 *
                                                                    n_p_203492 +
                                                                    i_207150];
                                for (int64_t i_207143 = 0; i_207143 <
                                     s_n_m_203636; i_207143++) {
                                    int64_t x_204712;
                                    
                                    x_204712 =
                                        ((int64_t *) mem_208710)[i_207157 *
                                                                 ctx_val_208739 +
                                                                 i_207150 *
                                                                 s_n_m_203636 +
                                                                 i_207143];
                                    
                                    double x_204713;
                                    
                                    x_204713 =
                                        ((double *) mem_208715)[i_207157 *
                                                                ctx_val_208739 +
                                                                i_207150 *
                                                                s_n_m_203636 +
                                                                i_207143];
                                    
                                    bool cond_204714 = i_207143 == (int64_t) 0;
                                    int64_t defunc_0_m_fun_res_204715;
                                    
                                    if (cond_204714) {
                                        defunc_0_m_fun_res_204715 = (int64_t) 0;
                                    } else {
                                        int64_t y_204716 = sub64(s_n_m_203636,
                                                                 (int64_t) 1);
                                        bool cond_204717 = i_207143 == y_204716;
                                        int64_t defunc_0_m_fun_res_f_res_204718;
                                        
                                        if (cond_204717) {
                                            int64_t
                                            defunc_0_m_fun_res_f_res_t_res_204719
                                            = sub64(pad_css_len_203632,
                                                    (int64_t) 1);
                                            
                                            defunc_0_m_fun_res_f_res_204718 =
                                                defunc_0_m_fun_res_f_res_t_res_204719;
                                        } else {
                                            int64_t x_204720 = sub64(i_207143,
                                                                     (int64_t) 1);
                                            int64_t x_204721 =
                                                    mul64(jump_s_203499,
                                                          x_204720);
                                            int64_t min_arg_204722 =
                                                    add64((int64_t) 1,
                                                          x_204721);
                                            int64_t min_res_204723 =
                                                    smin64(defunc_0_f_res_203631,
                                                           min_arg_204722);
                                            
                                            defunc_0_m_fun_res_f_res_204718 =
                                                min_res_204723;
                                        }
                                        defunc_0_m_fun_res_204715 =
                                            defunc_0_m_fun_res_f_res_204718;
                                    }
                                    
                                    double defunc_2_reduce_res_204747;
                                    double defunc_2_reduce_res_204748;
                                    double defunc_2_reduce_res_204749;
                                    double redout_207128;
                                    double redout_207129;
                                    double redout_207130;
                                    
                                    redout_207128 = 0.0;
                                    redout_207129 = 0.0;
                                    redout_207130 = 0.0;
                                    for (int64_t i_207133 = 0; i_207133 <
                                         q_s_203493; i_207133++) {
                                        bool cond_204762 = sle64(x_204706,
                                                                 i_207133);
                                        int64_t defunc_0_f_res_204763;
                                        
                                        if (cond_204762) {
                                            defunc_0_f_res_204763 = (int64_t) 0;
                                        } else {
                                            int64_t i_204764 = add64(x_204712,
                                                                     i_207133);
                                            int64_t defunc_0_add_arg_204765;
                                            
                                            defunc_0_add_arg_204765 =
                                                ((int64_t *) mem_208559)[i_207157 *
                                                                         ctx_val_208480 +
                                                                         i_207150 *
                                                                         defunc_0_f_res_203631 +
                                                                         i_204764];
                                            
                                            int64_t defunc_1_add_res_204766 =
                                                    add64((int64_t) 1,
                                                          defunc_0_add_arg_204765);
                                            
                                            defunc_0_f_res_204763 =
                                                defunc_1_add_res_204766;
                                        }
                                        
                                        double defunc_0_f_res_204767;
                                        
                                        if (cond_204762) {
                                            defunc_0_f_res_204767 = 0.0;
                                        } else {
                                            int64_t i_204768 = add64(x_204712,
                                                                     i_207133);
                                            double defunc_0_add_arg_204769;
                                            
                                            defunc_0_add_arg_204769 =
                                                ((double *) mem_209218)[i_207157 *
                                                                        ctx_val_208480 +
                                                                        i_207150 *
                                                                        defunc_0_f_res_203631 +
                                                                        i_204768];
                                            defunc_0_f_res_204767 =
                                                defunc_0_add_arg_204769;
                                        }
                                        
                                        int64_t binop_p_204770 =
                                                sub64(defunc_0_f_res_204763,
                                                      defunc_0_m_fun_res_204715);
                                        double defunc_0_f_res_204771 =
                                               sitofp_i64_f64(binop_p_204770);
                                        double abs_res_204772 =
                                               fabs(defunc_0_f_res_204771);
                                        double tmp1_204773 = abs_res_204772 /
                                               x_204713;
                                        double x_204774 = tmp1_204773 *
                                               tmp1_204773;
                                        double y_204775 = tmp1_204773 *
                                               x_204774;
                                        double tmp2_204776 = 1.0 - y_204775;
                                        double x_204777 = tmp2_204776 *
                                               tmp2_204776;
                                        double tmp3_204778 = tmp2_204776 *
                                               x_204777;
                                        double tmp4_204779 =
                                               defunc_0_f_res_204767 *
                                               tmp3_204778;
                                        double defunc_1_f_res_204780 =
                                               defunc_0_f_res_204771 *
                                               tmp4_204779;
                                        double defunc_1_f_res_204781 =
                                               defunc_0_f_res_204771 *
                                               defunc_1_f_res_204780;
                                        double defunc_1_op_res_204754 =
                                               tmp4_204779 + redout_207128;
                                        double defunc_1_op_res_204757 =
                                               defunc_1_f_res_204780 +
                                               redout_207129;
                                        double defunc_1_op_res_204760 =
                                               defunc_1_f_res_204781 +
                                               redout_207130;
                                        
                                        ((double *) mem_210121)[i_207133] =
                                            defunc_1_f_res_204780;
                                        ((double *) mem_210124)[i_207133] =
                                            tmp4_204779;
                                        
                                        double redout_tmp_213507 =
                                               defunc_1_op_res_204754;
                                        double redout_tmp_213508 =
                                               defunc_1_op_res_204757;
                                        double redout_tmp_213509 =
                                               defunc_1_op_res_204760;
                                        
                                        redout_207128 = redout_tmp_213507;
                                        redout_207129 = redout_tmp_213508;
                                        redout_207130 = redout_tmp_213509;
                                    }
                                    defunc_2_reduce_res_204747 = redout_207128;
                                    defunc_2_reduce_res_204748 = redout_207129;
                                    defunc_2_reduce_res_204749 = redout_207130;
                                    
                                    double x_204787 =
                                           defunc_2_reduce_res_204747 *
                                           defunc_2_reduce_res_204749;
                                    double y_204788 =
                                           defunc_2_reduce_res_204748 *
                                           defunc_2_reduce_res_204748;
                                    double y_204789 = x_204787 - y_204788;
                                    double det1_204790 = 1.0 / y_204789;
                                    double a11_204791 =
                                           defunc_2_reduce_res_204749 *
                                           det1_204790;
                                    double x_204792 = 0.0 -
                                           defunc_2_reduce_res_204748;
                                    double b11_204793 = det1_204790 * x_204792;
                                    double c11_204794 =
                                           defunc_2_reduce_res_204747 *
                                           det1_204790;
                                    double defunc_2_reduce_res_204795;
                                    double defunc_2_reduce_res_204796;
                                    double redout_207136;
                                    double redout_207137;
                                    
                                    redout_207136 = 0.0;
                                    redout_207137 = 0.0;
                                    for (int64_t i_207138 = 0; i_207138 <
                                         q_s_203493; i_207138++) {
                                        double x_204804;
                                        
                                        x_204804 =
                                            ((double *) mem_210124)[i_207138];
                                        
                                        double x_204805;
                                        
                                        x_204805 =
                                            ((double *) mem_210121)[i_207138];
                                        
                                        bool cond_204806 = sle64(x_204706,
                                                                 i_207138);
                                        double defunc_0_f_res_204807;
                                        
                                        if (cond_204806) {
                                            defunc_0_f_res_204807 = 0.0;
                                        } else {
                                            int64_t i_204808 = add64(x_204712,
                                                                     i_207138);
                                            double defunc_0_add_arg_204809;
                                            
                                            defunc_0_add_arg_204809 =
                                                ((double *) mem_209213)[i_207157 *
                                                                        ctx_val_208480 +
                                                                        i_207150 *
                                                                        defunc_0_f_res_203631 +
                                                                        i_204808];
                                            defunc_0_f_res_204807 =
                                                defunc_0_add_arg_204809;
                                        }
                                        
                                        double x_204810 = a11_204791 * x_204804;
                                        double y_204811 = b11_204793 * x_204805;
                                        double x_204812 = x_204810 + y_204811;
                                        double defunc_9_fit_fun_res_204813 =
                                               defunc_0_f_res_204807 * x_204812;
                                        double x_204814 = b11_204793 * x_204804;
                                        double y_204815 = c11_204794 * x_204805;
                                        double x_204816 = x_204814 + y_204815;
                                        double defunc_9_slope_fun_res_204817 =
                                               defunc_0_f_res_204807 * x_204816;
                                        double defunc_1_op_res_204799 =
                                               defunc_9_fit_fun_res_204813 +
                                               redout_207136;
                                        double defunc_1_op_res_204802 =
                                               defunc_9_slope_fun_res_204817 +
                                               redout_207137;
                                        double redout_tmp_213512 =
                                               defunc_1_op_res_204799;
                                        double redout_tmp_213513 =
                                               defunc_1_op_res_204802;
                                        
                                        redout_207136 = redout_tmp_213512;
                                        redout_207137 = redout_tmp_213513;
                                    }
                                    defunc_2_reduce_res_204795 = redout_207136;
                                    defunc_2_reduce_res_204796 = redout_207137;
                                    ((double *) mem_210019.mem)[i_207157 *
                                                                ctx_val_208739 +
                                                                i_207150 *
                                                                s_n_m_203636 +
                                                                i_207143] =
                                        defunc_2_reduce_res_204795;
                                    ((double *) mem_210024.mem)[i_207157 *
                                                                ctx_val_208739 +
                                                                i_207150 *
                                                                s_n_m_203636 +
                                                                i_207143] =
                                        defunc_2_reduce_res_204796;
                                }
                            }
                        }
                        if (memblock_set(ctx, &ext_mem_210484, &mem_210019,
                                         "mem_210019") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_210473, &mem_210024,
                                         "mem_210024") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_210024, "mem_210024") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_210019, "mem_210019") != 0)
                            return 1;
                    } else {
                        struct memblock mem_210233;
                        
                        mem_210233.references = NULL;
                        if (memblock_alloc(ctx, &mem_210233, bytes_208709,
                                           "mem_210233")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_210238;
                        
                        mem_210238.references = NULL;
                        if (memblock_alloc(ctx, &mem_210238, bytes_208709,
                                           "mem_210238")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (mem_210335_cached_sizze_213757 <
                            (size_t) bytes_210334) {
                            mem_210335 = realloc(mem_210335, bytes_210334);
                            mem_210335_cached_sizze_213757 = bytes_210334;
                        }
                        if (mem_210338_cached_sizze_213758 <
                            (size_t) bytes_210334) {
                            mem_210338 = realloc(mem_210338, bytes_210334);
                            mem_210338_cached_sizze_213758 = bytes_210334;
                        }
                        if (mem_210365_cached_sizze_213759 <
                            (size_t) bytes_210334) {
                            mem_210365 = realloc(mem_210365, bytes_210334);
                            mem_210365_cached_sizze_213759 = bytes_210334;
                        }
                        if (mem_210368_cached_sizze_213760 <
                            (size_t) bytes_210334) {
                            mem_210368 = realloc(mem_210368, bytes_210334);
                            mem_210368_cached_sizze_213760 = bytes_210334;
                        }
                        for (int64_t i_207200 = 0; i_207200 <
                             partition_sizze_203577; i_207200++) {
                            for (int64_t i_207193 = 0; i_207193 < n_p_203492;
                                 i_207193++) {
                                int64_t x_204834;
                                
                                x_204834 = ((int64_t *) mem_208563)[i_207200 *
                                                                    n_p_203492 +
                                                                    i_207193];
                                for (int64_t i_207186 = 0; i_207186 <
                                     s_n_m_203636; i_207186++) {
                                    int64_t x_204840;
                                    
                                    x_204840 =
                                        ((int64_t *) mem_208710)[i_207200 *
                                                                 ctx_val_208739 +
                                                                 i_207193 *
                                                                 s_n_m_203636 +
                                                                 i_207186];
                                    
                                    double x_204841;
                                    
                                    x_204841 =
                                        ((double *) mem_208715)[i_207200 *
                                                                ctx_val_208739 +
                                                                i_207193 *
                                                                s_n_m_203636 +
                                                                i_207186];
                                    
                                    bool cond_204842 = i_207186 == (int64_t) 0;
                                    int64_t defunc_0_m_fun_res_204843;
                                    
                                    if (cond_204842) {
                                        defunc_0_m_fun_res_204843 = (int64_t) 0;
                                    } else {
                                        int64_t y_204844 = sub64(s_n_m_203636,
                                                                 (int64_t) 1);
                                        bool cond_204845 = i_207186 == y_204844;
                                        int64_t defunc_0_m_fun_res_f_res_204846;
                                        
                                        if (cond_204845) {
                                            int64_t
                                            defunc_0_m_fun_res_f_res_t_res_204847
                                            = sub64(pad_css_len_203632,
                                                    (int64_t) 1);
                                            
                                            defunc_0_m_fun_res_f_res_204846 =
                                                defunc_0_m_fun_res_f_res_t_res_204847;
                                        } else {
                                            int64_t x_204848 = sub64(i_207186,
                                                                     (int64_t) 1);
                                            int64_t x_204849 =
                                                    mul64(jump_s_203499,
                                                          x_204848);
                                            int64_t min_arg_204850 =
                                                    add64((int64_t) 1,
                                                          x_204849);
                                            int64_t min_res_204851 =
                                                    smin64(defunc_0_f_res_203631,
                                                           min_arg_204850);
                                            
                                            defunc_0_m_fun_res_f_res_204846 =
                                                min_res_204851;
                                        }
                                        defunc_0_m_fun_res_204843 =
                                            defunc_0_m_fun_res_f_res_204846;
                                    }
                                    for (int64_t i_207164 = 0; i_207164 <
                                         q_s_203493; i_207164++) {
                                        bool cond_204855 = sle64(x_204834,
                                                                 i_207164);
                                        int64_t defunc_0_f_res_204856;
                                        
                                        if (cond_204855) {
                                            defunc_0_f_res_204856 = (int64_t) 0;
                                        } else {
                                            int64_t i_204857 = add64(x_204840,
                                                                     i_207164);
                                            int64_t defunc_0_add_arg_204858;
                                            
                                            defunc_0_add_arg_204858 =
                                                ((int64_t *) mem_208559)[i_207200 *
                                                                         ctx_val_208480 +
                                                                         i_207193 *
                                                                         defunc_0_f_res_203631 +
                                                                         i_204857];
                                            
                                            int64_t defunc_1_add_res_204859 =
                                                    add64((int64_t) 1,
                                                          defunc_0_add_arg_204858);
                                            
                                            defunc_0_f_res_204856 =
                                                defunc_1_add_res_204859;
                                        }
                                        
                                        double defunc_0_f_res_204860;
                                        
                                        if (cond_204855) {
                                            defunc_0_f_res_204860 = 0.0;
                                        } else {
                                            int64_t i_204861 = add64(x_204840,
                                                                     i_207164);
                                            double defunc_0_add_arg_204862;
                                            
                                            defunc_0_add_arg_204862 =
                                                ((double *) mem_209218)[i_207200 *
                                                                        ctx_val_208480 +
                                                                        i_207193 *
                                                                        defunc_0_f_res_203631 +
                                                                        i_204861];
                                            defunc_0_f_res_204860 =
                                                defunc_0_add_arg_204862;
                                        }
                                        
                                        int64_t binop_p_204863 =
                                                sub64(defunc_0_f_res_204856,
                                                      defunc_0_m_fun_res_204843);
                                        double defunc_0_f_res_204864 =
                                               sitofp_i64_f64(binop_p_204863);
                                        double abs_res_204865 =
                                               fabs(defunc_0_f_res_204864);
                                        double tmp1_204866 = abs_res_204865 /
                                               x_204841;
                                        double x_204867 = tmp1_204866 *
                                               tmp1_204866;
                                        double y_204868 = tmp1_204866 *
                                               x_204867;
                                        double tmp2_204869 = 1.0 - y_204868;
                                        double x_204870 = tmp2_204869 *
                                               tmp2_204869;
                                        double tmp3_204871 = tmp2_204869 *
                                               x_204870;
                                        double tmp4_204872 =
                                               defunc_0_f_res_204860 *
                                               tmp3_204871;
                                        
                                        ((double *) mem_210335)[i_207164] =
                                            defunc_0_f_res_204864;
                                        ((double *) mem_210338)[i_207164] =
                                            tmp4_204872;
                                    }
                                    
                                    double defunc_2_reduce_res_204879;
                                    double defunc_2_reduce_res_204880;
                                    double defunc_2_reduce_res_204881;
                                    double defunc_2_reduce_res_204882;
                                    double defunc_2_reduce_res_204883;
                                    double redout_207169;
                                    double redout_207170;
                                    double redout_207171;
                                    double redout_207172;
                                    double redout_207173;
                                    
                                    redout_207169 = 0.0;
                                    redout_207170 = 0.0;
                                    redout_207171 = 0.0;
                                    redout_207172 = 0.0;
                                    redout_207173 = 0.0;
                                    for (int64_t i_207176 = 0; i_207176 <
                                         q_s_203493; i_207176++) {
                                        double x_204901;
                                        
                                        x_204901 =
                                            ((double *) mem_210335)[i_207176];
                                        
                                        double x_204902;
                                        
                                        x_204902 =
                                            ((double *) mem_210338)[i_207176];
                                        
                                        double defunc_1_f_res_204903 =
                                               x_204901 * x_204902;
                                        double defunc_1_f_res_204904 =
                                               x_204901 * defunc_1_f_res_204903;
                                        double defunc_1_f_res_204905 =
                                               x_204901 * defunc_1_f_res_204904;
                                        double defunc_1_f_res_204906 =
                                               x_204901 * defunc_1_f_res_204905;
                                        double defunc_1_op_res_204888 =
                                               x_204902 + redout_207169;
                                        double defunc_1_op_res_204891 =
                                               defunc_1_f_res_204903 +
                                               redout_207170;
                                        double defunc_1_op_res_204894 =
                                               defunc_1_f_res_204904 +
                                               redout_207171;
                                        double defunc_1_op_res_204897 =
                                               defunc_1_f_res_204905 +
                                               redout_207172;
                                        double defunc_1_op_res_204900 =
                                               defunc_1_f_res_204906 +
                                               redout_207173;
                                        
                                        ((double *) mem_210365)[i_207176] =
                                            defunc_1_f_res_204904;
                                        ((double *) mem_210368)[i_207176] =
                                            defunc_1_f_res_204903;
                                        
                                        double redout_tmp_213522 =
                                               defunc_1_op_res_204888;
                                        double redout_tmp_213523 =
                                               defunc_1_op_res_204891;
                                        double redout_tmp_213524 =
                                               defunc_1_op_res_204894;
                                        double redout_tmp_213525 =
                                               defunc_1_op_res_204897;
                                        double redout_tmp_213526 =
                                               defunc_1_op_res_204900;
                                        
                                        redout_207169 = redout_tmp_213522;
                                        redout_207170 = redout_tmp_213523;
                                        redout_207171 = redout_tmp_213524;
                                        redout_207172 = redout_tmp_213525;
                                        redout_207173 = redout_tmp_213526;
                                    }
                                    defunc_2_reduce_res_204879 = redout_207169;
                                    defunc_2_reduce_res_204880 = redout_207170;
                                    defunc_2_reduce_res_204881 = redout_207171;
                                    defunc_2_reduce_res_204882 = redout_207172;
                                    defunc_2_reduce_res_204883 = redout_207173;
                                    
                                    double x_204914 =
                                           defunc_2_reduce_res_204881 *
                                           defunc_2_reduce_res_204883;
                                    double y_204915 =
                                           defunc_2_reduce_res_204882 *
                                           defunc_2_reduce_res_204882;
                                    double a12_204916 = x_204914 - y_204915;
                                    double x_204917 =
                                           defunc_2_reduce_res_204881 *
                                           defunc_2_reduce_res_204882;
                                    double y_204918 =
                                           defunc_2_reduce_res_204880 *
                                           defunc_2_reduce_res_204883;
                                    double b12_204919 = x_204917 - y_204918;
                                    double x_204920 =
                                           defunc_2_reduce_res_204880 *
                                           defunc_2_reduce_res_204882;
                                    double y_204921 =
                                           defunc_2_reduce_res_204881 *
                                           defunc_2_reduce_res_204881;
                                    double c12_204922 = x_204920 - y_204921;
                                    double x_204923 =
                                           defunc_2_reduce_res_204879 *
                                           defunc_2_reduce_res_204883;
                                    double b2_204924 = x_204923 - y_204921;
                                    double x_204925 =
                                           defunc_2_reduce_res_204880 *
                                           defunc_2_reduce_res_204881;
                                    double y_204926 =
                                           defunc_2_reduce_res_204879 *
                                           defunc_2_reduce_res_204882;
                                    double c2_204927 = x_204925 - y_204926;
                                    double x_204928 =
                                           defunc_2_reduce_res_204879 *
                                           a12_204916;
                                    double y_204929 =
                                           defunc_2_reduce_res_204880 *
                                           b12_204919;
                                    double x_204930 = x_204928 + y_204929;
                                    double y_204931 =
                                           defunc_2_reduce_res_204881 *
                                           c12_204922;
                                    double y_204932 = x_204930 + y_204931;
                                    double det_204933 = 1.0 / y_204932;
                                    double a12_204934 = a12_204916 * det_204933;
                                    double b12_204935 = b12_204919 * det_204933;
                                    double c12_204936 = c12_204922 * det_204933;
                                    double b2_204937 = b2_204924 * det_204933;
                                    double c2_204938 = c2_204927 * det_204933;
                                    double defunc_2_reduce_res_204939;
                                    double defunc_2_reduce_res_204940;
                                    double redout_207179;
                                    double redout_207180;
                                    
                                    redout_207179 = 0.0;
                                    redout_207180 = 0.0;
                                    for (int64_t i_207181 = 0; i_207181 <
                                         q_s_203493; i_207181++) {
                                        double x_204948;
                                        
                                        x_204948 =
                                            ((double *) mem_210338)[i_207181];
                                        
                                        double x_204949;
                                        
                                        x_204949 =
                                            ((double *) mem_210368)[i_207181];
                                        
                                        double x_204950;
                                        
                                        x_204950 =
                                            ((double *) mem_210365)[i_207181];
                                        
                                        bool cond_204951 = sle64(x_204834,
                                                                 i_207181);
                                        double defunc_0_f_res_204952;
                                        
                                        if (cond_204951) {
                                            defunc_0_f_res_204952 = 0.0;
                                        } else {
                                            int64_t i_204953 = add64(x_204840,
                                                                     i_207181);
                                            double defunc_0_add_arg_204954;
                                            
                                            defunc_0_add_arg_204954 =
                                                ((double *) mem_209213)[i_207200 *
                                                                        ctx_val_208480 +
                                                                        i_207193 *
                                                                        defunc_0_f_res_203631 +
                                                                        i_204953];
                                            defunc_0_f_res_204952 =
                                                defunc_0_add_arg_204954;
                                        }
                                        
                                        double x_204955 = a12_204934 * x_204948;
                                        double y_204956 = b12_204935 * x_204949;
                                        double x_204957 = x_204955 + y_204956;
                                        double y_204958 = c12_204936 * x_204950;
                                        double x_204959 = x_204957 + y_204958;
                                        double defunc_9_fit_fun_res_204960 =
                                               defunc_0_f_res_204952 * x_204959;
                                        double x_204961 = b12_204935 * x_204948;
                                        double y_204962 = b2_204937 * x_204949;
                                        double x_204963 = x_204961 + y_204962;
                                        double y_204964 = c2_204938 * x_204950;
                                        double x_204965 = x_204963 + y_204964;
                                        double defunc_9_slope_fun_res_204966 =
                                               defunc_0_f_res_204952 * x_204965;
                                        double defunc_1_op_res_204943 =
                                               defunc_9_fit_fun_res_204960 +
                                               redout_207179;
                                        double defunc_1_op_res_204946 =
                                               defunc_9_slope_fun_res_204966 +
                                               redout_207180;
                                        double redout_tmp_213529 =
                                               defunc_1_op_res_204943;
                                        double redout_tmp_213530 =
                                               defunc_1_op_res_204946;
                                        
                                        redout_207179 = redout_tmp_213529;
                                        redout_207180 = redout_tmp_213530;
                                    }
                                    defunc_2_reduce_res_204939 = redout_207179;
                                    defunc_2_reduce_res_204940 = redout_207180;
                                    ((double *) mem_210233.mem)[i_207200 *
                                                                ctx_val_208739 +
                                                                i_207193 *
                                                                s_n_m_203636 +
                                                                i_207186] =
                                        defunc_2_reduce_res_204939;
                                    ((double *) mem_210238.mem)[i_207200 *
                                                                ctx_val_208739 +
                                                                i_207193 *
                                                                s_n_m_203636 +
                                                                i_207186] =
                                        defunc_2_reduce_res_204940;
                                }
                            }
                        }
                        if (memblock_set(ctx, &ext_mem_210484, &mem_210233,
                                         "mem_210233") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_210473, &mem_210238,
                                         "mem_210238") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_210238, "mem_210238") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_210233, "mem_210233") != 0)
                            return 1;
                    }
                    if (memblock_set(ctx, &ext_mem_210507, &ext_mem_210484,
                                     "ext_mem_210484") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_210496, &ext_mem_210473,
                                     "ext_mem_210473") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_210473,
                                       "ext_mem_210473") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_210484,
                                       "ext_mem_210484") != 0)
                        return 1;
                }
                if (memblock_set(ctx, &ext_mem_210529, &ext_mem_210507,
                                 "ext_mem_210507") != 0)
                    return 1;
                if (memblock_set(ctx, &ext_mem_210518, &ext_mem_210496,
                                 "ext_mem_210496") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_210496, "ext_mem_210496") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_210507, "ext_mem_210507") != 0)
                    return 1;
            }
            
            int64_t ext_210636;
            struct memblock ext_mem_210632;
            
            ext_mem_210632.references = NULL;
            if (cond_203635) {
                ext_210636 = ctx_val_208739;
                if (memblock_set(ctx, &ext_mem_210632, &ext_mem_210529,
                                 "ext_mem_210529") != 0)
                    return 1;
            } else {
                bool bounds_invalid_upwards_204971 = slt64(pad_css_len_203632,
                                                           (int64_t) 0);
                bool valid_204972 = !bounds_invalid_upwards_204971;
                bool range_valid_c_204973;
                
                if (!valid_204972) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Range ", (long long) (int64_t) 0, "..",
                                  (long long) (int64_t) 1, "..<",
                                  (long long) pad_css_len_203632,
                                  " is invalid.",
                                  "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  loess.fut:557:3-566:9\n   #4  stl.fut:220:31-96\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:219:23-221:48\n   #8  /prelude/soacs.fut:67:19-23\n   #9  /prelude/soacs.fut:67:3-37\n   #10 stl.fut:218:15-222:44\n   #11 stl.fut:415:61-429:75\n   #12 stl.fut:455:3-469:34\n   #13 stl.fut:439:1-469:34\n");
                    if (memblock_unref(ctx, &ext_mem_210632,
                                       "ext_mem_210632") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_210518,
                                       "ext_mem_210518") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_210529,
                                       "ext_mem_210529") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209164,
                                       "mem_param_209164") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209156,
                                       "mem_param_209156") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212524,
                                       "ext_mem_212524") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212525,
                                       "ext_mem_212525") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209142,
                                       "mem_param_209142") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209134,
                                       "mem_param_209134") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209126,
                                       "mem_param_209126") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212853,
                                       "ext_mem_212853") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212854,
                                       "ext_mem_212854") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212855,
                                       "ext_mem_212855") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_209118, "mem_209118") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_209114, "mem_209114") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213364,
                                       "mem_out_213364") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213363,
                                       "mem_out_213363") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213362,
                                       "mem_out_213362") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                struct memblock mem_210544;
                
                mem_210544.references = NULL;
                if (memblock_alloc(ctx, &mem_210544, bytes_210543,
                                   "mem_210544")) {
                    err = 1;
                    goto cleanup;
                }
                
                int64_t ctx_val_210557 = n_p_203492 * pad_css_len_203632;
                
                for (int64_t i_207213 = 0; i_207213 < partition_sizze_203577;
                     i_207213++) {
                    for (int64_t i_207209 = 0; i_207209 < n_p_203492;
                         i_207209++) {
                        for (int64_t i_207205 = 0; i_207205 <
                             pad_css_len_203632; i_207205++) {
                            bool cond_204983 = i_207205 == (int64_t) 0;
                            double defunc_0_f_res_204984;
                            
                            if (cond_204983) {
                                bool y_204985 = slt64((int64_t) 0,
                                                      s_n_m_203636);
                                bool index_certs_204986;
                                
                                if (!y_204985) {
                                    ctx->error =
                                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                  "Index [",
                                                  (long long) (int64_t) 0,
                                                  "] out of bounds for array of shape [",
                                                  (long long) s_n_m_203636,
                                                  "].",
                                                  "-> #0  /prelude/array.fut:21:29-32\n   #1  loess.fut:559:12-20\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:557:3-566:9\n   #6  stl.fut:220:31-96\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:219:23-221:48\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:218:15-222:44\n   #13 stl.fut:415:61-429:75\n   #14 stl.fut:455:3-469:34\n   #15 stl.fut:439:1-469:34\n");
                                    if (memblock_unref(ctx, &mem_210544,
                                                       "mem_210544") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_210632,
                                                       "ext_mem_210632") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_210518,
                                                       "ext_mem_210518") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_210529,
                                                       "ext_mem_210529") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209164,
                                                       "mem_param_209164") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209156,
                                                       "mem_param_209156") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212524,
                                                       "ext_mem_212524") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212525,
                                                       "ext_mem_212525") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209142,
                                                       "mem_param_209142") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209134,
                                                       "mem_param_209134") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209126,
                                                       "mem_param_209126") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212853,
                                                       "ext_mem_212853") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212854,
                                                       "ext_mem_212854") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212855,
                                                       "ext_mem_212855") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_209118,
                                                       "mem_209118") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_209114,
                                                       "mem_209114") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_213364,
                                                       "mem_out_213364") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_213363,
                                                       "mem_out_213363") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_213362,
                                                       "mem_out_213362") != 0)
                                        return 1;
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                double head_res_204987;
                                
                                head_res_204987 =
                                    ((double *) ext_mem_210529.mem)[i_207213 *
                                                                    ctx_val_208739 +
                                                                    i_207209 *
                                                                    s_n_m_203636];
                                defunc_0_f_res_204984 = head_res_204987;
                            } else {
                                int64_t y_204988 = sub64(pad_css_len_203632,
                                                         (int64_t) 1);
                                bool cond_204989 = i_207205 == y_204988;
                                double defunc_0_f_res_f_res_204990;
                                
                                if (cond_204989) {
                                    int64_t i_204991 = sub64(s_n_m_203636,
                                                             (int64_t) 1);
                                    bool x_204992 = sle64((int64_t) 0,
                                                          i_204991);
                                    bool y_204993 = slt64(i_204991,
                                                          s_n_m_203636);
                                    bool bounds_check_204994 = x_204992 &&
                                         y_204993;
                                    bool index_certs_204995;
                                    
                                    if (!bounds_check_204994) {
                                        ctx->error =
                                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                      "Index [",
                                                      (long long) i_204991,
                                                      "] out of bounds for array of shape [",
                                                      (long long) s_n_m_203636,
                                                      "].",
                                                      "-> #0  /prelude/array.fut:26:29-34\n   #1  loess.fut:561:12-20\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:557:3-566:9\n   #6  stl.fut:220:31-96\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:219:23-221:48\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:218:15-222:44\n   #13 stl.fut:415:61-429:75\n   #14 stl.fut:455:3-469:34\n   #15 stl.fut:439:1-469:34\n");
                                        if (memblock_unref(ctx, &mem_210544,
                                                           "mem_210544") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210632,
                                                           "ext_mem_210632") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210518,
                                                           "ext_mem_210518") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210529,
                                                           "ext_mem_210529") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209164,
                                                           "mem_param_209164") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209156,
                                                           "mem_param_209156") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212524,
                                                           "ext_mem_212524") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212525,
                                                           "ext_mem_212525") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209142,
                                                           "mem_param_209142") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209134,
                                                           "mem_param_209134") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209126,
                                                           "mem_param_209126") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212853,
                                                           "ext_mem_212853") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212854,
                                                           "ext_mem_212854") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212855,
                                                           "ext_mem_212855") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209118,
                                                           "mem_209118") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209114,
                                                           "mem_209114") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213364,
                                                           "mem_out_213364") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213363,
                                                           "mem_out_213363") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213362,
                                                           "mem_out_213362") !=
                                            0)
                                            return 1;
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    double last_res_204996;
                                    
                                    last_res_204996 =
                                        ((double *) ext_mem_210529.mem)[i_207213 *
                                                                        ctx_val_208739 +
                                                                        i_207209 *
                                                                        s_n_m_203636 +
                                                                        i_204991];
                                    defunc_0_f_res_f_res_204990 =
                                        last_res_204996;
                                } else {
                                    int64_t x_204997 = sub64(i_207205,
                                                             (int64_t) 1);
                                    bool zzero_204998 = jump_s_203499 ==
                                         (int64_t) 0;
                                    bool nonzzero_204999 = !zzero_204998;
                                    bool nonzzero_cert_205000;
                                    
                                    if (!nonzzero_204999) {
                                        ctx->error =
                                            msgprintf("Error: %s\n\nBacktrace:\n%s",
                                                      "division by zero",
                                                      "-> #0  loess.fut:563:22-35\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:557:3-566:9\n   #5  stl.fut:220:31-96\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:219:23-221:48\n   #9  /prelude/soacs.fut:67:19-23\n   #10 /prelude/soacs.fut:67:3-37\n   #11 stl.fut:218:15-222:44\n   #12 stl.fut:415:61-429:75\n   #13 stl.fut:455:3-469:34\n   #14 stl.fut:439:1-469:34\n");
                                        if (memblock_unref(ctx, &mem_210544,
                                                           "mem_210544") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210632,
                                                           "ext_mem_210632") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210518,
                                                           "ext_mem_210518") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210529,
                                                           "ext_mem_210529") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209164,
                                                           "mem_param_209164") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209156,
                                                           "mem_param_209156") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212524,
                                                           "ext_mem_212524") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212525,
                                                           "ext_mem_212525") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209142,
                                                           "mem_param_209142") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209134,
                                                           "mem_param_209134") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209126,
                                                           "mem_param_209126") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212853,
                                                           "ext_mem_212853") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212854,
                                                           "ext_mem_212854") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212855,
                                                           "ext_mem_212855") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209118,
                                                           "mem_209118") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209114,
                                                           "mem_209114") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213364,
                                                           "mem_out_213364") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213363,
                                                           "mem_out_213363") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213362,
                                                           "mem_out_213362") !=
                                            0)
                                            return 1;
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    int64_t x_205001 = sdiv64(x_204997,
                                                              jump_s_203499);
                                    int64_t m_v_205002 = add64((int64_t) 1,
                                                               x_205001);
                                    int64_t j_205003;
                                    
                                    if (cond_204983) {
                                        j_205003 = (int64_t) 0;
                                    } else {
                                        int64_t y_205004 = sub64(s_n_m_203636,
                                                                 (int64_t) 1);
                                        bool cond_205005 = m_v_205002 ==
                                             y_205004;
                                        int64_t j_f_res_205006;
                                        
                                        if (cond_205005) {
                                            j_f_res_205006 = x_205001;
                                        } else {
                                            j_f_res_205006 = m_v_205002;
                                        }
                                        j_205003 = j_f_res_205006;
                                    }
                                    
                                    bool cond_205007 = j_205003 == (int64_t) 0;
                                    int64_t defunc_0_m_fun_res_205008;
                                    
                                    if (cond_205007) {
                                        defunc_0_m_fun_res_205008 = (int64_t) 0;
                                    } else {
                                        int64_t y_205009 = sub64(s_n_m_203636,
                                                                 (int64_t) 1);
                                        bool cond_205010 = j_205003 == y_205009;
                                        int64_t defunc_0_m_fun_res_f_res_205011;
                                        
                                        if (cond_205010) {
                                            defunc_0_m_fun_res_f_res_205011 =
                                                y_204988;
                                        } else {
                                            int64_t x_205012 = sub64(j_205003,
                                                                     (int64_t) 1);
                                            int64_t x_205013 =
                                                    mul64(jump_s_203499,
                                                          x_205012);
                                            int64_t min_arg_205014 =
                                                    add64((int64_t) 1,
                                                          x_205013);
                                            int64_t min_res_205015 =
                                                    smin64(defunc_0_f_res_203631,
                                                           min_arg_205014);
                                            
                                            defunc_0_m_fun_res_f_res_205011 =
                                                min_res_205015;
                                        }
                                        defunc_0_m_fun_res_205008 =
                                            defunc_0_m_fun_res_f_res_205011;
                                    }
                                    
                                    int64_t defunc_0_m_fun_arg_205016 =
                                            add64((int64_t) 1, j_205003);
                                    bool cond_205017 =
                                         defunc_0_m_fun_arg_205016 ==
                                         (int64_t) 0;
                                    int64_t defunc_0_m_fun_res_205018;
                                    
                                    if (cond_205017) {
                                        defunc_0_m_fun_res_205018 = (int64_t) 0;
                                    } else {
                                        int64_t y_205019 = sub64(s_n_m_203636,
                                                                 (int64_t) 1);
                                        bool cond_205020 =
                                             defunc_0_m_fun_arg_205016 ==
                                             y_205019;
                                        int64_t defunc_0_m_fun_res_f_res_205021;
                                        
                                        if (cond_205020) {
                                            defunc_0_m_fun_res_f_res_205021 =
                                                y_204988;
                                        } else {
                                            int64_t x_205022 =
                                                    mul64(jump_s_203499,
                                                          j_205003);
                                            int64_t min_arg_205023 =
                                                    add64((int64_t) 1,
                                                          x_205022);
                                            int64_t min_res_205024 =
                                                    smin64(defunc_0_f_res_203631,
                                                           min_arg_205023);
                                            
                                            defunc_0_m_fun_res_f_res_205021 =
                                                min_res_205024;
                                        }
                                        defunc_0_m_fun_res_205018 =
                                            defunc_0_m_fun_res_f_res_205021;
                                    }
                                    
                                    int64_t i64_arg_205025 =
                                            sub64(defunc_0_m_fun_res_205018,
                                                  defunc_0_m_fun_res_205008);
                                    double i64_res_205026 =
                                           sitofp_i64_f64(i64_arg_205025);
                                    int64_t i64_arg_205027 = sub64(i_207205,
                                                                   defunc_0_m_fun_res_205008);
                                    double i64_res_205028 =
                                           sitofp_i64_f64(i64_arg_205027);
                                    double u_205029 = i64_res_205028 /
                                           i64_res_205026;
                                    double u2_205030 = u_205029 * u_205029;
                                    double u3_205031 = u_205029 * u2_205030;
                                    double x_205032 = 2.0 * u3_205031;
                                    double y_205033 = 3.0 * u2_205030;
                                    double x_205034 = x_205032 - y_205033;
                                    double x_205035 = 1.0 + x_205034;
                                    bool x_205036 = sle64((int64_t) 0,
                                                          j_205003);
                                    bool y_205037 = slt64(j_205003,
                                                          s_n_m_203636);
                                    bool bounds_check_205038 = x_205036 &&
                                         y_205037;
                                    bool index_certs_205039;
                                    
                                    if (!bounds_check_205038) {
                                        ctx->error =
                                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                      "Index [",
                                                      (long long) j_205003,
                                                      "] out of bounds for array of shape [",
                                                      (long long) s_n_m_203636,
                                                      "].",
                                                      "-> #0  loess.fut:536:27-33\n   #1  loess.fut:565:15-52\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:557:3-566:9\n   #6  stl.fut:220:31-96\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:219:23-221:48\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:218:15-222:44\n   #13 stl.fut:415:61-429:75\n   #14 stl.fut:455:3-469:34\n   #15 stl.fut:439:1-469:34\n");
                                        if (memblock_unref(ctx, &mem_210544,
                                                           "mem_210544") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210632,
                                                           "ext_mem_210632") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210518,
                                                           "ext_mem_210518") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210529,
                                                           "ext_mem_210529") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209164,
                                                           "mem_param_209164") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209156,
                                                           "mem_param_209156") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212524,
                                                           "ext_mem_212524") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212525,
                                                           "ext_mem_212525") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209142,
                                                           "mem_param_209142") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209134,
                                                           "mem_param_209134") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209126,
                                                           "mem_param_209126") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212853,
                                                           "ext_mem_212853") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212854,
                                                           "ext_mem_212854") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212855,
                                                           "ext_mem_212855") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209118,
                                                           "mem_209118") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209114,
                                                           "mem_209114") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213364,
                                                           "mem_out_213364") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213363,
                                                           "mem_out_213363") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213362,
                                                           "mem_out_213362") !=
                                            0)
                                            return 1;
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    double y_205040;
                                    
                                    y_205040 =
                                        ((double *) ext_mem_210529.mem)[i_207213 *
                                                                        ctx_val_208739 +
                                                                        i_207209 *
                                                                        s_n_m_203636 +
                                                                        j_205003];
                                    
                                    double x_205041 = x_205035 * y_205040;
                                    double x_205042 = y_205033 - x_205032;
                                    bool x_205043 = sle64((int64_t) 0,
                                                          defunc_0_m_fun_arg_205016);
                                    bool y_205044 =
                                         slt64(defunc_0_m_fun_arg_205016,
                                               s_n_m_203636);
                                    bool bounds_check_205045 = x_205043 &&
                                         y_205044;
                                    bool index_certs_205046;
                                    
                                    if (!bounds_check_205045) {
                                        ctx->error =
                                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                      "Index [",
                                                      (long long) defunc_0_m_fun_arg_205016,
                                                      "] out of bounds for array of shape [",
                                                      (long long) s_n_m_203636,
                                                      "].",
                                                      "-> #0  loess.fut:537:27-37\n   #1  loess.fut:565:15-52\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:557:3-566:9\n   #6  stl.fut:220:31-96\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:219:23-221:48\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:218:15-222:44\n   #13 stl.fut:415:61-429:75\n   #14 stl.fut:455:3-469:34\n   #15 stl.fut:439:1-469:34\n");
                                        if (memblock_unref(ctx, &mem_210544,
                                                           "mem_210544") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210632,
                                                           "ext_mem_210632") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210518,
                                                           "ext_mem_210518") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210529,
                                                           "ext_mem_210529") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209164,
                                                           "mem_param_209164") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209156,
                                                           "mem_param_209156") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212524,
                                                           "ext_mem_212524") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212525,
                                                           "ext_mem_212525") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209142,
                                                           "mem_param_209142") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209134,
                                                           "mem_param_209134") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209126,
                                                           "mem_param_209126") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212853,
                                                           "ext_mem_212853") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212854,
                                                           "ext_mem_212854") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212855,
                                                           "ext_mem_212855") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209118,
                                                           "mem_209118") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209114,
                                                           "mem_209114") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213364,
                                                           "mem_out_213364") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213363,
                                                           "mem_out_213363") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213362,
                                                           "mem_out_213362") !=
                                            0)
                                            return 1;
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    double y_205047;
                                    
                                    y_205047 =
                                        ((double *) ext_mem_210529.mem)[i_207213 *
                                                                        ctx_val_208739 +
                                                                        i_207209 *
                                                                        s_n_m_203636 +
                                                                        defunc_0_m_fun_arg_205016];
                                    
                                    double y_205048 = x_205042 * y_205047;
                                    double x_205049 = x_205041 + y_205048;
                                    double y_205050 = 2.0 * u2_205030;
                                    double x_205051 = u3_205031 - y_205050;
                                    double x_205052 = u_205029 + x_205051;
                                    double y_205053;
                                    
                                    y_205053 =
                                        ((double *) ext_mem_210518.mem)[i_207213 *
                                                                        ctx_val_208739 +
                                                                        i_207209 *
                                                                        s_n_m_203636 +
                                                                        j_205003];
                                    
                                    double x_205054 = x_205052 * y_205053;
                                    double y_205055 = i64_res_205026 * x_205054;
                                    double x_205056 = x_205049 + y_205055;
                                    double x_205057 = u3_205031 - u2_205030;
                                    double y_205058;
                                    
                                    y_205058 =
                                        ((double *) ext_mem_210518.mem)[i_207213 *
                                                                        ctx_val_208739 +
                                                                        i_207209 *
                                                                        s_n_m_203636 +
                                                                        defunc_0_m_fun_arg_205016];
                                    
                                    double x_205059 = x_205057 * y_205058;
                                    double y_205060 = i64_res_205026 * x_205059;
                                    double defunc_4_interpolate_proc_res_205061
                                           = x_205056 + y_205060;
                                    
                                    defunc_0_f_res_f_res_204990 =
                                        defunc_4_interpolate_proc_res_205061;
                                }
                                defunc_0_f_res_204984 =
                                    defunc_0_f_res_f_res_204990;
                            }
                            ((double *) mem_210544.mem)[i_207213 *
                                                        ctx_val_210557 +
                                                        i_207209 *
                                                        pad_css_len_203632 +
                                                        i_207205] =
                                defunc_0_f_res_204984;
                        }
                    }
                }
                ext_210636 = ctx_val_210557;
                if (memblock_set(ctx, &ext_mem_210632, &mem_210544,
                                 "mem_210544") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_210544, "mem_210544") != 0)
                    return 1;
            }
            if (memblock_unref(ctx, &ext_mem_210518, "ext_mem_210518") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_210529, "ext_mem_210529") != 0)
                return 1;
            for (int64_t i_207221 = 0; i_207221 < partition_sizze_203577;
                 i_207221++) {
                for (int64_t i_207217 = 0; i_207217 < C_len_203634;
                     i_207217++) {
                    int64_t i_205068 = smod64(i_207217, n_p_203492);
                    bool x_205069 = sle64((int64_t) 0, i_205068);
                    bool y_205070 = slt64(i_205068, n_p_203492);
                    bool bounds_check_205071 = x_205069 && y_205070;
                    int64_t i_205072 = sdiv64(i_207217, n_p_203492);
                    bool x_205073 = sle64((int64_t) 0, i_205072);
                    bool y_205074 = slt64(i_205072, css_results_l_204110);
                    bool bounds_check_205075 = x_205073 && y_205074;
                    bool index_ok_205076 = bounds_check_205071 &&
                         bounds_check_205075;
                    bool index_certs_205077;
                    
                    if (!index_ok_205076) {
                        ctx->error =
                            msgprintf("Error: %s%lld%s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                                      "Index [", (long long) i_205068, ", ",
                                      (long long) i_205072,
                                      "] out of bounds for array of shape [",
                                      (long long) n_p_203492, "][",
                                      (long long) css_results_l_204110, "].",
                                      "-> #0  stl.fut:226:39-67\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:226:28-74\n   #5  stl.fut:225:21-227:39\n   #6  stl.fut:415:61-429:75\n   #7  stl.fut:455:3-469:34\n   #8  stl.fut:439:1-469:34\n");
                        if (memblock_unref(ctx, &ext_mem_210632,
                                           "ext_mem_210632") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_210518,
                                           "ext_mem_210518") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_210529,
                                           "ext_mem_210529") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_param_209164,
                                           "mem_param_209164") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_param_209156,
                                           "mem_param_209156") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_212524,
                                           "ext_mem_212524") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_212525,
                                           "ext_mem_212525") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_param_209142,
                                           "mem_param_209142") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_param_209134,
                                           "mem_param_209134") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_param_209126,
                                           "mem_param_209126") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_212853,
                                           "ext_mem_212853") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_212854,
                                           "ext_mem_212854") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_212855,
                                           "ext_mem_212855") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_209118, "mem_209118") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_209114, "mem_209114") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_213364,
                                           "mem_out_213364") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_213363,
                                           "mem_out_213363") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_213362,
                                           "mem_out_213362") != 0)
                            return 1;
                        err = 1;
                        goto cleanup;
                    }
                    if ((int64_t) 8 > 0)
                        memmove(mem_210643 + (i_207221 * C_len_203634 +
                                              i_207217) * (int64_t) 8,
                                ext_mem_210632.mem + ((int64_t) 0 + i_207221 *
                                                      ext_210636 + i_205068 *
                                                      ext_210635 + (int64_t) 1 *
                                                      i_205072) * (int64_t) 8,
                                (int64_t) 8);
                }
            }
            if (memblock_unref(ctx, &ext_mem_210632, "ext_mem_210632") != 0)
                return 1;
            for (int64_t i_207227 = 0; i_207227 < partition_sizze_203577;
                 i_207227++) {
                double defunc_2_reduce_res_205083;
                double redout_207223 = 0.0;
                
                for (int64_t i_207224 = 0; i_207224 < n_p_203492; i_207224++) {
                    double x_205087;
                    
                    x_205087 = ((double *) mem_210643)[i_207227 * C_len_203634 +
                                                       i_207224];
                    
                    double defunc_1_op_res_205086 = x_205087 + redout_207223;
                    double redout_tmp_213537 = defunc_1_op_res_205086;
                    
                    redout_207223 = redout_tmp_213537;
                }
                defunc_2_reduce_res_205083 = redout_207223;
                ((double *) mem_210686)[i_207227] = defunc_2_reduce_res_205083;
            }
            for (int64_t i_207237 = 0; i_207237 < partition_sizze_203577;
                 i_207237++) {
                double x_205091;
                
                x_205091 = ((double *) mem_210686)[i_207237];
                
                double discard_207234;
                double scanacc_207230 = 0.0;
                
                for (int64_t i_207232 = 0; i_207232 <
                     lifted_single_ma_l_arg_204134; i_207232++) {
                    bool cond_205097 = i_207232 == (int64_t) 0;
                    double defunc_0_f_res_205098;
                    
                    if (cond_205097) {
                        double defunc_0_f_res_t_res_205099 = x_205091 /
                               i64_res_203507;
                        
                        defunc_0_f_res_205098 = defunc_0_f_res_t_res_205099;
                    } else {
                        int64_t x_205100 = add64(n_p_203492, i_207232);
                        int64_t i_205101 = sub64(x_205100, (int64_t) 1);
                        bool x_205102 = sle64((int64_t) 0, i_205101);
                        bool y_205103 = slt64(i_205101, C_len_203634);
                        bool bounds_check_205104 = x_205102 && y_205103;
                        bool index_certs_205105;
                        
                        if (!bounds_check_205104) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) i_205101,
                                          "] out of bounds for array of shape [",
                                          (long long) C_len_203634, "].",
                                          "-> #0  stl.fut:32:23-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:27:13-33:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:26:5-34:23\n   #8  stl.fut:38:3-36\n   #9  stl.fut:231:23-47\n   #10 stl.fut:415:61-429:75\n   #11 stl.fut:455:3-469:34\n   #12 stl.fut:439:1-469:34\n");
                            if (memblock_unref(ctx, &ext_mem_210632,
                                               "ext_mem_210632") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210518,
                                               "ext_mem_210518") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210529,
                                               "ext_mem_210529") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209164,
                                               "mem_param_209164") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209156,
                                               "mem_param_209156") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212524,
                                               "ext_mem_212524") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212525,
                                               "ext_mem_212525") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209142,
                                               "mem_param_209142") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209134,
                                               "mem_param_209134") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209126,
                                               "mem_param_209126") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212853,
                                               "ext_mem_212853") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212854,
                                               "ext_mem_212854") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212855,
                                               "ext_mem_212855") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209118,
                                               "mem_209118") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209114,
                                               "mem_209114") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213364,
                                               "mem_out_213364") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213363,
                                               "mem_out_213363") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213362,
                                               "mem_out_213362") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        double x_205106;
                        
                        x_205106 = ((double *) mem_210643)[i_207237 *
                                                           C_len_203634 +
                                                           i_205101];
                        
                        int64_t i_205107 = sub64(i_207232, (int64_t) 1);
                        bool x_205108 = sle64((int64_t) 0, i_205107);
                        bool y_205109 = slt64(i_205107, C_len_203634);
                        bool bounds_check_205110 = x_205108 && y_205109;
                        bool index_certs_205111;
                        
                        if (!bounds_check_205110) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) i_205107,
                                          "] out of bounds for array of shape [",
                                          (long long) C_len_203634, "].",
                                          "-> #0  stl.fut:32:40-47\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:27:13-33:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:26:5-34:23\n   #8  stl.fut:38:3-36\n   #9  stl.fut:231:23-47\n   #10 stl.fut:415:61-429:75\n   #11 stl.fut:455:3-469:34\n   #12 stl.fut:439:1-469:34\n");
                            if (memblock_unref(ctx, &ext_mem_210632,
                                               "ext_mem_210632") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210518,
                                               "ext_mem_210518") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210529,
                                               "ext_mem_210529") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209164,
                                               "mem_param_209164") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209156,
                                               "mem_param_209156") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212524,
                                               "ext_mem_212524") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212525,
                                               "ext_mem_212525") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209142,
                                               "mem_param_209142") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209134,
                                               "mem_param_209134") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209126,
                                               "mem_param_209126") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212853,
                                               "ext_mem_212853") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212854,
                                               "ext_mem_212854") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212855,
                                               "ext_mem_212855") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209118,
                                               "mem_209118") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209114,
                                               "mem_209114") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213364,
                                               "mem_out_213364") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213363,
                                               "mem_out_213363") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213362,
                                               "mem_out_213362") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        double y_205112;
                        
                        y_205112 = ((double *) mem_210643)[i_207237 *
                                                           C_len_203634 +
                                                           i_205107];
                        
                        double x_205113 = x_205106 - y_205112;
                        double defunc_0_f_res_f_res_205114 = x_205113 /
                               i64_res_203507;
                        
                        defunc_0_f_res_205098 = defunc_0_f_res_f_res_205114;
                    }
                    
                    double defunc_1_op_res_205095 = defunc_0_f_res_205098 +
                           scanacc_207230;
                    
                    ((double *) mem_210715)[i_207232] = defunc_1_op_res_205095;
                    
                    double scanacc_tmp_213539 = defunc_1_op_res_205095;
                    
                    scanacc_207230 = scanacc_tmp_213539;
                }
                discard_207234 = scanacc_207230;
                if (lifted_single_ma_l_arg_204134 * (int64_t) 8 > 0)
                    memmove(mem_210702 + i_207237 *
                            lifted_single_ma_l_arg_204134 * (int64_t) 8,
                            mem_210715 + (int64_t) 0,
                            lifted_single_ma_l_arg_204134 * (int64_t) 8);
            }
            for (int64_t i_207243 = 0; i_207243 < partition_sizze_203577;
                 i_207243++) {
                double defunc_2_reduce_res_205119;
                double redout_207239 = 0.0;
                
                for (int64_t i_207240 = 0; i_207240 < n_p_203492; i_207240++) {
                    double x_205123;
                    
                    x_205123 = ((double *) mem_210702)[i_207243 *
                                                       lifted_single_ma_l_arg_204134 +
                                                       i_207240];
                    
                    double defunc_1_op_res_205122 = x_205123 + redout_207239;
                    double redout_tmp_213542 = defunc_1_op_res_205122;
                    
                    redout_207239 = redout_tmp_213542;
                }
                defunc_2_reduce_res_205119 = redout_207239;
                ((double *) mem_210738)[i_207243] = defunc_2_reduce_res_205119;
            }
            for (int64_t i_207253 = 0; i_207253 < partition_sizze_203577;
                 i_207253++) {
                double x_205127;
                
                x_205127 = ((double *) mem_210738)[i_207253];
                
                double discard_207250;
                double scanacc_207246 = 0.0;
                
                for (int64_t i_207248 = 0; i_207248 <
                     dyn_lifted_single_ma_l_arg_204144; i_207248++) {
                    bool cond_205133 = i_207248 == (int64_t) 0;
                    double defunc_0_f_res_205134;
                    
                    if (cond_205133) {
                        double defunc_0_f_res_t_res_205135 = x_205127 /
                               i64_res_203507;
                        
                        defunc_0_f_res_205134 = defunc_0_f_res_t_res_205135;
                    } else {
                        int64_t x_205136 = add64(n_p_203492, i_207248);
                        int64_t i_205137 = sub64(x_205136, (int64_t) 1);
                        bool x_205138 = sle64((int64_t) 0, i_205137);
                        bool y_205139 = slt64(i_205137,
                                              lifted_single_ma_l_arg_204134);
                        bool bounds_check_205140 = x_205138 && y_205139;
                        bool index_certs_205141;
                        
                        if (!bounds_check_205140) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) i_205137,
                                          "] out of bounds for array of shape [",
                                          (long long) lifted_single_ma_l_arg_204134,
                                          "].",
                                          "-> #0  stl.fut:32:23-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:27:13-33:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:26:5-34:23\n   #8  /prelude/functional.fut:9:42-44\n   #9  stl.fut:38:3-64\n   #10 stl.fut:231:23-47\n   #11 stl.fut:415:61-429:75\n   #12 stl.fut:455:3-469:34\n   #13 stl.fut:439:1-469:34\n");
                            if (memblock_unref(ctx, &ext_mem_210632,
                                               "ext_mem_210632") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210518,
                                               "ext_mem_210518") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210529,
                                               "ext_mem_210529") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209164,
                                               "mem_param_209164") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209156,
                                               "mem_param_209156") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212524,
                                               "ext_mem_212524") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212525,
                                               "ext_mem_212525") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209142,
                                               "mem_param_209142") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209134,
                                               "mem_param_209134") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209126,
                                               "mem_param_209126") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212853,
                                               "ext_mem_212853") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212854,
                                               "ext_mem_212854") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212855,
                                               "ext_mem_212855") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209118,
                                               "mem_209118") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209114,
                                               "mem_209114") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213364,
                                               "mem_out_213364") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213363,
                                               "mem_out_213363") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213362,
                                               "mem_out_213362") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        double x_205142;
                        
                        x_205142 = ((double *) mem_210702)[i_207253 *
                                                           lifted_single_ma_l_arg_204134 +
                                                           i_205137];
                        
                        int64_t i_205143 = sub64(i_207248, (int64_t) 1);
                        bool x_205144 = sle64((int64_t) 0, i_205143);
                        bool y_205145 = slt64(i_205143,
                                              lifted_single_ma_l_arg_204134);
                        bool bounds_check_205146 = x_205144 && y_205145;
                        bool index_certs_205147;
                        
                        if (!bounds_check_205146) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) i_205143,
                                          "] out of bounds for array of shape [",
                                          (long long) lifted_single_ma_l_arg_204134,
                                          "].",
                                          "-> #0  stl.fut:32:40-47\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:27:13-33:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:26:5-34:23\n   #8  /prelude/functional.fut:9:42-44\n   #9  stl.fut:38:3-64\n   #10 stl.fut:231:23-47\n   #11 stl.fut:415:61-429:75\n   #12 stl.fut:455:3-469:34\n   #13 stl.fut:439:1-469:34\n");
                            if (memblock_unref(ctx, &ext_mem_210632,
                                               "ext_mem_210632") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210518,
                                               "ext_mem_210518") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210529,
                                               "ext_mem_210529") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209164,
                                               "mem_param_209164") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209156,
                                               "mem_param_209156") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212524,
                                               "ext_mem_212524") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212525,
                                               "ext_mem_212525") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209142,
                                               "mem_param_209142") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209134,
                                               "mem_param_209134") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209126,
                                               "mem_param_209126") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212853,
                                               "ext_mem_212853") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212854,
                                               "ext_mem_212854") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212855,
                                               "ext_mem_212855") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209118,
                                               "mem_209118") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209114,
                                               "mem_209114") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213364,
                                               "mem_out_213364") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213363,
                                               "mem_out_213363") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213362,
                                               "mem_out_213362") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        double y_205148;
                        
                        y_205148 = ((double *) mem_210702)[i_207253 *
                                                           lifted_single_ma_l_arg_204134 +
                                                           i_205143];
                        
                        double x_205149 = x_205142 - y_205148;
                        double defunc_0_f_res_f_res_205150 = x_205149 /
                               i64_res_203507;
                        
                        defunc_0_f_res_205134 = defunc_0_f_res_f_res_205150;
                    }
                    
                    double defunc_1_op_res_205131 = defunc_0_f_res_205134 +
                           scanacc_207246;
                    
                    ((double *) mem_210767)[i_207248] = defunc_1_op_res_205131;
                    
                    double scanacc_tmp_213544 = defunc_1_op_res_205131;
                    
                    scanacc_207246 = scanacc_tmp_213544;
                }
                discard_207250 = scanacc_207246;
                if (dyn_lifted_single_ma_l_arg_204144 * (int64_t) 8 > 0)
                    memmove(mem_210754 + i_207253 *
                            dyn_lifted_single_ma_l_arg_204144 * (int64_t) 8,
                            mem_210767 + (int64_t) 0,
                            dyn_lifted_single_ma_l_arg_204144 * (int64_t) 8);
            }
            for (int64_t i_207259 = 0; i_207259 < partition_sizze_203577;
                 i_207259++) {
                double defunc_2_reduce_res_205155;
                double redout_207255 = 0.0;
                
                for (int32_t i_207797 = 0; i_207797 < 3; i_207797++) {
                    int64_t i_207256 = sext_i32_i64(i_207797);
                    double x_205159;
                    
                    x_205159 = ((double *) mem_210754)[i_207259 *
                                                       dyn_lifted_single_ma_l_arg_204144 +
                                                       i_207256];
                    
                    double defunc_1_op_res_205158 = x_205159 + redout_207255;
                    double redout_tmp_213547 = defunc_1_op_res_205158;
                    
                    redout_207255 = redout_tmp_213547;
                }
                defunc_2_reduce_res_205155 = redout_207255;
                ((double *) mem_210790)[i_207259] = defunc_2_reduce_res_205155;
            }
            for (int64_t i_207269 = 0; i_207269 < partition_sizze_203577;
                 i_207269++) {
                double x_205163;
                
                x_205163 = ((double *) mem_210790)[i_207269];
                
                double discard_207266;
                double scanacc_207262 = 0.0;
                
                for (int64_t i_207264 = 0; i_207264 < n_203490; i_207264++) {
                    bool cond_205169 = i_207264 == (int64_t) 0;
                    double defunc_0_f_res_205170;
                    
                    if (cond_205169) {
                        double defunc_0_f_res_t_res_205171 = x_205163 / 3.0;
                        
                        defunc_0_f_res_205170 = defunc_0_f_res_t_res_205171;
                    } else {
                        int64_t x_205172 = add64((int64_t) 3, i_207264);
                        int64_t i_205173 = sub64(x_205172, (int64_t) 1);
                        bool x_205174 = sle64((int64_t) 0, i_205173);
                        bool y_205175 = slt64(i_205173,
                                              dyn_lifted_single_ma_l_arg_204144);
                        bool bounds_check_205176 = x_205174 && y_205175;
                        bool index_certs_205177;
                        
                        if (!bounds_check_205176) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) i_205173,
                                          "] out of bounds for array of shape [",
                                          (long long) dyn_lifted_single_ma_l_arg_204144,
                                          "].",
                                          "-> #0  stl.fut:32:23-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:27:13-33:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:26:5-34:23\n   #8  /prelude/functional.fut:9:42-44\n   #9  stl.fut:38:3-84\n   #10 stl.fut:231:23-47\n   #11 stl.fut:415:61-429:75\n   #12 stl.fut:455:3-469:34\n   #13 stl.fut:439:1-469:34\n");
                            if (memblock_unref(ctx, &ext_mem_210632,
                                               "ext_mem_210632") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210518,
                                               "ext_mem_210518") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210529,
                                               "ext_mem_210529") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209164,
                                               "mem_param_209164") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209156,
                                               "mem_param_209156") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212524,
                                               "ext_mem_212524") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212525,
                                               "ext_mem_212525") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209142,
                                               "mem_param_209142") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209134,
                                               "mem_param_209134") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209126,
                                               "mem_param_209126") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212853,
                                               "ext_mem_212853") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212854,
                                               "ext_mem_212854") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212855,
                                               "ext_mem_212855") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209118,
                                               "mem_209118") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209114,
                                               "mem_209114") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213364,
                                               "mem_out_213364") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213363,
                                               "mem_out_213363") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213362,
                                               "mem_out_213362") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        double x_205178;
                        
                        x_205178 = ((double *) mem_210754)[i_207269 *
                                                           dyn_lifted_single_ma_l_arg_204144 +
                                                           i_205173];
                        
                        int64_t i_205179 = sub64(i_207264, (int64_t) 1);
                        bool x_205180 = sle64((int64_t) 0, i_205179);
                        bool y_205181 = slt64(i_205179,
                                              dyn_lifted_single_ma_l_arg_204144);
                        bool bounds_check_205182 = x_205180 && y_205181;
                        bool index_certs_205183;
                        
                        if (!bounds_check_205182) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) i_205179,
                                          "] out of bounds for array of shape [",
                                          (long long) dyn_lifted_single_ma_l_arg_204144,
                                          "].",
                                          "-> #0  stl.fut:32:40-47\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:27:13-33:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:26:5-34:23\n   #8  /prelude/functional.fut:9:42-44\n   #9  stl.fut:38:3-84\n   #10 stl.fut:231:23-47\n   #11 stl.fut:415:61-429:75\n   #12 stl.fut:455:3-469:34\n   #13 stl.fut:439:1-469:34\n");
                            if (memblock_unref(ctx, &ext_mem_210632,
                                               "ext_mem_210632") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210518,
                                               "ext_mem_210518") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210529,
                                               "ext_mem_210529") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209164,
                                               "mem_param_209164") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209156,
                                               "mem_param_209156") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212524,
                                               "ext_mem_212524") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212525,
                                               "ext_mem_212525") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209142,
                                               "mem_param_209142") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209134,
                                               "mem_param_209134") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209126,
                                               "mem_param_209126") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212853,
                                               "ext_mem_212853") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212854,
                                               "ext_mem_212854") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212855,
                                               "ext_mem_212855") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209118,
                                               "mem_209118") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209114,
                                               "mem_209114") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213364,
                                               "mem_out_213364") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213363,
                                               "mem_out_213363") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213362,
                                               "mem_out_213362") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        double y_205184;
                        
                        y_205184 = ((double *) mem_210754)[i_207269 *
                                                           dyn_lifted_single_ma_l_arg_204144 +
                                                           i_205179];
                        
                        double x_205185 = x_205178 - y_205184;
                        double defunc_0_f_res_f_res_205186 = x_205185 / 3.0;
                        
                        defunc_0_f_res_205170 = defunc_0_f_res_f_res_205186;
                    }
                    
                    double defunc_1_op_res_205167 = defunc_0_f_res_205170 +
                           scanacc_207262;
                    
                    ((double *) mem_210819)[i_207264] = defunc_1_op_res_205167;
                    
                    double scanacc_tmp_213549 = defunc_1_op_res_205167;
                    
                    scanacc_207262 = scanacc_tmp_213549;
                }
                discard_207266 = scanacc_207262;
                if (n_203490 * (int64_t) 8 > 0)
                    memmove(mem_210806 + i_207269 * n_203490 * (int64_t) 8,
                            mem_210819 + (int64_t) 0, n_203490 * (int64_t) 8);
            }
            
            struct memblock ext_mem_211465;
            
            ext_mem_211465.references = NULL;
            
            struct memblock ext_mem_211457;
            
            ext_mem_211457.references = NULL;
            if (cond_204160) {
                bool match_lit_205190 = (int64_t) 0 == d_l_203498;
                struct memblock ext_mem_211088;
                
                ext_mem_211088.references = NULL;
                
                struct memblock ext_mem_211080;
                
                ext_mem_211080.references = NULL;
                if (match_lit_205190) {
                    struct memblock mem_210843;
                    
                    mem_210843.references = NULL;
                    if (memblock_alloc(ctx, &mem_210843, bytes_208907,
                                       "mem_210843")) {
                        err = 1;
                        goto cleanup;
                    }
                    for (int64_t i_213551 = 0; i_213551 <
                         partition_sizze_203577; i_213551++) {
                        for (int64_t i_213552 = 0; i_213552 < l_n_m_203643;
                             i_213552++) {
                            ((double *) mem_210843.mem)[i_213551 *
                                                        l_n_m_203643 +
                                                        i_213552] = 0.0;
                        }
                    }
                    
                    struct memblock mem_210847;
                    
                    mem_210847.references = NULL;
                    if (memblock_alloc(ctx, &mem_210847, bytes_208907,
                                       "mem_210847")) {
                        err = 1;
                        goto cleanup;
                    }
                    for (int64_t i_207281 = 0; i_207281 <
                         partition_sizze_203577; i_207281++) {
                        for (int64_t i_207277 = 0; i_207277 < l_n_m_203643;
                             i_207277++) {
                            int64_t x_205202;
                            
                            x_205202 = ((int64_t *) mem_208908)[i_207281 *
                                                                l_n_m_203643 +
                                                                i_207277];
                            
                            double x_205203;
                            
                            x_205203 = ((double *) mem_208912)[i_207281 *
                                                               l_n_m_203643 +
                                                               i_207277];
                            
                            int64_t min_arg_205204 = mul64(jump_t_203500,
                                                           i_207277);
                            int64_t min_res_205205 = smin64(i_203670,
                                                            min_arg_205204);
                            int64_t defunc_0_g_res_205206 = add64((int64_t) 1,
                                                                  min_res_205205);
                            double defunc_2_reduce_res_205207;
                            double redout_207271 = 0.0;
                            
                            for (int64_t i_207272 = 0; i_207272 < q_l_203495;
                                 i_207272++) {
                                bool cond_205212 = sle64(n_203490, i_207272);
                                int64_t defunc_0_f_res_205213;
                                
                                if (cond_205212) {
                                    defunc_0_f_res_205213 = (int64_t) 0;
                                } else {
                                    int64_t i_205214 = add64(x_205202,
                                                             i_207272);
                                    int64_t defunc_1_add_res_205215 =
                                            add64((int64_t) 1, i_205214);
                                    
                                    defunc_0_f_res_205213 =
                                        defunc_1_add_res_205215;
                                }
                                
                                double defunc_0_f_res_205216;
                                
                                if (cond_205212) {
                                    defunc_0_f_res_205216 = 0.0;
                                } else {
                                    int64_t i_205217 = add64(x_205202,
                                                             i_207272);
                                    double defunc_0_add_arg_205218;
                                    
                                    defunc_0_add_arg_205218 =
                                        ((double *) mem_param_209142.mem)[ctx_param_ext_209137 +
                                                                          (i_207281 *
                                                                           ctx_param_ext_209138 +
                                                                           i_205217 *
                                                                           ctx_param_ext_209140)];
                                    defunc_0_f_res_205216 =
                                        defunc_0_add_arg_205218;
                                }
                                
                                int64_t binop_p_205219 =
                                        sub64(defunc_0_f_res_205213,
                                              defunc_0_g_res_205206);
                                double defunc_0_f_res_205220 =
                                       sitofp_i64_f64(binop_p_205219);
                                double abs_res_205221 =
                                       fabs(defunc_0_f_res_205220);
                                double tmp1_205222 = abs_res_205221 / x_205203;
                                double x_205223 = tmp1_205222 * tmp1_205222;
                                double y_205224 = tmp1_205222 * x_205223;
                                double tmp2_205225 = 1.0 - y_205224;
                                double x_205226 = tmp2_205225 * tmp2_205225;
                                double tmp3_205227 = tmp2_205225 * x_205226;
                                double w_j_205228 = defunc_0_f_res_205216 *
                                       tmp3_205227;
                                double defunc_1_op_res_205210 = w_j_205228 +
                                       redout_207271;
                                double redout_tmp_213555 =
                                       defunc_1_op_res_205210;
                                
                                redout_207271 = redout_tmp_213555;
                            }
                            defunc_2_reduce_res_205207 = redout_207271;
                            
                            double a0_205229 = 1.0 / defunc_2_reduce_res_205207;
                            double defunc_2_reduce_res_205230;
                            double redout_207273 = 0.0;
                            
                            for (int64_t i_207274 = 0; i_207274 < q_l_203495;
                                 i_207274++) {
                                bool cond_205235 = sle64(n_203490, i_207274);
                                int64_t defunc_0_f_res_205236;
                                
                                if (cond_205235) {
                                    defunc_0_f_res_205236 = (int64_t) 0;
                                } else {
                                    int64_t i_205237 = add64(x_205202,
                                                             i_207274);
                                    int64_t defunc_1_add_res_205238 =
                                            add64((int64_t) 1, i_205237);
                                    
                                    defunc_0_f_res_205236 =
                                        defunc_1_add_res_205238;
                                }
                                
                                double defunc_0_f_res_205239;
                                
                                if (cond_205235) {
                                    defunc_0_f_res_205239 = 0.0;
                                } else {
                                    int64_t i_205240 = add64(x_205202,
                                                             i_207274);
                                    double defunc_0_add_arg_205241;
                                    
                                    defunc_0_add_arg_205241 =
                                        ((double *) mem_param_209142.mem)[ctx_param_ext_209137 +
                                                                          (i_207281 *
                                                                           ctx_param_ext_209138 +
                                                                           i_205240 *
                                                                           ctx_param_ext_209140)];
                                    defunc_0_f_res_205239 =
                                        defunc_0_add_arg_205241;
                                }
                                
                                int64_t binop_p_205242 =
                                        sub64(defunc_0_f_res_205236,
                                              defunc_0_g_res_205206);
                                double defunc_0_f_res_205243 =
                                       sitofp_i64_f64(binop_p_205242);
                                double abs_res_205244 =
                                       fabs(defunc_0_f_res_205243);
                                double tmp1_205245 = abs_res_205244 / x_205203;
                                double x_205246 = tmp1_205245 * tmp1_205245;
                                double y_205247 = tmp1_205245 * x_205246;
                                double tmp2_205248 = 1.0 - y_205247;
                                double x_205249 = tmp2_205248 * tmp2_205248;
                                double tmp3_205250 = tmp2_205248 * x_205249;
                                double tmp4_205251 = defunc_0_f_res_205239 *
                                       tmp3_205250;
                                double defunc_0_f_res_205252;
                                
                                if (cond_205235) {
                                    defunc_0_f_res_205252 = 0.0;
                                } else {
                                    int64_t i_205253 = add64(x_205202,
                                                             i_207274);
                                    double defunc_0_add_arg_205254;
                                    
                                    defunc_0_add_arg_205254 =
                                        ((double *) mem_210806)[i_207281 *
                                                                n_203490 +
                                                                i_205253];
                                    defunc_0_f_res_205252 =
                                        defunc_0_add_arg_205254;
                                }
                                
                                double x_205255 = a0_205229 * tmp4_205251;
                                double defunc_9_fit_fun_res_205256 =
                                       defunc_0_f_res_205252 * x_205255;
                                double defunc_1_op_res_205233 =
                                       defunc_9_fit_fun_res_205256 +
                                       redout_207273;
                                double redout_tmp_213556 =
                                       defunc_1_op_res_205233;
                                
                                redout_207273 = redout_tmp_213556;
                            }
                            defunc_2_reduce_res_205230 = redout_207273;
                            ((double *) mem_210847.mem)[i_207281 *
                                                        l_n_m_203643 +
                                                        i_207277] =
                                defunc_2_reduce_res_205230;
                        }
                    }
                    if (memblock_set(ctx, &ext_mem_211088, &mem_210847,
                                     "mem_210847") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_211080, &mem_210843,
                                     "mem_210843") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_210847, "mem_210847") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_210843, "mem_210843") != 0)
                        return 1;
                } else {
                    bool match_lit_205259 = (int64_t) 1 == d_l_203498;
                    struct memblock ext_mem_211072;
                    
                    ext_mem_211072.references = NULL;
                    
                    struct memblock ext_mem_211064;
                    
                    ext_mem_211064.references = NULL;
                    if (match_lit_205259) {
                        struct memblock mem_210891;
                        
                        mem_210891.references = NULL;
                        if (memblock_alloc(ctx, &mem_210891, bytes_208907,
                                           "mem_210891")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_210895;
                        
                        mem_210895.references = NULL;
                        if (memblock_alloc(ctx, &mem_210895, bytes_208907,
                                           "mem_210895")) {
                            err = 1;
                            goto cleanup;
                        }
                        for (int64_t i_207301 = 0; i_207301 <
                             partition_sizze_203577; i_207301++) {
                            for (int64_t i_207294 = 0; i_207294 < l_n_m_203643;
                                 i_207294++) {
                                int64_t x_205272;
                                
                                x_205272 = ((int64_t *) mem_208908)[i_207301 *
                                                                    l_n_m_203643 +
                                                                    i_207294];
                                
                                double x_205273;
                                
                                x_205273 = ((double *) mem_208912)[i_207301 *
                                                                   l_n_m_203643 +
                                                                   i_207294];
                                
                                int64_t min_arg_205274 = mul64(jump_t_203500,
                                                               i_207294);
                                int64_t min_res_205275 = smin64(i_203670,
                                                                min_arg_205274);
                                int64_t defunc_0_g_res_205276 =
                                        add64((int64_t) 1, min_res_205275);
                                double defunc_2_reduce_res_205277;
                                double defunc_2_reduce_res_205278;
                                double defunc_2_reduce_res_205279;
                                double redout_207283;
                                double redout_207284;
                                double redout_207285;
                                
                                redout_207283 = 0.0;
                                redout_207284 = 0.0;
                                redout_207285 = 0.0;
                                for (int64_t i_207286 = 0; i_207286 <
                                     q_l_203495; i_207286++) {
                                    bool cond_205290 = sle64(n_203490,
                                                             i_207286);
                                    int64_t defunc_0_f_res_205291;
                                    
                                    if (cond_205290) {
                                        defunc_0_f_res_205291 = (int64_t) 0;
                                    } else {
                                        int64_t i_205292 = add64(x_205272,
                                                                 i_207286);
                                        int64_t defunc_1_add_res_205293 =
                                                add64((int64_t) 1, i_205292);
                                        
                                        defunc_0_f_res_205291 =
                                            defunc_1_add_res_205293;
                                    }
                                    
                                    double defunc_0_f_res_205294;
                                    
                                    if (cond_205290) {
                                        defunc_0_f_res_205294 = 0.0;
                                    } else {
                                        int64_t i_205295 = add64(x_205272,
                                                                 i_207286);
                                        double defunc_0_add_arg_205296;
                                        
                                        defunc_0_add_arg_205296 =
                                            ((double *) mem_param_209142.mem)[ctx_param_ext_209137 +
                                                                              (i_207301 *
                                                                               ctx_param_ext_209138 +
                                                                               i_205295 *
                                                                               ctx_param_ext_209140)];
                                        defunc_0_f_res_205294 =
                                            defunc_0_add_arg_205296;
                                    }
                                    
                                    int64_t binop_p_205297 =
                                            sub64(defunc_0_f_res_205291,
                                                  defunc_0_g_res_205276);
                                    double defunc_0_f_res_205298 =
                                           sitofp_i64_f64(binop_p_205297);
                                    double abs_res_205299 =
                                           fabs(defunc_0_f_res_205298);
                                    double tmp1_205300 = abs_res_205299 /
                                           x_205273;
                                    double x_205301 = tmp1_205300 * tmp1_205300;
                                    double y_205302 = tmp1_205300 * x_205301;
                                    double tmp2_205303 = 1.0 - y_205302;
                                    double x_205304 = tmp2_205303 * tmp2_205303;
                                    double tmp3_205305 = tmp2_205303 * x_205304;
                                    double w_j_205306 = defunc_0_f_res_205294 *
                                           tmp3_205305;
                                    double xw_j_205307 = defunc_0_f_res_205298 *
                                           w_j_205306;
                                    double x2w_j_205308 =
                                           defunc_0_f_res_205298 * xw_j_205307;
                                    double defunc_1_op_res_205282 = w_j_205306 +
                                           redout_207283;
                                    double defunc_1_op_res_205285 =
                                           xw_j_205307 + redout_207284;
                                    double defunc_1_op_res_205288 =
                                           x2w_j_205308 + redout_207285;
                                    double redout_tmp_213561 =
                                           defunc_1_op_res_205282;
                                    double redout_tmp_213562 =
                                           defunc_1_op_res_205285;
                                    double redout_tmp_213563 =
                                           defunc_1_op_res_205288;
                                    
                                    redout_207283 = redout_tmp_213561;
                                    redout_207284 = redout_tmp_213562;
                                    redout_207285 = redout_tmp_213563;
                                }
                                defunc_2_reduce_res_205277 = redout_207283;
                                defunc_2_reduce_res_205278 = redout_207284;
                                defunc_2_reduce_res_205279 = redout_207285;
                                
                                double x_205309 = defunc_2_reduce_res_205277 *
                                       defunc_2_reduce_res_205279;
                                double y_205310 = defunc_2_reduce_res_205278 *
                                       defunc_2_reduce_res_205278;
                                double y_205311 = x_205309 - y_205310;
                                double det1_205312 = 1.0 / y_205311;
                                double a11_205313 = defunc_2_reduce_res_205279 *
                                       det1_205312;
                                double x_205314 = 0.0 -
                                       defunc_2_reduce_res_205278;
                                double b11_205315 = det1_205312 * x_205314;
                                double c11_205316 = defunc_2_reduce_res_205277 *
                                       det1_205312;
                                double defunc_2_reduce_res_205317;
                                double defunc_2_reduce_res_205318;
                                double redout_207287;
                                double redout_207288;
                                
                                redout_207287 = 0.0;
                                redout_207288 = 0.0;
                                for (int64_t i_207289 = 0; i_207289 <
                                     q_l_203495; i_207289++) {
                                    bool cond_205326 = sle64(n_203490,
                                                             i_207289);
                                    int64_t defunc_0_f_res_205327;
                                    
                                    if (cond_205326) {
                                        defunc_0_f_res_205327 = (int64_t) 0;
                                    } else {
                                        int64_t i_205328 = add64(x_205272,
                                                                 i_207289);
                                        int64_t defunc_1_add_res_205329 =
                                                add64((int64_t) 1, i_205328);
                                        
                                        defunc_0_f_res_205327 =
                                            defunc_1_add_res_205329;
                                    }
                                    
                                    double defunc_0_f_res_205330;
                                    
                                    if (cond_205326) {
                                        defunc_0_f_res_205330 = 0.0;
                                    } else {
                                        int64_t i_205331 = add64(x_205272,
                                                                 i_207289);
                                        double defunc_0_add_arg_205332;
                                        
                                        defunc_0_add_arg_205332 =
                                            ((double *) mem_param_209142.mem)[ctx_param_ext_209137 +
                                                                              (i_207301 *
                                                                               ctx_param_ext_209138 +
                                                                               i_205331 *
                                                                               ctx_param_ext_209140)];
                                        defunc_0_f_res_205330 =
                                            defunc_0_add_arg_205332;
                                    }
                                    
                                    int64_t binop_p_205333 =
                                            sub64(defunc_0_f_res_205327,
                                                  defunc_0_g_res_205276);
                                    double defunc_0_f_res_205334 =
                                           sitofp_i64_f64(binop_p_205333);
                                    double abs_res_205335 =
                                           fabs(defunc_0_f_res_205334);
                                    double tmp1_205336 = abs_res_205335 /
                                           x_205273;
                                    double x_205337 = tmp1_205336 * tmp1_205336;
                                    double y_205338 = tmp1_205336 * x_205337;
                                    double tmp2_205339 = 1.0 - y_205338;
                                    double x_205340 = tmp2_205339 * tmp2_205339;
                                    double tmp3_205341 = tmp2_205339 * x_205340;
                                    double tmp4_205342 = defunc_0_f_res_205330 *
                                           tmp3_205341;
                                    double defunc_1_f_res_205343 =
                                           defunc_0_f_res_205334 * tmp4_205342;
                                    double defunc_0_f_res_205344;
                                    
                                    if (cond_205326) {
                                        defunc_0_f_res_205344 = 0.0;
                                    } else {
                                        int64_t i_205345 = add64(x_205272,
                                                                 i_207289);
                                        double defunc_0_add_arg_205346;
                                        
                                        defunc_0_add_arg_205346 =
                                            ((double *) mem_210806)[i_207301 *
                                                                    n_203490 +
                                                                    i_205345];
                                        defunc_0_f_res_205344 =
                                            defunc_0_add_arg_205346;
                                    }
                                    
                                    double x_205347 = a11_205313 * tmp4_205342;
                                    double y_205348 = b11_205315 *
                                           defunc_1_f_res_205343;
                                    double x_205349 = x_205347 + y_205348;
                                    double defunc_9_fit_fun_res_205350 =
                                           defunc_0_f_res_205344 * x_205349;
                                    double x_205351 = b11_205315 * tmp4_205342;
                                    double y_205352 = c11_205316 *
                                           defunc_1_f_res_205343;
                                    double x_205353 = x_205351 + y_205352;
                                    double defunc_9_slope_fun_res_205354 =
                                           defunc_0_f_res_205344 * x_205353;
                                    double defunc_1_op_res_205321 =
                                           defunc_9_fit_fun_res_205350 +
                                           redout_207287;
                                    double defunc_1_op_res_205324 =
                                           defunc_9_slope_fun_res_205354 +
                                           redout_207288;
                                    double redout_tmp_213564 =
                                           defunc_1_op_res_205321;
                                    double redout_tmp_213565 =
                                           defunc_1_op_res_205324;
                                    
                                    redout_207287 = redout_tmp_213564;
                                    redout_207288 = redout_tmp_213565;
                                }
                                defunc_2_reduce_res_205317 = redout_207287;
                                defunc_2_reduce_res_205318 = redout_207288;
                                ((double *) mem_210891.mem)[i_207301 *
                                                            l_n_m_203643 +
                                                            i_207294] =
                                    defunc_2_reduce_res_205317;
                                ((double *) mem_210895.mem)[i_207301 *
                                                            l_n_m_203643 +
                                                            i_207294] =
                                    defunc_2_reduce_res_205318;
                            }
                        }
                        if (memblock_set(ctx, &ext_mem_211072, &mem_210891,
                                         "mem_210891") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_211064, &mem_210895,
                                         "mem_210895") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_210895, "mem_210895") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_210891, "mem_210891") != 0)
                            return 1;
                    } else {
                        struct memblock mem_210979;
                        
                        mem_210979.references = NULL;
                        if (memblock_alloc(ctx, &mem_210979, bytes_208907,
                                           "mem_210979")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_210983;
                        
                        mem_210983.references = NULL;
                        if (memblock_alloc(ctx, &mem_210983, bytes_208907,
                                           "mem_210983")) {
                            err = 1;
                            goto cleanup;
                        }
                        for (int64_t i_207324 = 0; i_207324 <
                             partition_sizze_203577; i_207324++) {
                            for (int64_t i_207317 = 0; i_207317 < l_n_m_203643;
                                 i_207317++) {
                                int64_t x_205367;
                                
                                x_205367 = ((int64_t *) mem_208908)[i_207324 *
                                                                    l_n_m_203643 +
                                                                    i_207317];
                                
                                double x_205368;
                                
                                x_205368 = ((double *) mem_208912)[i_207324 *
                                                                   l_n_m_203643 +
                                                                   i_207317];
                                
                                int64_t min_arg_205369 = mul64(jump_t_203500,
                                                               i_207317);
                                int64_t min_res_205370 = smin64(i_203670,
                                                                min_arg_205369);
                                int64_t defunc_0_g_res_205371 =
                                        add64((int64_t) 1, min_res_205370);
                                double defunc_2_reduce_res_205372;
                                double defunc_2_reduce_res_205373;
                                double defunc_2_reduce_res_205374;
                                double defunc_2_reduce_res_205375;
                                double defunc_2_reduce_res_205376;
                                double redout_207304;
                                double redout_207305;
                                double redout_207306;
                                double redout_207307;
                                double redout_207308;
                                
                                redout_207304 = 0.0;
                                redout_207305 = 0.0;
                                redout_207306 = 0.0;
                                redout_207307 = 0.0;
                                redout_207308 = 0.0;
                                for (int64_t i_207309 = 0; i_207309 <
                                     q_l_203495; i_207309++) {
                                    bool cond_205393 = sle64(n_203490,
                                                             i_207309);
                                    int64_t defunc_0_f_res_205394;
                                    
                                    if (cond_205393) {
                                        defunc_0_f_res_205394 = (int64_t) 0;
                                    } else {
                                        int64_t i_205395 = add64(x_205367,
                                                                 i_207309);
                                        int64_t defunc_1_add_res_205396 =
                                                add64((int64_t) 1, i_205395);
                                        
                                        defunc_0_f_res_205394 =
                                            defunc_1_add_res_205396;
                                    }
                                    
                                    double defunc_0_f_res_205397;
                                    
                                    if (cond_205393) {
                                        defunc_0_f_res_205397 = 0.0;
                                    } else {
                                        int64_t i_205398 = add64(x_205367,
                                                                 i_207309);
                                        double defunc_0_add_arg_205399;
                                        
                                        defunc_0_add_arg_205399 =
                                            ((double *) mem_param_209142.mem)[ctx_param_ext_209137 +
                                                                              (i_207324 *
                                                                               ctx_param_ext_209138 +
                                                                               i_205398 *
                                                                               ctx_param_ext_209140)];
                                        defunc_0_f_res_205397 =
                                            defunc_0_add_arg_205399;
                                    }
                                    
                                    int64_t binop_p_205400 =
                                            sub64(defunc_0_f_res_205394,
                                                  defunc_0_g_res_205371);
                                    double defunc_0_f_res_205401 =
                                           sitofp_i64_f64(binop_p_205400);
                                    double abs_res_205402 =
                                           fabs(defunc_0_f_res_205401);
                                    double tmp1_205403 = abs_res_205402 /
                                           x_205368;
                                    double x_205404 = tmp1_205403 * tmp1_205403;
                                    double y_205405 = tmp1_205403 * x_205404;
                                    double tmp2_205406 = 1.0 - y_205405;
                                    double x_205407 = tmp2_205406 * tmp2_205406;
                                    double tmp3_205408 = tmp2_205406 * x_205407;
                                    double w_j_205409 = defunc_0_f_res_205397 *
                                           tmp3_205408;
                                    double xw_j_205410 = defunc_0_f_res_205401 *
                                           w_j_205409;
                                    double x2w_j_205411 =
                                           defunc_0_f_res_205401 * xw_j_205410;
                                    double x3w_j_205412 =
                                           defunc_0_f_res_205401 * x2w_j_205411;
                                    double x4w_j_205413 =
                                           defunc_0_f_res_205401 * x3w_j_205412;
                                    double defunc_1_op_res_205379 = w_j_205409 +
                                           redout_207304;
                                    double defunc_1_op_res_205382 =
                                           xw_j_205410 + redout_207305;
                                    double defunc_1_op_res_205385 =
                                           x2w_j_205411 + redout_207306;
                                    double defunc_1_op_res_205388 =
                                           x3w_j_205412 + redout_207307;
                                    double defunc_1_op_res_205391 =
                                           x4w_j_205413 + redout_207308;
                                    double redout_tmp_213570 =
                                           defunc_1_op_res_205379;
                                    double redout_tmp_213571 =
                                           defunc_1_op_res_205382;
                                    double redout_tmp_213572 =
                                           defunc_1_op_res_205385;
                                    double redout_tmp_213573 =
                                           defunc_1_op_res_205388;
                                    double redout_tmp_213574 =
                                           defunc_1_op_res_205391;
                                    
                                    redout_207304 = redout_tmp_213570;
                                    redout_207305 = redout_tmp_213571;
                                    redout_207306 = redout_tmp_213572;
                                    redout_207307 = redout_tmp_213573;
                                    redout_207308 = redout_tmp_213574;
                                }
                                defunc_2_reduce_res_205372 = redout_207304;
                                defunc_2_reduce_res_205373 = redout_207305;
                                defunc_2_reduce_res_205374 = redout_207306;
                                defunc_2_reduce_res_205375 = redout_207307;
                                defunc_2_reduce_res_205376 = redout_207308;
                                
                                double x_205414 = defunc_2_reduce_res_205374 *
                                       defunc_2_reduce_res_205376;
                                double y_205415 = defunc_2_reduce_res_205375 *
                                       defunc_2_reduce_res_205375;
                                double a12_205416 = x_205414 - y_205415;
                                double x_205417 = defunc_2_reduce_res_205374 *
                                       defunc_2_reduce_res_205375;
                                double y_205418 = defunc_2_reduce_res_205373 *
                                       defunc_2_reduce_res_205376;
                                double b12_205419 = x_205417 - y_205418;
                                double x_205420 = defunc_2_reduce_res_205373 *
                                       defunc_2_reduce_res_205375;
                                double y_205421 = defunc_2_reduce_res_205374 *
                                       defunc_2_reduce_res_205374;
                                double c12_205422 = x_205420 - y_205421;
                                double x_205423 = defunc_2_reduce_res_205372 *
                                       defunc_2_reduce_res_205376;
                                double b2_205424 = x_205423 - y_205421;
                                double x_205425 = defunc_2_reduce_res_205373 *
                                       defunc_2_reduce_res_205374;
                                double y_205426 = defunc_2_reduce_res_205372 *
                                       defunc_2_reduce_res_205375;
                                double c2_205427 = x_205425 - y_205426;
                                double x_205428 = defunc_2_reduce_res_205372 *
                                       a12_205416;
                                double y_205429 = defunc_2_reduce_res_205373 *
                                       b12_205419;
                                double x_205430 = x_205428 + y_205429;
                                double y_205431 = defunc_2_reduce_res_205374 *
                                       c12_205422;
                                double y_205432 = x_205430 + y_205431;
                                double det_205433 = 1.0 / y_205432;
                                double a12_205434 = a12_205416 * det_205433;
                                double b12_205435 = b12_205419 * det_205433;
                                double c12_205436 = c12_205422 * det_205433;
                                double b2_205437 = b2_205424 * det_205433;
                                double c2_205438 = c2_205427 * det_205433;
                                double defunc_2_reduce_res_205439;
                                double defunc_2_reduce_res_205440;
                                double redout_207310;
                                double redout_207311;
                                
                                redout_207310 = 0.0;
                                redout_207311 = 0.0;
                                for (int64_t i_207312 = 0; i_207312 <
                                     q_l_203495; i_207312++) {
                                    bool cond_205448 = sle64(n_203490,
                                                             i_207312);
                                    int64_t defunc_0_f_res_205449;
                                    
                                    if (cond_205448) {
                                        defunc_0_f_res_205449 = (int64_t) 0;
                                    } else {
                                        int64_t i_205450 = add64(x_205367,
                                                                 i_207312);
                                        int64_t defunc_1_add_res_205451 =
                                                add64((int64_t) 1, i_205450);
                                        
                                        defunc_0_f_res_205449 =
                                            defunc_1_add_res_205451;
                                    }
                                    
                                    double defunc_0_f_res_205452;
                                    
                                    if (cond_205448) {
                                        defunc_0_f_res_205452 = 0.0;
                                    } else {
                                        int64_t i_205453 = add64(x_205367,
                                                                 i_207312);
                                        double defunc_0_add_arg_205454;
                                        
                                        defunc_0_add_arg_205454 =
                                            ((double *) mem_param_209142.mem)[ctx_param_ext_209137 +
                                                                              (i_207324 *
                                                                               ctx_param_ext_209138 +
                                                                               i_205453 *
                                                                               ctx_param_ext_209140)];
                                        defunc_0_f_res_205452 =
                                            defunc_0_add_arg_205454;
                                    }
                                    
                                    int64_t binop_p_205455 =
                                            sub64(defunc_0_f_res_205449,
                                                  defunc_0_g_res_205371);
                                    double defunc_0_f_res_205456 =
                                           sitofp_i64_f64(binop_p_205455);
                                    double abs_res_205457 =
                                           fabs(defunc_0_f_res_205456);
                                    double tmp1_205458 = abs_res_205457 /
                                           x_205368;
                                    double x_205459 = tmp1_205458 * tmp1_205458;
                                    double y_205460 = tmp1_205458 * x_205459;
                                    double tmp2_205461 = 1.0 - y_205460;
                                    double x_205462 = tmp2_205461 * tmp2_205461;
                                    double tmp3_205463 = tmp2_205461 * x_205462;
                                    double tmp4_205464 = defunc_0_f_res_205452 *
                                           tmp3_205463;
                                    double defunc_1_f_res_205465 =
                                           defunc_0_f_res_205456 * tmp4_205464;
                                    double defunc_1_f_res_205466 =
                                           defunc_0_f_res_205456 *
                                           defunc_1_f_res_205465;
                                    double defunc_0_f_res_205467;
                                    
                                    if (cond_205448) {
                                        defunc_0_f_res_205467 = 0.0;
                                    } else {
                                        int64_t i_205468 = add64(x_205367,
                                                                 i_207312);
                                        double defunc_0_add_arg_205469;
                                        
                                        defunc_0_add_arg_205469 =
                                            ((double *) mem_210806)[i_207324 *
                                                                    n_203490 +
                                                                    i_205468];
                                        defunc_0_f_res_205467 =
                                            defunc_0_add_arg_205469;
                                    }
                                    
                                    double x_205470 = a12_205434 * tmp4_205464;
                                    double y_205471 = b12_205435 *
                                           defunc_1_f_res_205465;
                                    double x_205472 = x_205470 + y_205471;
                                    double y_205473 = c12_205436 *
                                           defunc_1_f_res_205466;
                                    double x_205474 = x_205472 + y_205473;
                                    double defunc_9_fit_fun_res_205475 =
                                           defunc_0_f_res_205467 * x_205474;
                                    double x_205476 = b12_205435 * tmp4_205464;
                                    double y_205477 = b2_205437 *
                                           defunc_1_f_res_205465;
                                    double x_205478 = x_205476 + y_205477;
                                    double y_205479 = c2_205438 *
                                           defunc_1_f_res_205466;
                                    double x_205480 = x_205478 + y_205479;
                                    double defunc_9_slope_fun_res_205481 =
                                           defunc_0_f_res_205467 * x_205480;
                                    double defunc_1_op_res_205443 =
                                           defunc_9_fit_fun_res_205475 +
                                           redout_207310;
                                    double defunc_1_op_res_205446 =
                                           defunc_9_slope_fun_res_205481 +
                                           redout_207311;
                                    double redout_tmp_213575 =
                                           defunc_1_op_res_205443;
                                    double redout_tmp_213576 =
                                           defunc_1_op_res_205446;
                                    
                                    redout_207310 = redout_tmp_213575;
                                    redout_207311 = redout_tmp_213576;
                                }
                                defunc_2_reduce_res_205439 = redout_207310;
                                defunc_2_reduce_res_205440 = redout_207311;
                                ((double *) mem_210979.mem)[i_207324 *
                                                            l_n_m_203643 +
                                                            i_207317] =
                                    defunc_2_reduce_res_205439;
                                ((double *) mem_210983.mem)[i_207324 *
                                                            l_n_m_203643 +
                                                            i_207317] =
                                    defunc_2_reduce_res_205440;
                            }
                        }
                        if (memblock_set(ctx, &ext_mem_211072, &mem_210979,
                                         "mem_210979") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_211064, &mem_210983,
                                         "mem_210983") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_210983, "mem_210983") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_210979, "mem_210979") != 0)
                            return 1;
                    }
                    if (memblock_set(ctx, &ext_mem_211088, &ext_mem_211072,
                                     "ext_mem_211072") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_211080, &ext_mem_211064,
                                     "ext_mem_211064") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_211064,
                                       "ext_mem_211064") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_211072,
                                       "ext_mem_211072") != 0)
                        return 1;
                }
                if (memblock_set(ctx, &ext_mem_211465, &ext_mem_211088,
                                 "ext_mem_211088") != 0)
                    return 1;
                if (memblock_set(ctx, &ext_mem_211457, &ext_mem_211080,
                                 "ext_mem_211080") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_211080, "ext_mem_211080") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_211088, "ext_mem_211088") != 0)
                    return 1;
            } else {
                bool match_lit_205484 = (int64_t) 0 == d_l_203498;
                int64_t binop_y_211125 = (int64_t) 8 * q_l_203495;
                int64_t bytes_211126 = smax64((int64_t) 0, binop_y_211125);
                struct memblock ext_mem_211449;
                
                ext_mem_211449.references = NULL;
                
                struct memblock ext_mem_211441;
                
                ext_mem_211441.references = NULL;
                if (match_lit_205484) {
                    struct memblock mem_211099;
                    
                    mem_211099.references = NULL;
                    if (memblock_alloc(ctx, &mem_211099, bytes_208907,
                                       "mem_211099")) {
                        err = 1;
                        goto cleanup;
                    }
                    for (int64_t i_213577 = 0; i_213577 <
                         partition_sizze_203577; i_213577++) {
                        for (int64_t i_213578 = 0; i_213578 < l_n_m_203643;
                             i_213578++) {
                            ((double *) mem_211099.mem)[i_213577 *
                                                        l_n_m_203643 +
                                                        i_213578] = 0.0;
                        }
                    }
                    
                    struct memblock mem_211103;
                    
                    mem_211103.references = NULL;
                    if (memblock_alloc(ctx, &mem_211103, bytes_208907,
                                       "mem_211103")) {
                        err = 1;
                        goto cleanup;
                    }
                    if (mem_211127_cached_sizze_213771 <
                        (size_t) bytes_211126) {
                        mem_211127 = realloc(mem_211127, bytes_211126);
                        mem_211127_cached_sizze_213771 = bytes_211126;
                    }
                    for (int64_t i_207340 = 0; i_207340 <
                         partition_sizze_203577; i_207340++) {
                        for (int64_t i_207336 = 0; i_207336 < l_n_m_203643;
                             i_207336++) {
                            int64_t x_205496;
                            
                            x_205496 = ((int64_t *) mem_208908)[i_207340 *
                                                                l_n_m_203643 +
                                                                i_207336];
                            
                            double x_205497;
                            
                            x_205497 = ((double *) mem_208912)[i_207340 *
                                                               l_n_m_203643 +
                                                               i_207336];
                            
                            int64_t min_arg_205498 = mul64(jump_t_203500,
                                                           i_207336);
                            int64_t min_res_205499 = smin64(i_203670,
                                                            min_arg_205498);
                            int64_t defunc_0_g_res_205500 = add64((int64_t) 1,
                                                                  min_res_205499);
                            double defunc_2_reduce_res_205501;
                            double redout_207328 = 0.0;
                            
                            for (int64_t i_207330 = 0; i_207330 < q_l_203495;
                                 i_207330++) {
                                bool cond_205507 = sle64(n_203490, i_207330);
                                int64_t defunc_0_f_res_205508;
                                
                                if (cond_205507) {
                                    defunc_0_f_res_205508 = (int64_t) 0;
                                } else {
                                    int64_t i_205509 = add64(x_205496,
                                                             i_207330);
                                    int64_t defunc_1_add_res_205510 =
                                            add64((int64_t) 1, i_205509);
                                    
                                    defunc_0_f_res_205508 =
                                        defunc_1_add_res_205510;
                                }
                                
                                double defunc_0_f_res_205511;
                                
                                if (cond_205507) {
                                    defunc_0_f_res_205511 = 0.0;
                                } else {
                                    int64_t i_205512 = add64(x_205496,
                                                             i_207330);
                                    double defunc_0_add_arg_205513;
                                    
                                    defunc_0_add_arg_205513 =
                                        ((double *) mem_param_209142.mem)[ctx_param_ext_209137 +
                                                                          (i_207340 *
                                                                           ctx_param_ext_209138 +
                                                                           i_205512 *
                                                                           ctx_param_ext_209140)];
                                    defunc_0_f_res_205511 =
                                        defunc_0_add_arg_205513;
                                }
                                
                                int64_t binop_p_205514 =
                                        sub64(defunc_0_f_res_205508,
                                              defunc_0_g_res_205500);
                                double defunc_0_f_res_205515 =
                                       sitofp_i64_f64(binop_p_205514);
                                double abs_res_205516 =
                                       fabs(defunc_0_f_res_205515);
                                double tmp1_205517 = abs_res_205516 / x_205497;
                                double x_205518 = tmp1_205517 * tmp1_205517;
                                double y_205519 = tmp1_205517 * x_205518;
                                double tmp2_205520 = 1.0 - y_205519;
                                double x_205521 = tmp2_205520 * tmp2_205520;
                                double tmp3_205522 = tmp2_205520 * x_205521;
                                double tmp4_205523 = defunc_0_f_res_205511 *
                                       tmp3_205522;
                                double defunc_1_op_res_205505 = tmp4_205523 +
                                       redout_207328;
                                
                                ((double *) mem_211127)[i_207330] = tmp4_205523;
                                
                                double redout_tmp_213581 =
                                       defunc_1_op_res_205505;
                                
                                redout_207328 = redout_tmp_213581;
                            }
                            defunc_2_reduce_res_205501 = redout_207328;
                            
                            double a0_205524 = 1.0 / defunc_2_reduce_res_205501;
                            double defunc_2_reduce_res_205525;
                            double redout_207332 = 0.0;
                            
                            for (int64_t i_207333 = 0; i_207333 < q_l_203495;
                                 i_207333++) {
                                double x_205530;
                                
                                x_205530 = ((double *) mem_211127)[i_207333];
                                
                                bool cond_205531 = sle64(n_203490, i_207333);
                                double defunc_0_f_res_205532;
                                
                                if (cond_205531) {
                                    defunc_0_f_res_205532 = 0.0;
                                } else {
                                    int64_t i_205533 = add64(x_205496,
                                                             i_207333);
                                    double defunc_0_add_arg_205534;
                                    
                                    defunc_0_add_arg_205534 =
                                        ((double *) mem_210806)[i_207340 *
                                                                n_203490 +
                                                                i_205533];
                                    defunc_0_f_res_205532 =
                                        defunc_0_add_arg_205534;
                                }
                                
                                double x_205535 = a0_205524 * x_205530;
                                double defunc_9_fit_fun_res_205536 =
                                       defunc_0_f_res_205532 * x_205535;
                                double defunc_1_op_res_205528 =
                                       defunc_9_fit_fun_res_205536 +
                                       redout_207332;
                                double redout_tmp_213583 =
                                       defunc_1_op_res_205528;
                                
                                redout_207332 = redout_tmp_213583;
                            }
                            defunc_2_reduce_res_205525 = redout_207332;
                            ((double *) mem_211103.mem)[i_207340 *
                                                        l_n_m_203643 +
                                                        i_207336] =
                                defunc_2_reduce_res_205525;
                        }
                    }
                    if (memblock_set(ctx, &ext_mem_211449, &mem_211103,
                                     "mem_211103") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_211441, &mem_211099,
                                     "mem_211099") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_211103, "mem_211103") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_211099, "mem_211099") != 0)
                        return 1;
                } else {
                    bool match_lit_205539 = (int64_t) 1 == d_l_203498;
                    int64_t binop_y_211209 = (int64_t) 8 * q_l_203495;
                    int64_t bytes_211210 = smax64((int64_t) 0, binop_y_211209);
                    int64_t binop_y_211327 = (int64_t) 8 * q_l_203495;
                    int64_t bytes_211328 = smax64((int64_t) 0, binop_y_211327);
                    struct memblock ext_mem_211433;
                    
                    ext_mem_211433.references = NULL;
                    
                    struct memblock ext_mem_211425;
                    
                    ext_mem_211425.references = NULL;
                    if (match_lit_205539) {
                        struct memblock mem_211162;
                        
                        mem_211162.references = NULL;
                        if (memblock_alloc(ctx, &mem_211162, bytes_208907,
                                           "mem_211162")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_211166;
                        
                        mem_211166.references = NULL;
                        if (memblock_alloc(ctx, &mem_211166, bytes_208907,
                                           "mem_211166")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (mem_211211_cached_sizze_213772 <
                            (size_t) bytes_211210) {
                            mem_211211 = realloc(mem_211211, bytes_211210);
                            mem_211211_cached_sizze_213772 = bytes_211210;
                        }
                        if (mem_211214_cached_sizze_213773 <
                            (size_t) bytes_211210) {
                            mem_211214 = realloc(mem_211214, bytes_211210);
                            mem_211214_cached_sizze_213773 = bytes_211210;
                        }
                        for (int64_t i_207366 = 0; i_207366 <
                             partition_sizze_203577; i_207366++) {
                            for (int64_t i_207359 = 0; i_207359 < l_n_m_203643;
                                 i_207359++) {
                                int64_t x_205552;
                                
                                x_205552 = ((int64_t *) mem_208908)[i_207366 *
                                                                    l_n_m_203643 +
                                                                    i_207359];
                                
                                double x_205553;
                                
                                x_205553 = ((double *) mem_208912)[i_207366 *
                                                                   l_n_m_203643 +
                                                                   i_207359];
                                
                                int64_t min_arg_205554 = mul64(jump_t_203500,
                                                               i_207359);
                                int64_t min_res_205555 = smin64(i_203670,
                                                                min_arg_205554);
                                int64_t defunc_0_g_res_205556 =
                                        add64((int64_t) 1, min_res_205555);
                                double defunc_2_reduce_res_205579;
                                double defunc_2_reduce_res_205580;
                                double defunc_2_reduce_res_205581;
                                double redout_207344;
                                double redout_207345;
                                double redout_207346;
                                
                                redout_207344 = 0.0;
                                redout_207345 = 0.0;
                                redout_207346 = 0.0;
                                for (int64_t i_207349 = 0; i_207349 <
                                     q_l_203495; i_207349++) {
                                    bool cond_205594 = sle64(n_203490,
                                                             i_207349);
                                    int64_t defunc_0_f_res_205595;
                                    
                                    if (cond_205594) {
                                        defunc_0_f_res_205595 = (int64_t) 0;
                                    } else {
                                        int64_t i_205596 = add64(x_205552,
                                                                 i_207349);
                                        int64_t defunc_1_add_res_205597 =
                                                add64((int64_t) 1, i_205596);
                                        
                                        defunc_0_f_res_205595 =
                                            defunc_1_add_res_205597;
                                    }
                                    
                                    double defunc_0_f_res_205598;
                                    
                                    if (cond_205594) {
                                        defunc_0_f_res_205598 = 0.0;
                                    } else {
                                        int64_t i_205599 = add64(x_205552,
                                                                 i_207349);
                                        double defunc_0_add_arg_205600;
                                        
                                        defunc_0_add_arg_205600 =
                                            ((double *) mem_param_209142.mem)[ctx_param_ext_209137 +
                                                                              (i_207366 *
                                                                               ctx_param_ext_209138 +
                                                                               i_205599 *
                                                                               ctx_param_ext_209140)];
                                        defunc_0_f_res_205598 =
                                            defunc_0_add_arg_205600;
                                    }
                                    
                                    int64_t binop_p_205601 =
                                            sub64(defunc_0_f_res_205595,
                                                  defunc_0_g_res_205556);
                                    double defunc_0_f_res_205602 =
                                           sitofp_i64_f64(binop_p_205601);
                                    double abs_res_205603 =
                                           fabs(defunc_0_f_res_205602);
                                    double tmp1_205604 = abs_res_205603 /
                                           x_205553;
                                    double x_205605 = tmp1_205604 * tmp1_205604;
                                    double y_205606 = tmp1_205604 * x_205605;
                                    double tmp2_205607 = 1.0 - y_205606;
                                    double x_205608 = tmp2_205607 * tmp2_205607;
                                    double tmp3_205609 = tmp2_205607 * x_205608;
                                    double tmp4_205610 = defunc_0_f_res_205598 *
                                           tmp3_205609;
                                    double defunc_1_f_res_205611 =
                                           defunc_0_f_res_205602 * tmp4_205610;
                                    double defunc_1_f_res_205612 =
                                           defunc_0_f_res_205602 *
                                           defunc_1_f_res_205611;
                                    double defunc_1_op_res_205586 =
                                           tmp4_205610 + redout_207344;
                                    double defunc_1_op_res_205589 =
                                           defunc_1_f_res_205611 +
                                           redout_207345;
                                    double defunc_1_op_res_205592 =
                                           defunc_1_f_res_205612 +
                                           redout_207346;
                                    
                                    ((double *) mem_211211)[i_207349] =
                                        defunc_1_f_res_205611;
                                    ((double *) mem_211214)[i_207349] =
                                        tmp4_205610;
                                    
                                    double redout_tmp_213588 =
                                           defunc_1_op_res_205586;
                                    double redout_tmp_213589 =
                                           defunc_1_op_res_205589;
                                    double redout_tmp_213590 =
                                           defunc_1_op_res_205592;
                                    
                                    redout_207344 = redout_tmp_213588;
                                    redout_207345 = redout_tmp_213589;
                                    redout_207346 = redout_tmp_213590;
                                }
                                defunc_2_reduce_res_205579 = redout_207344;
                                defunc_2_reduce_res_205580 = redout_207345;
                                defunc_2_reduce_res_205581 = redout_207346;
                                
                                double x_205618 = defunc_2_reduce_res_205579 *
                                       defunc_2_reduce_res_205581;
                                double y_205619 = defunc_2_reduce_res_205580 *
                                       defunc_2_reduce_res_205580;
                                double y_205620 = x_205618 - y_205619;
                                double det1_205621 = 1.0 / y_205620;
                                double a11_205622 = defunc_2_reduce_res_205581 *
                                       det1_205621;
                                double x_205623 = 0.0 -
                                       defunc_2_reduce_res_205580;
                                double b11_205624 = det1_205621 * x_205623;
                                double c11_205625 = defunc_2_reduce_res_205579 *
                                       det1_205621;
                                double defunc_2_reduce_res_205626;
                                double defunc_2_reduce_res_205627;
                                double redout_207352;
                                double redout_207353;
                                
                                redout_207352 = 0.0;
                                redout_207353 = 0.0;
                                for (int64_t i_207354 = 0; i_207354 <
                                     q_l_203495; i_207354++) {
                                    double x_205635;
                                    
                                    x_205635 =
                                        ((double *) mem_211214)[i_207354];
                                    
                                    double x_205636;
                                    
                                    x_205636 =
                                        ((double *) mem_211211)[i_207354];
                                    
                                    bool cond_205637 = sle64(n_203490,
                                                             i_207354);
                                    double defunc_0_f_res_205638;
                                    
                                    if (cond_205637) {
                                        defunc_0_f_res_205638 = 0.0;
                                    } else {
                                        int64_t i_205639 = add64(x_205552,
                                                                 i_207354);
                                        double defunc_0_add_arg_205640;
                                        
                                        defunc_0_add_arg_205640 =
                                            ((double *) mem_210806)[i_207366 *
                                                                    n_203490 +
                                                                    i_205639];
                                        defunc_0_f_res_205638 =
                                            defunc_0_add_arg_205640;
                                    }
                                    
                                    double x_205641 = a11_205622 * x_205635;
                                    double y_205642 = b11_205624 * x_205636;
                                    double x_205643 = x_205641 + y_205642;
                                    double defunc_9_fit_fun_res_205644 =
                                           defunc_0_f_res_205638 * x_205643;
                                    double x_205645 = b11_205624 * x_205635;
                                    double y_205646 = c11_205625 * x_205636;
                                    double x_205647 = x_205645 + y_205646;
                                    double defunc_9_slope_fun_res_205648 =
                                           defunc_0_f_res_205638 * x_205647;
                                    double defunc_1_op_res_205630 =
                                           defunc_9_fit_fun_res_205644 +
                                           redout_207352;
                                    double defunc_1_op_res_205633 =
                                           defunc_9_slope_fun_res_205648 +
                                           redout_207353;
                                    double redout_tmp_213593 =
                                           defunc_1_op_res_205630;
                                    double redout_tmp_213594 =
                                           defunc_1_op_res_205633;
                                    
                                    redout_207352 = redout_tmp_213593;
                                    redout_207353 = redout_tmp_213594;
                                }
                                defunc_2_reduce_res_205626 = redout_207352;
                                defunc_2_reduce_res_205627 = redout_207353;
                                ((double *) mem_211162.mem)[i_207366 *
                                                            l_n_m_203643 +
                                                            i_207359] =
                                    defunc_2_reduce_res_205626;
                                ((double *) mem_211166.mem)[i_207366 *
                                                            l_n_m_203643 +
                                                            i_207359] =
                                    defunc_2_reduce_res_205627;
                            }
                        }
                        if (memblock_set(ctx, &ext_mem_211433, &mem_211162,
                                         "mem_211162") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_211425, &mem_211166,
                                         "mem_211166") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_211166, "mem_211166") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_211162, "mem_211162") != 0)
                            return 1;
                    } else {
                        struct memblock mem_211280;
                        
                        mem_211280.references = NULL;
                        if (memblock_alloc(ctx, &mem_211280, bytes_208907,
                                           "mem_211280")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_211284;
                        
                        mem_211284.references = NULL;
                        if (memblock_alloc(ctx, &mem_211284, bytes_208907,
                                           "mem_211284")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (mem_211329_cached_sizze_213774 <
                            (size_t) bytes_211328) {
                            mem_211329 = realloc(mem_211329, bytes_211328);
                            mem_211329_cached_sizze_213774 = bytes_211328;
                        }
                        if (mem_211332_cached_sizze_213775 <
                            (size_t) bytes_211328) {
                            mem_211332 = realloc(mem_211332, bytes_211328);
                            mem_211332_cached_sizze_213775 = bytes_211328;
                        }
                        if (mem_211359_cached_sizze_213776 <
                            (size_t) bytes_211328) {
                            mem_211359 = realloc(mem_211359, bytes_211328);
                            mem_211359_cached_sizze_213776 = bytes_211328;
                        }
                        if (mem_211362_cached_sizze_213777 <
                            (size_t) bytes_211328) {
                            mem_211362 = realloc(mem_211362, bytes_211328);
                            mem_211362_cached_sizze_213777 = bytes_211328;
                        }
                        for (int64_t i_207402 = 0; i_207402 <
                             partition_sizze_203577; i_207402++) {
                            for (int64_t i_207395 = 0; i_207395 < l_n_m_203643;
                                 i_207395++) {
                                int64_t x_205661;
                                
                                x_205661 = ((int64_t *) mem_208908)[i_207402 *
                                                                    l_n_m_203643 +
                                                                    i_207395];
                                
                                double x_205662;
                                
                                x_205662 = ((double *) mem_208912)[i_207402 *
                                                                   l_n_m_203643 +
                                                                   i_207395];
                                
                                int64_t min_arg_205663 = mul64(jump_t_203500,
                                                               i_207395);
                                int64_t min_res_205664 = smin64(i_203670,
                                                                min_arg_205663);
                                int64_t defunc_0_g_res_205665 =
                                        add64((int64_t) 1, min_res_205664);
                                
                                for (int64_t i_207373 = 0; i_207373 <
                                     q_l_203495; i_207373++) {
                                    bool cond_205669 = sle64(n_203490,
                                                             i_207373);
                                    int64_t defunc_0_f_res_205670;
                                    
                                    if (cond_205669) {
                                        defunc_0_f_res_205670 = (int64_t) 0;
                                    } else {
                                        int64_t i_205671 = add64(x_205661,
                                                                 i_207373);
                                        int64_t defunc_1_add_res_205672 =
                                                add64((int64_t) 1, i_205671);
                                        
                                        defunc_0_f_res_205670 =
                                            defunc_1_add_res_205672;
                                    }
                                    
                                    double defunc_0_f_res_205673;
                                    
                                    if (cond_205669) {
                                        defunc_0_f_res_205673 = 0.0;
                                    } else {
                                        int64_t i_205674 = add64(x_205661,
                                                                 i_207373);
                                        double defunc_0_add_arg_205675;
                                        
                                        defunc_0_add_arg_205675 =
                                            ((double *) mem_param_209142.mem)[ctx_param_ext_209137 +
                                                                              (i_207402 *
                                                                               ctx_param_ext_209138 +
                                                                               i_205674 *
                                                                               ctx_param_ext_209140)];
                                        defunc_0_f_res_205673 =
                                            defunc_0_add_arg_205675;
                                    }
                                    
                                    int64_t binop_p_205676 =
                                            sub64(defunc_0_f_res_205670,
                                                  defunc_0_g_res_205665);
                                    double defunc_0_f_res_205677 =
                                           sitofp_i64_f64(binop_p_205676);
                                    double abs_res_205678 =
                                           fabs(defunc_0_f_res_205677);
                                    double tmp1_205679 = abs_res_205678 /
                                           x_205662;
                                    double x_205680 = tmp1_205679 * tmp1_205679;
                                    double y_205681 = tmp1_205679 * x_205680;
                                    double tmp2_205682 = 1.0 - y_205681;
                                    double x_205683 = tmp2_205682 * tmp2_205682;
                                    double tmp3_205684 = tmp2_205682 * x_205683;
                                    double tmp4_205685 = defunc_0_f_res_205673 *
                                           tmp3_205684;
                                    
                                    ((double *) mem_211329)[i_207373] =
                                        defunc_0_f_res_205677;
                                    ((double *) mem_211332)[i_207373] =
                                        tmp4_205685;
                                }
                                
                                double defunc_2_reduce_res_205692;
                                double defunc_2_reduce_res_205693;
                                double defunc_2_reduce_res_205694;
                                double defunc_2_reduce_res_205695;
                                double defunc_2_reduce_res_205696;
                                double redout_207378;
                                double redout_207379;
                                double redout_207380;
                                double redout_207381;
                                double redout_207382;
                                
                                redout_207378 = 0.0;
                                redout_207379 = 0.0;
                                redout_207380 = 0.0;
                                redout_207381 = 0.0;
                                redout_207382 = 0.0;
                                for (int64_t i_207385 = 0; i_207385 <
                                     q_l_203495; i_207385++) {
                                    double x_205714;
                                    
                                    x_205714 =
                                        ((double *) mem_211329)[i_207385];
                                    
                                    double x_205715;
                                    
                                    x_205715 =
                                        ((double *) mem_211332)[i_207385];
                                    
                                    double defunc_1_f_res_205716 = x_205714 *
                                           x_205715;
                                    double defunc_1_f_res_205717 = x_205714 *
                                           defunc_1_f_res_205716;
                                    double defunc_1_f_res_205718 = x_205714 *
                                           defunc_1_f_res_205717;
                                    double defunc_1_f_res_205719 = x_205714 *
                                           defunc_1_f_res_205718;
                                    double defunc_1_op_res_205701 = x_205715 +
                                           redout_207378;
                                    double defunc_1_op_res_205704 =
                                           defunc_1_f_res_205716 +
                                           redout_207379;
                                    double defunc_1_op_res_205707 =
                                           defunc_1_f_res_205717 +
                                           redout_207380;
                                    double defunc_1_op_res_205710 =
                                           defunc_1_f_res_205718 +
                                           redout_207381;
                                    double defunc_1_op_res_205713 =
                                           defunc_1_f_res_205719 +
                                           redout_207382;
                                    
                                    ((double *) mem_211359)[i_207385] =
                                        defunc_1_f_res_205717;
                                    ((double *) mem_211362)[i_207385] =
                                        defunc_1_f_res_205716;
                                    
                                    double redout_tmp_213601 =
                                           defunc_1_op_res_205701;
                                    double redout_tmp_213602 =
                                           defunc_1_op_res_205704;
                                    double redout_tmp_213603 =
                                           defunc_1_op_res_205707;
                                    double redout_tmp_213604 =
                                           defunc_1_op_res_205710;
                                    double redout_tmp_213605 =
                                           defunc_1_op_res_205713;
                                    
                                    redout_207378 = redout_tmp_213601;
                                    redout_207379 = redout_tmp_213602;
                                    redout_207380 = redout_tmp_213603;
                                    redout_207381 = redout_tmp_213604;
                                    redout_207382 = redout_tmp_213605;
                                }
                                defunc_2_reduce_res_205692 = redout_207378;
                                defunc_2_reduce_res_205693 = redout_207379;
                                defunc_2_reduce_res_205694 = redout_207380;
                                defunc_2_reduce_res_205695 = redout_207381;
                                defunc_2_reduce_res_205696 = redout_207382;
                                
                                double x_205727 = defunc_2_reduce_res_205694 *
                                       defunc_2_reduce_res_205696;
                                double y_205728 = defunc_2_reduce_res_205695 *
                                       defunc_2_reduce_res_205695;
                                double a12_205729 = x_205727 - y_205728;
                                double x_205730 = defunc_2_reduce_res_205694 *
                                       defunc_2_reduce_res_205695;
                                double y_205731 = defunc_2_reduce_res_205693 *
                                       defunc_2_reduce_res_205696;
                                double b12_205732 = x_205730 - y_205731;
                                double x_205733 = defunc_2_reduce_res_205693 *
                                       defunc_2_reduce_res_205695;
                                double y_205734 = defunc_2_reduce_res_205694 *
                                       defunc_2_reduce_res_205694;
                                double c12_205735 = x_205733 - y_205734;
                                double x_205736 = defunc_2_reduce_res_205692 *
                                       defunc_2_reduce_res_205696;
                                double b2_205737 = x_205736 - y_205734;
                                double x_205738 = defunc_2_reduce_res_205693 *
                                       defunc_2_reduce_res_205694;
                                double y_205739 = defunc_2_reduce_res_205692 *
                                       defunc_2_reduce_res_205695;
                                double c2_205740 = x_205738 - y_205739;
                                double x_205741 = defunc_2_reduce_res_205692 *
                                       a12_205729;
                                double y_205742 = defunc_2_reduce_res_205693 *
                                       b12_205732;
                                double x_205743 = x_205741 + y_205742;
                                double y_205744 = defunc_2_reduce_res_205694 *
                                       c12_205735;
                                double y_205745 = x_205743 + y_205744;
                                double det_205746 = 1.0 / y_205745;
                                double a12_205747 = a12_205729 * det_205746;
                                double b12_205748 = b12_205732 * det_205746;
                                double c12_205749 = c12_205735 * det_205746;
                                double b2_205750 = b2_205737 * det_205746;
                                double c2_205751 = c2_205740 * det_205746;
                                double defunc_2_reduce_res_205752;
                                double defunc_2_reduce_res_205753;
                                double redout_207388;
                                double redout_207389;
                                
                                redout_207388 = 0.0;
                                redout_207389 = 0.0;
                                for (int64_t i_207390 = 0; i_207390 <
                                     q_l_203495; i_207390++) {
                                    double x_205761;
                                    
                                    x_205761 =
                                        ((double *) mem_211332)[i_207390];
                                    
                                    double x_205762;
                                    
                                    x_205762 =
                                        ((double *) mem_211362)[i_207390];
                                    
                                    double x_205763;
                                    
                                    x_205763 =
                                        ((double *) mem_211359)[i_207390];
                                    
                                    bool cond_205764 = sle64(n_203490,
                                                             i_207390);
                                    double defunc_0_f_res_205765;
                                    
                                    if (cond_205764) {
                                        defunc_0_f_res_205765 = 0.0;
                                    } else {
                                        int64_t i_205766 = add64(x_205661,
                                                                 i_207390);
                                        double defunc_0_add_arg_205767;
                                        
                                        defunc_0_add_arg_205767 =
                                            ((double *) mem_210806)[i_207402 *
                                                                    n_203490 +
                                                                    i_205766];
                                        defunc_0_f_res_205765 =
                                            defunc_0_add_arg_205767;
                                    }
                                    
                                    double x_205768 = a12_205747 * x_205761;
                                    double y_205769 = b12_205748 * x_205762;
                                    double x_205770 = x_205768 + y_205769;
                                    double y_205771 = c12_205749 * x_205763;
                                    double x_205772 = x_205770 + y_205771;
                                    double defunc_9_fit_fun_res_205773 =
                                           defunc_0_f_res_205765 * x_205772;
                                    double x_205774 = b12_205748 * x_205761;
                                    double y_205775 = b2_205750 * x_205762;
                                    double x_205776 = x_205774 + y_205775;
                                    double y_205777 = c2_205751 * x_205763;
                                    double x_205778 = x_205776 + y_205777;
                                    double defunc_9_slope_fun_res_205779 =
                                           defunc_0_f_res_205765 * x_205778;
                                    double defunc_1_op_res_205756 =
                                           defunc_9_fit_fun_res_205773 +
                                           redout_207388;
                                    double defunc_1_op_res_205759 =
                                           defunc_9_slope_fun_res_205779 +
                                           redout_207389;
                                    double redout_tmp_213608 =
                                           defunc_1_op_res_205756;
                                    double redout_tmp_213609 =
                                           defunc_1_op_res_205759;
                                    
                                    redout_207388 = redout_tmp_213608;
                                    redout_207389 = redout_tmp_213609;
                                }
                                defunc_2_reduce_res_205752 = redout_207388;
                                defunc_2_reduce_res_205753 = redout_207389;
                                ((double *) mem_211280.mem)[i_207402 *
                                                            l_n_m_203643 +
                                                            i_207395] =
                                    defunc_2_reduce_res_205752;
                                ((double *) mem_211284.mem)[i_207402 *
                                                            l_n_m_203643 +
                                                            i_207395] =
                                    defunc_2_reduce_res_205753;
                            }
                        }
                        if (memblock_set(ctx, &ext_mem_211433, &mem_211280,
                                         "mem_211280") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_211425, &mem_211284,
                                         "mem_211284") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_211284, "mem_211284") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_211280, "mem_211280") != 0)
                            return 1;
                    }
                    if (memblock_set(ctx, &ext_mem_211449, &ext_mem_211433,
                                     "ext_mem_211433") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_211441, &ext_mem_211425,
                                     "ext_mem_211425") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_211425,
                                       "ext_mem_211425") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_211433,
                                       "ext_mem_211433") != 0)
                        return 1;
                }
                if (memblock_set(ctx, &ext_mem_211465, &ext_mem_211449,
                                 "ext_mem_211449") != 0)
                    return 1;
                if (memblock_set(ctx, &ext_mem_211457, &ext_mem_211441,
                                 "ext_mem_211441") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_211441, "ext_mem_211441") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_211449, "ext_mem_211449") != 0)
                    return 1;
            }
            
            struct memblock ext_mem_211517;
            
            ext_mem_211517.references = NULL;
            if (cond_204107) {
                bool zzero_205783 = jump_l_203501 == (int64_t) 0;
                bool nonzzero_205784 = !zzero_205783;
                bool nonzzero_cert_205785;
                
                if (!nonzzero_205784) {
                    ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                                           "division by zero",
                                           "-> #0  loess.fut:547:20-27\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:546:3-550:9\n   #5  stl.fut:252:23-75\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:250:15-253:43\n   #9  stl.fut:415:61-429:75\n   #10 stl.fut:455:3-469:34\n   #11 stl.fut:439:1-469:34\n");
                    if (memblock_unref(ctx, &ext_mem_211517,
                                       "ext_mem_211517") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_211457,
                                       "ext_mem_211457") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_211465,
                                       "ext_mem_211465") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_210632,
                                       "ext_mem_210632") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_210518,
                                       "ext_mem_210518") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_210529,
                                       "ext_mem_210529") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209164,
                                       "mem_param_209164") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209156,
                                       "mem_param_209156") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212524,
                                       "ext_mem_212524") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212525,
                                       "ext_mem_212525") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209142,
                                       "mem_param_209142") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209134,
                                       "mem_param_209134") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209126,
                                       "mem_param_209126") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212853,
                                       "ext_mem_212853") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212854,
                                       "ext_mem_212854") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212855,
                                       "ext_mem_212855") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_209118, "mem_209118") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_209114, "mem_209114") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213364,
                                       "mem_out_213364") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213363,
                                       "mem_out_213363") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213362,
                                       "mem_out_213362") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                int64_t y_205786 = sub64(l_n_m_203643, (int64_t) 1);
                struct memblock mem_211476;
                
                mem_211476.references = NULL;
                if (memblock_alloc(ctx, &mem_211476, bytes_208391,
                                   "mem_211476")) {
                    err = 1;
                    goto cleanup;
                }
                for (int64_t i_207411 = 0; i_207411 < partition_sizze_203577;
                     i_207411++) {
                    for (int64_t i_207407 = 0; i_207407 < n_203490;
                         i_207407++) {
                        int64_t m_v_205792 = sdiv64(i_207407, jump_l_203501);
                        bool cond_205793 = m_v_205792 == y_205786;
                        int64_t j_205794;
                        
                        if (cond_205793) {
                            int64_t j_t_res_205795 = sub64(m_v_205792,
                                                           (int64_t) 1);
                            
                            j_205794 = j_t_res_205795;
                        } else {
                            j_205794 = m_v_205792;
                        }
                        
                        int64_t min_arg_205796 = mul64(jump_l_203501, j_205794);
                        int64_t min_res_205797 = smin64(i_203670,
                                                        min_arg_205796);
                        int64_t defunc_0_m_fun_arg_205798 = add64((int64_t) 1,
                                                                  j_205794);
                        int64_t min_arg_205799 = mul64(jump_l_203501,
                                                       defunc_0_m_fun_arg_205798);
                        int64_t min_res_205800 = smin64(i_203670,
                                                        min_arg_205799);
                        int64_t i64_arg_205801 = sub64(min_res_205800,
                                                       min_res_205797);
                        double i64_res_205802 = sitofp_i64_f64(i64_arg_205801);
                        int64_t i64_arg_205803 = sub64(i_207407,
                                                       min_res_205797);
                        double i64_res_205804 = sitofp_i64_f64(i64_arg_205803);
                        double u_205805 = i64_res_205804 / i64_res_205802;
                        double u2_205806 = u_205805 * u_205805;
                        double u3_205807 = u_205805 * u2_205806;
                        double x_205808 = 2.0 * u3_205807;
                        double y_205809 = 3.0 * u2_205806;
                        double x_205810 = x_205808 - y_205809;
                        double x_205811 = 1.0 + x_205810;
                        bool x_205812 = sle64((int64_t) 0, j_205794);
                        bool y_205813 = slt64(j_205794, l_n_m_203643);
                        bool bounds_check_205814 = x_205812 && y_205813;
                        bool index_certs_205815;
                        
                        if (!bounds_check_205814) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) j_205794,
                                          "] out of bounds for array of shape [",
                                          (long long) l_n_m_203643, "].",
                                          "-> #0  loess.fut:536:27-33\n   #1  loess.fut:549:13-50\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:546:3-550:9\n   #6  stl.fut:252:23-75\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:250:15-253:43\n   #10 stl.fut:415:61-429:75\n   #11 stl.fut:455:3-469:34\n   #12 stl.fut:439:1-469:34\n");
                            if (memblock_unref(ctx, &mem_211476,
                                               "mem_211476") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_211517,
                                               "ext_mem_211517") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_211457,
                                               "ext_mem_211457") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_211465,
                                               "ext_mem_211465") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210632,
                                               "ext_mem_210632") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210518,
                                               "ext_mem_210518") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210529,
                                               "ext_mem_210529") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209164,
                                               "mem_param_209164") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209156,
                                               "mem_param_209156") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212524,
                                               "ext_mem_212524") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212525,
                                               "ext_mem_212525") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209142,
                                               "mem_param_209142") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209134,
                                               "mem_param_209134") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209126,
                                               "mem_param_209126") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212853,
                                               "ext_mem_212853") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212854,
                                               "ext_mem_212854") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212855,
                                               "ext_mem_212855") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209118,
                                               "mem_209118") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209114,
                                               "mem_209114") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213364,
                                               "mem_out_213364") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213363,
                                               "mem_out_213363") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213362,
                                               "mem_out_213362") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        double y_205816;
                        
                        y_205816 = ((double *) ext_mem_211465.mem)[i_207411 *
                                                                   l_n_m_203643 +
                                                                   j_205794];
                        
                        double x_205817 = x_205811 * y_205816;
                        double x_205818 = y_205809 - x_205808;
                        bool x_205819 = sle64((int64_t) 0,
                                              defunc_0_m_fun_arg_205798);
                        bool y_205820 = slt64(defunc_0_m_fun_arg_205798,
                                              l_n_m_203643);
                        bool bounds_check_205821 = x_205819 && y_205820;
                        bool index_certs_205822;
                        
                        if (!bounds_check_205821) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [",
                                          (long long) defunc_0_m_fun_arg_205798,
                                          "] out of bounds for array of shape [",
                                          (long long) l_n_m_203643, "].",
                                          "-> #0  loess.fut:537:27-37\n   #1  loess.fut:549:13-50\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:546:3-550:9\n   #6  stl.fut:252:23-75\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:250:15-253:43\n   #10 stl.fut:415:61-429:75\n   #11 stl.fut:455:3-469:34\n   #12 stl.fut:439:1-469:34\n");
                            if (memblock_unref(ctx, &mem_211476,
                                               "mem_211476") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_211517,
                                               "ext_mem_211517") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_211457,
                                               "ext_mem_211457") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_211465,
                                               "ext_mem_211465") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210632,
                                               "ext_mem_210632") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210518,
                                               "ext_mem_210518") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210529,
                                               "ext_mem_210529") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209164,
                                               "mem_param_209164") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209156,
                                               "mem_param_209156") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212524,
                                               "ext_mem_212524") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212525,
                                               "ext_mem_212525") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209142,
                                               "mem_param_209142") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209134,
                                               "mem_param_209134") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209126,
                                               "mem_param_209126") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212853,
                                               "ext_mem_212853") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212854,
                                               "ext_mem_212854") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212855,
                                               "ext_mem_212855") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209118,
                                               "mem_209118") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209114,
                                               "mem_209114") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213364,
                                               "mem_out_213364") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213363,
                                               "mem_out_213363") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213362,
                                               "mem_out_213362") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        double y_205823;
                        
                        y_205823 = ((double *) ext_mem_211465.mem)[i_207411 *
                                                                   l_n_m_203643 +
                                                                   defunc_0_m_fun_arg_205798];
                        
                        double y_205824 = x_205818 * y_205823;
                        double x_205825 = x_205817 + y_205824;
                        double y_205826 = 2.0 * u2_205806;
                        double x_205827 = u3_205807 - y_205826;
                        double x_205828 = u_205805 + x_205827;
                        double y_205829;
                        
                        y_205829 = ((double *) ext_mem_211457.mem)[i_207411 *
                                                                   l_n_m_203643 +
                                                                   j_205794];
                        
                        double x_205830 = x_205828 * y_205829;
                        double y_205831 = i64_res_205802 * x_205830;
                        double x_205832 = x_205825 + y_205831;
                        double x_205833 = u3_205807 - u2_205806;
                        double y_205834;
                        
                        y_205834 = ((double *) ext_mem_211457.mem)[i_207411 *
                                                                   l_n_m_203643 +
                                                                   defunc_0_m_fun_arg_205798];
                        
                        double x_205835 = x_205833 * y_205834;
                        double y_205836 = i64_res_205802 * x_205835;
                        double defunc_4_interpolate_proc_res_205837 = x_205832 +
                               y_205836;
                        
                        ((double *) mem_211476.mem)[i_207411 * n_203490 +
                                                    i_207407] =
                            defunc_4_interpolate_proc_res_205837;
                    }
                }
                if (memblock_set(ctx, &ext_mem_211517, &mem_211476,
                                 "mem_211476") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_211476, "mem_211476") != 0)
                    return 1;
            } else {
                bool dim_match_205838 = n_203490 == l_n_m_203643;
                bool empty_or_match_cert_205839;
                
                if (!dim_match_205838) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Value of (core language) shape (",
                                  (long long) partition_sizze_203577, ", ",
                                  (long long) l_n_m_203643,
                                  ") cannot match shape of type `[",
                                  (long long) partition_sizze_203577, "][",
                                  (long long) n_203490, "]t`.",
                                  "-> #0  stl.fut:255:15-36\n   #1  stl.fut:415:61-429:75\n   #2  stl.fut:455:3-469:34\n   #3  stl.fut:439:1-469:34\n");
                    if (memblock_unref(ctx, &ext_mem_211517,
                                       "ext_mem_211517") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_211457,
                                       "ext_mem_211457") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_211465,
                                       "ext_mem_211465") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_210632,
                                       "ext_mem_210632") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_210518,
                                       "ext_mem_210518") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_210529,
                                       "ext_mem_210529") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209164,
                                       "mem_param_209164") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209156,
                                       "mem_param_209156") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212524,
                                       "ext_mem_212524") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212525,
                                       "ext_mem_212525") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209142,
                                       "mem_param_209142") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209134,
                                       "mem_param_209134") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209126,
                                       "mem_param_209126") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212853,
                                       "ext_mem_212853") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212854,
                                       "ext_mem_212854") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212855,
                                       "ext_mem_212855") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_209118, "mem_209118") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_209114, "mem_209114") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213364,
                                       "mem_out_213364") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213363,
                                       "mem_out_213363") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213362,
                                       "mem_out_213362") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                if (memblock_set(ctx, &ext_mem_211517, &ext_mem_211465,
                                 "ext_mem_211465") != 0)
                    return 1;
            }
            if (memblock_unref(ctx, &ext_mem_211457, "ext_mem_211457") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_211465, "ext_mem_211465") != 0)
                return 1;
            
            struct memblock mem_211528;
            
            mem_211528.references = NULL;
            if (memblock_alloc(ctx, &mem_211528, bytes_208391, "mem_211528")) {
                err = 1;
                goto cleanup;
            }
            for (int64_t i_207419 = 0; i_207419 < partition_sizze_203577;
                 i_207419++) {
                for (int64_t i_207415 = 0; i_207415 < n_203490; i_207415++) {
                    int64_t slice_207756 = n_p_203492 + i_207415;
                    double x_205846;
                    
                    x_205846 = ((double *) mem_210643)[i_207419 * C_len_203634 +
                                                       slice_207756];
                    
                    double x_205847;
                    
                    x_205847 = ((double *) ext_mem_211517.mem)[i_207419 *
                                                               ext_211520 +
                                                               i_207415];
                    
                    double defunc_1_f_res_205848 = x_205846 - x_205847;
                    
                    ((double *) mem_211528.mem)[i_207419 * n_203490 +
                                                i_207415] =
                        defunc_1_f_res_205848;
                }
            }
            if (memblock_unref(ctx, &ext_mem_211517, "ext_mem_211517") != 0)
                return 1;
            
            struct memblock ext_mem_212464;
            
            ext_mem_212464.references = NULL;
            
            struct memblock ext_mem_212456;
            
            ext_mem_212456.references = NULL;
            if (cond_204165) {
                bool match_lit_205851 = (int64_t) 0 == d_t_203497;
                int64_t binop_y_211587 = (int64_t) 8 * n_203490;
                int64_t bytes_211588 = smax64((int64_t) 0, binop_y_211587);
                struct memblock ext_mem_211952;
                
                ext_mem_211952.references = NULL;
                
                struct memblock ext_mem_211944;
                
                ext_mem_211944.references = NULL;
                if (match_lit_205851) {
                    struct memblock mem_211572;
                    
                    mem_211572.references = NULL;
                    if (memblock_alloc(ctx, &mem_211572, bytes_209010,
                                       "mem_211572")) {
                        err = 1;
                        goto cleanup;
                    }
                    for (int64_t i_213614 = 0; i_213614 <
                         partition_sizze_203577; i_213614++) {
                        for (int64_t i_213615 = 0; i_213615 < t_n_m_203650;
                             i_213615++) {
                            ((double *) mem_211572.mem)[i_213614 *
                                                        t_n_m_203650 +
                                                        i_213615] = 0.0;
                        }
                    }
                    
                    struct memblock mem_211576;
                    
                    mem_211576.references = NULL;
                    if (memblock_alloc(ctx, &mem_211576, bytes_209010,
                                       "mem_211576")) {
                        err = 1;
                        goto cleanup;
                    }
                    if (mem_211589_cached_sizze_213778 <
                        (size_t) bytes_211588) {
                        mem_211589 = realloc(mem_211589, bytes_211588);
                        mem_211589_cached_sizze_213778 = bytes_211588;
                    }
                    if (mem_211604_cached_sizze_213779 <
                        (size_t) bytes_211588) {
                        mem_211604 = realloc(mem_211604, bytes_211588);
                        mem_211604_cached_sizze_213779 = bytes_211588;
                    }
                    if (mem_211607_cached_sizze_213780 <
                        (size_t) bytes_211588) {
                        mem_211607 = realloc(mem_211607, bytes_211588);
                        mem_211607_cached_sizze_213780 = bytes_211588;
                    }
                    for (int64_t i_207442 = 0; i_207442 <
                         partition_sizze_203577; i_207442++) {
                        int64_t x_205861;
                        
                        x_205861 = ((int64_t *) mem_208395)[i_207442];
                        for (int64_t i_207423 = 0; i_207423 < n_203490;
                             i_207423++) {
                            double x_205865;
                            
                            x_205865 = ((double *) mem_208352)[i_207442 *
                                                               n_203490 +
                                                               i_207423];
                            
                            double x_205866;
                            
                            x_205866 = ((double *) mem_211528.mem)[i_207442 *
                                                                   n_203490 +
                                                                   i_207423];
                            
                            double defunc_1_f_res_205867 = x_205865 - x_205866;
                            
                            ((double *) mem_211589)[i_207423] =
                                defunc_1_f_res_205867;
                        }
                        for (int64_t i_207429 = 0; i_207429 < n_203490;
                             i_207429++) {
                            int64_t x_205870;
                            
                            x_205870 = ((int64_t *) mem_208392)[i_207442 *
                                                                n_203490 +
                                                                i_207429];
                            
                            bool cond_205871 = sle64((int64_t) 0, x_205870);
                            double defunc_0_f_res_205872;
                            
                            if (cond_205871) {
                                bool y_205873 = slt64(x_205870, n_203490);
                                bool bounds_check_205874 = cond_205871 &&
                                     y_205873;
                                bool index_certs_205875;
                                
                                if (!bounds_check_205874) {
                                    ctx->error =
                                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                  "Index [",
                                                  (long long) x_205870,
                                                  "] out of bounds for array of shape [",
                                                  (long long) n_203490, "].",
                                                  "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:42:43-70\n   #3  stl.fut:281:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:279:13-284:41\n   #7  stl.fut:415:61-429:75\n   #8  stl.fut:455:3-469:34\n   #9  stl.fut:439:1-469:34\n");
                                    if (memblock_unref(ctx, &mem_211576,
                                                       "mem_211576") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_211572,
                                                       "mem_211572") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_211944,
                                                       "ext_mem_211944") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_211952,
                                                       "ext_mem_211952") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212456,
                                                       "ext_mem_212456") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212464,
                                                       "ext_mem_212464") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_211528,
                                                       "mem_211528") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_211517,
                                                       "ext_mem_211517") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_211457,
                                                       "ext_mem_211457") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_211465,
                                                       "ext_mem_211465") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_210632,
                                                       "ext_mem_210632") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_210518,
                                                       "ext_mem_210518") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_210529,
                                                       "ext_mem_210529") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209164,
                                                       "mem_param_209164") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209156,
                                                       "mem_param_209156") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212524,
                                                       "ext_mem_212524") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212525,
                                                       "ext_mem_212525") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209142,
                                                       "mem_param_209142") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209134,
                                                       "mem_param_209134") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209126,
                                                       "mem_param_209126") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212853,
                                                       "ext_mem_212853") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212854,
                                                       "ext_mem_212854") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212855,
                                                       "ext_mem_212855") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_209118,
                                                       "mem_209118") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_209114,
                                                       "mem_209114") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_213364,
                                                       "mem_out_213364") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_213363,
                                                       "mem_out_213363") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_213362,
                                                       "mem_out_213362") != 0)
                                        return 1;
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                double defunc_0_f_res_t_res_205876;
                                
                                defunc_0_f_res_t_res_205876 =
                                    ((double *) mem_211589)[x_205870];
                                defunc_0_f_res_205872 =
                                    defunc_0_f_res_t_res_205876;
                            } else {
                                defunc_0_f_res_205872 = 0.0;
                            }
                            
                            double defunc_0_f_res_205877;
                            
                            if (cond_205871) {
                                bool y_205878 = slt64(x_205870, n_203490);
                                bool bounds_check_205879 = cond_205871 &&
                                     y_205878;
                                bool index_certs_205880;
                                
                                if (!bounds_check_205879) {
                                    ctx->error =
                                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                  "Index [",
                                                  (long long) x_205870,
                                                  "] out of bounds for array of shape [",
                                                  (long long) n_203490, "].",
                                                  "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:42:43-70\n   #3  stl.fut:282:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:279:13-284:41\n   #7  stl.fut:415:61-429:75\n   #8  stl.fut:455:3-469:34\n   #9  stl.fut:439:1-469:34\n");
                                    if (memblock_unref(ctx, &mem_211576,
                                                       "mem_211576") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_211572,
                                                       "mem_211572") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_211944,
                                                       "ext_mem_211944") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_211952,
                                                       "ext_mem_211952") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212456,
                                                       "ext_mem_212456") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212464,
                                                       "ext_mem_212464") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_211528,
                                                       "mem_211528") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_211517,
                                                       "ext_mem_211517") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_211457,
                                                       "ext_mem_211457") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_211465,
                                                       "ext_mem_211465") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_210632,
                                                       "ext_mem_210632") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_210518,
                                                       "ext_mem_210518") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_210529,
                                                       "ext_mem_210529") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209164,
                                                       "mem_param_209164") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209156,
                                                       "mem_param_209156") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212524,
                                                       "ext_mem_212524") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212525,
                                                       "ext_mem_212525") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209142,
                                                       "mem_param_209142") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209134,
                                                       "mem_param_209134") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209126,
                                                       "mem_param_209126") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212853,
                                                       "ext_mem_212853") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212854,
                                                       "ext_mem_212854") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212855,
                                                       "ext_mem_212855") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_209118,
                                                       "mem_209118") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_209114,
                                                       "mem_209114") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_213364,
                                                       "mem_out_213364") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_213363,
                                                       "mem_out_213363") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_213362,
                                                       "mem_out_213362") != 0)
                                        return 1;
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                double defunc_0_f_res_t_res_205881;
                                
                                defunc_0_f_res_t_res_205881 =
                                    ((double *) mem_param_209142.mem)[ctx_param_ext_209137 +
                                                                      (i_207442 *
                                                                       ctx_param_ext_209138 +
                                                                       x_205870 *
                                                                       ctx_param_ext_209140)];
                                defunc_0_f_res_205877 =
                                    defunc_0_f_res_t_res_205881;
                            } else {
                                defunc_0_f_res_205877 = 0.0;
                            }
                            ((double *) mem_211604)[i_207429] =
                                defunc_0_f_res_205877;
                            ((double *) mem_211607)[i_207429] =
                                defunc_0_f_res_205872;
                        }
                        for (int64_t i_207438 = 0; i_207438 < t_n_m_203650;
                             i_207438++) {
                            int64_t x_205884;
                            
                            x_205884 = ((int64_t *) mem_209011)[i_207442 *
                                                                t_n_m_203650 +
                                                                i_207438];
                            
                            double x_205885;
                            
                            x_205885 = ((double *) mem_209015)[i_207442 *
                                                               t_n_m_203650 +
                                                               i_207438];
                            
                            int64_t min_arg_205886 = mul64(jump_t_203500,
                                                           i_207438);
                            int64_t min_res_205887 = smin64(i_203670,
                                                            min_arg_205886);
                            int64_t defunc_0_g_res_205888 = add64((int64_t) 1,
                                                                  min_res_205887);
                            double defunc_2_reduce_res_205889;
                            double redout_207432 = 0.0;
                            
                            for (int64_t i_207433 = 0; i_207433 < q_t_203494;
                                 i_207433++) {
                                bool cond_205894 = sle64(x_205861, i_207433);
                                int64_t defunc_0_f_res_205895;
                                
                                if (cond_205894) {
                                    defunc_0_f_res_205895 = (int64_t) 0;
                                } else {
                                    int64_t i_205896 = add64(x_205884,
                                                             i_207433);
                                    int64_t defunc_0_add_arg_205897;
                                    
                                    defunc_0_add_arg_205897 =
                                        ((int64_t *) mem_208392)[i_207442 *
                                                                 n_203490 +
                                                                 i_205896];
                                    
                                    int64_t defunc_1_add_res_205898 =
                                            add64((int64_t) 1,
                                                  defunc_0_add_arg_205897);
                                    
                                    defunc_0_f_res_205895 =
                                        defunc_1_add_res_205898;
                                }
                                
                                double defunc_0_f_res_205899;
                                
                                if (cond_205894) {
                                    defunc_0_f_res_205899 = 0.0;
                                } else {
                                    int64_t i_205900 = add64(x_205884,
                                                             i_207433);
                                    double defunc_0_add_arg_205901;
                                    
                                    defunc_0_add_arg_205901 =
                                        ((double *) mem_211604)[i_205900];
                                    defunc_0_f_res_205899 =
                                        defunc_0_add_arg_205901;
                                }
                                
                                int64_t binop_p_205902 =
                                        sub64(defunc_0_f_res_205895,
                                              defunc_0_g_res_205888);
                                double defunc_0_f_res_205903 =
                                       sitofp_i64_f64(binop_p_205902);
                                double abs_res_205904 =
                                       fabs(defunc_0_f_res_205903);
                                double tmp1_205905 = abs_res_205904 / x_205885;
                                double x_205906 = tmp1_205905 * tmp1_205905;
                                double y_205907 = tmp1_205905 * x_205906;
                                double tmp2_205908 = 1.0 - y_205907;
                                double x_205909 = tmp2_205908 * tmp2_205908;
                                double tmp3_205910 = tmp2_205908 * x_205909;
                                double w_j_205911 = defunc_0_f_res_205899 *
                                       tmp3_205910;
                                double defunc_1_op_res_205892 = w_j_205911 +
                                       redout_207432;
                                double redout_tmp_213621 =
                                       defunc_1_op_res_205892;
                                
                                redout_207432 = redout_tmp_213621;
                            }
                            defunc_2_reduce_res_205889 = redout_207432;
                            
                            double a0_205912 = 1.0 / defunc_2_reduce_res_205889;
                            double defunc_2_reduce_res_205913;
                            double redout_207434 = 0.0;
                            
                            for (int64_t i_207435 = 0; i_207435 < q_t_203494;
                                 i_207435++) {
                                bool cond_205918 = sle64(x_205861, i_207435);
                                int64_t defunc_0_f_res_205919;
                                
                                if (cond_205918) {
                                    defunc_0_f_res_205919 = (int64_t) 0;
                                } else {
                                    int64_t i_205920 = add64(x_205884,
                                                             i_207435);
                                    int64_t defunc_0_add_arg_205921;
                                    
                                    defunc_0_add_arg_205921 =
                                        ((int64_t *) mem_208392)[i_207442 *
                                                                 n_203490 +
                                                                 i_205920];
                                    
                                    int64_t defunc_1_add_res_205922 =
                                            add64((int64_t) 1,
                                                  defunc_0_add_arg_205921);
                                    
                                    defunc_0_f_res_205919 =
                                        defunc_1_add_res_205922;
                                }
                                
                                double defunc_0_f_res_205923;
                                
                                if (cond_205918) {
                                    defunc_0_f_res_205923 = 0.0;
                                } else {
                                    int64_t i_205924 = add64(x_205884,
                                                             i_207435);
                                    double defunc_0_add_arg_205925;
                                    
                                    defunc_0_add_arg_205925 =
                                        ((double *) mem_211604)[i_205924];
                                    defunc_0_f_res_205923 =
                                        defunc_0_add_arg_205925;
                                }
                                
                                int64_t binop_p_205926 =
                                        sub64(defunc_0_f_res_205919,
                                              defunc_0_g_res_205888);
                                double defunc_0_f_res_205927 =
                                       sitofp_i64_f64(binop_p_205926);
                                double abs_res_205928 =
                                       fabs(defunc_0_f_res_205927);
                                double tmp1_205929 = abs_res_205928 / x_205885;
                                double x_205930 = tmp1_205929 * tmp1_205929;
                                double y_205931 = tmp1_205929 * x_205930;
                                double tmp2_205932 = 1.0 - y_205931;
                                double x_205933 = tmp2_205932 * tmp2_205932;
                                double tmp3_205934 = tmp2_205932 * x_205933;
                                double tmp4_205935 = defunc_0_f_res_205923 *
                                       tmp3_205934;
                                double defunc_0_f_res_205936;
                                
                                if (cond_205918) {
                                    defunc_0_f_res_205936 = 0.0;
                                } else {
                                    int64_t i_205937 = add64(x_205884,
                                                             i_207435);
                                    double defunc_0_add_arg_205938;
                                    
                                    defunc_0_add_arg_205938 =
                                        ((double *) mem_211607)[i_205937];
                                    defunc_0_f_res_205936 =
                                        defunc_0_add_arg_205938;
                                }
                                
                                double x_205939 = a0_205912 * tmp4_205935;
                                double defunc_9_fit_fun_res_205940 =
                                       defunc_0_f_res_205936 * x_205939;
                                double defunc_1_op_res_205916 =
                                       defunc_9_fit_fun_res_205940 +
                                       redout_207434;
                                double redout_tmp_213622 =
                                       defunc_1_op_res_205916;
                                
                                redout_207434 = redout_tmp_213622;
                            }
                            defunc_2_reduce_res_205913 = redout_207434;
                            ((double *) mem_211576.mem)[i_207442 *
                                                        t_n_m_203650 +
                                                        i_207438] =
                                defunc_2_reduce_res_205913;
                        }
                    }
                    if (memblock_set(ctx, &ext_mem_211952, &mem_211576,
                                     "mem_211576") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_211944, &mem_211572,
                                     "mem_211572") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_211576, "mem_211576") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_211572, "mem_211572") != 0)
                        return 1;
                } else {
                    bool match_lit_205943 = (int64_t) 1 == d_t_203497;
                    int64_t binop_y_211690 = (int64_t) 8 * n_203490;
                    int64_t bytes_211691 = smax64((int64_t) 0, binop_y_211690);
                    int64_t binop_y_211823 = (int64_t) 8 * n_203490;
                    int64_t bytes_211824 = smax64((int64_t) 0, binop_y_211823);
                    struct memblock ext_mem_211936;
                    
                    ext_mem_211936.references = NULL;
                    
                    struct memblock ext_mem_211928;
                    
                    ext_mem_211928.references = NULL;
                    if (match_lit_205943) {
                        struct memblock mem_211665;
                        
                        mem_211665.references = NULL;
                        if (memblock_alloc(ctx, &mem_211665, bytes_209010,
                                           "mem_211665")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_211669;
                        
                        mem_211669.references = NULL;
                        if (memblock_alloc(ctx, &mem_211669, bytes_209010,
                                           "mem_211669")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (mem_211692_cached_sizze_213781 <
                            (size_t) bytes_211691) {
                            mem_211692 = realloc(mem_211692, bytes_211691);
                            mem_211692_cached_sizze_213781 = bytes_211691;
                        }
                        if (mem_211707_cached_sizze_213782 <
                            (size_t) bytes_211691) {
                            mem_211707 = realloc(mem_211707, bytes_211691);
                            mem_211707_cached_sizze_213782 = bytes_211691;
                        }
                        if (mem_211710_cached_sizze_213783 <
                            (size_t) bytes_211691) {
                            mem_211710 = realloc(mem_211710, bytes_211691);
                            mem_211710_cached_sizze_213783 = bytes_211691;
                        }
                        for (int64_t i_207473 = 0; i_207473 <
                             partition_sizze_203577; i_207473++) {
                            int64_t x_205953;
                            
                            x_205953 = ((int64_t *) mem_208395)[i_207473];
                            for (int64_t i_207446 = 0; i_207446 < n_203490;
                                 i_207446++) {
                                double x_205957;
                                
                                x_205957 = ((double *) mem_208352)[i_207473 *
                                                                   n_203490 +
                                                                   i_207446];
                                
                                double x_205958;
                                
                                x_205958 =
                                    ((double *) mem_211528.mem)[i_207473 *
                                                                n_203490 +
                                                                i_207446];
                                
                                double defunc_1_f_res_205959 = x_205957 -
                                       x_205958;
                                
                                ((double *) mem_211692)[i_207446] =
                                    defunc_1_f_res_205959;
                            }
                            for (int64_t i_207452 = 0; i_207452 < n_203490;
                                 i_207452++) {
                                int64_t x_205962;
                                
                                x_205962 = ((int64_t *) mem_208392)[i_207473 *
                                                                    n_203490 +
                                                                    i_207452];
                                
                                bool cond_205963 = sle64((int64_t) 0, x_205962);
                                double defunc_0_f_res_205964;
                                
                                if (cond_205963) {
                                    bool y_205965 = slt64(x_205962, n_203490);
                                    bool bounds_check_205966 = cond_205963 &&
                                         y_205965;
                                    bool index_certs_205967;
                                    
                                    if (!bounds_check_205966) {
                                        ctx->error =
                                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                      "Index [",
                                                      (long long) x_205962,
                                                      "] out of bounds for array of shape [",
                                                      (long long) n_203490,
                                                      "].",
                                                      "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:42:43-70\n   #3  stl.fut:281:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:279:13-284:41\n   #7  stl.fut:415:61-429:75\n   #8  stl.fut:455:3-469:34\n   #9  stl.fut:439:1-469:34\n");
                                        if (memblock_unref(ctx, &mem_211669,
                                                           "mem_211669") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_211665,
                                                           "mem_211665") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211928,
                                                           "ext_mem_211928") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211936,
                                                           "ext_mem_211936") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211944,
                                                           "ext_mem_211944") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211952,
                                                           "ext_mem_211952") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212456,
                                                           "ext_mem_212456") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212464,
                                                           "ext_mem_212464") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_211528,
                                                           "mem_211528") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211517,
                                                           "ext_mem_211517") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211457,
                                                           "ext_mem_211457") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211465,
                                                           "ext_mem_211465") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210632,
                                                           "ext_mem_210632") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210518,
                                                           "ext_mem_210518") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210529,
                                                           "ext_mem_210529") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209164,
                                                           "mem_param_209164") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209156,
                                                           "mem_param_209156") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212524,
                                                           "ext_mem_212524") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212525,
                                                           "ext_mem_212525") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209142,
                                                           "mem_param_209142") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209134,
                                                           "mem_param_209134") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209126,
                                                           "mem_param_209126") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212853,
                                                           "ext_mem_212853") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212854,
                                                           "ext_mem_212854") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212855,
                                                           "ext_mem_212855") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209118,
                                                           "mem_209118") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209114,
                                                           "mem_209114") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213364,
                                                           "mem_out_213364") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213363,
                                                           "mem_out_213363") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213362,
                                                           "mem_out_213362") !=
                                            0)
                                            return 1;
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    double defunc_0_f_res_t_res_205968;
                                    
                                    defunc_0_f_res_t_res_205968 =
                                        ((double *) mem_211692)[x_205962];
                                    defunc_0_f_res_205964 =
                                        defunc_0_f_res_t_res_205968;
                                } else {
                                    defunc_0_f_res_205964 = 0.0;
                                }
                                
                                double defunc_0_f_res_205969;
                                
                                if (cond_205963) {
                                    bool y_205970 = slt64(x_205962, n_203490);
                                    bool bounds_check_205971 = cond_205963 &&
                                         y_205970;
                                    bool index_certs_205972;
                                    
                                    if (!bounds_check_205971) {
                                        ctx->error =
                                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                      "Index [",
                                                      (long long) x_205962,
                                                      "] out of bounds for array of shape [",
                                                      (long long) n_203490,
                                                      "].",
                                                      "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:42:43-70\n   #3  stl.fut:282:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:279:13-284:41\n   #7  stl.fut:415:61-429:75\n   #8  stl.fut:455:3-469:34\n   #9  stl.fut:439:1-469:34\n");
                                        if (memblock_unref(ctx, &mem_211669,
                                                           "mem_211669") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_211665,
                                                           "mem_211665") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211928,
                                                           "ext_mem_211928") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211936,
                                                           "ext_mem_211936") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211944,
                                                           "ext_mem_211944") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211952,
                                                           "ext_mem_211952") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212456,
                                                           "ext_mem_212456") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212464,
                                                           "ext_mem_212464") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_211528,
                                                           "mem_211528") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211517,
                                                           "ext_mem_211517") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211457,
                                                           "ext_mem_211457") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211465,
                                                           "ext_mem_211465") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210632,
                                                           "ext_mem_210632") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210518,
                                                           "ext_mem_210518") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210529,
                                                           "ext_mem_210529") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209164,
                                                           "mem_param_209164") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209156,
                                                           "mem_param_209156") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212524,
                                                           "ext_mem_212524") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212525,
                                                           "ext_mem_212525") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209142,
                                                           "mem_param_209142") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209134,
                                                           "mem_param_209134") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209126,
                                                           "mem_param_209126") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212853,
                                                           "ext_mem_212853") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212854,
                                                           "ext_mem_212854") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212855,
                                                           "ext_mem_212855") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209118,
                                                           "mem_209118") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209114,
                                                           "mem_209114") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213364,
                                                           "mem_out_213364") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213363,
                                                           "mem_out_213363") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213362,
                                                           "mem_out_213362") !=
                                            0)
                                            return 1;
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    double defunc_0_f_res_t_res_205973;
                                    
                                    defunc_0_f_res_t_res_205973 =
                                        ((double *) mem_param_209142.mem)[ctx_param_ext_209137 +
                                                                          (i_207473 *
                                                                           ctx_param_ext_209138 +
                                                                           x_205962 *
                                                                           ctx_param_ext_209140)];
                                    defunc_0_f_res_205969 =
                                        defunc_0_f_res_t_res_205973;
                                } else {
                                    defunc_0_f_res_205969 = 0.0;
                                }
                                ((double *) mem_211707)[i_207452] =
                                    defunc_0_f_res_205969;
                                ((double *) mem_211710)[i_207452] =
                                    defunc_0_f_res_205964;
                            }
                            for (int64_t i_207466 = 0; i_207466 < t_n_m_203650;
                                 i_207466++) {
                                int64_t x_205977;
                                
                                x_205977 = ((int64_t *) mem_209011)[i_207473 *
                                                                    t_n_m_203650 +
                                                                    i_207466];
                                
                                double x_205978;
                                
                                x_205978 = ((double *) mem_209015)[i_207473 *
                                                                   t_n_m_203650 +
                                                                   i_207466];
                                
                                int64_t min_arg_205979 = mul64(jump_t_203500,
                                                               i_207466);
                                int64_t min_res_205980 = smin64(i_203670,
                                                                min_arg_205979);
                                int64_t defunc_0_g_res_205981 =
                                        add64((int64_t) 1, min_res_205980);
                                double defunc_2_reduce_res_205982;
                                double defunc_2_reduce_res_205983;
                                double defunc_2_reduce_res_205984;
                                double redout_207455;
                                double redout_207456;
                                double redout_207457;
                                
                                redout_207455 = 0.0;
                                redout_207456 = 0.0;
                                redout_207457 = 0.0;
                                for (int64_t i_207458 = 0; i_207458 <
                                     q_t_203494; i_207458++) {
                                    bool cond_205995 = sle64(x_205953,
                                                             i_207458);
                                    int64_t defunc_0_f_res_205996;
                                    
                                    if (cond_205995) {
                                        defunc_0_f_res_205996 = (int64_t) 0;
                                    } else {
                                        int64_t i_205997 = add64(x_205977,
                                                                 i_207458);
                                        int64_t defunc_0_add_arg_205998;
                                        
                                        defunc_0_add_arg_205998 =
                                            ((int64_t *) mem_208392)[i_207473 *
                                                                     n_203490 +
                                                                     i_205997];
                                        
                                        int64_t defunc_1_add_res_205999 =
                                                add64((int64_t) 1,
                                                      defunc_0_add_arg_205998);
                                        
                                        defunc_0_f_res_205996 =
                                            defunc_1_add_res_205999;
                                    }
                                    
                                    double defunc_0_f_res_206000;
                                    
                                    if (cond_205995) {
                                        defunc_0_f_res_206000 = 0.0;
                                    } else {
                                        int64_t i_206001 = add64(x_205977,
                                                                 i_207458);
                                        double defunc_0_add_arg_206002;
                                        
                                        defunc_0_add_arg_206002 =
                                            ((double *) mem_211707)[i_206001];
                                        defunc_0_f_res_206000 =
                                            defunc_0_add_arg_206002;
                                    }
                                    
                                    int64_t binop_p_206003 =
                                            sub64(defunc_0_f_res_205996,
                                                  defunc_0_g_res_205981);
                                    double defunc_0_f_res_206004 =
                                           sitofp_i64_f64(binop_p_206003);
                                    double abs_res_206005 =
                                           fabs(defunc_0_f_res_206004);
                                    double tmp1_206006 = abs_res_206005 /
                                           x_205978;
                                    double x_206007 = tmp1_206006 * tmp1_206006;
                                    double y_206008 = tmp1_206006 * x_206007;
                                    double tmp2_206009 = 1.0 - y_206008;
                                    double x_206010 = tmp2_206009 * tmp2_206009;
                                    double tmp3_206011 = tmp2_206009 * x_206010;
                                    double w_j_206012 = defunc_0_f_res_206000 *
                                           tmp3_206011;
                                    double xw_j_206013 = defunc_0_f_res_206004 *
                                           w_j_206012;
                                    double x2w_j_206014 =
                                           defunc_0_f_res_206004 * xw_j_206013;
                                    double defunc_1_op_res_205987 = w_j_206012 +
                                           redout_207455;
                                    double defunc_1_op_res_205990 =
                                           xw_j_206013 + redout_207456;
                                    double defunc_1_op_res_205993 =
                                           x2w_j_206014 + redout_207457;
                                    double redout_tmp_213630 =
                                           defunc_1_op_res_205987;
                                    double redout_tmp_213631 =
                                           defunc_1_op_res_205990;
                                    double redout_tmp_213632 =
                                           defunc_1_op_res_205993;
                                    
                                    redout_207455 = redout_tmp_213630;
                                    redout_207456 = redout_tmp_213631;
                                    redout_207457 = redout_tmp_213632;
                                }
                                defunc_2_reduce_res_205982 = redout_207455;
                                defunc_2_reduce_res_205983 = redout_207456;
                                defunc_2_reduce_res_205984 = redout_207457;
                                
                                double x_206015 = defunc_2_reduce_res_205982 *
                                       defunc_2_reduce_res_205984;
                                double y_206016 = defunc_2_reduce_res_205983 *
                                       defunc_2_reduce_res_205983;
                                double y_206017 = x_206015 - y_206016;
                                double det1_206018 = 1.0 / y_206017;
                                double a11_206019 = defunc_2_reduce_res_205984 *
                                       det1_206018;
                                double x_206020 = 0.0 -
                                       defunc_2_reduce_res_205983;
                                double b11_206021 = det1_206018 * x_206020;
                                double c11_206022 = defunc_2_reduce_res_205982 *
                                       det1_206018;
                                double defunc_2_reduce_res_206023;
                                double defunc_2_reduce_res_206024;
                                double redout_207459;
                                double redout_207460;
                                
                                redout_207459 = 0.0;
                                redout_207460 = 0.0;
                                for (int64_t i_207461 = 0; i_207461 <
                                     q_t_203494; i_207461++) {
                                    bool cond_206032 = sle64(x_205953,
                                                             i_207461);
                                    int64_t defunc_0_f_res_206033;
                                    
                                    if (cond_206032) {
                                        defunc_0_f_res_206033 = (int64_t) 0;
                                    } else {
                                        int64_t i_206034 = add64(x_205977,
                                                                 i_207461);
                                        int64_t defunc_0_add_arg_206035;
                                        
                                        defunc_0_add_arg_206035 =
                                            ((int64_t *) mem_208392)[i_207473 *
                                                                     n_203490 +
                                                                     i_206034];
                                        
                                        int64_t defunc_1_add_res_206036 =
                                                add64((int64_t) 1,
                                                      defunc_0_add_arg_206035);
                                        
                                        defunc_0_f_res_206033 =
                                            defunc_1_add_res_206036;
                                    }
                                    
                                    double defunc_0_f_res_206037;
                                    
                                    if (cond_206032) {
                                        defunc_0_f_res_206037 = 0.0;
                                    } else {
                                        int64_t i_206038 = add64(x_205977,
                                                                 i_207461);
                                        double defunc_0_add_arg_206039;
                                        
                                        defunc_0_add_arg_206039 =
                                            ((double *) mem_211707)[i_206038];
                                        defunc_0_f_res_206037 =
                                            defunc_0_add_arg_206039;
                                    }
                                    
                                    int64_t binop_p_206040 =
                                            sub64(defunc_0_f_res_206033,
                                                  defunc_0_g_res_205981);
                                    double defunc_0_f_res_206041 =
                                           sitofp_i64_f64(binop_p_206040);
                                    double abs_res_206042 =
                                           fabs(defunc_0_f_res_206041);
                                    double tmp1_206043 = abs_res_206042 /
                                           x_205978;
                                    double x_206044 = tmp1_206043 * tmp1_206043;
                                    double y_206045 = tmp1_206043 * x_206044;
                                    double tmp2_206046 = 1.0 - y_206045;
                                    double x_206047 = tmp2_206046 * tmp2_206046;
                                    double tmp3_206048 = tmp2_206046 * x_206047;
                                    double tmp4_206049 = defunc_0_f_res_206037 *
                                           tmp3_206048;
                                    double defunc_1_f_res_206050 =
                                           defunc_0_f_res_206041 * tmp4_206049;
                                    double defunc_0_f_res_206051;
                                    
                                    if (cond_206032) {
                                        defunc_0_f_res_206051 = 0.0;
                                    } else {
                                        int64_t i_206052 = add64(x_205977,
                                                                 i_207461);
                                        double defunc_0_add_arg_206053;
                                        
                                        defunc_0_add_arg_206053 =
                                            ((double *) mem_211710)[i_206052];
                                        defunc_0_f_res_206051 =
                                            defunc_0_add_arg_206053;
                                    }
                                    
                                    double x_206054 = a11_206019 * tmp4_206049;
                                    double y_206055 = b11_206021 *
                                           defunc_1_f_res_206050;
                                    double x_206056 = x_206054 + y_206055;
                                    double defunc_9_fit_fun_res_206057 =
                                           defunc_0_f_res_206051 * x_206056;
                                    double x_206058 = b11_206021 * tmp4_206049;
                                    double y_206059 = c11_206022 *
                                           defunc_1_f_res_206050;
                                    double x_206060 = x_206058 + y_206059;
                                    double defunc_9_slope_fun_res_206061 =
                                           defunc_0_f_res_206051 * x_206060;
                                    double defunc_1_op_res_206027 =
                                           defunc_9_fit_fun_res_206057 +
                                           redout_207459;
                                    double defunc_1_op_res_206030 =
                                           defunc_9_slope_fun_res_206061 +
                                           redout_207460;
                                    double redout_tmp_213633 =
                                           defunc_1_op_res_206027;
                                    double redout_tmp_213634 =
                                           defunc_1_op_res_206030;
                                    
                                    redout_207459 = redout_tmp_213633;
                                    redout_207460 = redout_tmp_213634;
                                }
                                defunc_2_reduce_res_206023 = redout_207459;
                                defunc_2_reduce_res_206024 = redout_207460;
                                ((double *) mem_211665.mem)[i_207473 *
                                                            t_n_m_203650 +
                                                            i_207466] =
                                    defunc_2_reduce_res_206023;
                                ((double *) mem_211669.mem)[i_207473 *
                                                            t_n_m_203650 +
                                                            i_207466] =
                                    defunc_2_reduce_res_206024;
                            }
                        }
                        if (memblock_set(ctx, &ext_mem_211936, &mem_211665,
                                         "mem_211665") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_211928, &mem_211669,
                                         "mem_211669") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_211669, "mem_211669") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_211665, "mem_211665") != 0)
                            return 1;
                    } else {
                        struct memblock mem_211798;
                        
                        mem_211798.references = NULL;
                        if (memblock_alloc(ctx, &mem_211798, bytes_209010,
                                           "mem_211798")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_211802;
                        
                        mem_211802.references = NULL;
                        if (memblock_alloc(ctx, &mem_211802, bytes_209010,
                                           "mem_211802")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (mem_211825_cached_sizze_213784 <
                            (size_t) bytes_211824) {
                            mem_211825 = realloc(mem_211825, bytes_211824);
                            mem_211825_cached_sizze_213784 = bytes_211824;
                        }
                        if (mem_211840_cached_sizze_213785 <
                            (size_t) bytes_211824) {
                            mem_211840 = realloc(mem_211840, bytes_211824);
                            mem_211840_cached_sizze_213785 = bytes_211824;
                        }
                        if (mem_211843_cached_sizze_213786 <
                            (size_t) bytes_211824) {
                            mem_211843 = realloc(mem_211843, bytes_211824);
                            mem_211843_cached_sizze_213786 = bytes_211824;
                        }
                        for (int64_t i_207507 = 0; i_207507 <
                             partition_sizze_203577; i_207507++) {
                            int64_t x_206071;
                            
                            x_206071 = ((int64_t *) mem_208395)[i_207507];
                            for (int64_t i_207478 = 0; i_207478 < n_203490;
                                 i_207478++) {
                                double x_206075;
                                
                                x_206075 = ((double *) mem_208352)[i_207507 *
                                                                   n_203490 +
                                                                   i_207478];
                                
                                double x_206076;
                                
                                x_206076 =
                                    ((double *) mem_211528.mem)[i_207507 *
                                                                n_203490 +
                                                                i_207478];
                                
                                double defunc_1_f_res_206077 = x_206075 -
                                       x_206076;
                                
                                ((double *) mem_211825)[i_207478] =
                                    defunc_1_f_res_206077;
                            }
                            for (int64_t i_207484 = 0; i_207484 < n_203490;
                                 i_207484++) {
                                int64_t x_206080;
                                
                                x_206080 = ((int64_t *) mem_208392)[i_207507 *
                                                                    n_203490 +
                                                                    i_207484];
                                
                                bool cond_206081 = sle64((int64_t) 0, x_206080);
                                double defunc_0_f_res_206082;
                                
                                if (cond_206081) {
                                    bool y_206083 = slt64(x_206080, n_203490);
                                    bool bounds_check_206084 = cond_206081 &&
                                         y_206083;
                                    bool index_certs_206085;
                                    
                                    if (!bounds_check_206084) {
                                        ctx->error =
                                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                      "Index [",
                                                      (long long) x_206080,
                                                      "] out of bounds for array of shape [",
                                                      (long long) n_203490,
                                                      "].",
                                                      "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:42:43-70\n   #3  stl.fut:281:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:279:13-284:41\n   #7  stl.fut:415:61-429:75\n   #8  stl.fut:455:3-469:34\n   #9  stl.fut:439:1-469:34\n");
                                        if (memblock_unref(ctx, &mem_211802,
                                                           "mem_211802") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_211798,
                                                           "mem_211798") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211928,
                                                           "ext_mem_211928") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211936,
                                                           "ext_mem_211936") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211944,
                                                           "ext_mem_211944") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211952,
                                                           "ext_mem_211952") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212456,
                                                           "ext_mem_212456") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212464,
                                                           "ext_mem_212464") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_211528,
                                                           "mem_211528") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211517,
                                                           "ext_mem_211517") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211457,
                                                           "ext_mem_211457") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211465,
                                                           "ext_mem_211465") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210632,
                                                           "ext_mem_210632") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210518,
                                                           "ext_mem_210518") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210529,
                                                           "ext_mem_210529") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209164,
                                                           "mem_param_209164") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209156,
                                                           "mem_param_209156") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212524,
                                                           "ext_mem_212524") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212525,
                                                           "ext_mem_212525") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209142,
                                                           "mem_param_209142") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209134,
                                                           "mem_param_209134") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209126,
                                                           "mem_param_209126") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212853,
                                                           "ext_mem_212853") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212854,
                                                           "ext_mem_212854") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212855,
                                                           "ext_mem_212855") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209118,
                                                           "mem_209118") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209114,
                                                           "mem_209114") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213364,
                                                           "mem_out_213364") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213363,
                                                           "mem_out_213363") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213362,
                                                           "mem_out_213362") !=
                                            0)
                                            return 1;
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    double defunc_0_f_res_t_res_206086;
                                    
                                    defunc_0_f_res_t_res_206086 =
                                        ((double *) mem_211825)[x_206080];
                                    defunc_0_f_res_206082 =
                                        defunc_0_f_res_t_res_206086;
                                } else {
                                    defunc_0_f_res_206082 = 0.0;
                                }
                                
                                double defunc_0_f_res_206087;
                                
                                if (cond_206081) {
                                    bool y_206088 = slt64(x_206080, n_203490);
                                    bool bounds_check_206089 = cond_206081 &&
                                         y_206088;
                                    bool index_certs_206090;
                                    
                                    if (!bounds_check_206089) {
                                        ctx->error =
                                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                      "Index [",
                                                      (long long) x_206080,
                                                      "] out of bounds for array of shape [",
                                                      (long long) n_203490,
                                                      "].",
                                                      "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:42:43-70\n   #3  stl.fut:282:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:279:13-284:41\n   #7  stl.fut:415:61-429:75\n   #8  stl.fut:455:3-469:34\n   #9  stl.fut:439:1-469:34\n");
                                        if (memblock_unref(ctx, &mem_211802,
                                                           "mem_211802") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_211798,
                                                           "mem_211798") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211928,
                                                           "ext_mem_211928") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211936,
                                                           "ext_mem_211936") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211944,
                                                           "ext_mem_211944") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211952,
                                                           "ext_mem_211952") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212456,
                                                           "ext_mem_212456") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212464,
                                                           "ext_mem_212464") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_211528,
                                                           "mem_211528") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211517,
                                                           "ext_mem_211517") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211457,
                                                           "ext_mem_211457") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211465,
                                                           "ext_mem_211465") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210632,
                                                           "ext_mem_210632") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210518,
                                                           "ext_mem_210518") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210529,
                                                           "ext_mem_210529") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209164,
                                                           "mem_param_209164") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209156,
                                                           "mem_param_209156") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212524,
                                                           "ext_mem_212524") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212525,
                                                           "ext_mem_212525") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209142,
                                                           "mem_param_209142") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209134,
                                                           "mem_param_209134") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209126,
                                                           "mem_param_209126") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212853,
                                                           "ext_mem_212853") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212854,
                                                           "ext_mem_212854") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212855,
                                                           "ext_mem_212855") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209118,
                                                           "mem_209118") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209114,
                                                           "mem_209114") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213364,
                                                           "mem_out_213364") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213363,
                                                           "mem_out_213363") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213362,
                                                           "mem_out_213362") !=
                                            0)
                                            return 1;
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    double defunc_0_f_res_t_res_206091;
                                    
                                    defunc_0_f_res_t_res_206091 =
                                        ((double *) mem_param_209142.mem)[ctx_param_ext_209137 +
                                                                          (i_207507 *
                                                                           ctx_param_ext_209138 +
                                                                           x_206080 *
                                                                           ctx_param_ext_209140)];
                                    defunc_0_f_res_206087 =
                                        defunc_0_f_res_t_res_206091;
                                } else {
                                    defunc_0_f_res_206087 = 0.0;
                                }
                                ((double *) mem_211840)[i_207484] =
                                    defunc_0_f_res_206087;
                                ((double *) mem_211843)[i_207484] =
                                    defunc_0_f_res_206082;
                            }
                            for (int64_t i_207500 = 0; i_207500 < t_n_m_203650;
                                 i_207500++) {
                                int64_t x_206095;
                                
                                x_206095 = ((int64_t *) mem_209011)[i_207507 *
                                                                    t_n_m_203650 +
                                                                    i_207500];
                                
                                double x_206096;
                                
                                x_206096 = ((double *) mem_209015)[i_207507 *
                                                                   t_n_m_203650 +
                                                                   i_207500];
                                
                                int64_t min_arg_206097 = mul64(jump_t_203500,
                                                               i_207500);
                                int64_t min_res_206098 = smin64(i_203670,
                                                                min_arg_206097);
                                int64_t defunc_0_g_res_206099 =
                                        add64((int64_t) 1, min_res_206098);
                                double defunc_2_reduce_res_206100;
                                double defunc_2_reduce_res_206101;
                                double defunc_2_reduce_res_206102;
                                double defunc_2_reduce_res_206103;
                                double defunc_2_reduce_res_206104;
                                double redout_207487;
                                double redout_207488;
                                double redout_207489;
                                double redout_207490;
                                double redout_207491;
                                
                                redout_207487 = 0.0;
                                redout_207488 = 0.0;
                                redout_207489 = 0.0;
                                redout_207490 = 0.0;
                                redout_207491 = 0.0;
                                for (int64_t i_207492 = 0; i_207492 <
                                     q_t_203494; i_207492++) {
                                    bool cond_206121 = sle64(x_206071,
                                                             i_207492);
                                    int64_t defunc_0_f_res_206122;
                                    
                                    if (cond_206121) {
                                        defunc_0_f_res_206122 = (int64_t) 0;
                                    } else {
                                        int64_t i_206123 = add64(x_206095,
                                                                 i_207492);
                                        int64_t defunc_0_add_arg_206124;
                                        
                                        defunc_0_add_arg_206124 =
                                            ((int64_t *) mem_208392)[i_207507 *
                                                                     n_203490 +
                                                                     i_206123];
                                        
                                        int64_t defunc_1_add_res_206125 =
                                                add64((int64_t) 1,
                                                      defunc_0_add_arg_206124);
                                        
                                        defunc_0_f_res_206122 =
                                            defunc_1_add_res_206125;
                                    }
                                    
                                    double defunc_0_f_res_206126;
                                    
                                    if (cond_206121) {
                                        defunc_0_f_res_206126 = 0.0;
                                    } else {
                                        int64_t i_206127 = add64(x_206095,
                                                                 i_207492);
                                        double defunc_0_add_arg_206128;
                                        
                                        defunc_0_add_arg_206128 =
                                            ((double *) mem_211840)[i_206127];
                                        defunc_0_f_res_206126 =
                                            defunc_0_add_arg_206128;
                                    }
                                    
                                    int64_t binop_p_206129 =
                                            sub64(defunc_0_f_res_206122,
                                                  defunc_0_g_res_206099);
                                    double defunc_0_f_res_206130 =
                                           sitofp_i64_f64(binop_p_206129);
                                    double abs_res_206131 =
                                           fabs(defunc_0_f_res_206130);
                                    double tmp1_206132 = abs_res_206131 /
                                           x_206096;
                                    double x_206133 = tmp1_206132 * tmp1_206132;
                                    double y_206134 = tmp1_206132 * x_206133;
                                    double tmp2_206135 = 1.0 - y_206134;
                                    double x_206136 = tmp2_206135 * tmp2_206135;
                                    double tmp3_206137 = tmp2_206135 * x_206136;
                                    double w_j_206138 = defunc_0_f_res_206126 *
                                           tmp3_206137;
                                    double xw_j_206139 = defunc_0_f_res_206130 *
                                           w_j_206138;
                                    double x2w_j_206140 =
                                           defunc_0_f_res_206130 * xw_j_206139;
                                    double x3w_j_206141 =
                                           defunc_0_f_res_206130 * x2w_j_206140;
                                    double x4w_j_206142 =
                                           defunc_0_f_res_206130 * x3w_j_206141;
                                    double defunc_1_op_res_206107 = w_j_206138 +
                                           redout_207487;
                                    double defunc_1_op_res_206110 =
                                           xw_j_206139 + redout_207488;
                                    double defunc_1_op_res_206113 =
                                           x2w_j_206140 + redout_207489;
                                    double defunc_1_op_res_206116 =
                                           x3w_j_206141 + redout_207490;
                                    double defunc_1_op_res_206119 =
                                           x4w_j_206142 + redout_207491;
                                    double redout_tmp_213642 =
                                           defunc_1_op_res_206107;
                                    double redout_tmp_213643 =
                                           defunc_1_op_res_206110;
                                    double redout_tmp_213644 =
                                           defunc_1_op_res_206113;
                                    double redout_tmp_213645 =
                                           defunc_1_op_res_206116;
                                    double redout_tmp_213646 =
                                           defunc_1_op_res_206119;
                                    
                                    redout_207487 = redout_tmp_213642;
                                    redout_207488 = redout_tmp_213643;
                                    redout_207489 = redout_tmp_213644;
                                    redout_207490 = redout_tmp_213645;
                                    redout_207491 = redout_tmp_213646;
                                }
                                defunc_2_reduce_res_206100 = redout_207487;
                                defunc_2_reduce_res_206101 = redout_207488;
                                defunc_2_reduce_res_206102 = redout_207489;
                                defunc_2_reduce_res_206103 = redout_207490;
                                defunc_2_reduce_res_206104 = redout_207491;
                                
                                double x_206143 = defunc_2_reduce_res_206102 *
                                       defunc_2_reduce_res_206104;
                                double y_206144 = defunc_2_reduce_res_206103 *
                                       defunc_2_reduce_res_206103;
                                double a12_206145 = x_206143 - y_206144;
                                double x_206146 = defunc_2_reduce_res_206102 *
                                       defunc_2_reduce_res_206103;
                                double y_206147 = defunc_2_reduce_res_206101 *
                                       defunc_2_reduce_res_206104;
                                double b12_206148 = x_206146 - y_206147;
                                double x_206149 = defunc_2_reduce_res_206101 *
                                       defunc_2_reduce_res_206103;
                                double y_206150 = defunc_2_reduce_res_206102 *
                                       defunc_2_reduce_res_206102;
                                double c12_206151 = x_206149 - y_206150;
                                double x_206152 = defunc_2_reduce_res_206100 *
                                       defunc_2_reduce_res_206104;
                                double b2_206153 = x_206152 - y_206150;
                                double x_206154 = defunc_2_reduce_res_206101 *
                                       defunc_2_reduce_res_206102;
                                double y_206155 = defunc_2_reduce_res_206100 *
                                       defunc_2_reduce_res_206103;
                                double c2_206156 = x_206154 - y_206155;
                                double x_206157 = defunc_2_reduce_res_206100 *
                                       a12_206145;
                                double y_206158 = defunc_2_reduce_res_206101 *
                                       b12_206148;
                                double x_206159 = x_206157 + y_206158;
                                double y_206160 = defunc_2_reduce_res_206102 *
                                       c12_206151;
                                double y_206161 = x_206159 + y_206160;
                                double det_206162 = 1.0 / y_206161;
                                double a12_206163 = a12_206145 * det_206162;
                                double b12_206164 = b12_206148 * det_206162;
                                double c12_206165 = c12_206151 * det_206162;
                                double b2_206166 = b2_206153 * det_206162;
                                double c2_206167 = c2_206156 * det_206162;
                                double defunc_2_reduce_res_206168;
                                double defunc_2_reduce_res_206169;
                                double redout_207493;
                                double redout_207494;
                                
                                redout_207493 = 0.0;
                                redout_207494 = 0.0;
                                for (int64_t i_207495 = 0; i_207495 <
                                     q_t_203494; i_207495++) {
                                    bool cond_206177 = sle64(x_206071,
                                                             i_207495);
                                    int64_t defunc_0_f_res_206178;
                                    
                                    if (cond_206177) {
                                        defunc_0_f_res_206178 = (int64_t) 0;
                                    } else {
                                        int64_t i_206179 = add64(x_206095,
                                                                 i_207495);
                                        int64_t defunc_0_add_arg_206180;
                                        
                                        defunc_0_add_arg_206180 =
                                            ((int64_t *) mem_208392)[i_207507 *
                                                                     n_203490 +
                                                                     i_206179];
                                        
                                        int64_t defunc_1_add_res_206181 =
                                                add64((int64_t) 1,
                                                      defunc_0_add_arg_206180);
                                        
                                        defunc_0_f_res_206178 =
                                            defunc_1_add_res_206181;
                                    }
                                    
                                    double defunc_0_f_res_206182;
                                    
                                    if (cond_206177) {
                                        defunc_0_f_res_206182 = 0.0;
                                    } else {
                                        int64_t i_206183 = add64(x_206095,
                                                                 i_207495);
                                        double defunc_0_add_arg_206184;
                                        
                                        defunc_0_add_arg_206184 =
                                            ((double *) mem_211840)[i_206183];
                                        defunc_0_f_res_206182 =
                                            defunc_0_add_arg_206184;
                                    }
                                    
                                    int64_t binop_p_206185 =
                                            sub64(defunc_0_f_res_206178,
                                                  defunc_0_g_res_206099);
                                    double defunc_0_f_res_206186 =
                                           sitofp_i64_f64(binop_p_206185);
                                    double abs_res_206187 =
                                           fabs(defunc_0_f_res_206186);
                                    double tmp1_206188 = abs_res_206187 /
                                           x_206096;
                                    double x_206189 = tmp1_206188 * tmp1_206188;
                                    double y_206190 = tmp1_206188 * x_206189;
                                    double tmp2_206191 = 1.0 - y_206190;
                                    double x_206192 = tmp2_206191 * tmp2_206191;
                                    double tmp3_206193 = tmp2_206191 * x_206192;
                                    double tmp4_206194 = defunc_0_f_res_206182 *
                                           tmp3_206193;
                                    double defunc_1_f_res_206195 =
                                           defunc_0_f_res_206186 * tmp4_206194;
                                    double defunc_1_f_res_206196 =
                                           defunc_0_f_res_206186 *
                                           defunc_1_f_res_206195;
                                    double defunc_0_f_res_206197;
                                    
                                    if (cond_206177) {
                                        defunc_0_f_res_206197 = 0.0;
                                    } else {
                                        int64_t i_206198 = add64(x_206095,
                                                                 i_207495);
                                        double defunc_0_add_arg_206199;
                                        
                                        defunc_0_add_arg_206199 =
                                            ((double *) mem_211843)[i_206198];
                                        defunc_0_f_res_206197 =
                                            defunc_0_add_arg_206199;
                                    }
                                    
                                    double x_206200 = a12_206163 * tmp4_206194;
                                    double y_206201 = b12_206164 *
                                           defunc_1_f_res_206195;
                                    double x_206202 = x_206200 + y_206201;
                                    double y_206203 = c12_206165 *
                                           defunc_1_f_res_206196;
                                    double x_206204 = x_206202 + y_206203;
                                    double defunc_9_fit_fun_res_206205 =
                                           defunc_0_f_res_206197 * x_206204;
                                    double x_206206 = b12_206164 * tmp4_206194;
                                    double y_206207 = b2_206166 *
                                           defunc_1_f_res_206195;
                                    double x_206208 = x_206206 + y_206207;
                                    double y_206209 = c2_206167 *
                                           defunc_1_f_res_206196;
                                    double x_206210 = x_206208 + y_206209;
                                    double defunc_9_slope_fun_res_206211 =
                                           defunc_0_f_res_206197 * x_206210;
                                    double defunc_1_op_res_206172 =
                                           defunc_9_fit_fun_res_206205 +
                                           redout_207493;
                                    double defunc_1_op_res_206175 =
                                           defunc_9_slope_fun_res_206211 +
                                           redout_207494;
                                    double redout_tmp_213647 =
                                           defunc_1_op_res_206172;
                                    double redout_tmp_213648 =
                                           defunc_1_op_res_206175;
                                    
                                    redout_207493 = redout_tmp_213647;
                                    redout_207494 = redout_tmp_213648;
                                }
                                defunc_2_reduce_res_206168 = redout_207493;
                                defunc_2_reduce_res_206169 = redout_207494;
                                ((double *) mem_211798.mem)[i_207507 *
                                                            t_n_m_203650 +
                                                            i_207500] =
                                    defunc_2_reduce_res_206168;
                                ((double *) mem_211802.mem)[i_207507 *
                                                            t_n_m_203650 +
                                                            i_207500] =
                                    defunc_2_reduce_res_206169;
                            }
                        }
                        if (memblock_set(ctx, &ext_mem_211936, &mem_211798,
                                         "mem_211798") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_211928, &mem_211802,
                                         "mem_211802") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_211802, "mem_211802") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_211798, "mem_211798") != 0)
                            return 1;
                    }
                    if (memblock_set(ctx, &ext_mem_211952, &ext_mem_211936,
                                     "ext_mem_211936") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_211944, &ext_mem_211928,
                                     "ext_mem_211928") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_211928,
                                       "ext_mem_211928") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_211936,
                                       "ext_mem_211936") != 0)
                        return 1;
                }
                if (memblock_set(ctx, &ext_mem_212464, &ext_mem_211952,
                                 "ext_mem_211952") != 0)
                    return 1;
                if (memblock_set(ctx, &ext_mem_212456, &ext_mem_211944,
                                 "ext_mem_211944") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_211944, "ext_mem_211944") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_211952, "ext_mem_211952") != 0)
                    return 1;
            } else {
                bool match_lit_206214 = (int64_t) 0 == d_t_203497;
                int64_t binop_y_211978 = (int64_t) 8 * n_203490;
                int64_t bytes_211979 = smax64((int64_t) 0, binop_y_211978);
                int64_t binop_y_212034 = (int64_t) 8 * q_t_203494;
                int64_t bytes_212035 = smax64((int64_t) 0, binop_y_212034);
                struct memblock ext_mem_212448;
                
                ext_mem_212448.references = NULL;
                
                struct memblock ext_mem_212440;
                
                ext_mem_212440.references = NULL;
                if (match_lit_206214) {
                    struct memblock mem_211963;
                    
                    mem_211963.references = NULL;
                    if (memblock_alloc(ctx, &mem_211963, bytes_209010,
                                       "mem_211963")) {
                        err = 1;
                        goto cleanup;
                    }
                    for (int64_t i_213649 = 0; i_213649 <
                         partition_sizze_203577; i_213649++) {
                        for (int64_t i_213650 = 0; i_213650 < t_n_m_203650;
                             i_213650++) {
                            ((double *) mem_211963.mem)[i_213649 *
                                                        t_n_m_203650 +
                                                        i_213650] = 0.0;
                        }
                    }
                    
                    struct memblock mem_211967;
                    
                    mem_211967.references = NULL;
                    if (memblock_alloc(ctx, &mem_211967, bytes_209010,
                                       "mem_211967")) {
                        err = 1;
                        goto cleanup;
                    }
                    if (mem_211980_cached_sizze_213787 <
                        (size_t) bytes_211979) {
                        mem_211980 = realloc(mem_211980, bytes_211979);
                        mem_211980_cached_sizze_213787 = bytes_211979;
                    }
                    if (mem_211995_cached_sizze_213788 <
                        (size_t) bytes_211979) {
                        mem_211995 = realloc(mem_211995, bytes_211979);
                        mem_211995_cached_sizze_213788 = bytes_211979;
                    }
                    if (mem_211998_cached_sizze_213789 <
                        (size_t) bytes_211979) {
                        mem_211998 = realloc(mem_211998, bytes_211979);
                        mem_211998_cached_sizze_213789 = bytes_211979;
                    }
                    if (mem_212036_cached_sizze_213790 <
                        (size_t) bytes_212035) {
                        mem_212036 = realloc(mem_212036, bytes_212035);
                        mem_212036_cached_sizze_213790 = bytes_212035;
                    }
                    for (int64_t i_207534 = 0; i_207534 <
                         partition_sizze_203577; i_207534++) {
                        int64_t x_206224;
                        
                        x_206224 = ((int64_t *) mem_208395)[i_207534];
                        for (int64_t i_207512 = 0; i_207512 < n_203490;
                             i_207512++) {
                            double x_206228;
                            
                            x_206228 = ((double *) mem_208352)[i_207534 *
                                                               n_203490 +
                                                               i_207512];
                            
                            double x_206229;
                            
                            x_206229 = ((double *) mem_211528.mem)[i_207534 *
                                                                   n_203490 +
                                                                   i_207512];
                            
                            double defunc_1_f_res_206230 = x_206228 - x_206229;
                            
                            ((double *) mem_211980)[i_207512] =
                                defunc_1_f_res_206230;
                        }
                        for (int64_t i_207518 = 0; i_207518 < n_203490;
                             i_207518++) {
                            int64_t x_206233;
                            
                            x_206233 = ((int64_t *) mem_208392)[i_207534 *
                                                                n_203490 +
                                                                i_207518];
                            
                            bool cond_206234 = sle64((int64_t) 0, x_206233);
                            double defunc_0_f_res_206235;
                            
                            if (cond_206234) {
                                bool y_206236 = slt64(x_206233, n_203490);
                                bool bounds_check_206237 = cond_206234 &&
                                     y_206236;
                                bool index_certs_206238;
                                
                                if (!bounds_check_206237) {
                                    ctx->error =
                                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                  "Index [",
                                                  (long long) x_206233,
                                                  "] out of bounds for array of shape [",
                                                  (long long) n_203490, "].",
                                                  "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:42:43-70\n   #3  stl.fut:281:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:279:13-284:41\n   #7  stl.fut:415:61-429:75\n   #8  stl.fut:455:3-469:34\n   #9  stl.fut:439:1-469:34\n");
                                    if (memblock_unref(ctx, &mem_211967,
                                                       "mem_211967") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_211963,
                                                       "mem_211963") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212440,
                                                       "ext_mem_212440") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212448,
                                                       "ext_mem_212448") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212456,
                                                       "ext_mem_212456") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212464,
                                                       "ext_mem_212464") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_211528,
                                                       "mem_211528") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_211517,
                                                       "ext_mem_211517") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_211457,
                                                       "ext_mem_211457") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_211465,
                                                       "ext_mem_211465") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_210632,
                                                       "ext_mem_210632") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_210518,
                                                       "ext_mem_210518") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_210529,
                                                       "ext_mem_210529") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209164,
                                                       "mem_param_209164") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209156,
                                                       "mem_param_209156") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212524,
                                                       "ext_mem_212524") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212525,
                                                       "ext_mem_212525") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209142,
                                                       "mem_param_209142") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209134,
                                                       "mem_param_209134") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209126,
                                                       "mem_param_209126") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212853,
                                                       "ext_mem_212853") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212854,
                                                       "ext_mem_212854") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212855,
                                                       "ext_mem_212855") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_209118,
                                                       "mem_209118") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_209114,
                                                       "mem_209114") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_213364,
                                                       "mem_out_213364") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_213363,
                                                       "mem_out_213363") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_213362,
                                                       "mem_out_213362") != 0)
                                        return 1;
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                double defunc_0_f_res_t_res_206239;
                                
                                defunc_0_f_res_t_res_206239 =
                                    ((double *) mem_211980)[x_206233];
                                defunc_0_f_res_206235 =
                                    defunc_0_f_res_t_res_206239;
                            } else {
                                defunc_0_f_res_206235 = 0.0;
                            }
                            
                            double defunc_0_f_res_206240;
                            
                            if (cond_206234) {
                                bool y_206241 = slt64(x_206233, n_203490);
                                bool bounds_check_206242 = cond_206234 &&
                                     y_206241;
                                bool index_certs_206243;
                                
                                if (!bounds_check_206242) {
                                    ctx->error =
                                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                  "Index [",
                                                  (long long) x_206233,
                                                  "] out of bounds for array of shape [",
                                                  (long long) n_203490, "].",
                                                  "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:42:43-70\n   #3  stl.fut:282:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:279:13-284:41\n   #7  stl.fut:415:61-429:75\n   #8  stl.fut:455:3-469:34\n   #9  stl.fut:439:1-469:34\n");
                                    if (memblock_unref(ctx, &mem_211967,
                                                       "mem_211967") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_211963,
                                                       "mem_211963") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212440,
                                                       "ext_mem_212440") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212448,
                                                       "ext_mem_212448") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212456,
                                                       "ext_mem_212456") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212464,
                                                       "ext_mem_212464") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_211528,
                                                       "mem_211528") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_211517,
                                                       "ext_mem_211517") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_211457,
                                                       "ext_mem_211457") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_211465,
                                                       "ext_mem_211465") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_210632,
                                                       "ext_mem_210632") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_210518,
                                                       "ext_mem_210518") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_210529,
                                                       "ext_mem_210529") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209164,
                                                       "mem_param_209164") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209156,
                                                       "mem_param_209156") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212524,
                                                       "ext_mem_212524") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212525,
                                                       "ext_mem_212525") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209142,
                                                       "mem_param_209142") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209134,
                                                       "mem_param_209134") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209126,
                                                       "mem_param_209126") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212853,
                                                       "ext_mem_212853") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212854,
                                                       "ext_mem_212854") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212855,
                                                       "ext_mem_212855") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_209118,
                                                       "mem_209118") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_209114,
                                                       "mem_209114") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_213364,
                                                       "mem_out_213364") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_213363,
                                                       "mem_out_213363") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_213362,
                                                       "mem_out_213362") != 0)
                                        return 1;
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                double defunc_0_f_res_t_res_206244;
                                
                                defunc_0_f_res_t_res_206244 =
                                    ((double *) mem_param_209142.mem)[ctx_param_ext_209137 +
                                                                      (i_207534 *
                                                                       ctx_param_ext_209138 +
                                                                       x_206233 *
                                                                       ctx_param_ext_209140)];
                                defunc_0_f_res_206240 =
                                    defunc_0_f_res_t_res_206244;
                            } else {
                                defunc_0_f_res_206240 = 0.0;
                            }
                            ((double *) mem_211995)[i_207518] =
                                defunc_0_f_res_206240;
                            ((double *) mem_211998)[i_207518] =
                                defunc_0_f_res_206235;
                        }
                        for (int64_t i_207530 = 0; i_207530 < t_n_m_203650;
                             i_207530++) {
                            int64_t x_206247;
                            
                            x_206247 = ((int64_t *) mem_209011)[i_207534 *
                                                                t_n_m_203650 +
                                                                i_207530];
                            
                            double x_206248;
                            
                            x_206248 = ((double *) mem_209015)[i_207534 *
                                                               t_n_m_203650 +
                                                               i_207530];
                            
                            int64_t min_arg_206249 = mul64(jump_t_203500,
                                                           i_207530);
                            int64_t min_res_206250 = smin64(i_203670,
                                                            min_arg_206249);
                            int64_t defunc_0_g_res_206251 = add64((int64_t) 1,
                                                                  min_res_206250);
                            double defunc_2_reduce_res_206252;
                            double redout_207522 = 0.0;
                            
                            for (int64_t i_207524 = 0; i_207524 < q_t_203494;
                                 i_207524++) {
                                bool cond_206258 = sle64(x_206224, i_207524);
                                int64_t defunc_0_f_res_206259;
                                
                                if (cond_206258) {
                                    defunc_0_f_res_206259 = (int64_t) 0;
                                } else {
                                    int64_t i_206260 = add64(x_206247,
                                                             i_207524);
                                    int64_t defunc_0_add_arg_206261;
                                    
                                    defunc_0_add_arg_206261 =
                                        ((int64_t *) mem_208392)[i_207534 *
                                                                 n_203490 +
                                                                 i_206260];
                                    
                                    int64_t defunc_1_add_res_206262 =
                                            add64((int64_t) 1,
                                                  defunc_0_add_arg_206261);
                                    
                                    defunc_0_f_res_206259 =
                                        defunc_1_add_res_206262;
                                }
                                
                                double defunc_0_f_res_206263;
                                
                                if (cond_206258) {
                                    defunc_0_f_res_206263 = 0.0;
                                } else {
                                    int64_t i_206264 = add64(x_206247,
                                                             i_207524);
                                    double defunc_0_add_arg_206265;
                                    
                                    defunc_0_add_arg_206265 =
                                        ((double *) mem_211995)[i_206264];
                                    defunc_0_f_res_206263 =
                                        defunc_0_add_arg_206265;
                                }
                                
                                int64_t binop_p_206266 =
                                        sub64(defunc_0_f_res_206259,
                                              defunc_0_g_res_206251);
                                double defunc_0_f_res_206267 =
                                       sitofp_i64_f64(binop_p_206266);
                                double abs_res_206268 =
                                       fabs(defunc_0_f_res_206267);
                                double tmp1_206269 = abs_res_206268 / x_206248;
                                double x_206270 = tmp1_206269 * tmp1_206269;
                                double y_206271 = tmp1_206269 * x_206270;
                                double tmp2_206272 = 1.0 - y_206271;
                                double x_206273 = tmp2_206272 * tmp2_206272;
                                double tmp3_206274 = tmp2_206272 * x_206273;
                                double tmp4_206275 = defunc_0_f_res_206263 *
                                       tmp3_206274;
                                double defunc_1_op_res_206256 = tmp4_206275 +
                                       redout_207522;
                                
                                ((double *) mem_212036)[i_207524] = tmp4_206275;
                                
                                double redout_tmp_213656 =
                                       defunc_1_op_res_206256;
                                
                                redout_207522 = redout_tmp_213656;
                            }
                            defunc_2_reduce_res_206252 = redout_207522;
                            
                            double a0_206276 = 1.0 / defunc_2_reduce_res_206252;
                            double defunc_2_reduce_res_206277;
                            double redout_207526 = 0.0;
                            
                            for (int64_t i_207527 = 0; i_207527 < q_t_203494;
                                 i_207527++) {
                                double x_206282;
                                
                                x_206282 = ((double *) mem_212036)[i_207527];
                                
                                bool cond_206283 = sle64(x_206224, i_207527);
                                double defunc_0_f_res_206284;
                                
                                if (cond_206283) {
                                    defunc_0_f_res_206284 = 0.0;
                                } else {
                                    int64_t i_206285 = add64(x_206247,
                                                             i_207527);
                                    double defunc_0_add_arg_206286;
                                    
                                    defunc_0_add_arg_206286 =
                                        ((double *) mem_211998)[i_206285];
                                    defunc_0_f_res_206284 =
                                        defunc_0_add_arg_206286;
                                }
                                
                                double x_206287 = a0_206276 * x_206282;
                                double defunc_9_fit_fun_res_206288 =
                                       defunc_0_f_res_206284 * x_206287;
                                double defunc_1_op_res_206280 =
                                       defunc_9_fit_fun_res_206288 +
                                       redout_207526;
                                double redout_tmp_213658 =
                                       defunc_1_op_res_206280;
                                
                                redout_207526 = redout_tmp_213658;
                            }
                            defunc_2_reduce_res_206277 = redout_207526;
                            ((double *) mem_211967.mem)[i_207534 *
                                                        t_n_m_203650 +
                                                        i_207530] =
                                defunc_2_reduce_res_206277;
                        }
                    }
                    if (memblock_set(ctx, &ext_mem_212448, &mem_211967,
                                     "mem_211967") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_212440, &mem_211963,
                                     "mem_211963") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_211967, "mem_211967") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_211963, "mem_211963") != 0)
                        return 1;
                } else {
                    bool match_lit_206291 = (int64_t) 1 == d_t_203497;
                    int64_t binop_y_212096 = (int64_t) 8 * n_203490;
                    int64_t bytes_212097 = smax64((int64_t) 0, binop_y_212096);
                    int64_t binop_y_212163 = (int64_t) 8 * q_t_203494;
                    int64_t bytes_212164 = smax64((int64_t) 0, binop_y_212163);
                    int64_t binop_y_212259 = (int64_t) 8 * n_203490;
                    int64_t bytes_212260 = smax64((int64_t) 0, binop_y_212259);
                    int64_t binop_y_212326 = (int64_t) 8 * q_t_203494;
                    int64_t bytes_212327 = smax64((int64_t) 0, binop_y_212326);
                    struct memblock ext_mem_212432;
                    
                    ext_mem_212432.references = NULL;
                    
                    struct memblock ext_mem_212424;
                    
                    ext_mem_212424.references = NULL;
                    if (match_lit_206291) {
                        struct memblock mem_212071;
                        
                        mem_212071.references = NULL;
                        if (memblock_alloc(ctx, &mem_212071, bytes_209010,
                                           "mem_212071")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_212075;
                        
                        mem_212075.references = NULL;
                        if (memblock_alloc(ctx, &mem_212075, bytes_209010,
                                           "mem_212075")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (mem_212098_cached_sizze_213791 <
                            (size_t) bytes_212097) {
                            mem_212098 = realloc(mem_212098, bytes_212097);
                            mem_212098_cached_sizze_213791 = bytes_212097;
                        }
                        if (mem_212113_cached_sizze_213792 <
                            (size_t) bytes_212097) {
                            mem_212113 = realloc(mem_212113, bytes_212097);
                            mem_212113_cached_sizze_213792 = bytes_212097;
                        }
                        if (mem_212116_cached_sizze_213793 <
                            (size_t) bytes_212097) {
                            mem_212116 = realloc(mem_212116, bytes_212097);
                            mem_212116_cached_sizze_213793 = bytes_212097;
                        }
                        if (mem_212165_cached_sizze_213794 <
                            (size_t) bytes_212164) {
                            mem_212165 = realloc(mem_212165, bytes_212164);
                            mem_212165_cached_sizze_213794 = bytes_212164;
                        }
                        if (mem_212168_cached_sizze_213795 <
                            (size_t) bytes_212164) {
                            mem_212168 = realloc(mem_212168, bytes_212164);
                            mem_212168_cached_sizze_213795 = bytes_212164;
                        }
                        for (int64_t i_207571 = 0; i_207571 <
                             partition_sizze_203577; i_207571++) {
                            int64_t x_206301;
                            
                            x_206301 = ((int64_t *) mem_208395)[i_207571];
                            for (int64_t i_207538 = 0; i_207538 < n_203490;
                                 i_207538++) {
                                double x_206305;
                                
                                x_206305 = ((double *) mem_208352)[i_207571 *
                                                                   n_203490 +
                                                                   i_207538];
                                
                                double x_206306;
                                
                                x_206306 =
                                    ((double *) mem_211528.mem)[i_207571 *
                                                                n_203490 +
                                                                i_207538];
                                
                                double defunc_1_f_res_206307 = x_206305 -
                                       x_206306;
                                
                                ((double *) mem_212098)[i_207538] =
                                    defunc_1_f_res_206307;
                            }
                            for (int64_t i_207544 = 0; i_207544 < n_203490;
                                 i_207544++) {
                                int64_t x_206310;
                                
                                x_206310 = ((int64_t *) mem_208392)[i_207571 *
                                                                    n_203490 +
                                                                    i_207544];
                                
                                bool cond_206311 = sle64((int64_t) 0, x_206310);
                                double defunc_0_f_res_206312;
                                
                                if (cond_206311) {
                                    bool y_206313 = slt64(x_206310, n_203490);
                                    bool bounds_check_206314 = cond_206311 &&
                                         y_206313;
                                    bool index_certs_206315;
                                    
                                    if (!bounds_check_206314) {
                                        ctx->error =
                                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                      "Index [",
                                                      (long long) x_206310,
                                                      "] out of bounds for array of shape [",
                                                      (long long) n_203490,
                                                      "].",
                                                      "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:42:43-70\n   #3  stl.fut:281:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:279:13-284:41\n   #7  stl.fut:415:61-429:75\n   #8  stl.fut:455:3-469:34\n   #9  stl.fut:439:1-469:34\n");
                                        if (memblock_unref(ctx, &mem_212075,
                                                           "mem_212075") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_212071,
                                                           "mem_212071") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212424,
                                                           "ext_mem_212424") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212432,
                                                           "ext_mem_212432") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212440,
                                                           "ext_mem_212440") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212448,
                                                           "ext_mem_212448") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212456,
                                                           "ext_mem_212456") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212464,
                                                           "ext_mem_212464") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_211528,
                                                           "mem_211528") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211517,
                                                           "ext_mem_211517") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211457,
                                                           "ext_mem_211457") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211465,
                                                           "ext_mem_211465") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210632,
                                                           "ext_mem_210632") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210518,
                                                           "ext_mem_210518") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210529,
                                                           "ext_mem_210529") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209164,
                                                           "mem_param_209164") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209156,
                                                           "mem_param_209156") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212524,
                                                           "ext_mem_212524") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212525,
                                                           "ext_mem_212525") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209142,
                                                           "mem_param_209142") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209134,
                                                           "mem_param_209134") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209126,
                                                           "mem_param_209126") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212853,
                                                           "ext_mem_212853") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212854,
                                                           "ext_mem_212854") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212855,
                                                           "ext_mem_212855") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209118,
                                                           "mem_209118") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209114,
                                                           "mem_209114") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213364,
                                                           "mem_out_213364") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213363,
                                                           "mem_out_213363") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213362,
                                                           "mem_out_213362") !=
                                            0)
                                            return 1;
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    double defunc_0_f_res_t_res_206316;
                                    
                                    defunc_0_f_res_t_res_206316 =
                                        ((double *) mem_212098)[x_206310];
                                    defunc_0_f_res_206312 =
                                        defunc_0_f_res_t_res_206316;
                                } else {
                                    defunc_0_f_res_206312 = 0.0;
                                }
                                
                                double defunc_0_f_res_206317;
                                
                                if (cond_206311) {
                                    bool y_206318 = slt64(x_206310, n_203490);
                                    bool bounds_check_206319 = cond_206311 &&
                                         y_206318;
                                    bool index_certs_206320;
                                    
                                    if (!bounds_check_206319) {
                                        ctx->error =
                                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                      "Index [",
                                                      (long long) x_206310,
                                                      "] out of bounds for array of shape [",
                                                      (long long) n_203490,
                                                      "].",
                                                      "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:42:43-70\n   #3  stl.fut:282:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:279:13-284:41\n   #7  stl.fut:415:61-429:75\n   #8  stl.fut:455:3-469:34\n   #9  stl.fut:439:1-469:34\n");
                                        if (memblock_unref(ctx, &mem_212075,
                                                           "mem_212075") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_212071,
                                                           "mem_212071") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212424,
                                                           "ext_mem_212424") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212432,
                                                           "ext_mem_212432") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212440,
                                                           "ext_mem_212440") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212448,
                                                           "ext_mem_212448") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212456,
                                                           "ext_mem_212456") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212464,
                                                           "ext_mem_212464") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_211528,
                                                           "mem_211528") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211517,
                                                           "ext_mem_211517") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211457,
                                                           "ext_mem_211457") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211465,
                                                           "ext_mem_211465") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210632,
                                                           "ext_mem_210632") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210518,
                                                           "ext_mem_210518") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210529,
                                                           "ext_mem_210529") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209164,
                                                           "mem_param_209164") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209156,
                                                           "mem_param_209156") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212524,
                                                           "ext_mem_212524") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212525,
                                                           "ext_mem_212525") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209142,
                                                           "mem_param_209142") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209134,
                                                           "mem_param_209134") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209126,
                                                           "mem_param_209126") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212853,
                                                           "ext_mem_212853") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212854,
                                                           "ext_mem_212854") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212855,
                                                           "ext_mem_212855") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209118,
                                                           "mem_209118") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209114,
                                                           "mem_209114") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213364,
                                                           "mem_out_213364") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213363,
                                                           "mem_out_213363") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213362,
                                                           "mem_out_213362") !=
                                            0)
                                            return 1;
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    double defunc_0_f_res_t_res_206321;
                                    
                                    defunc_0_f_res_t_res_206321 =
                                        ((double *) mem_param_209142.mem)[ctx_param_ext_209137 +
                                                                          (i_207571 *
                                                                           ctx_param_ext_209138 +
                                                                           x_206310 *
                                                                           ctx_param_ext_209140)];
                                    defunc_0_f_res_206317 =
                                        defunc_0_f_res_t_res_206321;
                                } else {
                                    defunc_0_f_res_206317 = 0.0;
                                }
                                ((double *) mem_212113)[i_207544] =
                                    defunc_0_f_res_206317;
                                ((double *) mem_212116)[i_207544] =
                                    defunc_0_f_res_206312;
                            }
                            for (int64_t i_207564 = 0; i_207564 < t_n_m_203650;
                                 i_207564++) {
                                int64_t x_206325;
                                
                                x_206325 = ((int64_t *) mem_209011)[i_207571 *
                                                                    t_n_m_203650 +
                                                                    i_207564];
                                
                                double x_206326;
                                
                                x_206326 = ((double *) mem_209015)[i_207571 *
                                                                   t_n_m_203650 +
                                                                   i_207564];
                                
                                int64_t min_arg_206327 = mul64(jump_t_203500,
                                                               i_207564);
                                int64_t min_res_206328 = smin64(i_203670,
                                                                min_arg_206327);
                                int64_t defunc_0_g_res_206329 =
                                        add64((int64_t) 1, min_res_206328);
                                double defunc_2_reduce_res_206353;
                                double defunc_2_reduce_res_206354;
                                double defunc_2_reduce_res_206355;
                                double redout_207549;
                                double redout_207550;
                                double redout_207551;
                                
                                redout_207549 = 0.0;
                                redout_207550 = 0.0;
                                redout_207551 = 0.0;
                                for (int64_t i_207554 = 0; i_207554 <
                                     q_t_203494; i_207554++) {
                                    bool cond_206368 = sle64(x_206301,
                                                             i_207554);
                                    int64_t defunc_0_f_res_206369;
                                    
                                    if (cond_206368) {
                                        defunc_0_f_res_206369 = (int64_t) 0;
                                    } else {
                                        int64_t i_206370 = add64(x_206325,
                                                                 i_207554);
                                        int64_t defunc_0_add_arg_206371;
                                        
                                        defunc_0_add_arg_206371 =
                                            ((int64_t *) mem_208392)[i_207571 *
                                                                     n_203490 +
                                                                     i_206370];
                                        
                                        int64_t defunc_1_add_res_206372 =
                                                add64((int64_t) 1,
                                                      defunc_0_add_arg_206371);
                                        
                                        defunc_0_f_res_206369 =
                                            defunc_1_add_res_206372;
                                    }
                                    
                                    double defunc_0_f_res_206373;
                                    
                                    if (cond_206368) {
                                        defunc_0_f_res_206373 = 0.0;
                                    } else {
                                        int64_t i_206374 = add64(x_206325,
                                                                 i_207554);
                                        double defunc_0_add_arg_206375;
                                        
                                        defunc_0_add_arg_206375 =
                                            ((double *) mem_212113)[i_206374];
                                        defunc_0_f_res_206373 =
                                            defunc_0_add_arg_206375;
                                    }
                                    
                                    int64_t binop_p_206376 =
                                            sub64(defunc_0_f_res_206369,
                                                  defunc_0_g_res_206329);
                                    double defunc_0_f_res_206377 =
                                           sitofp_i64_f64(binop_p_206376);
                                    double abs_res_206378 =
                                           fabs(defunc_0_f_res_206377);
                                    double tmp1_206379 = abs_res_206378 /
                                           x_206326;
                                    double x_206380 = tmp1_206379 * tmp1_206379;
                                    double y_206381 = tmp1_206379 * x_206380;
                                    double tmp2_206382 = 1.0 - y_206381;
                                    double x_206383 = tmp2_206382 * tmp2_206382;
                                    double tmp3_206384 = tmp2_206382 * x_206383;
                                    double tmp4_206385 = defunc_0_f_res_206373 *
                                           tmp3_206384;
                                    double defunc_1_f_res_206386 =
                                           defunc_0_f_res_206377 * tmp4_206385;
                                    double defunc_1_f_res_206387 =
                                           defunc_0_f_res_206377 *
                                           defunc_1_f_res_206386;
                                    double defunc_1_op_res_206360 =
                                           tmp4_206385 + redout_207549;
                                    double defunc_1_op_res_206363 =
                                           defunc_1_f_res_206386 +
                                           redout_207550;
                                    double defunc_1_op_res_206366 =
                                           defunc_1_f_res_206387 +
                                           redout_207551;
                                    
                                    ((double *) mem_212165)[i_207554] =
                                        defunc_1_f_res_206386;
                                    ((double *) mem_212168)[i_207554] =
                                        tmp4_206385;
                                    
                                    double redout_tmp_213666 =
                                           defunc_1_op_res_206360;
                                    double redout_tmp_213667 =
                                           defunc_1_op_res_206363;
                                    double redout_tmp_213668 =
                                           defunc_1_op_res_206366;
                                    
                                    redout_207549 = redout_tmp_213666;
                                    redout_207550 = redout_tmp_213667;
                                    redout_207551 = redout_tmp_213668;
                                }
                                defunc_2_reduce_res_206353 = redout_207549;
                                defunc_2_reduce_res_206354 = redout_207550;
                                defunc_2_reduce_res_206355 = redout_207551;
                                
                                double x_206393 = defunc_2_reduce_res_206353 *
                                       defunc_2_reduce_res_206355;
                                double y_206394 = defunc_2_reduce_res_206354 *
                                       defunc_2_reduce_res_206354;
                                double y_206395 = x_206393 - y_206394;
                                double det1_206396 = 1.0 / y_206395;
                                double a11_206397 = defunc_2_reduce_res_206355 *
                                       det1_206396;
                                double x_206398 = 0.0 -
                                       defunc_2_reduce_res_206354;
                                double b11_206399 = det1_206396 * x_206398;
                                double c11_206400 = defunc_2_reduce_res_206353 *
                                       det1_206396;
                                double defunc_2_reduce_res_206401;
                                double defunc_2_reduce_res_206402;
                                double redout_207557;
                                double redout_207558;
                                
                                redout_207557 = 0.0;
                                redout_207558 = 0.0;
                                for (int64_t i_207559 = 0; i_207559 <
                                     q_t_203494; i_207559++) {
                                    double x_206410;
                                    
                                    x_206410 =
                                        ((double *) mem_212168)[i_207559];
                                    
                                    double x_206411;
                                    
                                    x_206411 =
                                        ((double *) mem_212165)[i_207559];
                                    
                                    bool cond_206412 = sle64(x_206301,
                                                             i_207559);
                                    double defunc_0_f_res_206413;
                                    
                                    if (cond_206412) {
                                        defunc_0_f_res_206413 = 0.0;
                                    } else {
                                        int64_t i_206414 = add64(x_206325,
                                                                 i_207559);
                                        double defunc_0_add_arg_206415;
                                        
                                        defunc_0_add_arg_206415 =
                                            ((double *) mem_212116)[i_206414];
                                        defunc_0_f_res_206413 =
                                            defunc_0_add_arg_206415;
                                    }
                                    
                                    double x_206416 = a11_206397 * x_206410;
                                    double y_206417 = b11_206399 * x_206411;
                                    double x_206418 = x_206416 + y_206417;
                                    double defunc_9_fit_fun_res_206419 =
                                           defunc_0_f_res_206413 * x_206418;
                                    double x_206420 = b11_206399 * x_206410;
                                    double y_206421 = c11_206400 * x_206411;
                                    double x_206422 = x_206420 + y_206421;
                                    double defunc_9_slope_fun_res_206423 =
                                           defunc_0_f_res_206413 * x_206422;
                                    double defunc_1_op_res_206405 =
                                           defunc_9_fit_fun_res_206419 +
                                           redout_207557;
                                    double defunc_1_op_res_206408 =
                                           defunc_9_slope_fun_res_206423 +
                                           redout_207558;
                                    double redout_tmp_213671 =
                                           defunc_1_op_res_206405;
                                    double redout_tmp_213672 =
                                           defunc_1_op_res_206408;
                                    
                                    redout_207557 = redout_tmp_213671;
                                    redout_207558 = redout_tmp_213672;
                                }
                                defunc_2_reduce_res_206401 = redout_207557;
                                defunc_2_reduce_res_206402 = redout_207558;
                                ((double *) mem_212071.mem)[i_207571 *
                                                            t_n_m_203650 +
                                                            i_207564] =
                                    defunc_2_reduce_res_206401;
                                ((double *) mem_212075.mem)[i_207571 *
                                                            t_n_m_203650 +
                                                            i_207564] =
                                    defunc_2_reduce_res_206402;
                            }
                        }
                        if (memblock_set(ctx, &ext_mem_212432, &mem_212071,
                                         "mem_212071") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_212424, &mem_212075,
                                         "mem_212075") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_212075, "mem_212075") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_212071, "mem_212071") != 0)
                            return 1;
                    } else {
                        struct memblock mem_212234;
                        
                        mem_212234.references = NULL;
                        if (memblock_alloc(ctx, &mem_212234, bytes_209010,
                                           "mem_212234")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_212238;
                        
                        mem_212238.references = NULL;
                        if (memblock_alloc(ctx, &mem_212238, bytes_209010,
                                           "mem_212238")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (mem_212261_cached_sizze_213796 <
                            (size_t) bytes_212260) {
                            mem_212261 = realloc(mem_212261, bytes_212260);
                            mem_212261_cached_sizze_213796 = bytes_212260;
                        }
                        if (mem_212276_cached_sizze_213797 <
                            (size_t) bytes_212260) {
                            mem_212276 = realloc(mem_212276, bytes_212260);
                            mem_212276_cached_sizze_213797 = bytes_212260;
                        }
                        if (mem_212279_cached_sizze_213798 <
                            (size_t) bytes_212260) {
                            mem_212279 = realloc(mem_212279, bytes_212260);
                            mem_212279_cached_sizze_213798 = bytes_212260;
                        }
                        if (mem_212328_cached_sizze_213799 <
                            (size_t) bytes_212327) {
                            mem_212328 = realloc(mem_212328, bytes_212327);
                            mem_212328_cached_sizze_213799 = bytes_212327;
                        }
                        if (mem_212331_cached_sizze_213800 <
                            (size_t) bytes_212327) {
                            mem_212331 = realloc(mem_212331, bytes_212327);
                            mem_212331_cached_sizze_213800 = bytes_212327;
                        }
                        if (mem_212358_cached_sizze_213801 <
                            (size_t) bytes_212327) {
                            mem_212358 = realloc(mem_212358, bytes_212327);
                            mem_212358_cached_sizze_213801 = bytes_212327;
                        }
                        if (mem_212361_cached_sizze_213802 <
                            (size_t) bytes_212327) {
                            mem_212361 = realloc(mem_212361, bytes_212327);
                            mem_212361_cached_sizze_213802 = bytes_212327;
                        }
                        for (int64_t i_207618 = 0; i_207618 <
                             partition_sizze_203577; i_207618++) {
                            int64_t x_206433;
                            
                            x_206433 = ((int64_t *) mem_208395)[i_207618];
                            for (int64_t i_207576 = 0; i_207576 < n_203490;
                                 i_207576++) {
                                double x_206437;
                                
                                x_206437 = ((double *) mem_208352)[i_207618 *
                                                                   n_203490 +
                                                                   i_207576];
                                
                                double x_206438;
                                
                                x_206438 =
                                    ((double *) mem_211528.mem)[i_207618 *
                                                                n_203490 +
                                                                i_207576];
                                
                                double defunc_1_f_res_206439 = x_206437 -
                                       x_206438;
                                
                                ((double *) mem_212261)[i_207576] =
                                    defunc_1_f_res_206439;
                            }
                            for (int64_t i_207582 = 0; i_207582 < n_203490;
                                 i_207582++) {
                                int64_t x_206442;
                                
                                x_206442 = ((int64_t *) mem_208392)[i_207618 *
                                                                    n_203490 +
                                                                    i_207582];
                                
                                bool cond_206443 = sle64((int64_t) 0, x_206442);
                                double defunc_0_f_res_206444;
                                
                                if (cond_206443) {
                                    bool y_206445 = slt64(x_206442, n_203490);
                                    bool bounds_check_206446 = cond_206443 &&
                                         y_206445;
                                    bool index_certs_206447;
                                    
                                    if (!bounds_check_206446) {
                                        ctx->error =
                                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                      "Index [",
                                                      (long long) x_206442,
                                                      "] out of bounds for array of shape [",
                                                      (long long) n_203490,
                                                      "].",
                                                      "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:42:43-70\n   #3  stl.fut:281:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:279:13-284:41\n   #7  stl.fut:415:61-429:75\n   #8  stl.fut:455:3-469:34\n   #9  stl.fut:439:1-469:34\n");
                                        if (memblock_unref(ctx, &mem_212238,
                                                           "mem_212238") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_212234,
                                                           "mem_212234") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212424,
                                                           "ext_mem_212424") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212432,
                                                           "ext_mem_212432") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212440,
                                                           "ext_mem_212440") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212448,
                                                           "ext_mem_212448") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212456,
                                                           "ext_mem_212456") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212464,
                                                           "ext_mem_212464") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_211528,
                                                           "mem_211528") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211517,
                                                           "ext_mem_211517") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211457,
                                                           "ext_mem_211457") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211465,
                                                           "ext_mem_211465") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210632,
                                                           "ext_mem_210632") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210518,
                                                           "ext_mem_210518") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210529,
                                                           "ext_mem_210529") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209164,
                                                           "mem_param_209164") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209156,
                                                           "mem_param_209156") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212524,
                                                           "ext_mem_212524") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212525,
                                                           "ext_mem_212525") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209142,
                                                           "mem_param_209142") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209134,
                                                           "mem_param_209134") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209126,
                                                           "mem_param_209126") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212853,
                                                           "ext_mem_212853") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212854,
                                                           "ext_mem_212854") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212855,
                                                           "ext_mem_212855") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209118,
                                                           "mem_209118") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209114,
                                                           "mem_209114") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213364,
                                                           "mem_out_213364") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213363,
                                                           "mem_out_213363") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213362,
                                                           "mem_out_213362") !=
                                            0)
                                            return 1;
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    double defunc_0_f_res_t_res_206448;
                                    
                                    defunc_0_f_res_t_res_206448 =
                                        ((double *) mem_212261)[x_206442];
                                    defunc_0_f_res_206444 =
                                        defunc_0_f_res_t_res_206448;
                                } else {
                                    defunc_0_f_res_206444 = 0.0;
                                }
                                
                                double defunc_0_f_res_206449;
                                
                                if (cond_206443) {
                                    bool y_206450 = slt64(x_206442, n_203490);
                                    bool bounds_check_206451 = cond_206443 &&
                                         y_206450;
                                    bool index_certs_206452;
                                    
                                    if (!bounds_check_206451) {
                                        ctx->error =
                                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                      "Index [",
                                                      (long long) x_206442,
                                                      "] out of bounds for array of shape [",
                                                      (long long) n_203490,
                                                      "].",
                                                      "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:42:43-70\n   #3  stl.fut:282:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:279:13-284:41\n   #7  stl.fut:415:61-429:75\n   #8  stl.fut:455:3-469:34\n   #9  stl.fut:439:1-469:34\n");
                                        if (memblock_unref(ctx, &mem_212238,
                                                           "mem_212238") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_212234,
                                                           "mem_212234") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212424,
                                                           "ext_mem_212424") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212432,
                                                           "ext_mem_212432") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212440,
                                                           "ext_mem_212440") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212448,
                                                           "ext_mem_212448") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212456,
                                                           "ext_mem_212456") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212464,
                                                           "ext_mem_212464") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_211528,
                                                           "mem_211528") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211517,
                                                           "ext_mem_211517") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211457,
                                                           "ext_mem_211457") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211465,
                                                           "ext_mem_211465") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210632,
                                                           "ext_mem_210632") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210518,
                                                           "ext_mem_210518") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210529,
                                                           "ext_mem_210529") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209164,
                                                           "mem_param_209164") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209156,
                                                           "mem_param_209156") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212524,
                                                           "ext_mem_212524") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212525,
                                                           "ext_mem_212525") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209142,
                                                           "mem_param_209142") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209134,
                                                           "mem_param_209134") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209126,
                                                           "mem_param_209126") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212853,
                                                           "ext_mem_212853") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212854,
                                                           "ext_mem_212854") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212855,
                                                           "ext_mem_212855") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209118,
                                                           "mem_209118") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209114,
                                                           "mem_209114") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213364,
                                                           "mem_out_213364") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213363,
                                                           "mem_out_213363") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213362,
                                                           "mem_out_213362") !=
                                            0)
                                            return 1;
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    double defunc_0_f_res_t_res_206453;
                                    
                                    defunc_0_f_res_t_res_206453 =
                                        ((double *) mem_param_209142.mem)[ctx_param_ext_209137 +
                                                                          (i_207618 *
                                                                           ctx_param_ext_209138 +
                                                                           x_206442 *
                                                                           ctx_param_ext_209140)];
                                    defunc_0_f_res_206449 =
                                        defunc_0_f_res_t_res_206453;
                                } else {
                                    defunc_0_f_res_206449 = 0.0;
                                }
                                ((double *) mem_212276)[i_207582] =
                                    defunc_0_f_res_206449;
                                ((double *) mem_212279)[i_207582] =
                                    defunc_0_f_res_206444;
                            }
                            for (int64_t i_207611 = 0; i_207611 < t_n_m_203650;
                                 i_207611++) {
                                int64_t x_206457;
                                
                                x_206457 = ((int64_t *) mem_209011)[i_207618 *
                                                                    t_n_m_203650 +
                                                                    i_207611];
                                
                                double x_206458;
                                
                                x_206458 = ((double *) mem_209015)[i_207618 *
                                                                   t_n_m_203650 +
                                                                   i_207611];
                                
                                int64_t min_arg_206459 = mul64(jump_t_203500,
                                                               i_207611);
                                int64_t min_res_206460 = smin64(i_203670,
                                                                min_arg_206459);
                                int64_t defunc_0_g_res_206461 =
                                        add64((int64_t) 1, min_res_206460);
                                
                                for (int64_t i_207589 = 0; i_207589 <
                                     q_t_203494; i_207589++) {
                                    bool cond_206465 = sle64(x_206433,
                                                             i_207589);
                                    int64_t defunc_0_f_res_206466;
                                    
                                    if (cond_206465) {
                                        defunc_0_f_res_206466 = (int64_t) 0;
                                    } else {
                                        int64_t i_206467 = add64(x_206457,
                                                                 i_207589);
                                        int64_t defunc_0_add_arg_206468;
                                        
                                        defunc_0_add_arg_206468 =
                                            ((int64_t *) mem_208392)[i_207618 *
                                                                     n_203490 +
                                                                     i_206467];
                                        
                                        int64_t defunc_1_add_res_206469 =
                                                add64((int64_t) 1,
                                                      defunc_0_add_arg_206468);
                                        
                                        defunc_0_f_res_206466 =
                                            defunc_1_add_res_206469;
                                    }
                                    
                                    double defunc_0_f_res_206470;
                                    
                                    if (cond_206465) {
                                        defunc_0_f_res_206470 = 0.0;
                                    } else {
                                        int64_t i_206471 = add64(x_206457,
                                                                 i_207589);
                                        double defunc_0_add_arg_206472;
                                        
                                        defunc_0_add_arg_206472 =
                                            ((double *) mem_212276)[i_206471];
                                        defunc_0_f_res_206470 =
                                            defunc_0_add_arg_206472;
                                    }
                                    
                                    int64_t binop_p_206473 =
                                            sub64(defunc_0_f_res_206466,
                                                  defunc_0_g_res_206461);
                                    double defunc_0_f_res_206474 =
                                           sitofp_i64_f64(binop_p_206473);
                                    double abs_res_206475 =
                                           fabs(defunc_0_f_res_206474);
                                    double tmp1_206476 = abs_res_206475 /
                                           x_206458;
                                    double x_206477 = tmp1_206476 * tmp1_206476;
                                    double y_206478 = tmp1_206476 * x_206477;
                                    double tmp2_206479 = 1.0 - y_206478;
                                    double x_206480 = tmp2_206479 * tmp2_206479;
                                    double tmp3_206481 = tmp2_206479 * x_206480;
                                    double tmp4_206482 = defunc_0_f_res_206470 *
                                           tmp3_206481;
                                    
                                    ((double *) mem_212328)[i_207589] =
                                        defunc_0_f_res_206474;
                                    ((double *) mem_212331)[i_207589] =
                                        tmp4_206482;
                                }
                                
                                double defunc_2_reduce_res_206489;
                                double defunc_2_reduce_res_206490;
                                double defunc_2_reduce_res_206491;
                                double defunc_2_reduce_res_206492;
                                double defunc_2_reduce_res_206493;
                                double redout_207594;
                                double redout_207595;
                                double redout_207596;
                                double redout_207597;
                                double redout_207598;
                                
                                redout_207594 = 0.0;
                                redout_207595 = 0.0;
                                redout_207596 = 0.0;
                                redout_207597 = 0.0;
                                redout_207598 = 0.0;
                                for (int64_t i_207601 = 0; i_207601 <
                                     q_t_203494; i_207601++) {
                                    double x_206511;
                                    
                                    x_206511 =
                                        ((double *) mem_212328)[i_207601];
                                    
                                    double x_206512;
                                    
                                    x_206512 =
                                        ((double *) mem_212331)[i_207601];
                                    
                                    double defunc_1_f_res_206513 = x_206511 *
                                           x_206512;
                                    double defunc_1_f_res_206514 = x_206511 *
                                           defunc_1_f_res_206513;
                                    double defunc_1_f_res_206515 = x_206511 *
                                           defunc_1_f_res_206514;
                                    double defunc_1_f_res_206516 = x_206511 *
                                           defunc_1_f_res_206515;
                                    double defunc_1_op_res_206498 = x_206512 +
                                           redout_207594;
                                    double defunc_1_op_res_206501 =
                                           defunc_1_f_res_206513 +
                                           redout_207595;
                                    double defunc_1_op_res_206504 =
                                           defunc_1_f_res_206514 +
                                           redout_207596;
                                    double defunc_1_op_res_206507 =
                                           defunc_1_f_res_206515 +
                                           redout_207597;
                                    double defunc_1_op_res_206510 =
                                           defunc_1_f_res_206516 +
                                           redout_207598;
                                    
                                    ((double *) mem_212358)[i_207601] =
                                        defunc_1_f_res_206514;
                                    ((double *) mem_212361)[i_207601] =
                                        defunc_1_f_res_206513;
                                    
                                    double redout_tmp_213682 =
                                           defunc_1_op_res_206498;
                                    double redout_tmp_213683 =
                                           defunc_1_op_res_206501;
                                    double redout_tmp_213684 =
                                           defunc_1_op_res_206504;
                                    double redout_tmp_213685 =
                                           defunc_1_op_res_206507;
                                    double redout_tmp_213686 =
                                           defunc_1_op_res_206510;
                                    
                                    redout_207594 = redout_tmp_213682;
                                    redout_207595 = redout_tmp_213683;
                                    redout_207596 = redout_tmp_213684;
                                    redout_207597 = redout_tmp_213685;
                                    redout_207598 = redout_tmp_213686;
                                }
                                defunc_2_reduce_res_206489 = redout_207594;
                                defunc_2_reduce_res_206490 = redout_207595;
                                defunc_2_reduce_res_206491 = redout_207596;
                                defunc_2_reduce_res_206492 = redout_207597;
                                defunc_2_reduce_res_206493 = redout_207598;
                                
                                double x_206524 = defunc_2_reduce_res_206491 *
                                       defunc_2_reduce_res_206493;
                                double y_206525 = defunc_2_reduce_res_206492 *
                                       defunc_2_reduce_res_206492;
                                double a12_206526 = x_206524 - y_206525;
                                double x_206527 = defunc_2_reduce_res_206491 *
                                       defunc_2_reduce_res_206492;
                                double y_206528 = defunc_2_reduce_res_206490 *
                                       defunc_2_reduce_res_206493;
                                double b12_206529 = x_206527 - y_206528;
                                double x_206530 = defunc_2_reduce_res_206490 *
                                       defunc_2_reduce_res_206492;
                                double y_206531 = defunc_2_reduce_res_206491 *
                                       defunc_2_reduce_res_206491;
                                double c12_206532 = x_206530 - y_206531;
                                double x_206533 = defunc_2_reduce_res_206489 *
                                       defunc_2_reduce_res_206493;
                                double b2_206534 = x_206533 - y_206531;
                                double x_206535 = defunc_2_reduce_res_206490 *
                                       defunc_2_reduce_res_206491;
                                double y_206536 = defunc_2_reduce_res_206489 *
                                       defunc_2_reduce_res_206492;
                                double c2_206537 = x_206535 - y_206536;
                                double x_206538 = defunc_2_reduce_res_206489 *
                                       a12_206526;
                                double y_206539 = defunc_2_reduce_res_206490 *
                                       b12_206529;
                                double x_206540 = x_206538 + y_206539;
                                double y_206541 = defunc_2_reduce_res_206491 *
                                       c12_206532;
                                double y_206542 = x_206540 + y_206541;
                                double det_206543 = 1.0 / y_206542;
                                double a12_206544 = a12_206526 * det_206543;
                                double b12_206545 = b12_206529 * det_206543;
                                double c12_206546 = c12_206532 * det_206543;
                                double b2_206547 = b2_206534 * det_206543;
                                double c2_206548 = c2_206537 * det_206543;
                                double defunc_2_reduce_res_206549;
                                double defunc_2_reduce_res_206550;
                                double redout_207604;
                                double redout_207605;
                                
                                redout_207604 = 0.0;
                                redout_207605 = 0.0;
                                for (int64_t i_207606 = 0; i_207606 <
                                     q_t_203494; i_207606++) {
                                    double x_206558;
                                    
                                    x_206558 =
                                        ((double *) mem_212331)[i_207606];
                                    
                                    double x_206559;
                                    
                                    x_206559 =
                                        ((double *) mem_212361)[i_207606];
                                    
                                    double x_206560;
                                    
                                    x_206560 =
                                        ((double *) mem_212358)[i_207606];
                                    
                                    bool cond_206561 = sle64(x_206433,
                                                             i_207606);
                                    double defunc_0_f_res_206562;
                                    
                                    if (cond_206561) {
                                        defunc_0_f_res_206562 = 0.0;
                                    } else {
                                        int64_t i_206563 = add64(x_206457,
                                                                 i_207606);
                                        double defunc_0_add_arg_206564;
                                        
                                        defunc_0_add_arg_206564 =
                                            ((double *) mem_212279)[i_206563];
                                        defunc_0_f_res_206562 =
                                            defunc_0_add_arg_206564;
                                    }
                                    
                                    double x_206565 = a12_206544 * x_206558;
                                    double y_206566 = b12_206545 * x_206559;
                                    double x_206567 = x_206565 + y_206566;
                                    double y_206568 = c12_206546 * x_206560;
                                    double x_206569 = x_206567 + y_206568;
                                    double defunc_9_fit_fun_res_206570 =
                                           defunc_0_f_res_206562 * x_206569;
                                    double x_206571 = b12_206545 * x_206558;
                                    double y_206572 = b2_206547 * x_206559;
                                    double x_206573 = x_206571 + y_206572;
                                    double y_206574 = c2_206548 * x_206560;
                                    double x_206575 = x_206573 + y_206574;
                                    double defunc_9_slope_fun_res_206576 =
                                           defunc_0_f_res_206562 * x_206575;
                                    double defunc_1_op_res_206553 =
                                           defunc_9_fit_fun_res_206570 +
                                           redout_207604;
                                    double defunc_1_op_res_206556 =
                                           defunc_9_slope_fun_res_206576 +
                                           redout_207605;
                                    double redout_tmp_213689 =
                                           defunc_1_op_res_206553;
                                    double redout_tmp_213690 =
                                           defunc_1_op_res_206556;
                                    
                                    redout_207604 = redout_tmp_213689;
                                    redout_207605 = redout_tmp_213690;
                                }
                                defunc_2_reduce_res_206549 = redout_207604;
                                defunc_2_reduce_res_206550 = redout_207605;
                                ((double *) mem_212234.mem)[i_207618 *
                                                            t_n_m_203650 +
                                                            i_207611] =
                                    defunc_2_reduce_res_206549;
                                ((double *) mem_212238.mem)[i_207618 *
                                                            t_n_m_203650 +
                                                            i_207611] =
                                    defunc_2_reduce_res_206550;
                            }
                        }
                        if (memblock_set(ctx, &ext_mem_212432, &mem_212234,
                                         "mem_212234") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_212424, &mem_212238,
                                         "mem_212238") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_212238, "mem_212238") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_212234, "mem_212234") != 0)
                            return 1;
                    }
                    if (memblock_set(ctx, &ext_mem_212448, &ext_mem_212432,
                                     "ext_mem_212432") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_212440, &ext_mem_212424,
                                     "ext_mem_212424") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212424,
                                       "ext_mem_212424") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212432,
                                       "ext_mem_212432") != 0)
                        return 1;
                }
                if (memblock_set(ctx, &ext_mem_212464, &ext_mem_212448,
                                 "ext_mem_212448") != 0)
                    return 1;
                if (memblock_set(ctx, &ext_mem_212456, &ext_mem_212440,
                                 "ext_mem_212440") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_212440, "ext_mem_212440") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_212448, "ext_mem_212448") != 0)
                    return 1;
            }
            
            struct memblock ext_mem_212516;
            
            ext_mem_212516.references = NULL;
            if (cond_204108) {
                bool zzero_206580 = jump_t_203500 == (int64_t) 0;
                bool nonzzero_206581 = !zzero_206580;
                bool nonzzero_cert_206582;
                
                if (!nonzzero_206581) {
                    ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                                           "division by zero",
                                           "-> #0  loess.fut:547:20-27\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:546:3-550:9\n   #5  stl.fut:304:23-75\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:303:15-305:43\n   #9  stl.fut:415:61-429:75\n   #10 stl.fut:455:3-469:34\n   #11 stl.fut:439:1-469:34\n");
                    if (memblock_unref(ctx, &ext_mem_212516,
                                       "ext_mem_212516") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212456,
                                       "ext_mem_212456") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212464,
                                       "ext_mem_212464") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_211528, "mem_211528") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_211517,
                                       "ext_mem_211517") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_211457,
                                       "ext_mem_211457") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_211465,
                                       "ext_mem_211465") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_210632,
                                       "ext_mem_210632") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_210518,
                                       "ext_mem_210518") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_210529,
                                       "ext_mem_210529") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209164,
                                       "mem_param_209164") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209156,
                                       "mem_param_209156") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212524,
                                       "ext_mem_212524") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212525,
                                       "ext_mem_212525") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209142,
                                       "mem_param_209142") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209134,
                                       "mem_param_209134") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209126,
                                       "mem_param_209126") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212853,
                                       "ext_mem_212853") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212854,
                                       "ext_mem_212854") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212855,
                                       "ext_mem_212855") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_209118, "mem_209118") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_209114, "mem_209114") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213364,
                                       "mem_out_213364") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213363,
                                       "mem_out_213363") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213362,
                                       "mem_out_213362") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                int64_t y_206583 = sub64(t_n_m_203650, (int64_t) 1);
                struct memblock mem_212475;
                
                mem_212475.references = NULL;
                if (memblock_alloc(ctx, &mem_212475, bytes_208391,
                                   "mem_212475")) {
                    err = 1;
                    goto cleanup;
                }
                for (int64_t i_207627 = 0; i_207627 < partition_sizze_203577;
                     i_207627++) {
                    for (int64_t i_207623 = 0; i_207623 < n_203490;
                         i_207623++) {
                        int64_t m_v_206589 = sdiv64(i_207623, jump_t_203500);
                        bool cond_206590 = m_v_206589 == y_206583;
                        int64_t j_206591;
                        
                        if (cond_206590) {
                            int64_t j_t_res_206592 = sub64(m_v_206589,
                                                           (int64_t) 1);
                            
                            j_206591 = j_t_res_206592;
                        } else {
                            j_206591 = m_v_206589;
                        }
                        
                        int64_t min_arg_206593 = mul64(jump_t_203500, j_206591);
                        int64_t min_res_206594 = smin64(i_203670,
                                                        min_arg_206593);
                        int64_t defunc_0_m_fun_arg_206595 = add64((int64_t) 1,
                                                                  j_206591);
                        int64_t min_arg_206596 = mul64(jump_t_203500,
                                                       defunc_0_m_fun_arg_206595);
                        int64_t min_res_206597 = smin64(i_203670,
                                                        min_arg_206596);
                        int64_t i64_arg_206598 = sub64(min_res_206597,
                                                       min_res_206594);
                        double i64_res_206599 = sitofp_i64_f64(i64_arg_206598);
                        int64_t i64_arg_206600 = sub64(i_207623,
                                                       min_res_206594);
                        double i64_res_206601 = sitofp_i64_f64(i64_arg_206600);
                        double u_206602 = i64_res_206601 / i64_res_206599;
                        double u2_206603 = u_206602 * u_206602;
                        double u3_206604 = u_206602 * u2_206603;
                        double x_206605 = 2.0 * u3_206604;
                        double y_206606 = 3.0 * u2_206603;
                        double x_206607 = x_206605 - y_206606;
                        double x_206608 = 1.0 + x_206607;
                        bool x_206609 = sle64((int64_t) 0, j_206591);
                        bool y_206610 = slt64(j_206591, t_n_m_203650);
                        bool bounds_check_206611 = x_206609 && y_206610;
                        bool index_certs_206612;
                        
                        if (!bounds_check_206611) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) j_206591,
                                          "] out of bounds for array of shape [",
                                          (long long) t_n_m_203650, "].",
                                          "-> #0  loess.fut:536:27-33\n   #1  loess.fut:549:13-50\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:546:3-550:9\n   #6  stl.fut:304:23-75\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:303:15-305:43\n   #10 stl.fut:415:61-429:75\n   #11 stl.fut:455:3-469:34\n   #12 stl.fut:439:1-469:34\n");
                            if (memblock_unref(ctx, &mem_212475,
                                               "mem_212475") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212516,
                                               "ext_mem_212516") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212456,
                                               "ext_mem_212456") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212464,
                                               "ext_mem_212464") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_211528,
                                               "mem_211528") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_211517,
                                               "ext_mem_211517") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_211457,
                                               "ext_mem_211457") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_211465,
                                               "ext_mem_211465") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210632,
                                               "ext_mem_210632") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210518,
                                               "ext_mem_210518") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210529,
                                               "ext_mem_210529") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209164,
                                               "mem_param_209164") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209156,
                                               "mem_param_209156") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212524,
                                               "ext_mem_212524") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212525,
                                               "ext_mem_212525") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209142,
                                               "mem_param_209142") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209134,
                                               "mem_param_209134") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209126,
                                               "mem_param_209126") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212853,
                                               "ext_mem_212853") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212854,
                                               "ext_mem_212854") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212855,
                                               "ext_mem_212855") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209118,
                                               "mem_209118") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209114,
                                               "mem_209114") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213364,
                                               "mem_out_213364") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213363,
                                               "mem_out_213363") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213362,
                                               "mem_out_213362") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        double y_206613;
                        
                        y_206613 = ((double *) ext_mem_212464.mem)[i_207627 *
                                                                   t_n_m_203650 +
                                                                   j_206591];
                        
                        double x_206614 = x_206608 * y_206613;
                        double x_206615 = y_206606 - x_206605;
                        bool x_206616 = sle64((int64_t) 0,
                                              defunc_0_m_fun_arg_206595);
                        bool y_206617 = slt64(defunc_0_m_fun_arg_206595,
                                              t_n_m_203650);
                        bool bounds_check_206618 = x_206616 && y_206617;
                        bool index_certs_206619;
                        
                        if (!bounds_check_206618) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [",
                                          (long long) defunc_0_m_fun_arg_206595,
                                          "] out of bounds for array of shape [",
                                          (long long) t_n_m_203650, "].",
                                          "-> #0  loess.fut:537:27-37\n   #1  loess.fut:549:13-50\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:546:3-550:9\n   #6  stl.fut:304:23-75\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:303:15-305:43\n   #10 stl.fut:415:61-429:75\n   #11 stl.fut:455:3-469:34\n   #12 stl.fut:439:1-469:34\n");
                            if (memblock_unref(ctx, &mem_212475,
                                               "mem_212475") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212516,
                                               "ext_mem_212516") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212456,
                                               "ext_mem_212456") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212464,
                                               "ext_mem_212464") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_211528,
                                               "mem_211528") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_211517,
                                               "ext_mem_211517") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_211457,
                                               "ext_mem_211457") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_211465,
                                               "ext_mem_211465") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210632,
                                               "ext_mem_210632") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210518,
                                               "ext_mem_210518") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210529,
                                               "ext_mem_210529") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209164,
                                               "mem_param_209164") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209156,
                                               "mem_param_209156") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212524,
                                               "ext_mem_212524") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212525,
                                               "ext_mem_212525") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209142,
                                               "mem_param_209142") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209134,
                                               "mem_param_209134") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209126,
                                               "mem_param_209126") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212853,
                                               "ext_mem_212853") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212854,
                                               "ext_mem_212854") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212855,
                                               "ext_mem_212855") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209118,
                                               "mem_209118") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209114,
                                               "mem_209114") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213364,
                                               "mem_out_213364") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213363,
                                               "mem_out_213363") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213362,
                                               "mem_out_213362") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        double y_206620;
                        
                        y_206620 = ((double *) ext_mem_212464.mem)[i_207627 *
                                                                   t_n_m_203650 +
                                                                   defunc_0_m_fun_arg_206595];
                        
                        double y_206621 = x_206615 * y_206620;
                        double x_206622 = x_206614 + y_206621;
                        double y_206623 = 2.0 * u2_206603;
                        double x_206624 = u3_206604 - y_206623;
                        double x_206625 = u_206602 + x_206624;
                        double y_206626;
                        
                        y_206626 = ((double *) ext_mem_212456.mem)[i_207627 *
                                                                   t_n_m_203650 +
                                                                   j_206591];
                        
                        double x_206627 = x_206625 * y_206626;
                        double y_206628 = i64_res_206599 * x_206627;
                        double x_206629 = x_206622 + y_206628;
                        double x_206630 = u3_206604 - u2_206603;
                        double y_206631;
                        
                        y_206631 = ((double *) ext_mem_212456.mem)[i_207627 *
                                                                   t_n_m_203650 +
                                                                   defunc_0_m_fun_arg_206595];
                        
                        double x_206632 = x_206630 * y_206631;
                        double y_206633 = i64_res_206599 * x_206632;
                        double defunc_4_interpolate_proc_res_206634 = x_206629 +
                               y_206633;
                        
                        ((double *) mem_212475.mem)[i_207627 * n_203490 +
                                                    i_207623] =
                            defunc_4_interpolate_proc_res_206634;
                    }
                }
                if (memblock_set(ctx, &ext_mem_212516, &mem_212475,
                                 "mem_212475") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_212475, "mem_212475") != 0)
                    return 1;
            } else {
                bool dim_match_206636 = n_203490 == t_n_m_203650;
                bool empty_or_match_cert_206637;
                
                if (!dim_match_206636) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Value of (core language) shape (",
                                  (long long) partition_sizze_203577, ", ",
                                  (long long) t_n_m_203650,
                                  ") cannot match shape of type `[",
                                  (long long) partition_sizze_203577, "][",
                                  (long long) n_203490, "]t`.",
                                  "-> #0  stl.fut:307:15-36\n   #1  stl.fut:415:61-429:75\n   #2  stl.fut:455:3-469:34\n   #3  stl.fut:439:1-469:34\n");
                    if (memblock_unref(ctx, &ext_mem_212516,
                                       "ext_mem_212516") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212456,
                                       "ext_mem_212456") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212464,
                                       "ext_mem_212464") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_211528, "mem_211528") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_211517,
                                       "ext_mem_211517") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_211457,
                                       "ext_mem_211457") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_211465,
                                       "ext_mem_211465") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_210632,
                                       "ext_mem_210632") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_210518,
                                       "ext_mem_210518") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_210529,
                                       "ext_mem_210529") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209164,
                                       "mem_param_209164") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209156,
                                       "mem_param_209156") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212524,
                                       "ext_mem_212524") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212525,
                                       "ext_mem_212525") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209142,
                                       "mem_param_209142") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209134,
                                       "mem_param_209134") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209126,
                                       "mem_param_209126") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212853,
                                       "ext_mem_212853") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212854,
                                       "ext_mem_212854") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212855,
                                       "ext_mem_212855") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_209118, "mem_209118") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_209114, "mem_209114") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213364,
                                       "mem_out_213364") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213363,
                                       "mem_out_213363") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213362,
                                       "mem_out_213362") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                if (memblock_set(ctx, &ext_mem_212516, &ext_mem_212464,
                                 "ext_mem_212464") != 0)
                    return 1;
            }
            if (memblock_unref(ctx, &ext_mem_212456, "ext_mem_212456") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_212464, "ext_mem_212464") != 0)
                return 1;
            
            int64_t ctx_param_ext_tmp_213446 = ext_212520;
            int64_t ctx_param_ext_tmp_213447 = ext_212519;
            struct memblock mem_param_tmp_213448;
            
            mem_param_tmp_213448.references = NULL;
            if (memblock_set(ctx, &mem_param_tmp_213448, &mem_211528,
                             "mem_211528") != 0)
                return 1;
            
            struct memblock mem_param_tmp_213449;
            
            mem_param_tmp_213449.references = NULL;
            if (memblock_set(ctx, &mem_param_tmp_213449, &ext_mem_212516,
                             "ext_mem_212516") != 0)
                return 1;
            ctx_param_ext_209158 = ctx_param_ext_tmp_213446;
            ctx_param_ext_209160 = ctx_param_ext_tmp_213447;
            if (memblock_set(ctx, &mem_param_209156, &mem_param_tmp_213448,
                             "mem_param_tmp_213448") != 0)
                return 1;
            if (memblock_set(ctx, &mem_param_209164, &mem_param_tmp_213449,
                             "mem_param_tmp_213449") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_param_tmp_213449,
                               "mem_param_tmp_213449") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_param_tmp_213448,
                               "mem_param_tmp_213448") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_212516, "ext_mem_212516") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_212456, "ext_mem_212456") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_212464, "ext_mem_212464") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_211528, "mem_211528") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_211517, "ext_mem_211517") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_211457, "ext_mem_211457") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_211465, "ext_mem_211465") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_210632, "ext_mem_210632") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_210518, "ext_mem_210518") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_210529, "ext_mem_210529") != 0)
                return 1;
        }
        ext_212531 = ctx_param_ext_209158;
        ext_212529 = ctx_param_ext_209160;
        if (memblock_set(ctx, &ext_mem_212525, &mem_param_209156,
                         "mem_param_209156") != 0)
            return 1;
        if (memblock_set(ctx, &ext_mem_212524, &mem_param_209164,
                         "mem_param_209164") != 0)
            return 1;
        
        bool cond_206639 = slt64(i_outer_204192, y_204109);
        int64_t ext_212852;
        
        if (cond_206639) {
            ext_212852 = partition_sizze_203577;
        } else {
            ext_212852 = ctx_param_ext_209139;
        }
        
        int64_t ext_212851;
        
        if (cond_206639) {
            ext_212851 = n_203490;
        } else {
            ext_212851 = ctx_param_ext_209141;
        }
        
        int64_t ext_212850;
        
        if (cond_206639) {
            ext_212850 = partition_sizze_203577;
        } else {
            ext_212850 = ctx_param_ext_209135;
        }
        
        int64_t ext_212849;
        
        if (cond_206639) {
            ext_212849 = n_203490;
        } else {
            ext_212849 = ctx_param_ext_209136;
        }
        
        int64_t ext_212848;
        
        if (cond_206639) {
            ext_212848 = n_203490;
        } else {
            ext_212848 = ctx_param_ext_209138;
        }
        
        int64_t ext_212847;
        
        if (cond_206639) {
            ext_212847 = (int64_t) 1;
        } else {
            ext_212847 = ctx_param_ext_209140;
        }
        
        int64_t ext_212846;
        
        if (cond_206639) {
            ext_212846 = (int64_t) 0;
        } else {
            ext_212846 = ctx_param_ext_209137;
        }
        
        struct memblock ext_mem_212845;
        
        ext_mem_212845.references = NULL;
        if (cond_206639) {
            if (mem_212543_cached_sizze_213803 < (size_t) bytes_208391) {
                mem_212543 = realloc(mem_212543, bytes_208391);
                mem_212543_cached_sizze_213803 = bytes_208391;
            }
            if (mem_212547_cached_sizze_213804 < (size_t) bytes_208391) {
                mem_212547 = realloc(mem_212547, bytes_208391);
                mem_212547_cached_sizze_213804 = bytes_208391;
            }
            for (int64_t i_207641 = 0; i_207641 < partition_sizze_203577;
                 i_207641++) {
                for (int64_t i_207631 = 0; i_207631 < n_203490; i_207631++) {
                    double x_206648;
                    
                    x_206648 = ((double *) mem_208352)[i_207641 * n_203490 +
                                                       i_207631];
                    
                    double x_206649;
                    
                    x_206649 = ((double *) ext_mem_212525.mem)[i_207641 *
                                                               n_203490 +
                                                               i_207631];
                    
                    double x_206650;
                    
                    x_206650 = ((double *) ext_mem_212524.mem)[i_207641 *
                                                               ext_212529 +
                                                               i_207631];
                    
                    double x_206651 = x_206648 - x_206649;
                    double defunc_2_f_res_206652 = x_206651 - x_206650;
                    bool isnan_res_206653;
                    
                    isnan_res_206653 = futrts_isnan64(defunc_2_f_res_206652);
                    
                    double defunc_0_f_res_206654;
                    
                    if (isnan_res_206653) {
                        defunc_0_f_res_206654 = defunc_2_f_res_206652;
                    } else {
                        double abs_res_206655 = fabs(defunc_2_f_res_206652);
                        
                        defunc_0_f_res_206654 = abs_res_206655;
                    }
                    ((double *) mem_212547)[i_207641 * n_203490 + i_207631] =
                        defunc_0_f_res_206654;
                }
                for (int64_t i_207635 = 0; i_207635 < n_203490; i_207635++) {
                    int64_t x_206657;
                    
                    x_206657 = ((int64_t *) mem_208392)[i_207641 * n_203490 +
                                                        i_207635];
                    
                    bool cond_206658 = sle64((int64_t) 0, x_206657);
                    double defunc_0_f_res_206659;
                    
                    if (cond_206658) {
                        bool y_206660 = slt64(x_206657, n_203490);
                        bool bounds_check_206661 = cond_206658 && y_206660;
                        bool index_certs_206662;
                        
                        if (!bounds_check_206661) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) x_206657,
                                          "] out of bounds for array of shape [",
                                          (long long) n_203490, "].",
                                          "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:334:21-49\n   #3  /prelude/soacs.fut:67:19-23\n   #4  /prelude/soacs.fut:67:3-37\n   #5  stl.fut:332:13-335:35\n   #6  stl.fut:415:61-429:75\n   #7  stl.fut:455:3-469:34\n   #8  stl.fut:439:1-469:34\n");
                            if (memblock_unref(ctx, &ext_mem_212845,
                                               "ext_mem_212845") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209164,
                                               "mem_param_209164") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209156,
                                               "mem_param_209156") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212524,
                                               "ext_mem_212524") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212525,
                                               "ext_mem_212525") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209142,
                                               "mem_param_209142") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209134,
                                               "mem_param_209134") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209126,
                                               "mem_param_209126") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212853,
                                               "ext_mem_212853") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212854,
                                               "ext_mem_212854") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212855,
                                               "ext_mem_212855") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209118,
                                               "mem_209118") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209114,
                                               "mem_209114") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213364,
                                               "mem_out_213364") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213363,
                                               "mem_out_213363") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213362,
                                               "mem_out_213362") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        double defunc_0_f_res_t_res_206663;
                        
                        defunc_0_f_res_t_res_206663 =
                            ((double *) mem_212547)[i_207641 * n_203490 +
                                                    x_206657];
                        defunc_0_f_res_206659 = defunc_0_f_res_t_res_206663;
                    } else {
                        defunc_0_f_res_206659 = INFINITY;
                    }
                    ((double *) mem_212543)[i_207641 * n_203490 + i_207635] =
                        defunc_0_f_res_206659;
                }
            }
            
            bool loop_nonempty_206666 = slt32(0, iters_206665);
            bool loop_not_taken_206667 = !loop_nonempty_206666;
            bool protect_assert_disj_206668 = bounds_check_203673 ||
                 loop_not_taken_206667;
            bool index_certs_206669;
            
            if (!protect_assert_disj_206668) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) i_203670,
                              "] out of bounds for array of shape [",
                              (long long) n_203490, "].",
                              "-> #0  /prelude/array.fut:26:29-34\n   #1  lib/github.com/diku-dk/sorts/radix_sort.fut:25:24-35\n   #2  lib/github.com/diku-dk/sorts/radix_sort.fut:53:31-62\n   #3  lib/github.com/diku-dk/sorts/radix_sort.fut:104:6-36\n   #4  stl.fut:338:35-77\n   #5  stl.fut:337:28-339:40\n   #6  stl.fut:415:61-429:75\n   #7  stl.fut:455:3-469:34\n   #8  stl.fut:439:1-469:34\n");
                if (memblock_unref(ctx, &ext_mem_212845, "ext_mem_212845") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_209164,
                                   "mem_param_209164") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_209156,
                                   "mem_param_209156") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_212524, "ext_mem_212524") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_212525, "ext_mem_212525") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_209142,
                                   "mem_param_209142") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_209134,
                                   "mem_param_209134") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_209126,
                                   "mem_param_209126") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_212853, "ext_mem_212853") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_212854, "ext_mem_212854") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_212855, "ext_mem_212855") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_209118, "mem_209118") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_209114, "mem_209114") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_213364, "mem_out_213364") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_213363, "mem_out_213363") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_213362, "mem_out_213362") != 0)
                    return 1;
                err = 1;
                goto cleanup;
            }
            if (mem_212631_cached_sizze_213805 < (size_t) bytes_208391) {
                mem_212631 = realloc(mem_212631, bytes_208391);
                mem_212631_cached_sizze_213805 = bytes_208391;
            }
            if (mem_212652_cached_sizze_213806 < (size_t) bytes_212651) {
                mem_212652 = realloc(mem_212652, bytes_212651);
                mem_212652_cached_sizze_213806 = bytes_212651;
            }
            if (mem_212655_cached_sizze_213807 < (size_t) bytes_212651) {
                mem_212655 = realloc(mem_212655, bytes_212651);
                mem_212655_cached_sizze_213807 = bytes_212651;
            }
            if (mem_212658_cached_sizze_213808 < (size_t) bytes_212651) {
                mem_212658 = realloc(mem_212658, bytes_212651);
                mem_212658_cached_sizze_213808 = bytes_212651;
            }
            if (mem_212661_cached_sizze_213809 < (size_t) bytes_212651) {
                mem_212661 = realloc(mem_212661, bytes_212651);
                mem_212661_cached_sizze_213809 = bytes_212651;
            }
            if (mem_212664_cached_sizze_213810 < (size_t) bytes_212663) {
                mem_212664 = realloc(mem_212664, bytes_212663);
                mem_212664_cached_sizze_213810 = bytes_212663;
            }
            if (mem_212727_cached_sizze_213811 < (size_t) bytes_212651) {
                mem_212727 = realloc(mem_212727, bytes_212651);
                mem_212727_cached_sizze_213811 = bytes_212651;
            }
            for (int64_t i_207679 = 0; i_207679 < partition_sizze_203577;
                 i_207679++) {
                if (n_203490 * (int64_t) 8 > 0)
                    memmove(mem_212631 + i_207679 * n_203490 * (int64_t) 8,
                            mem_212543 + ((int64_t) 0 + i_207679 * n_203490) *
                            (int64_t) 8, n_203490 * (int64_t) 8);
                for (int32_t i_206673 = 0; i_206673 < iters_206665;
                     i_206673++) {
                    int32_t defunc_2_radix_sort_step_arg_206675 = mul32(2,
                                                                        i_206673);
                    int32_t defunc_0_get_bit_arg_206676 = add32(1,
                                                                defunc_2_radix_sort_step_arg_206675);
                    bool cond_f_res_206677 = defunc_0_get_bit_arg_206676 == 63;
                    bool cond_f_res_206678 =
                         defunc_2_radix_sort_step_arg_206675 == 63;
                    int64_t unsign_arg_206679 =
                            zext_i32_i64(defunc_0_get_bit_arg_206676);
                    int64_t unsign_arg_206680 =
                            zext_i32_i64(defunc_2_radix_sort_step_arg_206675);
                    int64_t discard_207664;
                    int64_t discard_207665;
                    int64_t discard_207666;
                    int64_t discard_207667;
                    int64_t scanacc_207649;
                    int64_t scanacc_207650;
                    int64_t scanacc_207651;
                    int64_t scanacc_207652;
                    
                    scanacc_207649 = (int64_t) 0;
                    scanacc_207650 = (int64_t) 0;
                    scanacc_207651 = (int64_t) 0;
                    scanacc_207652 = (int64_t) 0;
                    for (int64_t i_207658 = 0; i_207658 < n_203490;
                         i_207658++) {
                        double x_206722;
                        
                        x_206722 = ((double *) mem_212631)[i_207679 * n_203490 +
                                                           i_207658];
                        
                        int64_t i64_arg_206723;
                        
                        i64_arg_206723 = futrts_to_bits64(x_206722);
                        
                        int64_t unsign_arg_206724 = ashr64(i64_arg_206723,
                                                           unsign_arg_206679);
                        int64_t unsign_arg_206725 = (int64_t) 1 &
                                unsign_arg_206724;
                        int32_t to_i32_res_206726 =
                                zext_i64_i32(unsign_arg_206725);
                        int64_t unsign_arg_206727 = ashr64(i64_arg_206723,
                                                           (int64_t) 63);
                        int64_t unsign_arg_206728 = (int64_t) 1 &
                                unsign_arg_206727;
                        int32_t to_i32_res_206729 =
                                zext_i64_i32(unsign_arg_206728);
                        bool cond_206730 = to_i32_res_206729 == 1;
                        bool x_206731 = !cond_206730;
                        bool y_206732 = cond_f_res_206677 && x_206731;
                        bool cond_206733 = cond_206730 || y_206732;
                        int32_t defunc_1_get_bit_res_206734;
                        
                        if (cond_206733) {
                            int32_t defunc_1_get_bit_res_t_res_206735 = 1 ^
                                    to_i32_res_206726;
                            
                            defunc_1_get_bit_res_206734 =
                                defunc_1_get_bit_res_t_res_206735;
                        } else {
                            defunc_1_get_bit_res_206734 = to_i32_res_206726;
                        }
                        
                        int32_t x_206736 = mul32(2,
                                                 defunc_1_get_bit_res_206734);
                        int64_t unsign_arg_206737 = ashr64(i64_arg_206723,
                                                           unsign_arg_206680);
                        int64_t unsign_arg_206738 = (int64_t) 1 &
                                unsign_arg_206737;
                        int32_t to_i32_res_206739 =
                                zext_i64_i32(unsign_arg_206738);
                        bool y_206740 = cond_f_res_206678 && x_206731;
                        bool cond_206741 = cond_206730 || y_206740;
                        int32_t defunc_1_get_bit_res_206742;
                        
                        if (cond_206741) {
                            int32_t defunc_1_get_bit_res_t_res_206743 = 1 ^
                                    to_i32_res_206739;
                            
                            defunc_1_get_bit_res_206742 =
                                defunc_1_get_bit_res_t_res_206743;
                        } else {
                            defunc_1_get_bit_res_206742 = to_i32_res_206739;
                        }
                        
                        int32_t defunc_0_f_res_206744 = add32(x_206736,
                                                              defunc_1_get_bit_res_206742);
                        bool cond_206745 = defunc_0_f_res_206744 == 0;
                        int64_t defunc_0_f_res_206746 =
                                btoi_bool_i64(cond_206745);
                        int64_t defunc_0_f_res_206747;
                        int64_t defunc_0_f_res_206748;
                        int64_t defunc_0_f_res_206749;
                        
                        if (cond_206745) {
                            defunc_0_f_res_206747 = (int64_t) 0;
                            defunc_0_f_res_206748 = (int64_t) 0;
                            defunc_0_f_res_206749 = (int64_t) 0;
                        } else {
                            bool cond_206750 = defunc_0_f_res_206744 == 1;
                            int64_t defunc_0_f_res_f_res_206751 =
                                    btoi_bool_i64(cond_206750);
                            int64_t defunc_0_f_res_f_res_206752;
                            int64_t defunc_0_f_res_f_res_206753;
                            
                            if (cond_206750) {
                                defunc_0_f_res_f_res_206752 = (int64_t) 0;
                                defunc_0_f_res_f_res_206753 = (int64_t) 0;
                            } else {
                                bool cond_206754 = defunc_0_f_res_206744 == 2;
                                int64_t defunc_0_f_res_f_res_f_res_206755 =
                                        btoi_bool_i64(cond_206754);
                                bool cond_neg_206756 = !cond_206754;
                                int64_t defunc_0_f_res_f_res_f_res_206757 =
                                        btoi_bool_i64(cond_neg_206756);
                                
                                defunc_0_f_res_f_res_206752 =
                                    defunc_0_f_res_f_res_f_res_206755;
                                defunc_0_f_res_f_res_206753 =
                                    defunc_0_f_res_f_res_f_res_206757;
                            }
                            defunc_0_f_res_206747 = defunc_0_f_res_f_res_206751;
                            defunc_0_f_res_206748 = defunc_0_f_res_f_res_206752;
                            defunc_0_f_res_206749 = defunc_0_f_res_f_res_206753;
                        }
                        
                        int64_t defunc_1_op_res_206718 =
                                add64(defunc_0_f_res_206746, scanacc_207649);
                        int64_t defunc_1_op_res_206719 =
                                add64(defunc_0_f_res_206747, scanacc_207650);
                        int64_t defunc_1_op_res_206720 =
                                add64(defunc_0_f_res_206748, scanacc_207651);
                        int64_t defunc_1_op_res_206721 =
                                add64(defunc_0_f_res_206749, scanacc_207652);
                        
                        ((int64_t *) mem_212652)[i_207658] =
                            defunc_1_op_res_206718;
                        ((int64_t *) mem_212655)[i_207658] =
                            defunc_1_op_res_206719;
                        ((int64_t *) mem_212658)[i_207658] =
                            defunc_1_op_res_206720;
                        ((int64_t *) mem_212661)[i_207658] =
                            defunc_1_op_res_206721;
                        ((int32_t *) mem_212664)[i_207658] =
                            defunc_0_f_res_206744;
                        
                        int64_t scanacc_tmp_213699 = defunc_1_op_res_206718;
                        int64_t scanacc_tmp_213700 = defunc_1_op_res_206719;
                        int64_t scanacc_tmp_213701 = defunc_1_op_res_206720;
                        int64_t scanacc_tmp_213702 = defunc_1_op_res_206721;
                        
                        scanacc_207649 = scanacc_tmp_213699;
                        scanacc_207650 = scanacc_tmp_213700;
                        scanacc_207651 = scanacc_tmp_213701;
                        scanacc_207652 = scanacc_tmp_213702;
                    }
                    discard_207664 = scanacc_207649;
                    discard_207665 = scanacc_207650;
                    discard_207666 = scanacc_207651;
                    discard_207667 = scanacc_207652;
                    
                    int64_t last_res_206763;
                    
                    last_res_206763 = ((int64_t *) mem_212652)[i_203670];
                    
                    int64_t last_res_206764;
                    
                    last_res_206764 = ((int64_t *) mem_212655)[i_203670];
                    
                    int64_t last_res_206765;
                    
                    last_res_206765 = ((int64_t *) mem_212658)[i_203670];
                    if (n_203490 * (int64_t) 8 > 0)
                        memmove(mem_212727 + (int64_t) 0, mem_212631 +
                                ((int64_t) 0 + i_207679 * n_203490) *
                                (int64_t) 8, n_203490 * (int64_t) 8);
                    for (int64_t write_iter_207668 = 0; write_iter_207668 <
                         n_203490; write_iter_207668++) {
                        int32_t write_iv_207670;
                        
                        write_iv_207670 =
                            ((int32_t *) mem_212664)[write_iter_207668];
                        
                        int64_t write_iv_207671;
                        
                        write_iv_207671 =
                            ((int64_t *) mem_212652)[write_iter_207668];
                        
                        int64_t write_iv_207672;
                        
                        write_iv_207672 =
                            ((int64_t *) mem_212655)[write_iter_207668];
                        
                        int64_t write_iv_207673;
                        
                        write_iv_207673 =
                            ((int64_t *) mem_212658)[write_iter_207668];
                        
                        int64_t write_iv_207674;
                        
                        write_iv_207674 =
                            ((int64_t *) mem_212661)[write_iter_207668];
                        
                        bool match_lit_206774 = 0 == write_iv_207670;
                        int64_t defunc_1_f_res_206775;
                        
                        if (match_lit_206774) {
                            int64_t case_res_206776 = sub64(write_iv_207671,
                                                            (int64_t) 1);
                            
                            defunc_1_f_res_206775 = case_res_206776;
                        } else {
                            bool match_lit_206777 = 1 == write_iv_207670;
                            int64_t x_206778;
                            
                            if (match_lit_206777) {
                                int64_t x_206779 = add64(last_res_206763,
                                                         write_iv_207672);
                                int64_t case_res_206780 = sub64(x_206779,
                                                                (int64_t) 1);
                                
                                x_206778 = case_res_206780;
                            } else {
                                bool match_lit_206781 = 2 == write_iv_207670;
                                int64_t x_206782;
                                
                                if (match_lit_206781) {
                                    int64_t x_206783 = add64(last_res_206763,
                                                             last_res_206764);
                                    int64_t x_206784 = add64(x_206783,
                                                             write_iv_207673);
                                    int64_t case_res_206785 = sub64(x_206784,
                                                                    (int64_t) 1);
                                    
                                    x_206782 = case_res_206785;
                                } else {
                                    int64_t x_206786 = add64(last_res_206763,
                                                             last_res_206764);
                                    int64_t x_206787 = add64(last_res_206765,
                                                             x_206786);
                                    int64_t x_206788 = add64(x_206787,
                                                             write_iv_207674);
                                    int64_t defunc_1_f_res_res_206789 =
                                            sub64(x_206788, (int64_t) 1);
                                    
                                    x_206782 = defunc_1_f_res_res_206789;
                                }
                                x_206778 = x_206782;
                            }
                            defunc_1_f_res_206775 = x_206778;
                        }
                        if (sle64((int64_t) 0, defunc_1_f_res_206775) &&
                            slt64(defunc_1_f_res_206775, n_203490)) {
                            if ((int64_t) 8 > 0)
                                memmove(mem_212727 + defunc_1_f_res_206775 *
                                        (int64_t) 8, mem_212631 + ((int64_t) 0 +
                                                                   i_207679 *
                                                                   n_203490 +
                                                                   (int64_t) 1 *
                                                                   write_iter_207668) *
                                        (int64_t) 8, (int64_t) 8);
                        }
                    }
                    if (n_203490 * (int64_t) 8 > 0)
                        memmove(mem_212631 + i_207679 * n_203490 * (int64_t) 8,
                                mem_212727 + (int64_t) 0, n_203490 *
                                (int64_t) 8);
                }
            }
            
            bool empty_slice_206791 = j_m_i_204133 == (int64_t) 0;
            int64_t m_206792 = sub64(j_m_i_204133, (int64_t) 1);
            int64_t i_p_m_t_s_206793 = add64(stl_res_203664, m_206792);
            bool zzero_leq_i_p_m_t_s_206794 = sle64((int64_t) 0,
                                                    i_p_m_t_s_206793);
            bool i_p_m_t_s_leq_w_206795 = slt64(i_p_m_t_s_206793, n_203490);
            bool zzero_lte_i_206796 = sle64((int64_t) 0, stl_res_203664);
            bool i_lte_j_206797 = sle64(stl_res_203664, stl_res_203665);
            bool y_206798 = i_p_m_t_s_leq_w_206795 && zzero_lte_i_206796;
            bool y_206799 = zzero_leq_i_p_m_t_s_206794 && y_206798;
            bool y_206800 = i_lte_j_206797 && y_206799;
            bool forwards_ok_206801 = zzero_lte_i_206796 && y_206800;
            bool ok_or_empty_206802 = empty_slice_206791 || forwards_ok_206801;
            bool index_certs_206803;
            
            if (!ok_or_empty_206802) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) stl_res_203664, ":",
                              (long long) stl_res_203665,
                              "] out of bounds for array of shape [",
                              (long long) n_203490, "].",
                              "-> #0  stl.fut:344:33-51\n   #1  stl.fut:342:13-349:28\n   #2  stl.fut:415:61-429:75\n   #3  stl.fut:455:3-469:34\n   #4  stl.fut:439:1-469:34\n");
                if (memblock_unref(ctx, &ext_mem_212845, "ext_mem_212845") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_209164,
                                   "mem_param_209164") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_209156,
                                   "mem_param_209156") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_212524, "ext_mem_212524") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_212525, "ext_mem_212525") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_209142,
                                   "mem_param_209142") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_209134,
                                   "mem_param_209134") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_209126,
                                   "mem_param_209126") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_212853, "ext_mem_212853") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_212854, "ext_mem_212854") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_212855, "ext_mem_212855") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_209118, "mem_209118") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_209114, "mem_209114") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_213364, "mem_out_213364") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_213363, "mem_out_213363") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_213362, "mem_out_213362") != 0)
                    return 1;
                err = 1;
                goto cleanup;
            }
            if (mem_212758_cached_sizze_213812 < (size_t) bytes_208394) {
                mem_212758 = realloc(mem_212758, bytes_208394);
                mem_212758_cached_sizze_213812 = bytes_208394;
            }
            if (mem_212761_cached_sizze_213813 < (size_t) bytes_208394) {
                mem_212761 = realloc(mem_212761, bytes_208394);
                mem_212761_cached_sizze_213813 = bytes_208394;
            }
            if (mem_212764_cached_sizze_213814 < (size_t) bytes_208394) {
                mem_212764 = realloc(mem_212764, bytes_208394);
                mem_212764_cached_sizze_213814 = bytes_208394;
            }
            for (int64_t i_207689 = 0; i_207689 < partition_sizze_203577;
                 i_207689++) {
                double defunc_2_reduce_res_206809;
                double redout_207681 = 0.0;
                
                for (int64_t i_207682 = 0; i_207682 < j_m_i_204133;
                     i_207682++) {
                    int64_t slice_207716 = stl_res_203664 + i_207682;
                    double x_206813;
                    
                    x_206813 = ((double *) mem_212631)[i_207689 * n_203490 +
                                                       slice_207716];
                    
                    double defunc_1_op_res_206812 = x_206813 + redout_207681;
                    double redout_tmp_213712 = defunc_1_op_res_206812;
                    
                    redout_207681 = redout_tmp_213712;
                }
                defunc_2_reduce_res_206809 = redout_207681;
                
                double h_206814 = 3.0 * defunc_2_reduce_res_206809;
                double h9_206815 = 0.999 * h_206814;
                double h1_206816 = 1.0e-3 * h_206814;
                
                ((double *) mem_212758)[i_207689] = h_206814;
                ((double *) mem_212761)[i_207689] = h9_206815;
                ((double *) mem_212764)[i_207689] = h1_206816;
            }
            
            struct memblock mem_212804;
            
            mem_212804.references = NULL;
            if (memblock_alloc(ctx, &mem_212804, bytes_208391, "mem_212804")) {
                err = 1;
                goto cleanup;
            }
            for (int64_t i_207699 = 0; i_207699 < partition_sizze_203577;
                 i_207699++) {
                double x_206822;
                
                x_206822 = ((double *) mem_212758)[i_207699];
                
                double x_206823;
                
                x_206823 = ((double *) mem_212761)[i_207699];
                
                double x_206824;
                
                x_206824 = ((double *) mem_212764)[i_207699];
                for (int64_t i_207695 = 0; i_207695 < n_203490; i_207695++) {
                    double x_206826;
                    
                    x_206826 = ((double *) mem_212547)[i_207699 * n_203490 +
                                                       i_207695];
                    
                    double x_206827 = x_206826 / x_206822;
                    double y_206828 = fpow64(x_206827, 2.0);
                    double x_206829 = 1.0 - y_206828;
                    double bicube_206830 = fpow64(x_206829, 2.0);
                    bool isnan_res_206831;
                    
                    isnan_res_206831 = futrts_isnan64(x_206826);
                    
                    bool cond_f_res_206832 = x_206826 <= x_206824;
                    bool x_206833 = !isnan_res_206831;
                    bool y_206834 = cond_f_res_206832 && x_206833;
                    bool cond_206835 = isnan_res_206831 || y_206834;
                    double defunc_0_f_res_206836;
                    
                    if (cond_206835) {
                        defunc_0_f_res_206836 = 1.0;
                    } else {
                        bool cond_206837 = x_206823 <= x_206826;
                        bool cond_f_res_206838 = x_206826 <= 1.0e-6;
                        bool x_206839 = !cond_206837;
                        bool y_206840 = cond_f_res_206838 && x_206839;
                        bool cond_206841 = cond_206837 || y_206840;
                        double defunc_0_f_res_f_res_206842;
                        
                        if (cond_206841) {
                            defunc_0_f_res_f_res_206842 = 1.0e-6;
                        } else {
                            defunc_0_f_res_f_res_206842 = bicube_206830;
                        }
                        defunc_0_f_res_206836 = defunc_0_f_res_f_res_206842;
                    }
                    ((double *) mem_212804.mem)[i_207699 * n_203490 +
                                                i_207695] =
                        defunc_0_f_res_206836;
                }
            }
            if (memblock_set(ctx, &ext_mem_212845, &mem_212804, "mem_212804") !=
                0)
                return 1;
            if (memblock_unref(ctx, &mem_212804, "mem_212804") != 0)
                return 1;
        } else {
            if (memblock_set(ctx, &ext_mem_212845, &mem_param_209142,
                             "mem_param_209142") != 0)
                return 1;
        }
        
        int64_t ctx_param_ext_tmp_213431 = ext_212531;
        int64_t ctx_param_ext_tmp_213432 = ext_212529;
        int64_t ctx_param_ext_tmp_213433 = ext_212850;
        int64_t ctx_param_ext_tmp_213434 = ext_212849;
        int64_t ctx_param_ext_tmp_213435 = ext_212846;
        int64_t ctx_param_ext_tmp_213436 = ext_212848;
        int64_t ctx_param_ext_tmp_213437 = ext_212852;
        int64_t ctx_param_ext_tmp_213438 = ext_212847;
        int64_t ctx_param_ext_tmp_213439 = ext_212851;
        struct memblock mem_param_tmp_213440;
        
        mem_param_tmp_213440.references = NULL;
        if (memblock_set(ctx, &mem_param_tmp_213440, &ext_mem_212525,
                         "ext_mem_212525") != 0)
            return 1;
        
        struct memblock mem_param_tmp_213441;
        
        mem_param_tmp_213441.references = NULL;
        if (memblock_set(ctx, &mem_param_tmp_213441, &ext_mem_212524,
                         "ext_mem_212524") != 0)
            return 1;
        
        struct memblock mem_param_tmp_213442;
        
        mem_param_tmp_213442.references = NULL;
        if (memblock_set(ctx, &mem_param_tmp_213442, &ext_mem_212845,
                         "ext_mem_212845") != 0)
            return 1;
        ctx_param_ext_209128 = ctx_param_ext_tmp_213431;
        ctx_param_ext_209130 = ctx_param_ext_tmp_213432;
        ctx_param_ext_209135 = ctx_param_ext_tmp_213433;
        ctx_param_ext_209136 = ctx_param_ext_tmp_213434;
        ctx_param_ext_209137 = ctx_param_ext_tmp_213435;
        ctx_param_ext_209138 = ctx_param_ext_tmp_213436;
        ctx_param_ext_209139 = ctx_param_ext_tmp_213437;
        ctx_param_ext_209140 = ctx_param_ext_tmp_213438;
        ctx_param_ext_209141 = ctx_param_ext_tmp_213439;
        if (memblock_set(ctx, &mem_param_209126, &mem_param_tmp_213440,
                         "mem_param_tmp_213440") != 0)
            return 1;
        if (memblock_set(ctx, &mem_param_209134, &mem_param_tmp_213441,
                         "mem_param_tmp_213441") != 0)
            return 1;
        if (memblock_set(ctx, &mem_param_209142, &mem_param_tmp_213442,
                         "mem_param_tmp_213442") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_param_tmp_213442,
                           "mem_param_tmp_213442") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_param_tmp_213441,
                           "mem_param_tmp_213441") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_param_tmp_213440,
                           "mem_param_tmp_213440") != 0)
            return 1;
        if (memblock_unref(ctx, &ext_mem_212845, "ext_mem_212845") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_param_209164, "mem_param_209164") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_param_209156, "mem_param_209156") != 0)
            return 1;
        if (memblock_unref(ctx, &ext_mem_212524, "ext_mem_212524") != 0)
            return 1;
        if (memblock_unref(ctx, &ext_mem_212525, "ext_mem_212525") != 0)
            return 1;
    }
    ext_212868 = ctx_param_ext_209128;
    ext_212866 = ctx_param_ext_209130;
    ext_212862 = ctx_param_ext_209135;
    ext_212861 = ctx_param_ext_209136;
    ext_212860 = ctx_param_ext_209137;
    ext_212859 = ctx_param_ext_209138;
    ext_212858 = ctx_param_ext_209139;
    ext_212857 = ctx_param_ext_209140;
    ext_212856 = ctx_param_ext_209141;
    if (memblock_set(ctx, &ext_mem_212855, &mem_param_209126,
                     "mem_param_209126") != 0)
        return 1;
    if (memblock_set(ctx, &ext_mem_212854, &mem_param_209134,
                     "mem_param_209134") != 0)
        return 1;
    if (memblock_set(ctx, &ext_mem_212853, &mem_param_209142,
                     "mem_param_209142") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_209114, "mem_209114") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_209118, "mem_209118") != 0)
        return 1;
    if (mem_212880_cached_sizze_213815 < (size_t) bytes_208351) {
        mem_212880 = realloc(mem_212880, bytes_208351);
        mem_212880_cached_sizze_213815 = bytes_208351;
    }
    for (int64_t i_213715 = 0; i_213715 < m_203489; i_213715++) {
        for (int64_t i_213716 = 0; i_213716 < n_203490; i_213716++) {
            ((double *) mem_212880)[i_213715 * n_203490 + i_213716] = NAN;
        }
    }
    if (mem_212884_cached_sizze_213816 < (size_t) bytes_208351) {
        mem_212884 = realloc(mem_212884, bytes_208351);
        mem_212884_cached_sizze_213816 = bytes_208351;
    }
    for (int64_t i_213717 = 0; i_213717 < m_203489; i_213717++) {
        for (int64_t i_213718 = 0; i_213718 < n_203490; i_213718++) {
            ((double *) mem_212884)[i_213717 * n_203490 + i_213718] = NAN;
        }
    }
    if (mem_212888_cached_sizze_213817 < (size_t) bytes_208351) {
        mem_212888 = realloc(mem_212888, bytes_208351);
        mem_212888_cached_sizze_213817 = bytes_208351;
    }
    for (int64_t i_213719 = 0; i_213719 < m_203489; i_213719++) {
        for (int64_t i_213720 = 0; i_213720 < n_203490; i_213720++) {
            ((double *) mem_212888)[i_213719 * n_203490 + i_213720] = NAN;
        }
    }
    
    int64_t binop_y_212919 = (int64_t) 8 * n_203490;
    int64_t bytes_212920 = smax64((int64_t) 0, binop_y_212919);
    
    if (mem_212921_cached_sizze_213818 < (size_t) bytes_212920) {
        mem_212921 = realloc(mem_212921, bytes_212920);
        mem_212921_cached_sizze_213818 = bytes_212920;
    }
    if (mem_212924_cached_sizze_213819 < (size_t) bytes_212920) {
        mem_212924 = realloc(mem_212924, bytes_212920);
        mem_212924_cached_sizze_213819 = bytes_212920;
    }
    if (mem_212927_cached_sizze_213820 < (size_t) bytes_212920) {
        mem_212927 = realloc(mem_212927, bytes_212920);
        mem_212927_cached_sizze_213820 = bytes_212920;
    }
    for (int64_t write_iter_207705 = 0; write_iter_207705 <
         partition_sizze_203577; write_iter_207705++) {
        int64_t write_iv_207712;
        
        write_iv_207712 = ((int64_t *) mem_208355)[write_iter_207705];
        if (n_203490 * (int64_t) 8 > 0)
            memmove(mem_212921 + (int64_t) 0, ext_mem_212855.mem +
                    ((int64_t) 0 + write_iter_207705 * n_203490) * (int64_t) 8,
                    n_203490 * (int64_t) 8);
        if (n_203490 * (int64_t) 8 > 0)
            memmove(mem_212924 + (int64_t) 0, ext_mem_212854.mem +
                    ((int64_t) 0 + write_iter_207705 * ext_212866) *
                    (int64_t) 8, n_203490 * (int64_t) 8);
        for (int64_t i_207703 = 0; i_207703 < n_203490; i_207703++) {
            double x_206855;
            
            x_206855 = ((double *) mem_208352)[write_iter_207705 * n_203490 +
                                               i_207703];
            
            double x_206856;
            
            x_206856 = ((double *) ext_mem_212855.mem)[write_iter_207705 *
                                                       n_203490 + i_207703];
            
            double x_206857;
            
            x_206857 = ((double *) ext_mem_212854.mem)[write_iter_207705 *
                                                       ext_212866 + i_207703];
            
            double x_206858 = x_206855 - x_206856;
            double defunc_2_f_res_206859 = x_206858 - x_206857;
            
            ((double *) mem_212927)[i_207703] = defunc_2_f_res_206859;
        }
        if ((sle64((int64_t) 0, write_iv_207712) && slt64(write_iv_207712,
                                                          m_203489)) &&
            (sle64((int64_t) 0, (int64_t) 0) && slt64(n_203490 - (int64_t) 1,
                                                      n_203490))) {
            if (n_203490 * (int64_t) 8 > 0)
                memmove(mem_212888 + write_iv_207712 * n_203490 * (int64_t) 8,
                        mem_212927 + (int64_t) 0, n_203490 * (int64_t) 8);
        }
        if ((sle64((int64_t) 0, write_iv_207712) && slt64(write_iv_207712,
                                                          m_203489)) &&
            (sle64((int64_t) 0, (int64_t) 0) && slt64(n_203490 - (int64_t) 1,
                                                      n_203490))) {
            if (n_203490 * (int64_t) 8 > 0)
                memmove(mem_212884 + write_iv_207712 * n_203490 * (int64_t) 8,
                        mem_212924 + (int64_t) 0, n_203490 * (int64_t) 8);
        }
        if ((sle64((int64_t) 0, write_iv_207712) && slt64(write_iv_207712,
                                                          m_203489)) &&
            (sle64((int64_t) 0, (int64_t) 0) && slt64(n_203490 - (int64_t) 1,
                                                      n_203490))) {
            if (n_203490 * (int64_t) 8 > 0)
                memmove(mem_212880 + write_iv_207712 * n_203490 * (int64_t) 8,
                        mem_212921 + (int64_t) 0, n_203490 * (int64_t) 8);
        }
    }
    if (memblock_unref(ctx, &ext_mem_212854, "ext_mem_212854") != 0)
        return 1;
    if (memblock_unref(ctx, &ext_mem_212855, "ext_mem_212855") != 0)
        return 1;
    
    struct memblock mem_212967;
    
    mem_212967.references = NULL;
    if (memblock_alloc(ctx, &mem_212967, bytes_208351, "mem_212967")) {
        err = 1;
        goto cleanup;
    }
    if (m_203489 * n_203490 * (int64_t) 8 > 0)
        memmove(mem_212967.mem + (int64_t) 0, mem_212880 + (int64_t) 0,
                m_203489 * n_203490 * (int64_t) 8);
    
    struct memblock mem_212972;
    
    mem_212972.references = NULL;
    if (memblock_alloc(ctx, &mem_212972, bytes_208351, "mem_212972")) {
        err = 1;
        goto cleanup;
    }
    if (m_203489 * n_203490 * (int64_t) 8 > 0)
        memmove(mem_212972.mem + (int64_t) 0, mem_212884 + (int64_t) 0,
                m_203489 * n_203490 * (int64_t) 8);
    
    struct memblock mem_212977;
    
    mem_212977.references = NULL;
    if (memblock_alloc(ctx, &mem_212977, bytes_208351, "mem_212977")) {
        err = 1;
        goto cleanup;
    }
    if (m_203489 * n_203490 * (int64_t) 8 > 0)
        memmove(mem_212977.mem + (int64_t) 0, mem_212888 + (int64_t) 0,
                m_203489 * n_203490 * (int64_t) 8);
    if (memblock_set(ctx, &mem_out_213362, &mem_212967, "mem_212967") != 0)
        return 1;
    if (memblock_set(ctx, &mem_out_213363, &mem_212972, "mem_212972") != 0)
        return 1;
    if (memblock_set(ctx, &mem_out_213364, &mem_212977, "mem_212977") != 0)
        return 1;
    (*mem_out_p_213725).references = NULL;
    if (memblock_set(ctx, &*mem_out_p_213725, &mem_out_213362,
                     "mem_out_213362") != 0)
        return 1;
    (*mem_out_p_213726).references = NULL;
    if (memblock_set(ctx, &*mem_out_p_213726, &mem_out_213363,
                     "mem_out_213363") != 0)
        return 1;
    (*mem_out_p_213727).references = NULL;
    if (memblock_set(ctx, &*mem_out_p_213727, &mem_out_213364,
                     "mem_out_213364") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_212977, "mem_212977") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_212972, "mem_212972") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_212967, "mem_212967") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_param_209142, "mem_param_209142") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_param_209134, "mem_param_209134") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_param_209126, "mem_param_209126") != 0)
        return 1;
    if (memblock_unref(ctx, &ext_mem_212853, "ext_mem_212853") != 0)
        return 1;
    if (memblock_unref(ctx, &ext_mem_212854, "ext_mem_212854") != 0)
        return 1;
    if (memblock_unref(ctx, &ext_mem_212855, "ext_mem_212855") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_209118, "mem_209118") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_209114, "mem_209114") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_out_213364, "mem_out_213364") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_out_213363, "mem_out_213363") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_out_213362, "mem_out_213362") != 0)
        return 1;
    
  cleanup:
    { }
    free(mem_208321);
    free(mem_208324);
    free(mem_208352);
    free(mem_208355);
    free(mem_208375);
    free(mem_208392);
    free(mem_208395);
    free(mem_208415);
    free(mem_208430);
    free(mem_208467);
    free(mem_208559);
    free(mem_208563);
    free(mem_208616);
    free(mem_208631);
    free(mem_208710);
    free(mem_208715);
    free(mem_208776);
    free(mem_208908);
    free(mem_208912);
    free(mem_208935);
    free(mem_209011);
    free(mem_209015);
    free(mem_209038);
    free(mem_209168);
    free(mem_209213);
    free(mem_209218);
    free(mem_209962);
    free(mem_210121);
    free(mem_210124);
    free(mem_210335);
    free(mem_210338);
    free(mem_210365);
    free(mem_210368);
    free(mem_210643);
    free(mem_210686);
    free(mem_210702);
    free(mem_210715);
    free(mem_210738);
    free(mem_210754);
    free(mem_210767);
    free(mem_210790);
    free(mem_210806);
    free(mem_210819);
    free(mem_211127);
    free(mem_211211);
    free(mem_211214);
    free(mem_211329);
    free(mem_211332);
    free(mem_211359);
    free(mem_211362);
    free(mem_211589);
    free(mem_211604);
    free(mem_211607);
    free(mem_211692);
    free(mem_211707);
    free(mem_211710);
    free(mem_211825);
    free(mem_211840);
    free(mem_211843);
    free(mem_211980);
    free(mem_211995);
    free(mem_211998);
    free(mem_212036);
    free(mem_212098);
    free(mem_212113);
    free(mem_212116);
    free(mem_212165);
    free(mem_212168);
    free(mem_212261);
    free(mem_212276);
    free(mem_212279);
    free(mem_212328);
    free(mem_212331);
    free(mem_212358);
    free(mem_212361);
    free(mem_212543);
    free(mem_212547);
    free(mem_212631);
    free(mem_212652);
    free(mem_212655);
    free(mem_212658);
    free(mem_212661);
    free(mem_212664);
    free(mem_212727);
    free(mem_212758);
    free(mem_212761);
    free(mem_212764);
    free(mem_212880);
    free(mem_212884);
    free(mem_212888);
    free(mem_212921);
    free(mem_212924);
    free(mem_212927);
    return err;
}

int futhark_entry_main(struct futhark_context *ctx,
                       struct futhark_f64_2d **out0,
                       struct futhark_f64_2d **out1,
                       struct futhark_f64_2d **out2, const
                       struct futhark_f64_2d *in0, const int64_t in1, const
                       int64_t in2, const int64_t in3, const int64_t in4, const
                       int64_t in5, const int64_t in6, const int64_t in7, const
                       int64_t in8, const int64_t in9, const int64_t in10, const
                       int64_t in11, const int64_t in12, const int64_t in13,
                       const int64_t in14)
{
    struct memblock Y_mem_208318;
    
    Y_mem_208318.references = NULL;
    
    int64_t m_203489;
    int64_t n_203490;
    int64_t n_p_203492;
    int64_t q_s_203493;
    int64_t q_t_203494;
    int64_t q_l_203495;
    int64_t d_s_203496;
    int64_t d_t_203497;
    int64_t d_l_203498;
    int64_t jump_s_203499;
    int64_t jump_t_203500;
    int64_t jump_l_203501;
    int64_t n_inner_203502;
    int64_t n_outer_203503;
    int64_t jump_threshold_203504;
    int64_t q_threshold_203505;
    struct memblock mem_out_213362;
    
    mem_out_213362.references = NULL;
    
    struct memblock mem_out_213363;
    
    mem_out_213363.references = NULL;
    
    struct memblock mem_out_213364;
    
    mem_out_213364.references = NULL;
    
    int ret = 0;
    
    lock_lock(&ctx->lock);
    Y_mem_208318 = in0->mem;
    m_203489 = in0->shape[0];
    n_203490 = in0->shape[1];
    n_p_203492 = in1;
    q_s_203493 = in2;
    q_t_203494 = in3;
    q_l_203495 = in4;
    d_s_203496 = in5;
    d_t_203497 = in6;
    d_l_203498 = in7;
    jump_s_203499 = in8;
    jump_t_203500 = in9;
    jump_l_203501 = in10;
    n_inner_203502 = in11;
    n_outer_203503 = in12;
    jump_threshold_203504 = in13;
    q_threshold_203505 = in14;
    if (!(m_203489 == in0->shape[0] && n_203490 == in0->shape[1])) {
        ret = 1;
        if (!ctx->error)
            ctx->error =
                msgprintf("Error: entry point arguments have invalid sizes.\n");
    }
    if (ret == 0) {
        ret = futrts_entry_main(ctx, &mem_out_213362, &mem_out_213363,
                                &mem_out_213364, Y_mem_208318, m_203489,
                                n_203490, n_p_203492, q_s_203493, q_t_203494,
                                q_l_203495, d_s_203496, d_t_203497, d_l_203498,
                                jump_s_203499, jump_t_203500, jump_l_203501,
                                n_inner_203502, n_outer_203503,
                                jump_threshold_203504, q_threshold_203505);
        if (ret == 0) {
            assert((*out0 =
                    (struct futhark_f64_2d *) malloc(sizeof(struct futhark_f64_2d))) !=
                NULL);
            (*out0)->mem = mem_out_213362;
            (*out0)->shape[0] = m_203489;
            (*out0)->shape[1] = n_203490;
            assert((*out1 =
                    (struct futhark_f64_2d *) malloc(sizeof(struct futhark_f64_2d))) !=
                NULL);
            (*out1)->mem = mem_out_213363;
            (*out1)->shape[0] = m_203489;
            (*out1)->shape[1] = n_203490;
            assert((*out2 =
                    (struct futhark_f64_2d *) malloc(sizeof(struct futhark_f64_2d))) !=
                NULL);
            (*out2)->mem = mem_out_213364;
            (*out2)->shape[0] = m_203489;
            (*out2)->shape[1] = n_203490;
        }
    }
    lock_unlock(&ctx->lock);
    return ret;
}
  
